Solve nonlinear shell equations of Reissner-Naghdi type in the case of 
a cylindrical benchmark problem with membrane-dominated asymptotic behaviour in 
the linear regime. The linearized problem has been described in 
Pitkäranta et al. Shell deformation states and the finite element method: 
a benchmark study of cylindrical shells. Computer Methods in Applied Mechanics 
and Engineering 1995. 128:81-121. As opposed to the reference, here the shell
problem is treated as nonlinear but the shell is subject to a small load 
so that nonlinear effects are not yet significant.

Results below: The error of strain energy when the shell problem is linear
(Large Deflection = False) and when the mesh is refined as

Element Divisions 1 = 1 16 1  
Element Divisions 2 = 1 8 8 1


II. TRIANGLES

Strain reduction method = (solver default)
=============================================
0.17117806858885401
8.0459096871946856E-002
4.0737524719288952E-002
2.1793374374732059E-002
1.2305197940152243E-002


Strain reduction method = 0 (no reduction)
======================================
0.60208880588825542
0.36239878327635855
0.19892547738477828
0.10410455934524342
5.3183057528120692E-002

This is a simple verification case to check that a Faraday disc creates
the expected potential difference between the rim and and the axis.
As explained in the following, this case is also instructive to understand 
how Elmer treats Maxwell's equations in the case of a moving body.

Here a metallic disc rotates and is subject to a uniform magnetic field 
parallel to the disc axis. When the disc is put to rotate, the mobile charges
of the conductor start to feel a radial force due to the Lorentz term v x B
and hence accumulate on the insulated rim surface. As a consequence of charge
separation a radial electric field E is produced. The process of charge 
separation continues as long as steady state is reached such that the force on
the charges which is produced by the Lorentz term v x B balances the force 
which is produced by E. That is, in the steady state we have 

              E'(x) = E(x) + v(x) x B(x) = 0, 

with E'(x) being the spatial field that describes the force experienced by 
a charge (see Elmer Models Manual for Maxwell's equations in terms of E'). 
Note that the solution is expressed in the spatial coordinates and attention 
is not fixed on particular material points (this is known as the Euler 
description in the continuum mechanics).  

The potential difference between the centre and the rim is known to be 
1/2 w a^2 |B|, where a is the radius of the disc and w is the angular 
velocity. Elmer generates E'(x) as the electric field variable and we expect 
to obtain E' = 0 up to the discretization error.

This is a simple 2-D test case where the UMAT subroutine is called to obtain 
the definition of the constitutive law of St Venant-Kirchhoff type (the case of 
plane strain). The case has been checked to yield the same result as obtained 
by using the earlier implementation of the same model within this solver. Note 
that the nonlinear iterations of the two versions may however perform 
differently as the umat version employs an inexact Newton iteration.

A verification case for assembling 3D solid and 2D shell equations
into a single linear system so that the eigenanalysis of the coupled 
equations can be performed.

This is a cylindrical shell problem with bending-dominated 
asymptotic behaviour. Here the boundary layer adjacent to the free 
edge is modelled in 3D and the 2D shell model is used elsewhere. 
The results of this simulation should be compared with those of 
the 2D shell model

       ../tests/Shell_BenchmarkCase2_Quad/eigenanalysis.sif

The eigenmodes computed with the different strategies
appear to be in good agreement. Note that only symmetric modes
are sought here.

For static analysis of the coupled equations see also the tests 

      ../tests/Shell_with_Solid_BenchmarkCase1/case.sif
      ../tests/Shell_with_Solid_BenchmarkCase2/case.sif

Solve nonlinear shell equations of Reissner-Naghdi type when the shell 
solver reads the director data as an ordinary Elmer solver variable. This
case can also be run in parallel, while parallel execution is not currently
possible if the data file format mesh.director or mesh.elements.data is used
to specify the director (currently there is no parallel file formats for these
files). 

This case employs a slightly modified version of the solver NormalSolver
(the source code is contained in CylinderNormalSolver.F90).
The original mesh files located in the mesh directory give nodes which are on
a cylindrical surface. The known relation between the global coordinates and
the director vector is used to solve the Elmer variable 'Director' that
represents the shell director data.

A cylindrical benchmark problem with membrane-dominated asymptotic behaviour 
in the linear regime is solved. The linearized problem has been described in 
Pitkäranta et al. Shell deformation states and the finite element method: 
a benchmark study of cylindrical shells. Computer Methods in Applied Mechanics
and Engineering 1995. 128:81-121. Here the shell is subject to a moderate 
load so that nonlinear effects start to be significant. 

Solve nonlinear shell equations of Reissner-Naghdi type in the case of 
a benchmark problem where an open hemispherical shell is subject to point
loads. The reference results can be found in Sze KY, Liu XH, Lo SH. Popular 
benchmark problems for geometric nonlinear analysis of shells. Finite Elements 
in Analysis and Design 2004, 40(11):1551-1569.

Solve nonlinear shell equations of Reissner-Naghdi type in the case of 
a cylindrical benchmark problem with bending-dominated asymptotic behaviour in 
the linear regime. The linearized problem has been described in 
Pitkäranta et al. Shell deformation states and the finite element method: 
a benchmark study of cylindrical shells. Computer Methods in Applied Mechanics 
and Engineering 1995. 128:81-121. As opposed to the reference, here the shell
problem is treated as nonlinear but the shell is subject to a small load 
so that nonlinear effects are not yet significant.

Results below: The error of strain energy when the shell problem is linear
(Large Deflection = False) and when the mesh is refined as

Element Divisions 1 = 1 16 1  
Element Divisions 2 = 1 8 8 1

II. TRIANGLES

Strain reduction method = (solver default)
================================
0.29711241047737302
0.13457391530595891
6.6902992719152621E-002
3.3425402541436458E-002
1.6919882217024968E-002

A verification case for assembling 3D solid and 2D shell equations
into a single linear system so that the coupled equations can 
be solved simultaneously.

This is a bending-dominated benchmark problem described in 
Pitkäranta et al. Shell deformation states and the finite element 
method: a benchmark study of cylindrical shells. Here the boundary
layer adjacent to the free edge is modelled in 3D and
the 2D shell model is used elsewhere. For a model using 
the shell equations only see the test 

      ../tests/Shell_BenchmarkCase2_Quad

The results of the coupled simulation have been verified
against using the pure shell equations.

This is a simple 2-D test case where the UMAT subroutine is called to obtain 
the definition of the basic isotropic constitutive law (the case of plane 
strain). The small strain tensor is employed, so the nonlinear iteration should
terminate after the first solution step. To increment the load without inertia
effects, the simulation type is here selected to be "scanning". The case has 
been checked to yield the same result as obtained by using the linear elasticity
solver (StressSolve).

Solve nonlinear shell equations of Reissner-Naghdi type in the case of 
a cylindrical benchmark problem with bending-dominated asymptotic behaviour in 
the linear regime. The linearized problem has been described in 
Pitkäranta et al. Shell deformation states and the finite element method: 
a benchmark study of cylindrical shells. Computer Methods in Applied Mechanics 
and Engineering 1995. 128:81-121. As opposed to the reference, here the shell
problem is treated as nonlinear but the shell is subject to a small load 
so that nonlinear effects are not yet significant.

Results below: The error of strain energy when the shell problem is linear
(Large Deflection = False) and when the mesh is refined as

Element Divisions 1 = 1 16 1  
Element Divisions 2 = 1 8 8 1

I. QUADS

The default (strain reduction) method
================================
0.28534440085557611
0.14033086583199897
7.0275522871128052E-002
3.5170214283552041E-002
1.7592769166581007E-002


Strain reduction method = 0 (no reduction)
======================================
0.99896892914864110
0.99574227718518038
0.98313882259801899
0.93712411256923966
0.80190890167786044

The solution of a magnetostatic problem by using the consistently regularized 
formulation (to ensure a unique vector potential solution). See also the 
alternate test mgdyn_bh_gauge2 for using a more effective linear solver.  

The consistently regularized formulation employs the scalar variable as 
an augmented Lagrangian variable to impose the divergence-free constraint on A. 
The uniqueness of the vector potential can also be enforced in an iterated
manner without introducing a coupled system to solve A and the Lagrange 
multiplier. For this alternative see the file with_projection.sif in this 
directory.

Here the principal purpose is to test the ability to use p-basis functions
of varying degree within a single model. The example case is a structural
shell model. This case has been derived from the test 

               ..tests/Classical2DShell/

Linearized 2-D shell equations of Reissner-Naghdi type are solved in the case
of a straight cylindrical shell with membrane-dominated asymptotic behaviour.
The problem has been described in Pitkäranta et al. Shell deformation states 
and the finite element method: a benchmark study of cylindrical shells. 
Computer Methods in Applied Mechanics and Engineering 1995. 128:81-121. Here
the shell equations are written in lines of curvature coordinates (y1 = 
angular direction, y2 = axial direction) and a special solver code is
employed to handle the problem using the exact surface parametrization. The
solver code outputs the energy norm of the error.

The part of the computational domain where a boundary layer has an important
role is associated with an additional body identifier so that a different
degree of approximation can be used within the boundary layer.

The degree of approximation is defined by using a special keyword construct

              Element = "p:%a_matc_function"

where the part "a_matc_function" is the name of a MATC function of a 4-tuple.
The first argument is the identifier of the body while the remaining components
are the coordinates of the element mid-point. At the time of writing, this
seems to be the only functional way to get varying p within a single model.

The energy norm of the error for different p-element definitions (over the
same 2 X 2 mesh, with p being fixed as p=8 in the boundary layer and p varying
elsewhere) is found to be as follows (the shell thickness d=0.1): 

p=1  Relative energy error =    0.80299745294707536
p=2  Relative energy error =    0.21996131107911385
p=3  Relative energy error =    0.14832093405769983
p=4  Relative energy error =    2.9071622043103682E-002
p=5  Relative energy error =    7.0387548946027100E-003
p=6  Relative energy error =    2.3735430471359740E-003
p=7  Relative energy error =    5.8687310435069976E-004
p=8: Relative energy error =    1.3339513082990932E-004

This case gives an eigenanalysis model for a cantilever which has an L-shaped 
cross section. The results have been verified by comparing against other models
of the same problem.

The default shell model which takes into account the straining of the shell 
director may not be convenient in cases where the director field is not
smooth. Here a drilling rotation formulation is used instead in order to handle
the discontinuity of the director field.

This is an axially symmetric test case where the UMAT subroutine is called to 
obtain the definition of the constitutive law of St Venant-Kirchhoff type. 
The case is derived from the test .../tests/TankAst (see this root case for the
origin of the test problem), but here the problem is handled as nonlinear and 
using the local UMAT subroutine to define the constitutive law. Since the load
is not severe, the results are essentially the same as obtained by using the 
linear model of this problem (and without UMAT). 

The author of this version: Mika Malinen

Solve linearized 2-D shell equations of Reissner-Naghdi type in the case of 
a straight cylindrical shell with membrane-dominated asymptotic behaviour.
The problem has been described in Pitkäranta et al. Shell deformation states 
and the finite element method: a benchmark study of cylindrical shells. 
Computer Methods in Applied Mechanics and Engineering 1995. 128:81-121. Here
the shell equations are written in lines of curvature coordinates (y1 = 
angular direction, y2 = axial direction) and a special solver code is
employed to handle the problem using the exact surface parametrization.

This test provides a case for verification of the p-version of FEM.
Note that now Elmer uses economic quadrature rules for element definitions
"p:k" with 1 < k <= 8.

The energy norm of the error for different p-element definitions (over the
same 2 X 2 mesh) is found to be as follows (the shell thickness d=0.1): 

p:1       Relative energy error =   0.88896260271790639 / Standard quadrature with 4 points
p:2       Relative energy error =   0.29814339193540801 / Standard quadrature with 9 points 
p:2       Relative energy error =   0.31558716335632925 / Economic quadrature with 8 points
p:2 b:1   Relative energy error =   0.23711572317485702 / Standard quadrature with 9 points 
p:2 b:15  Relative energy error =   0.10031149151079155 / Standard quadrature with 49 points
p:3       Relative energy error =   0.17701104808582918 / Economic quadrature with 16 points
p:3       Relative energy error =   0.17653138601955753 / Economic quadrature with 12 points
p:3 b:15  Relative energy error =    1.9351692322981600E-002 / Standard quadrature with 49 points
p:4       Relative energy error =    3.4526616304186068E-002 / Standard quadrature with 25 points
p:4       Relative energy error =    3.4142444709100675E-002 / Economic quadrature with 20 points
p:4 b:15  Relative energy error =    7.0424540514543998E-003 / Standard quadrature with 49 points
p:4 b:15  Relative energy error =    7.0424540545392430E-003 / Economic quadrature with 60 points
p:5       Relative energy error =    7.8498375202090825E-003 / Standard quadrature with 36 points
p:5       Relative energy error =    7.6894824635956784E-003 / Economic quadrature with 25 points
p:5 b:15  Relative energy error =    2.0809479830700603E-003 / Standard quadrature with 49 points
p:5 b:15  Relative energy error =    2.0809479941845269E-003 / Economic quadrature with 60 points
p:6       Relative energy error =    2.4502183740983921E-003 / Standard quadrature with 49 points
p:6       Relative energy error =    2.4235601772779774E-003 / Economic quadrature with 36 points
p:6 b:15  Relative energy error =    6.2443241030678861E-004 / Standard quadrature with 49 points
p:6 b:15  Relative energy error =    6.2443249134393978E-004 / Economic quadrature with 60 points
p:7       Relative energy error =    6.0846479859093326E-004 / Standard quadrature with 64 points
p:7       Relative energy error =    6.0719712904946162E-004 / Economic quadrature with 45 points
p:7 b:15  Relative energy error =    1.6535890420287850E-004 / Standard quadrature with 49 points
p:7 b:15  Relative energy error =    1.6535885933152163E-004 / Economic quadrature with 60 points
p:8       Relative energy error =    1.3328077843970739E-004 / Standard quadrature with 81 points
p:8       Relative energy error =    1.3339513082990932E-004 / Economic quadrature with 60 points
p:8 b:15  Relative energy error =    1.3328077843970739E-004 / Standard quadrature with 49 points
p:8 b:15  Relative energy error =    1.3339513082990932E-004 / Economic quadrature with 60 points
p:9       Relative energy error =    6.7817426835655489E-005 

Note that, except for the case p=2, the current version of Elmer doesn't 
offer a way to obtain an approximation based on the space Q_{p} of polynomials
of degree at most p in each variable separately, since Elmer doesn't employ
the bubbles corresponding to Q_{p}. For example the p-approximation space 
S_{p=8} of Elmer has 15 bubble functions and includes only Q_{4}. 
A deterioration of accuracy may thus happen over non-affine finite elements. 
The results above also show the error when the bubble augmentation 
corresponding S_{p=8} is used in connection with p-elements of lower order. 

For a very high p errors from floating-point arithmetic may limit the 
obtainable accuracy.

This case gives a FE model for a fan blade problem considered in

Olson M, Lindberg G: Vibration analysis of cantilevered curved plates using
a new cylindrical shell finite element. A report of Air Force Flight Dynamics
Laboratory, AFFDL-TR-68-150, 1968.

The report lists the first natural frequencies that were measured 
experimentally. The table below shows the first seven vibration frequencies 
obtained computationally with this FE model and the experimental values of
the report. Note that Elmer outputs true eigenvalues, so to get the natural 
frequency one needs to compute f = sqrt(lambda)/(2 pi), with lambda being 
the eigenvalue. 

Mode  FE model    Experimental  
1     95.3        86.6
2     145.3       135.5
3     251.6       258.9
4     362.5       350.6
5     404.6       395.2
6     535.3       531.1
7     748.0       743.2

IMPORTANT NOTE: The example implementation given here is obsolete and should 
not be considered as a model for implementing solvers based on edge finite 
elements. For the vector Helmholtz solver see instead the solver module 

   .../fem/src/modules/VectorHelmholtz.F90

A verification case for assembling 3D solid and 2D shell equations
into a single linear system so that the coupled equations can 
be solved simultaneously.

This is a membrane-dominated benchmark problem described in 
Pitkäranta et al. Shell deformation states and the finite element 
method: a benchmark study of cylindrical shells. Here the boundary
layer adjacent to the clamped edge is modelled in 3D and
the 2D shell model is used elsewhere. For a model using 
the shell equations only see the test 

      ../tests/Shell_BenchmarkCase1_Quad

The coupling conditions are enforced quite near the clamped 
edge where the boundary layer is still strong in order to
test that the effects of bending and transverse shear deformation 
are handled correctly by the interface conditions.

The results of the coupled simulation have been verified
against using pure shell equations and pure 3D elasticity
equations.

Solve nonlinear shell equations of Reissner-Naghdi type in the case of 
a benchmark problem where a cantilever is subject to a shear force at an end. 
The reference results can be found in Sze KY, Liu XH, Lo SH. Popular benchmark 
problems for geometric nonlinear analysis of shells. Finite Elements in Analysis
and Design 2004, 40(11):1551-1569.

Solve nonlinear shell equations of Reissner-Naghdi type in the case of 
a benchmark problem where a straight cylindrical shell is subject to a pinching
force and has rigid end diaphragms allowing axial slip. The reference results
can be found in Sze KY, Liu XH, Lo SH. Popular benchmark problems for 
geometric nonlinear analysis of shells. Finite Elements in Analysis and Design 
2004, 40(11):1551-1569.

IMPORTANT NOTE: The example implementation given here is obsolete and should 
not be considered as a model for implementing solvers based on face finite 
elements. For a model implementation that employs general utility subroutines
see instead the solver module 

   .../fem/src/modules/ModelMixedPoisson.F90

Use mesh.elements.data to define the shell director data.

Solve nonlinear shell equations of Reissner-Naghdi type in the case of 
a cylindrical benchmark problem with membrane-dominated asymptotic behaviour in 
the linear regime. The linearized problem has been described in 
Pitkäranta et al. Shell deformation states and the finite element method: 
a benchmark study of cylindrical shells. Computer Methods in Applied Mechanics 
and Engineering 1995. 128:81-121. As opposed to the reference, here the shell
problem is treated as nonlinear but the shell is subject to a small load 
so that nonlinear effects are not yet significant.

Results below: The error of strain energy when the shell problem is linear
(Large Deflection = False) and when the mesh is refined as


Element Divisions 1 = 1 16 1  
Element Divisions 2 = 1 8 8 1

I. QUADS

The default (strain reduction) method
================================
0.14861001305832033
7.5690869266818270E-002
3.9563764284136951E-002
2.1413131342297147E-002
1.2155740035002147E-002

Strain reduction method = 0 (no reduction)
======================================
0.51900858861935217
0.30075442699998356
0.16281741500325506
8.4638690386812335E-002
4.3193057630034115E-002

This is a special model of the Faraday wheel to test the mortar FE 
approximation. To this end the wheel is artificially broken into an inner part
and outer part which are meshed independently. Moreover, the vector potential
variable is made unique in an iterated manner (the nonlinear iteration is 
employed for this purpose) by performing the Helmholtz projection after 
solving the A-V solution candidate. For a similar verification case see the 
test ../mgdyn_faraday_disc/ and for a transient version of this model the file
transient_with_projection.sif in this directory.

Here a metallic disc rotates and is subject to a uniform magnetic field 
parallel to the disc axis. When the disc is put to rotate, the mobile charges
of the conductor start to feel a radial force due to the Lorentz term v x B
and hence accumulate on the insulated rim surface. As a consequence of charge
separation a radial electric field E is produced. The process of charge 
separation continues as long as steady state is reached such that the force on
the charges which is produced by the Lorentz term v x B balances the force 
which is produced by E. That is, in the steady state we have 

              E'(x) = E(x) + v(x) x B(x) = 0, 

with E'(x) being the spatial field that describes the force experienced by 
a charge (see Elmer Models Manual for Maxwell's equations in terms of E'). 
Note that the solution is expressed in the spatial coordinates and attention 
is not fixed on particular material points (this is known as the Euler 
description in the continuum mechanics).  

The continuity of the A-V solution is enforced weakly over the artificial 
contact surface of the inner and outer part.

This is a simple verification case to check that a Faraday disc creates
the expected potential difference between the rim and and the axis.
The same case is solved as a steady-state problem in the test 
../mgdyn_faraday_disc. Here transient analysis is performed using a sequence
of instantaneous configurations. As explained in the following, this case is 
also instructive to understand how Elmer treats Maxwell's equations in the 
case of a moving body.

Here a metallic disc rotates and is subject to a uniform magnetic field
parallel to the disc axis. When the disc is put to rotate, the mobile charges
of the conductor start to feel a radial force due to the Lorentz term v x B
and hence accumulate on the insulated rim surface. As a consequence of charge
separation a radial electric field E is produced. The process of charge 
separation continues as long as steady state is reached such that the force on
the charges which is produced by the Lorentz term v x B balances the force 
which is produced by E. That is, in the steady state we have 

              E'(x) = E(x) + v(x) x B(x) = 0, 

with E'(x) being the spatial field that describes the force experienced by 
a charge (see Elmer Models Manual for Maxwell's equations in terms of E'). 

Here the rotation is modelled by mapping the mesh at the previous time into
the current configuration, so the (mesh) velocity corresponds to the velocity
field as recorded by an observer at rest (the frame with respect to which the
node coordinates are calculated). The spatial discretization is thus done over
an instantaneous configuration. It should be noted that in the steady state 
limit the scalar potential variable V of the model is related to the standard
E field via

              E = -grad(psi),   with psi = V + v.A,

where A is the vector potential and v is the velocity, respectively. Note also
that the solution is expressed in the spatial coordinates and attention 
is not fixed on particular material points (this is known as the Euler 
description in the continuum mechanics).  

The potential difference between the centre and the rim in terms of the 
variable psi is known to be 1/2 w a^2 |B|, where a is the radius of the disc 
and w is the angular velocity. Elmer generates E'(x) as the electric field 
variable and we expect to obtain E' = 0 up to the discretization error.
To reach the steady state, increase the number of time steps (here the number
of time steps has been reduced for quicker execution).

The author of this test: Mika Malinen

!------------------------------------------------------------------------------
!> Compare keyword strategies with and without a Handle. 
!> This test for real valued keywords.
!------------------------------------------------------------------------------
SUBROUTINE KeywordCompare( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  LOGICAL :: Found
  INTEGER :: t, NoActive
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Material, BodyForce
  TYPE(ValueHandle_t) :: RealVal_h
  INTEGER :: i, TimeSweeps, key
  REAL(KIND=dp) :: OldCounter(10),NewCounter(10)
#ifndef USE_ISO_C_BINDINGS
  REAL(KIND=dp) :: CPUTime,RealTime
#endif
  REAL(KIND=dp) :: RealVal_AtIp, OldTimes(10), NewTimes(10), PseudoNorm, Val


  REAL(KIND=dp), ALLOCATABLE :: Basis(:), RealVal(:)
  REAL(KIND=dp) :: DetJ
  TYPE(GaussIntegrationPoints_t) :: IP
  TYPE(Nodes_t) :: Nodes
  INTEGER :: elem, n
  INTEGER, POINTER :: Indexes(:)
  LOGICAL :: Stat
  CHARACTER(LEN=20) :: KeywordName
  
  SAVE Nodes


  
  CALL Info( 'KeywordCompare','')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')
  CALL Info( 'KeywordCompare','Comparing keyword strategies for real values')

  Mesh => GetMesh()

  n = 20
  ALLOCATE( Basis(n), RealVal(n) )
  
  
  NoActive = GetNOFActive()
  TimeSweeps = ListGetInteger( Solver % Values,'Timer Sweeps')

  OldTimes = 0.0_dp
  NewTimes = 0.0_dp
  OldCounter = 0.0_dp
  NewCounter = 0.0_dp


  CALL Info('KeywordCompare','Starting real value keyword comparision')
  OldTimes(1) = RealTime()

  DO key = 1, 10
    PRINT *,'Testing keyword number:',key
    KeywordName = 'Float Value '//TRIM(I2S(key))
    
    OldTimes(key) = RealTime()  
    DO i=1,TimeSweeps
      DO elem=1,NoActive
        Element => GetActiveElement(elem)
        Material => GetMaterial()
        
        CALL GetElementNodes( Nodes )
        n  = GetElementNOFNodes()
        indexes => Element % NodeIndexes
        
        RealVal(1:n) = ListGetReal( Material,KeywordName,n,Indexes,Found )

        IP = GaussPoints( Element )
        DO t=1,IP % n
          stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis )
          RealVal_AtIp = SUM( Basis(1:n) * RealVal(1:n) )
          OldCounter(key) = OldCounter(key) +  RealVal_AtIp * IP % s(t)
        END DO
      END DO
    END DO
    OldTimes(key) = RealTime() - OldTimes(key)
    

    NewTimes(key) = RealTime()  
    
    CALL ListInitElementKeyword( RealVal_h,'Material',KeywordName )
      
    DO i=1,TimeSweeps
      DO elem=1,NoActive
        Element => GetActiveElement(elem)

        CALL GetElementNodes( Nodes )
        n  = GetElementNOFNodes()      

        IP = GaussPoints( Element )
        DO t=1,IP % n
          stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis )
          RealVal_AtIp = ListGetElementReal( RealVal_h, Basis, Element, Found )
          NewCounter(key) = NewCounter(key) + RealVal_AtIp * IP % s(t)
        END DO
      END DO
    END DO
    NewTimes(key) = RealTime() - NewTimes(key)

    PRINT *,'Compare integrals:', OldCounter(key), NewCounter(key), &
        NewCounter(key)/OldCounter(key)
    PRINT *,'Time consumptions:',OldTimes(key),NewTimes(key)
    PRINT *,'Speed-up for Real:', OldTimes(key)/NewTimes(key)

  END DO


  PseudoNorm = 1.0_dp * SUM(NewCounter) / SUM(OldCounter)
  PRINT *,'PseudoNorm:',PseudoNorm

  Solver % Variable % Values = PseudoNorm
  Solver % Variable % Norm = PseudoNorm
   
      
  CALL Info( 'KeywordCompare','Add done')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')


END SUBROUTINE KeywordCompare

MODULE Blowers

  USE Types
  USE DefUtils
  IMPLICIT NONE

  LOGICAL :: Visited = .FALSE.
  REAL(KIND=dp) :: x1,y1,r1,x2,y2,r2,vx1,vy1,vx2,vy2
  
  SAVE :: Visited,x1,y1,r1,x2,y2,r2,vx1,vy1,vx2,vy2


CONTAINS

  FUNCTION InsideBlower(Model,n) RESULT ( BlowerInd ) 
    INTEGER :: n 
    INTEGER :: BlowerInd
    TYPE(Model_t) :: Model

    REAL(KIND=dp) :: x,y
    TYPE(Valuelist_t), POINTER :: List

    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    
   
    IF(.NOT. Visited ) THEN
      List => Model % Simulation 
      x1 = GetCReal( List,'Blower 1 x')
      y1 = GetCReal( List,'Blower 1 y')
      r1 = GetCReal( List,'Blower 1 r')
      vx1 = GetCReal( List,'Blower 1 vx')
      vy1 = GetCReal( List,'Blower 1 vy')
      PRINT *,'Blower 1:',x1,y1,r1,vx1,vy1

      x2 = GetCReal( List,'Blower 2 x')
      y2 = GetCReal( List,'Blower 2 y')
      r2 = GetCReal( List,'Blower 2 r')
      vx2 = GetCReal( List,'Blower 2 vx')
      vy2 = GetCReal( List,'Blower 2 vy')
      PRINT *,'Blower 1:',x2,y2,r2,vx2,vy2
    
      Visited = .TRUE.
    END IF

    
    IF( (x-x1)**2 + (y-y1)**2 < r1**2 ) THEN
      BlowerInd = 1
    ELSE IF( (x-x2)**2 + (y-y2)**2 < r2**2 ) THEN
      BlowerInd = 2 
    ELSE
      BlowerInd = 0
    END IF

  END FUNCTION InsideBlower


END MODULE Blowers


FUNCTION BlowerVelox( Model, n, t ) RESULT(f)
  USE Types
  USE DefUtils
  USE Blowers
  
  IMPLICIT NONE
  
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t,f
  
  INTEGER :: ind
  
  ind = InsideBlower(Model, n)
  IF( ind == 1 ) THEN
    f = vx1
  ELSE IF( ind == 2 ) THEN
    f = vx2 
  ELSE
    f = 0.0_dp
  END IF
END FUNCTION BlowerVelox


FUNCTION BlowerVeloy( Model, n, t ) RESULT(f)
  USE Types
  USE DefUtils
  USE Blowers
  
  IMPLICIT NONE
  
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t,f
  
  INTEGER :: ind
  
  ind = InsideBlower(Model, n)
  IF( ind == 1 ) THEN
    f = vy1
  ELSE IF( ind == 2 ) THEN
    f = vy2 
  ELSE
    f = 0.0_dp
  END IF
END FUNCTION BlowerVeloy


FUNCTION BlowerVeloCond( Model, n, t ) RESULT(f)
  USE Types
  USE DefUtils
  USE Blowers
  
  IMPLICIT NONE
  
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t,f
  
  INTEGER :: ind
  
  ind = InsideBlower(Model, n)
  IF( ind > 0 ) THEN
    f = 1.0_dp
  ELSE
    f = -1.0_dp
  END IF
END FUNCTION BlowerVeloCond

module ToroidCurrents
  contains 

    function rho(r, r0, y)
      USE Types 
      real(kind=dp) :: rho, r, r0, y
      
       rho = sqrt((r-r0)**2+y**2)
    end function rho

    function currentInToroidR(r, r0, y, turns, I) result (curr)
      USE Types 
      real(kind=dp) :: r, r0, y, curr, rho1, rho2, turns, I
   
      rho1 = rho(8d-3, r0, y)
      rho2 = rho(10d-3, r0, y)

      curr = turns * I /(2*pi*(rho2-rho1)*r)*(-y/rho(r, r0, y))

    end function currentInToroidR

    function currentInToroidY(r, r0, y, turns, I) result (curr)
      USE Types 
      real(kind=dp) :: r, r0, y, curr, rho1, rho2, turns, I
   
      rho1 = rho(8d-3, r0, y)
      rho2 = rho(10d-3, r0, y)

      curr = turns * I /(2*pi*(rho2-rho1)*r)*((r-r0)/rho(r, r0, y))

    end function currentInToroidY

End module ToroidCurrents

FUNCTION currdens1( model, n, args) RESULT(curr)
  USE DefUtils
  Use ToroidCurrents
  IMPLICIT None
  TYPE(Model_t) :: model
  INTEGER :: n
  REAL(KIND=dp) :: x, y, z, args(4), curr, f, omega, &
                   theta, r0, r, turns, I, t

  x = args(1)
  y = args(2)
  z = args(3)
  t = args(4)

  r0 = 45d-3
  turns = 100d0

  f = 500d0
  omega = 2d0*pi*f

  I = 2d0 * sin(omega * t)

  r = sqrt(x**2 + z**2)

  theta = atan(x/z)

  curr = currentInToroidR(r, r0, y, turns, I) * sin(theta)

END FUNCTION currdens1

FUNCTION currdens2( model, n, args) RESULT(curr)
  USE DefUtils
  Use ToroidCurrents
  IMPLICIT None
  TYPE(Model_t) :: model
  INTEGER :: n
  REAL(KIND=dp) :: x, y, z, args(4), curr, f, omega, &
                   theta, r0, r, turns, I, t

  x = args(1)
  y = args(2)
  z = args(3)
  t = args(4)

  r0 = 45d-3
  turns = 100d0

  f = 500d0
  omega = 2d0*pi*f

  I = 2d0 * sin(omega * t)

  r = sqrt(x**2 + z**2)

  theta = atan(x/z)

  curr = currentInToroidY(r, r0, y, turns, I)

END FUNCTION currdens2

FUNCTION currdens3( model, n, args) RESULT(curr)
  USE DefUtils
  Use ToroidCurrents
  IMPLICIT None
  TYPE(Model_t) :: model
  INTEGER :: n
  REAL(KIND=dp) :: x, y, z, args(4), curr, f, omega, &
                   theta, r0, r, turns, I, t

  x = args(1)
  y = args(2)
  z = args(3)
  t = args(4)

  r0 = 45d-3
  turns = 100d0

  f = 500d0
  omega = 2d0*pi*f

  I = 2d0 * sin(omega * t)

  r = sqrt(x**2 + z**2)

  theta = atan(x/z)

  curr = currentInToroidR(r, r0, y, turns, I) * cos(theta)

END FUNCTION currdens3

!------------------------------------------------------------------------------
SUBROUTINE BulkAssembly( Model,Solver,dt,Transient, &
    Mass, Damp, Stiff, Force, InElement, nrow, ncol )
!------------------------------------------------------------------------------

   USE DefUtils

 
  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t) :: Solver
  LOGICAL ::  Transient
  REAL(KIND=dp) :: dt
  TYPE(Element_t):: InElement
  INTEGER :: Nrow, Ncol 
  REAL(KIND=dp) :: Stiff(:,:), Damp(:,:), Mass(:,:), Force(:)
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------

  TYPE(GaussIntegrationPoints_t) :: IntegStuff
  TYPE(Nodes_t) :: Nodes
  REAL(KIND=dp), ALLOCATABLE :: Basis(:), dBasisdx(:,:)
  REAL(KIND=dp), ALLOCATABLE :: Source(:)
  REAL(KIND=dp) :: Young, Poisson, Lame1, Lame2
  REAL(KIND=dp) :: SourceAtIP, Weight, DetJ
  INTEGER :: i,j,k,t,p,q,n, nd,dim
  LOGICAL :: Visited = .FALSE., Found
  TYPE(Element_t), POINTER :: Element
  TYPE(ValueList_t), POINTER :: Material, Params

  SAVE Visited, Source, Nodes, Basis, dBasisdx, Params

  dim = CoordinateSystemDimension()

  IF( .NOT. Visited ) THEN
     n = Solver % Mesh % MaxElementDOFs
     ALLOCATE( Source(n), Basis(n), dBasisdx(n,3) )
     CALL info('PoissonBulkAssembly','1st time')
     Params => GetSolverParams()
     Visited = .TRUE.
  END IF

  n  = GetElementNOFNodes()
  nd = GetElementNOFDOFs()
  CALL GetElementNodes( Nodes ) 
  Material => GetMaterial()  

  i = GetInteger( Params,'Block Matrix Row')
  j = GetInteger( Params,'Block Matrix Column')
  Source(1:n) = GetReal( Material,'Source',Found)

  Young   = GetCReal( Material, 'Youngs modulus', Found )
  Poisson = GetCReal( Material, 'Poisson Ratio',  Found )

  Lame1 = Young*Poisson/((1+Poisson)*(1-2*Poisson))
  Lame2 = Young/(2*(1+Poisson))

  Element => GetCurrentElement()
  IntegStuff = GaussPoints( Element )


  DO t=1,IntegStuff % n
    Found = ElementInfo( Element, Nodes, IntegStuff % u(t), &
        IntegStuff % v(t), IntegStuff % w(t), detJ, Basis, dBasisdx )

    Weight = IntegStuff % s(t) * detJ

    SourceAtIP = SUM( Basis(1:n) * Source(1:n) )

    IF ( i==j ) THEN
      STIFF(1:nd,1:nd) = STIFF(1:nd,1:nd) + &
            Weight*Lame2*MATMUL(dBasisdx,TRANSPOSE(dBasisdx))
      FORCE(1:nd) = FORCE(1:nd) + Weight * SourceAtIP * Basis(1:nd)
    END IF
    
    DO p=1,nd
      DO q=1,nd
        STIFF(p,q) = STIFF(p,q) + &
              Weight*Lame1*dBasisdx(q,j)*dBasisdx(p,i)
        STIFF(p,q) = STIFF(p,q) + &
              Weight*Lame2*dBasisdx(q,i)*dBasisdx(p,j)
      END DO
    END DO
  END DO
!------------------------------------------------------------------------------
END SUBROUTINE BulkAssembly
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
SUBROUTINE BoundaryAssembly( Model,Solver,dt,Transient, &
            Mass, Damp, Stiff, Force, InElement, nrow, ncol )
!------------------------------------------------------------------------------

  USE DefUtils
 
  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t), TARGET :: Solver
  LOGICAL ::  Transient
  REAL(KIND=dp) :: dt
  REAL(KIND=dp) :: Stiff(:,:), Damp(:,:), Mass(:,:), Force(:)
  TYPE(Element_t), TARGET :: InElement
  INTEGER :: Nrow, Ncol 
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------

  TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
  TYPE(Nodes_t) :: Nodes
  REAL(KIND=dp), ALLOCATABLE :: Flux(:), Text(:), Coeff(:)
  REAL(KIND=dp), ALLOCATABLE :: Basis(:), dBasisdx(:,:)
  REAL(KIND=dp) :: FluxAtIP, TextAtIP, CoeffAtIP, Weight, DetJ
  INTEGER :: i,j,t,p,q,n
  LOGICAL :: Visited = .FALSE., Found, Found2
  TYPE(ValueList_t), POINTER :: BC
  TYPE(Element_t), POINTER :: Element

  
  SAVE Visited, Flux, Text, Coeff, Nodes, Basis, dBasisdx


  IF( .NOT. Visited ) THEN
    N = Solver % Mesh % MaxElementNodes    
    ALLOCATE( Flux(n), Text(n), Coeff(n), Basis(n), dBasisdx(n,3), &
        Nodes % x(n), Nodes % y(n), Nodes % z(n) )     
    CALL info('PoissonBoundaryAssembly','1st time')
    Visited = .TRUE.
  END IF
  
  Element => GetCurrentElement()
  n = Nrow 
  CALL GetElementNodes( Nodes ) 
  
  BC => GetBC( )
  
  Flux(1:n) = GetReal( BC,'Flux',Found )
  Coeff(1:n) = GetReal( BC,'Coeffient',Found2 )
  IF(.NOT. (Found .OR. Found2)) RETURN
  Text(1:n) = GetReal( BC,'External',Found )


  IntegStuff = GaussPoints( Element )
  
  DO t=1,IntegStuff % n
    
    Found = ElementInfo( Element, Nodes, IntegStuff % u(t), &
        IntegStuff % v(t), IntegStuff % w(t), detJ, Basis, dBasisdx )
    
    Weight = IntegStuff % s(t) * detJ
    
    FluxAtIP = SUM( Basis(1:Nrow) * Flux(1:Nrow) )
    CoeffAtIP = SUM( Basis(1:Nrow) * Coeff(1:Nrow) )
    TextAtIP = SUM( Basis(1:Nrow) * Text(1:Nrow) )
    
    DO p=1,n
      DO q=1,n
        STIFF(p,q) = STIFF(p,q) + Weight * CoeffAtIP * &
            Basis(p)*Basis(q)
      END DO
      FORCE(p) = FORCE(p) + Weight * Basis(p) * &
          ( FluxAtIP + CoeffAtIP * TextAtIP )
    END DO
  END DO

!------------------------------------------------------------------------------
END SUBROUTINE BoundaryAssembly
!------------------------------------------------------------------------------

  FUNCTION Capacity( Model, n, t ) RESULT(f)
    USE DefUtils
    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    INTEGER :: n
    REAL(KIND=dp) :: t,f

    REAL(KIND=dp) :: x
    REAL(KIND=dp) :: Width
    LOGICAL :: Visited = .FALSE.

    SAVE Width, Visited 
    
    IF(.NOT. Visited ) THEN
      Width = ListGetConstReal( Model % Simulation,'Bandwidth Parameter' )
      PRINT *,'Bandwidth Parameter:',Width 
      Visited = .TRUE.
    END IF
    
    x = ABS( t / Width )

    IF( x > 1.0_dp ) THEN
      f = 1.0_dp
    ELSE
      f = 1.0_dp + 0.5 *(1+COS(PI*x)) / Width
    END IF

  END FUNCTION Capacity

!
! IMPORTANT NOTE: The example implementation given here is obsolete and should 
! not be considered as a model for implementing solvers based on edge finite 
! elements. For the vector Helmholtz solver see instead the solver module 
!
!   .../fem/src/modules/VectorHelmholtz.F90
!
SUBROUTINE HrotSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the vector Helmholtz equation
! 
!   -rot rot u + A u = f
!
!  using edge elements (Nedelec/Whitney basis of lowest degree).
!
!  Dirichlet b.c. is given for u.t. Robin b.c. given in the form
!
!     rot u = g - B u.t
!
!  The variariational form discretized by the fem is precisely
!
!   (rot u, rot v) + (A u, v) + <B u.t, v.t> = (f, v) + <g, v.t> 
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Found
  TYPE(Element_t),POINTER :: Element, Edge, Parent
  TYPE(Nodes_t) :: Nodes, EdgeNodes
  TYPE(ValueList_t), POINTER :: BodyForce, Material, BC
  TYPE(Variable_t), POINTER :: Var

  REAL(KIND=dp) :: Norm, Normal(3), Normal2(3), &
       u, v, w, NormalSign, Edgeh

  INTEGER :: n, nb, nd, t, istat, i, j, k, l, active

  REAL(KIND=dp),    ALLOCATABLE :: LOAD(:,:), Acoef(:,:), Bcoef(:,:)
  COMPLEX(KIND=dp), ALLOCATABLE :: STIFF(:,:), MASS(:,:), FORCE(:)

  TYPE(Mesh_t), POINTER :: Mesh
  LOGICAL :: stat, EigenAnalysis

  SAVE STIFF, LOAD, MASS, FORCE, Acoef, Bcoef, &
       AllocationsDone, Nodes, EdgeNodes
!------------------------------------------------------------------------------

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  Mesh => GetMesh()

  IF ( .NOT. AllocationsDone ) THEN
     N = Mesh % MaxElementDOFs  ! just big enough
     ALLOCATE( FORCE(2*N), LOAD(2,N), STIFF(2*N,2*N), &
          MASS(2*N,2*N), Acoef(2,N), Bcoef(2,N), STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'PoissonSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF
  
  Solver % Matrix % Complex = .TRUE.
  EigenAnalysis = GetLogical( GetSolverParams(), 'Eigen Analysis' )
  
  !System assembly:
  !----------------
  active = GetNOFActive()
  CALL DefaultInitialize()
  DO t=1,active
     Element => GetActiveElement(t)
     n  = GetElementNOFNodes() ! kulmat
     nd = GetElementNOFDOFs()  ! vapausasteet

     LOAD = 0.0d0
     BodyForce => GetBodyForce()
     IF ( ASSOCIATED(BodyForce) ) THEN
        Load(1,1:n) = GetReal( BodyForce, 'f 1', Found )
        Load(2,1:n) = GetReal( BodyForce, 'f 2', Found )
     END IF

     Acoef = 0.0d0
     Material => GetMaterial( Element )
     IF ( ASSOCIATED(material) ) THEN
        Acoef(1,1:n) = GetReal( Material, 'A 1', Found )
        Acoef(2,1:n) = GetReal( Material, 'A 2', Found )
     END IF

     !Get element local matrix and rhs vector:
     !----------------------------------------
     CALL LocalMatrix(  STIFF, MASS, FORCE, LOAD, Acoef, Element, n, nd )

     !Update global matrix and rhs vector from local matrix & vector:
     !---------------------------------------------------------------
     CALL DefaultUpdateEquations( STIFF, FORCE )
     IF ( EigenAnalysis ) CALL DefaultUpdateMass( MASS )
  END DO

!------------------------------------------------------------------------------
!
!  Neumann & Newton BCs:
!  ---------------------
   Var => Solver % Variable

   DO t=1, Mesh % NumberOfBoundaryElements
      Element => GetBoundaryElement(t)
      IF ( GetElementFamily() == 1 .OR. .NOT.ActiveBoundaryElement() ) CYCLE
      
      BC => GetBC(Element)
      IF ( .NOT. ASSOCIATED(BC) ) CYCLE
         
      n = GetElementNOFNodes(Element)
      
      Load(1,1:n) = GetReal( BC, 'g 1', Found )
      Load(2,1:n) = GetReal( BC, 'g 2', Found )
      
      Bcoef(1,1:n) = GetReal( BC, 'B 1', Found )
      Bcoef(2,1:n) = GetReal( BC, 'B 2', Found )
         
!     The boundary integral terms are computed for the parent element:
!     ----------------------------------------------------------------
      Parent => Element % BoundaryInfo % Left
      IF ( .NOT. ASSOCIATED( Parent ) ) THEN
         Parent => Element % BoundaryInfo % Right
      END IF
      IF ( .NOT. ASSOCIATED( Parent ) ) CYCLE

      STIFF = 0.0d0
      FORCE = 0.0d0
      DO j=1,Parent % Type % NumberOfEdges
         Edge => Mesh % Edges( Parent % EdgeIndexes(j) )

         n = 0
         DO k=1,Element % Type % NumberOfNodes
            DO l=1,Edge % Type % NumberOfNodes
               IF ( Edge % NodeIndexes(l) == Element % NodeIndexes(k) ) n = n + 1
            END DO
         END DO

         IF ( n == Edge % Type % NumberOfNodes ) THEN
            Edgeh = (Model % Mesh % Nodes % x(Edge % NodeIndexes(2)) &
                    -Model % Mesh % Nodes % x(Edge % NodeIndexes(1)))**2 &
                   +(Model % Mesh % Nodes % y(Edge % NodeIndexes(2)) &
                    -Model % Mesh % Nodes % y(Edge % NodeIndexes(1)))**2 
            Edgeh = SQRT( Edgeh )

            FORCE(j) = DCMPLX( SUM( Load(1,1:2))/2.0d0, &
                              SUM( Load(2,1:2))/2.0d0 )
            
            STIFF(j,j) =  DCMPLX( SUM(Bcoef(1,1:2))/2.0d0 / Edgeh, &
                                 SUM(Bcoef(2,1:2))/2.0d0 / Edgeh )
         END IF
      END DO
      CALL DefaultUpdateEquations( STIFF, FORCE, Parent )
   END DO

!------------------------------------------------------------------------------
   CALL DefaultFinishAssembly()
   CALL MyDirichletBCs()

   ! And finally, solve:
   !--------------------
   Norm = DefaultSolve()

!*****************************************************************************
   CALL WriteResults
!*****************************************************************************

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, MASS, FORCE, LOAD, Acoef, Element, n, nd )
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: LOAD(:,:), Acoef(:,:)
    COMPLEX(KIND=dp) :: STIFF(:,:), FORCE(:), MASS(:,:)
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),DetJ,L1,L2
    REAL(KIND=dp) :: WhitneyBasis(3,2), RotWhitneyBasis(3), A1, A2
    LOGICAL :: Stat
    INTEGER :: t, i, j, k
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )


    STIFF = 0.0d0
    FORCE = 0.0d0
    MASS = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )

    DO t=1,IP % n
!      Haetaan ensin normaalit solmukantafunktiot:
!      -------------------------------------------
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t),  detJ, Basis, dBasisdx )

       L1 = SUM( Basis(1:n) * LOAD(1,1:n) )
       L2 = SUM( Basis(1:n) * LOAD(2,1:n) )

       A1 = SUM( Basis(1:n) * Acoef(1,1:n) )
       A2 = SUM( Basis(1:n) * Acoef(2,1:n) )

!      Haetaan Raviart-Thomas kantafunktiot:
!      -------------------------------------
       CALL EdgeBasis( WhitneyBasis, RotWhitneyBasis, &
            IP % u(t), IP % v(t), IP % w(t), Element, n )

!      Compute element stiffness matrix and force vector:
!      ---------------------------------------------------
       DO i = 1,3
         FORCE(i) = FORCE(i) + (L1*WhitneyBasis(i,1) + L2*WhitneyBasis(i,2)) * detJ * IP % s(t)
         DO j = 1,3
           STIFF(i,j) = STIFF(i,j) + RotWhitneyBasis(i) * RotWhitneyBasis(j) * detJ * IP % s(t)
           STIFF(i,j) = STIFF(i,j) &
                + DCMPLX( A1, A2 ) * SUM(WhitneyBasis(i,:)*WhitneyBasis(j,:)) * detJ * IP % s(t)
           MASS(i,j) = MASS(i,j) +  SUM(WhitneyBasis(i,:)*WhitneyBasis(j,:)) * detJ * IP % s(t)
         END DO
       END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------

  SUBROUTINE WriteResults
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: u, v, w, Ratkaisu(2), Ratkaisu2(2), WhitneyBasis(3,2), &
         RotWhitneyBasis(3), Edgeh, Rot, Rot2

    INTEGER :: Active, Indexes(6)

    OPEN(unit=10, file='ratkaisu.ep')

   Active = GetNOFActive()
   t = Active * 3 ! nurkkasolmujen lukumäärä

   write(10,'(4i10,A)') t, Active, 8, 1, &
        ' vector: ReU vector: ImU scalar: ReRotU scalar: ImRotU'

!  Kirjoitetaan solmukoordinaatit:
!  -------------------------------
   Active = GetNOFActive()
   DO i = 1, Active
      Element => GetActiveElement(i)
      DO j = 1,3
         k = Element % NodeIndexes(j)
         write(10,*) Model % Mesh % Nodes % x(k), &
              Model % Mesh % Nodes % y(k), Model % Mesh % Nodes % z(k)
      END DO
   END DO

!  Kirjoitetaan elementit:
!  -----------------------
   WRITE(10,'(a)') '#group all'
   DO i = 1, Active
      Element => GetActiveElement(i)
      WRITE(10,*) 'body1   303', 3*(i-1)+0,3*(i-1)+1,3*(i-1)+2
   END DO
   WRITE(10,'(a)') '#endgroup all'

!  Kirjoitetaan tulokset:
!  ----------------------
   Var => VariableGet( Model % Variables, 'tangent component' )

   WRITE(10,'(a)') '#time 1   1  1  1.0'
   DO i = 1, Active

      Element => GetActiveElement(i)

!     Luuppi nurkkapisteiden yli:
!     ---------------------------
      w = 0.0d0
      DO j = 1,3

         ! Nurkan koordinaatit:
         ! --------------------
         SELECT CASE(j)
         CASE(1)
            u = 0.0d0
            v = 0.0d0
         CASE(2)
            u = 1.0d0
            v = 0.0d0
         CASE(3)
            u = 0.0d0
            v = 1.0d0
         END SELECT

         ! Kantafunktioiden arvot nurkkapisteessä:
         ! ---------------------------------------
         CALL EdgeBasis( WhitneyBasis, RotWhitneyBasis, u, v, w, Element, n )
         k = GetElementDOFs( Indexes )

         ratkaisu = 0.0d0
         ratkaisu2 = 0.0d0
         Rot = 0.0d0
         Rot2 = 0.0d0
         DO k = 1,3
           ratkaisu(1) = ratkaisu(1) + WhitneyBasis(k,1) * Var % Values(2*Var % Perm( Indexes(k))-1)
           ratkaisu(2) = ratkaisu(2) + WhitneyBasis(k,2) * Var % Values(2*Var % Perm( Indexes(k))-1)

           ratkaisu2(1) = ratkaisu2(1) + WhitneyBasis(k,1) * Var % Values(2*Var % Perm( Indexes(k)))
           ratkaisu2(2) = ratkaisu2(2) + WhitneyBasis(k,2) * Var % Values(2*Var % Perm( Indexes(k)))
            
           Rot = Rot + RotWhitneyBasis(k) * Var % Values(2*Var % Perm(Indexes(k))-1 )
           Rot2 = Rot2 + RotWhitneyBasis(k) * Var % Values(2*Var % Perm(Indexes(k)) )
         END DO
         WRITE(10,'(6E20.10)') Ratkaisu(1), Ratkaisu(2), 0.0, Ratkaisu2(1), Ratkaisu2(2), 0.0, Rot, Rot2
      END DO
   END DO

   CLOSE(10)
!------------------------------------------------------------------------
 END SUBROUTINE WriteResults
!------------------------------------------------------------------------


!------------------------------------------------------------------------
 SUBROUTINE MyDirichletBCs( USolver )
!------------------------------------------------------------------------
     TYPE(Solver_t), OPTIONAL, TARGET :: USolver

     TYPE(Matrix_t), POINTER   :: A
     TYPE(Variable_t), POINTER :: x
     TYPE(Solver_t), POINTER :: Solver
     REAL(KIND=dp), POINTER    :: b(:)
     INTEGER :: i,j, k, l, n, nb, DOF
     REAL(KIND=dp) :: xx
     LOGICAL :: Flag,Found
     TYPE(ValueList_t), POINTER :: BC
     TYPE(Element_t), POINTER :: Element, Parent, Edge, Face, SaveElement

     CHARACTER(LEN=MAX_NAME_LEN) :: name

!    For 2d elements:
!    ----------------
     REAL(KIND=dp) :: BoundaryData(2), Edgeh

     IF ( PRESENT( USolver ) ) THEN
        Solver => USolver
     ELSE
        Solver => Model % Solver
     END IF

     A => Solver % Matrix
     x => Solver % Variable
     b => A % RHS

     DO DOF=1,x % DOFs
        name = x % name
        IF ( x % DOFs > 1 ) name = ComponentName(name,DOF)
        CALL SetDirichletBoundaries( Model, A, b, Name, DOF, x % DOFs, x % Perm )

        SaveElement => Model % CurrentElement

!       Dirichlet BCs for face & edge DOFs:
!       -----------------------------------
        DO i=1,Mesh % NumberOfBoundaryElements

           Element => GetBoundaryElement(i)
           IF ( .NOT. ActiveBoundaryElement() ) CYCLE

           BC => GetBC()
           IF ( .NOT. ASSOCIATED( BC ) ) CYCLE
           IF ( .NOT. ListCheckPresent( BC, TRIM(Name) ) ) CYCLE

           BoundaryData(1:2) = GetReal( BC, TRIM(name), Found )

           Parent => Element % BoundaryInfo % Left
           IF ( .NOT. ASSOCIATED( Parent ) ) THEN
               Parent => Element % BoundaryInfo % Right
           END IF
           IF ( .NOT. ASSOCIATED( Parent ) ) CYCLE

           IF ( ASSOCIATED( Mesh % Edges ) ) THEN
              DO j=1,Parent % Type % NumberOfEdges
                 Edge => Mesh % Edges( Parent % EdgeIndexes(j) )

                 Edgeh = (Model % Mesh % Nodes % x(Edge % NodeIndexes(2)) &
                         -Model % Mesh % Nodes % x(Edge % NodeIndexes(1)))**2 &
                        +(Model % Mesh % Nodes % y(Edge % NodeIndexes(2)) &
                         -Model % Mesh % Nodes % y(Edge % NodeIndexes(1)))**2 
                 Edgeh = SQRT( Edgeh )

                 n = 0
                 DO k=1,Element % Type % NumberOfNodes
                    DO l=1,Edge % Type % NumberOfNodes
                       IF ( Edge % NodeIndexes(l) == Element % NodeIndexes(k) ) n = n + 1
                    END DO
                 END DO

                 IF ( n == Edge % Type % NumberOfNodes ) THEN

                    DO k=1,Edge % BDOFs

                       n = Mesh % NumberofNodes + &
                           (Parent % EdgeIndexes(j)-1) * Mesh % MaxEdgeDOFs + k

                       n = x % Perm( n )
                       IF ( n <= 0 ) CYCLE

                          DO l=1,x % DOFs
                          nb = x % DOFs * (n-1) + l
                          CALL CRS_ZeroRow( A, nb )

!                         Check if this could be done any better:
!                         ---------------------------------------
                          IF( l == 1 .AND. TRIM(name) == 'tangent component 1' ) THEN
                             IF( Edge % NodeIndexes(2) > Edge % NodeIndexes(1) ) THEN
                                A % RHS(nb) = +SUM( BoundaryData(1:2) ) / 2.0d0 * Edgeh
                             ELSE
                                A % RHS(nb) = -SUM( BoundaryData(1:2) ) / 2.0d0 * Edgeh
                             END IF
                          END IF

                          IF( l == 2 .AND. TRIM(name) == 'tangent component 2' ) THEN
                             IF( Edge % NodeIndexes(2) > Edge % NodeIndexes(1) ) THEN
                                A % RHS(nb) = +SUM( BoundaryData(1:2) ) / 2.0d0 * Edgeh
                             ELSE
                                A % RHS(nb) = -SUM( BoundaryData(1:2) ) / 2.0d0 * Edgeh
                             END IF
                          END IF

                          A % Values( A % Diag(nb) ) = 1.0d0
                       END DO
                    END DO
                 END IF
              END DO
           END IF

           IF ( ASSOCIATED( Mesh % Faces ) ) THEN
              DO j=1,Parent % Type % NumberOfFaces
                 Face => Mesh % Faces( Parent % FaceIndexes(j) )
                 n = 0
                 DO k=1,Element % Type % NumberOfNodes
                    DO l=1,Face % Type % NumberOfNodes
                       IF ( Face % NodeIndexes(l) == Element % NodeIndexes(k) ) n = n + 1
                    END DO
                 END DO

                 IF ( n == Face % Type % NumberOfNodes ) THEN
                    DO k=1,Face % BDOFs
                       n = Mesh % Numberofnodes +  &
                         Mesh % MaxEdgeDOFs * Mesh % NumberOfEdges + &
                            Mesh % MaxFaceDOFs * (Parent % FaceIndexes(j)-1) + k

                       n = x % Perm( n )
                       IF ( n <= 0 ) CYCLE
                       DO l=1,x % DOFs
                          nb = x % DOFs * (n-1) + l
                          CALL CRS_ZeroRow( A, nb )
                          A % RHS(nb) = 0.0d0
                          A % Values( A % Diag(nb) ) = 1.0d0
                       END DO
                    END DO
                    EXIT
                 END IF
              END DO
           END IF
        END DO
        Model % CurrentElement => SaveElement
     END DO
!------------------------------------------------------------------------
   END SUBROUTINE MyDirichletBCs
!------------------------------------------------------------------------


!------------------------------------------------------------------------
   SUBROUTINE EdgeBasis( WhitneyBasis, RotWhitneyBasis, u, v, w, Element, n )
!------------------------------------------------------------------------
     REAL(KIND=dp) :: WhitneyBasis(:,:), RotWhitneyBasis(:), u, v, w
     TYPE(Element_t) :: Element

     INTEGER :: n
!------------------------------------------------------------------------
     TYPE(Nodes_t) :: Nodes
     SAVE Nodes

     REAL(KIND=dp) :: detJ, Basis(3), dBasisdx(3,3)
     LOGICAL :: stat
!------------------------------------------------------------------------
     CALL GetElementNodes( Nodes )
     
     stat = ElementInfo( Element, Nodes, u, v, w, &
          detJ, Basis, dBasisdx )

     WhitneyBasis(1,1) = Basis(1) * dBasisdx(2,1) - Basis(2) * dBasisdx(1,1)
     WhitneyBasis(1,2) = Basis(1) * dBasisdx(2,2) - Basis(2) * dBasisdx(1,2)
     WhitneyBasis(2,1) = Basis(2) * dBasisdx(3,1) - Basis(3) * dBasisdx(2,1)
     WhitneyBasis(2,2) = Basis(2) * dBasisdx(3,2) - Basis(3) * dBasisdx(2,2)
     WhitneyBasis(3,1) = Basis(3) * dBasisdx(1,1) - Basis(1) * dBasisdx(3,1)
     WhitneyBasis(3,2) = Basis(3) * dBasisdx(1,2) - Basis(1) * dBasisdx(3,2)

     RotWhitneyBasis(1) = 2.0d0 * ( dBasisdx(1,2) * dBasisdx(2,1) - dBasisdx(2,2) * dBasisdx(1,1) )
     RotWhitneyBasis(2) = 2.0d0 * ( dBasisdx(2,2) * dBasisdx(3,1) - dBasisdx(3,2) * dBasisdx(2,1) )
     RotWhitneyBasis(3) = 2.0d0 * ( dBasisdx(3,2) * dBasisdx(1,1) - dBasisdx(1,2) * dBasisdx(3,1) )

     IF( Element % NodeIndexes(2) < Element % NodeIndexes(1) ) THEN
        WhitneyBasis(1,:)  = -WhitneyBasis(1,:)
        RotWhitneyBasis(1) = -RotWhitneyBasis(1)
     END IF
     
     IF( Element % NodeIndexes(3) < Element % NodeIndexes(2) ) THEN
        WhitneyBasis(2,:)  = -WhitneyBasis(2,:)
        RotWhitneyBasis(2) = -RotWhitneyBasis(2)
     END IF
     
     IF( Element % NodeIndexes(1) < Element % NodeIndexes(3) ) THEN
        WhitneyBasis(3,:)  = -WhitneyBasis(3,:)
        RotWhitneyBasis(3) = -RotWhitneyBasis(3)
     END IF
!------------------------------------------------------------------------------
   END SUBROUTINE EdgeBasis
!------------------------------------------------------------------------------
 END SUBROUTINE HrotSolver
!------------------------------------------------------------------------------

!-----------------------------------------------------------------------------
!> A prototype solver for advection-diffusion-reaction equation,
!> This equation is generic and intended for education purposes
!> but may also serve as a starting point for more complex solvers.
!------------------------------------------------------------------------------
SUBROUTINE CalculateFraction( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Variable_t), POINTER :: VarTot, VarB
  REAL(KIND=dp) :: MinW, MaxW, SumTot, SumB, SumF
  INTEGER :: i, zerocount
  !------------------------------------------------------------------------------

  VarTot => VariableGet( Solver % Mesh % Variables,'Particle Weight')
  VarB => VariableGet( Solver % Mesh % Variables,'Particle Weight B')

  MinW = MINVAL( VarTot % Values )
  MaxW = MAXVAL( VarTot % Values )
  SumTot = SUM( VarTot % Values )
  SumB = SUM( VarB % Values ) 

  PRINT *,'Calculate Fraction'
  PRINT *,'Min and max weight:',minw, maxw
  IF( minw > EPSILON( minw ) ) THEN
    PRINT *,'Ratio of max and min w:',maxw / minw
  END IF
  PRINT *,'Ratio of b and tot w:',SumB / SumTot

  zerocount = 0
  DO i = 1, SIZE( VarTot % Values )
    IF( VarTot % Values(i) < EPSILON( MinW ) ) THEN
      Solver % Variable % Values(i) = -1.0_dp
      zerocount = zerocount + 1
    ELSE  
      Solver % Variable % Values(i) = VarB % Values(i) / VarTot % Values(i)
    END IF
  END DO
  Solver % Variable % Norm = 1.0_dp

  SumF = SUM( Solver % Variable % Values )
  PRINT *,'Sum of fraction:',Sumf
  PRINT *,'Undetermined nodes:',zerocount
  
END SUBROUTINE CalculateFraction

!-------------------------------------------------------------
! Gives the upper limit as determined by a sphere in a fixed
! position: R^2=x^2+y^2+(z-H)^2.
!-------------------------------------------------------------
  FUNCTION SphereBottom( Model, n, t ) RESULT(f)
    USE DefUtils
    IMPLICIT NONE

    TYPE(Model_t) :: Model
    INTEGER :: n
    REAL(KIND=dp) :: t,f
!-------------------------------------------------------------
    REAL(KIND=dp) :: x,y,z,R,Disc,H

    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    
    z = Model % Nodes % z(n)
    R = 3.0_dp
    
    R = ListGetCReal( Model % Simulation,'Sphere Radius')
    H = ListGetCReal( Model % Simulation,'Sphere Z')

    Disc = R**2 - x**2 - y**2
    IF( Disc < 0 ) THEN
      f = HUGE(f)
    ELSE
      f = H - SQRT(Disc)
!      PRINT *,'Contact:',x,y,z,H,f
    END IF

  END FUNCTION SphereBottom
!-------------------------------------------------------------

FUNCTION Source( Model, n, f ) RESULT(h)
   USE Lists
   TYPE(Model_t) :: Model
   INTEGER :: n
   REAL(KIND=dp) :: g, f, h, x, s, Time, OldTime = 0

   INTEGER :: i, Case = 1
   TYPE(Variable_t), POINTER :: T, P

    T => VariableGet( Model % Variables, 'Time' )
    Time = T % Values(1)
    P => VariableGet( Model % Variables, 'Potential' )

!   First check the previous result
!   -------------------------------
    IF ( Time > OldTime + 1 + 1.0d-8 ) THEN
       OldTime = FLOOR( Time )
       x = Model % Nodes % x(1)
       s = P % Values( P % Perm(1) )
       SELECT CASE(Case)
          CASE(1) ! can we parabola
              IF ( ABS(f-0.5d0) > 1.0d-3 ) &
                CALL Fatal( 'Source', 'Not able to integrate parabola?' )
              Model % Solver % Matrix % Force = 0.0d0
              P % Values = 0.0d0
              P % PrevValues(:,:) = 0.0d0
          CASE(2) ! how about third degree polynomial?
              IF ( ABS(s-1.0d0/6.0d0) > 1.0d-3 ) &
                CALL Fatal( 'Source', 'Not able 3rd deg polynomial ?' )
              Model % Solver % Matrix % Force = 0.0d0
              P % Values = 1.0d0
              P % PrevValues(:,:) = 1.0d0
          CASE(3) ! how about an exponential
             IF ( ABS(s-EXP(1.0d0)) > 1.0d-3 ) &
                CALL Fatal( 'Source', 'Not able to integrate sine?' )
              Model % Solver % Matrix % Force = 0.0d0
              P % Values = 0.0d0
              P % PrevValues(:,:) = 0.0d0
       END SELECT
       Case = Case + 1
    END IF

    g = P % Values( P % Perm(n) )

    Time = Time - FLOOR(Time)
    IF ( ABS(Time) < 1.0d-8 ) Time = 1

!   Then define new one
!   -------------------
    SELECT CASE(Case)
       CASE(1) ! how about a  parabola ?
          h = 1
       CASE(2) ! how about a third degree polynomial
          h = Time
       CASE(3) ! how about an exponential
          h = g
       CASE(4) 
          h = 0.0d0
    END SELECT
END FUNCTION Source

FUNCTION SourceFun(Model, n, t) RESULT(f)
  USE DefUtils
  IMPLICIT None
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t, f

  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp) :: xq, yq, zq

  Mesh => Model % Mesh

  xq = Mesh % Nodes % x(n)
  yq = Mesh % Nodes % y(n)
  zq = Mesh % Nodes % z(n)

  f = 32.0d0 * ( yq-yq**2 + xq-xq**2 )

END FUNCTION SourceFun

!/*****************************************************************************/
! *
! *  Elmer, A Finite Element Software for Multiphysical Problems
! *
! *  Copyright 1st April 1995 - , CSC - IT Center for Science Ltd., Finland
! * 
! *  This program is free software; you can redistribute it and/or
! *  modify it under the terms of the GNU General Public License
! *  as published by the Free Software Foundation; either version 2
! *  of the License, or (at your option) any later version.
! * 
! *  This program is distributed in the hope that it will be useful,
! *  but WITHOUT ANY WARRANTY; without even the implied warranty of
! *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! *  GNU General Public License for more details.
! *
! *  You should have received a copy of the GNU General Public License
! *  along with this program (in file fem/GPL-2); if not, write to the 
! *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
! *  Boston, MA 02110-1301, USA.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! *  Authors: Mika Malinen
! *  Web:     http://www.csc.fi/elmer
! *  Address: CSC - IT Center for Science Ltd.
! *           Keilaranta 14
! *           02101 Espoo, Finland 
! *
! *  Original Date: Oct 12, 2015
! *
! *****************************************************************************/

!------------------------------------------------------------------------------
SUBROUTINE BestApproximationSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!
!  Solve the best approximation of the vector field
! 
!              U = (1,1,1), or              (Test Mode = Integer 1)   
!              U = (1+z-y,1-z+x,1-x+y), or  (Test Mode = Integer 2)
!              U = (0,0,-1/2(yx^2+xy^2))    (Test Mode = Integer 3)
!              U = (xy^2,x^2y,0) in 2D      (Test Mode = Integer 4)   
!              U = (-xy^2,x^2y,0) in 2D     (Test Mode = Integer 5)
!
!  with respect to the L2 norm (the default) or an energy norm using 
!  H(curl)-conforming basis functions. Here the energy norm corresponds to 
!  the operator I + MatPar * curl curl, with MatPar a scalar field specified
!  by the user. Additionally, compute the relative error of the solution or 
!  of the curl field using the L2 norm. This solver can thus be used for checking 
!  that the convergence rate is correct.
!
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Found
  TYPE(Element_t), POINTER :: Element
  TYPE(Nodes_t) :: Nodes
  TYPE(ValueList_t), POINTER :: BodyForce, Material, BC
  TYPE(Variable_t), POINTER :: Var

  REAL(KIND=dp) :: Norm, u, v, w, Err, EK, SolNorm, MatPar = 0.0d0

  INTEGER :: n, ne, nf, nb, np, nd, t, istat, i, j, k, l, active, dim, TestMode
  INTEGER :: ElementOrder

  REAL(KIND=dp), ALLOCATABLE :: LOAD(:,:), Acoef(:)
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), FORCE(:)

  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(Matrix_t), POINTER :: A

  LOGICAL :: stat, PiolaVersion, SecondFamily, ErrorEstimation
  LOGICAL :: UseCurlNorm

  INTEGER, ALLOCATABLE :: Indices(:)

  SAVE STIFF, LOAD, FORCE, Acoef, AllocationsDone, Nodes, Indices
!------------------------------------------------------------------------------
  PiolaVersion = GetLogical( GetSolverParams(), 'Optimal Family', Found)
  ElementOrder = 1
  IF ( GetLogical(GetSolverParams(), 'Quadratic Approximation', Found) ) THEN
    ElementOrder = 2
    PiolaVersion = .TRUE.
  END IF
  SecondFamily = GetLogical( GetSolverParams(), 'Second Kind Basis', Found)

  ErrorEstimation = GetLogical( GetSolverParams(), 'Error Computation', Found)
  IF (.NOT. Found) ErrorEstimation = .TRUE.

  UseCurlNorm = GetLogical( GetSolverParams(), 'Compute Curl Error', Found)

  TestMode = ListGetInteger( GetSolverParams(), 'Test Mode', Found)
  IF (.NOT. Found) TestMode = 2

  dim = CoordinateSystemDimension()

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  Mesh => GetMesh()

  IF ( .NOT. AllocationsDone ) THEN
    N = Mesh % MaxElementDOFs  ! just big enough
    ALLOCATE( FORCE(N), LOAD(6,N), STIFF(N,N), &
        Indices(N), Acoef(N), STAT=istat )
    IF ( istat /= 0 ) THEN
      CALL Fatal( 'BestApproximationSolver', 'Memory allocation error.' )
    END IF
    AllocationsDone = .TRUE.
  END IF
  
  Solver % Matrix % COMPLEX = .FALSE.
  A => GetMatrix()

  !-----------------------
  ! System assembly:
  !----------------------
  active = GetNOFActive()
  CALL DefaultInitialize()

  DO t=1,active
    Element => GetActiveElement(t)
    n  = GetElementNOFNodes() ! The number of nodes corresponding to the background mesh
    nd = GetElementNOFDOFs()
    nb = GetElementNOFBDOFs()

    Acoef(1:n) = 0.0d0
    Material => GetMaterial( Element )
    IF ( ASSOCIATED(Material) ) THEN
      Acoef(1:n) = GetReal( Material, 'Material Param', Found )
      IF (.NOT. Found) Acoef(1:n) = 0.0d0
    END IF

    !Get element local matrix and rhs vector:
    !----------------------------------------
    CALL LocalMatrix( STIFF, FORCE, Acoef, Element, n, nd+nb, dim)

    !Update global matrix and rhs vector from local matrix & vector:
    !---------------------------------------------------------------
    CALL DefaultUpdateEquations( STIFF, FORCE )

  END DO

  CALL DefaultFinishBulkAssembly()
  CALL DefaultFinishAssembly()

  CALL DefaultDirichletBCs()

  Norm = DefaultSolve()  

  !-------------------------------------------------------------------
  ! Compute the norm of the error
  !--------------------------------------------------------------------
  IF (ErrorEstimation) THEN
    Err = 0.0d0
    SolNorm = 0.0d0
    DO t=1,Solver % NumberOfActiveElements
      Element => GetActiveElement(t)
      n  = GetElementNOFNodes()
      nd = GetElementDOFs( Indices )

      Load(1,1:nd) = Solver % Variable % Values( Solver % Variable % &
          Perm(Indices(1:nd)) )

      CALL ComputeApproximationError(Load, Element, n, nd, dim, Err, SolNorm, UseCurlNorm)
    END DO

    WRITE (*, '(A,E16.8)') 'Error Norm = ', SQRT(ParallelReduction(Err))/SQRT(ParallelReduction(SolNorm))
  END IF

CONTAINS


!---------------------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, NodalMatPar, Element, n, nd, dim)
!---------------------------------------------------------------------------------------------
    REAL(KIND=dp) :: STIFF(:,:), FORCE(:), NodalMatPar(:)
    TYPE(Element_t), POINTER :: Element
    INTEGER :: n, nd, dim
    !------------------------------------------------------------------------------
    REAL(KIND=dp) :: MatPar
    REAL(KIND=dp) :: EBasis(nd,3), CurlEBasis(nd,3), F(3,3), G(3,3)
    REAL(KIND=dp) :: dBasisdx(n,3)
    REAL(KIND=dp) :: Basis(n), DetJ, xq, yq, zq, uq, vq, wq, sq
    LOGICAL :: Stat, Found
    INTEGER :: t, i, j, p, q, np

    TYPE(GaussIntegrationPoints_t) :: IP
    TYPE(Nodes_t), SAVE :: Nodes
    !------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )

    STIFF = 0.0d0
    FORCE = 0.0d0

    !-------------------------------------
    ! Numerical integration over element:
    !-------------------------------------
    IP = GaussPoints(Element, EdgeBasis=.TRUE., PReferenceElement=PiolaVersion, &
         EdgeBasisDegree=ElementOrder)    
    
    np = 0  ! Set np = n, if nodal dofs are employed; otherwise set np = 0

    DO t=1,IP % n
      IF (PiolaVersion) THEN
        stat = EdgeElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), detF=detJ, Basis=Basis, EdgeBasis=EBasis, &
            RotBasis=CurlEBasis, ApplyPiolaTransform = .TRUE., &
            SecondFamily=SecondFamily, BasisDegree = ElementOrder)
      ELSE
        stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), detJ, Basis, dBasisdx )
        CALL GetEdgeBasis(Element, EBasis, CurlEBasis, Basis, dBasisdx)
      END IF

      xq = SUM( Nodes % x(1:n) * Basis(1:n) )
      yq = SUM( Nodes % y(1:n) * Basis(1:n) )
      zq = SUM( Nodes % z(1:n) * Basis(1:n) )

      MatPar = SUM( NodalMatPar(1:n) * Basis(1:n) )

      !----------------------------------------------------------------
      ! The following branch could be used to produce the 
      ! Galerkin projection of a solution component for visualization.
      !------------------------------------------------------------------
      IF (np > 0) THEN
        DO p = 1,n
          DO q = 1,n       
            STIFF(p,q) = STIFF(p,q) + Basis(p) * Basis(q) * detJ * IP % s(t)    
          END DO

          DO q = 1,nd-np
            j = np + q
            STIFF(p,j) = STIFF(p,j) - EBasis(q,3) * Basis(p) * detJ * IP % s(t)
          END DO
        END DO
      END IF

      !--------------------------------------------------------------
      ! The equations for H(curl)-conforming part...
      !---------------------------------------------------------------
      DO p = 1,nd-np
        !----------------------------
        ! The inner product (u,v)_E
        !----------------------------
        i = np + p
        DO q = 1,nd-np
          j = np + q
          STIFF(i,j) = STIFF(i,j) + 1.0d0 * &
              SUM( EBasis(q,1:dim) * EBasis(p,1:dim) ) * detJ * IP % s(t) + &
              MatPar * SUM( CurlEBasis(q,1:dim) * CurlEBasis(p,1:dim) ) * detJ * IP % s(t)
        END DO

        !----------------------------------------
        ! RHS corresponding to the exact solution 
        !----------------------------------------
        SELECT CASE(TestMode)
        CASE (1)
          FORCE(i) = FORCE(i) +  (1.0d0) * EBasis(p,1) * detJ * IP % s(t) + &
              (1.0d0)* EBasis(p,2) * detJ * IP % s(t) + &
              (1.0d0) * EBasis(p,3) * detJ * IP % s(t)
        CASE (2)
          FORCE(i) = FORCE(i) +  (1.0d0+zq-yq) * EBasis(p,1) * detJ * IP % s(t) + &
              (1.0d0+xq-zq)* EBasis(p,2) * detJ * IP % s(t) + &
              (1.0d0-xq+yq) * EBasis(p,3) * detJ * IP % s(t) + &
              MatPar * (2.0d0) * CurlEBasis(p,1) * detJ * IP % s(t) + &
              MatPar * (2.0d0) * CurlEBasis(p,2) * detJ * IP % s(t) + &
              MatPar * (2.0d0) * CurlEBasis(p,3) * detJ * IP % s(t)
        CASE (3)
          FORCE(i) = FORCE(i) +  (0.0d0) * EBasis(p,1) * detJ * IP % s(t) + &
              (0.0d0)* EBasis(p,2) * detJ * IP % s(t) - &
              0.5d0*(yq*xq**2+xq*yq**2) * EBasis(p,3) * detJ * IP % s(t) + &
              MatPar * (-0.5d0*xq**2 - yq*xq) * CurlEBasis(p,1) * detJ * IP % s(t) + &
              MatPar * (0.5d0*yq**2 + yq*xq) * CurlEBasis(p,2) * detJ * IP % s(t) + &
              MatPar * (0.0d0) * CurlEBasis(p,3) * detJ * IP % s(t)
        CASE(4)
          FORCE(i) = FORCE(i) +  (xq*yq**2) * EBasis(p,1) * detJ * IP % s(t) + &
              (yq*xq**2)* EBasis(p,2) * detJ * IP % s(t)
        CASE(5)
          FORCE(i) = FORCE(i) +  (-xq*yq**2) * EBasis(p,1) * detJ * IP % s(t) + &
              (yq*xq**2)* EBasis(p,2) * detJ * IP % s(t)
 
        END SELECT
      END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------



!----------------------------------------------------------------------------------
  SUBROUTINE ComputeApproximationError(LOAD, Element, n, nd, dim, EK, SolNorm, UseCurlNorm)
!----------------------------------------------------------------------------------
    REAL(KIND=dp) :: Load(:,:), EK, SolNorm
    TYPE(Element_t), POINTER :: Element    
    INTEGER :: n, nd, dim
    LOGICAL :: UseCurlNorm
!--------------------------------------------------------------------------------
    REAL(KIND=dp) :: EBasis(nd,3), CurlEBasis(nd,3)
    REAL(KIND=dp) :: Basis(n), DetJ, xq, yq, zq, uq, vq, wq, sq, &
         u(3), rotu(3), sol(3), rotsol(3), e(3), rote(3), F(3,3), G(3,3)
    REAL(KIND=dp) :: dBasisdx(n,3)
    LOGICAL :: Stat, Found
    INTEGER :: t, i, j, p, q, np
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t), SAVE :: Nodes
    !------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )

    !-------------------------------------
    ! Numerical integration over element:
    !-------------------------------------
    IP = GaussPoints(Element, EdgeBasis=.TRUE., PReferenceElement=PiolaVersion, EdgeBasisDegree=ElementOrder) 

    np = 0  ! Set np = n, if nodal dofs are employed; otherwise set np = 0

    DO t=1,IP % n

      IF (PiolaVersion) THEN
        stat = EdgeElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), F, G, detJ, Basis, EBasis, CurlEBasis, ApplyPiolaTransform = .TRUE., &
            SecondFamily=SecondFamily, BasisDegree=ElementOrder)
      ELSE
        stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), detJ, Basis, dBasisdx )
        CALL GetEdgeBasis(Element, EBasis, CurlEBasis, Basis, dBasisdx)
      END IF

      xq = SUM( Nodes % x(1:n) * Basis(1:n) )
      yq = SUM( Nodes % y(1:n) * Basis(1:n) )
      zq = SUM( Nodes % z(1:n) * Basis(1:n) )

      u = 0.0d0
      DO i=1,dim
        u(i) = SUM( Load(1,np+1:nd) * EBasis(1:nd-np,i) )
      END DO

      rotu(1) = SUM( Load(1,np+1:nd) * CurlEBasis(1:nd-np,1) )
      rotu(2) = SUM( Load(1,np+1:nd) * CurlEBasis(1:nd-np,2) )
      rotu(3) = SUM( Load(1,np+1:nd) * CurlEBasis(1:nd-np,3) )       

      ! Compute the square of the energy norm of the solution and error:
      SELECT CASE(TestMode)
      CASE (1)
        sol(1) = 1.0d0
        sol(2) = 1.0d0
        sol(3) = 1.0d0
        rotsol(1:3) = 0.0d0
      CASE (2)
        sol(1) = 1.0d0 + zq - yq
        sol(2) = 1.0d0 - zq + xq
        sol(3) = 1.0d0 - xq + yq
        rotsol(1:3) = 2.0d0
      CASE (3)
        sol(1:2) = 0.0d0
        sol(3) = -0.5d0*(yq*xq**2+xq*yq**2)
        rotsol(1) = -0.5d0*xq**2 - yq*xq 
        rotsol(2) = 0.5d0*yq**2 + yq*xq
        rotsol(3) = 0.0d0
      CASE(4)
        sol(1) = xq*yq**2
        sol(2) = yq*xq**2
        sol(3) = 0.0d0
        rotsol = 0.0d0
      CASE(5)
        sol(1) = -xq*yq**2
        sol(2) = yq*xq**2
        sol(3) = 0.0d0
        rotsol(1:3) = 0.0d0
        rotsol(3) = 4.0d0*xq*yq
      END SELECT

      e(:) = sol(:) - u(:)  
      rote(:) = rotsol(:) - rotu(:)

      IF (UseCurlNorm) THEN
        ! Curl error in L2:
        !-------------------
        SolNorm = SolNorm + SUM( rotsol(1:3) * rotsol(1:3) ) * detJ
        EK = EK + SUM( rote(1:3) * rote(1:3) ) * detJ       
 
        ! Energy norm:
        !--------------
        !SolNorm = SolNorm + (SUM( Sol(1:3) * Sol(1:3) ) + 1.0d0 * SUM( rotsol(1:3) * rotsol(1:3) )) * detJ
        !EK = EK + (SUM( e(1:3) * e(1:3) ) + 1.0d0 * SUM( rote(1:3) * rote(1:3) )) * detJ

      ELSE
        ! L2 norm
        SolNorm = SolNorm + SUM( Sol(1:3) * Sol(1:3) )* detJ
        EK = EK + SUM( e(1:3) * e(1:3) )* detJ
      END IF
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE ComputeApproximationError
!-----------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE BestApproximationSolver
!------------------------------------------------------------------------------

!/*****************************************************************************/
! *
! *  Elmer, A Finite Element Software for Multiphysical Problems
! *
! *  Copyright 1st April 1995 - , CSC - IT Center for Science Ltd., Finland
! * 
! *  This program is free software; you can redistribute it and/or
! *  modify it under the terms of the GNU General Public License
! *  as published by the Free Software Foundation; either version 2
! *  of the License, or (at your option) any later version.
! * 
! *  This program is distributed in the hope that it will be useful,
! *  but WITHOUT ANY WARRANTY; without even the implied warranty of
! *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! *  GNU General Public License for more details.
! *
! *  You should have received a copy of the GNU General Public License
! *  along with this program (in file fem/GPL-2); if not, write to the 
! *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
! *  Boston, MA 02110-1301, USA.
! *
! *****************************************************************************
!
!******************************************************************************
! *
! *  Authors: Mikko, Lyly, Juha Ruokolainen, Thomas Zwinger
! *  Email:   Juha.Ruokolainen@csc.fi
! *  Web:     http://www.csc.fi/elmer
! *  Address: CSC - IT Center for Science Ltd.
! *           Keilaranta 14
! *           02101 Espoo, Finland 
! *
! *  Original Date: 04 Apr 2004
! *
! ****************************************************************************

!------------------------------------------------------------------------------
!>  Advection-reaction equation solver for scalar fields with discontinuous Galerkin method.
!> \ingroup Solvers
!------------------------------------------------------------------------------
  SUBROUTINE AdvectionReactionSolver( Model,Solver,dt,Transient )
!------------------------------------------------------------------------------
     USE DefUtils

     IMPLICIT NONE
!------------------------------------------------------------------------------
     TYPE(Model_t) :: Model            !< All model information (mesh, materials, BCs, etc...)
     TYPE(Solver_t), TARGET :: Solver  !< Linear & nonlinear equation solver options
     REAL(KIND=dp) :: dt               !< Timestep size for time dependent simulations
     LOGICAL :: Transient    !< Steady state or transient simulation
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
     TYPE(ValueList_t), POINTER :: BC, BodyForce, Material,&
          Equation, Constants, SolverParams

     TYPE(Element_t), POINTER :: Element, Face, &
       ParentElement, P1, P2

     LOGICAL :: AllocationsDone = .FALSE., Found, Stat, &
          LimitSolution, FoundLowerLimit, FoundUpperLimit
     INTEGER :: Active, DIM,NonLinearIterMin,NonlinearIterMax,iter,&
          CorrectedLowerLimit,CorrectedUpperLimit
     INTEGER :: n1,nd1,nd2,n2, k, n, nd,t, istat, i, j, dummyInt, NumberOfFAces, Indexes(128)
#ifdef USE_ISO_C_BINDINGS
     REAL(KIND=dp) :: Norm,RelativeChange,at,at0,totat,st,totst,&
          OriginalValue 
#else
     REAL(KIND=dp) :: Norm,RelativeChange,at,at0,totat,st,totst,CPUTime,RealTime,&
          OriginalValue 
#endif
     REAL(KIND=dp), ALLOCATABLE :: MASS(:,:), STIFF(:,:), LOAD(:), &
              FORCE(:), Velo(:,:), MeshVelo(:,:), Gamma(:), Ref(:), &
              UpperLimit(:), LowerLimit(:)
     TYPE(Mesh_t), POINTER :: Mesh
     TYPE(Variable_t), POINTER ::  Var
     CHARACTER(LEN=MAX_NAME_LEN) ::  VariableName, SolverName, ExpVariableName

     SAVE MASS, STIFF, LOAD, FORCE, Velo, MeshVelo, Gamma, &
          AllocationsDone, DIM, VariableName, SolverName, &
          UpperLimit, LowerLimit
!*******************************************************************************

     TYPE( Element_t ), POINTER :: Faces(:)
     TYPE(Nodes_t) :: ElementNodes

     INTEGER :: DOFs
!*******************************************************************************
     SolverName = 'AdvectionReaction ('// TRIM(Solver % Variable % Name) // ')'
     VariableName = TRIM(Solver % Variable % Name)
     WRITE(Message,'(A,A)')&
          'AdvectionReactionSolver for variable ', VariableName
     CALL INFO(SolverName,Message,Level=1)

     Mesh => GetMesh()

     IF ( CoordinateSystemDimension() == 2 ) THEN
        Faces => Mesh % Edges
        NumberOfFaces = Mesh % NumberOfEdges
     ELSE
        Faces => Mesh % Faces
        NumberOfFaces = Mesh % NumberOfFaces
     END IF

     ! Initialize & allocate some permanent storage, this is done first time only:
     !----------------------------------------------------------------------------
     IF ( .NOT. AllocationsDone ) THEN

        N = 2 * MAX(Mesh % MaxElementDOFs, Mesh % MaxElementNodes )
        ALLOCATE( FORCE(N), MASS(n,n), STIFF(N,N), LOAD(N),  &
                  Velo(3,N), MeshVelo( 3,N ), Gamma(n), &
                  UpperLimit(n), LowerLimit(n), STAT = istat )
        
       IF ( istat /= 0 ) THEN
          CALL FATAL(SolverName,'Memory allocation error.' )
       ELSE
          CALL INFO(SolverName,'Memory allocation done',Level=1 )
       END IF
       DIM = CoordinateSystemDimension()
       AllocationsDone = .TRUE.
     END IF

     !------------------------------------------------------------------------------
     !    Read physical and numerical constants and initialize 
     !------------------------------------------------------------------------------
     Constants => GetConstants()
     SolverParams => GetSolverParams()

     NonlinearIterMax = GetInteger(   SolverParams, &
                     'Nonlinear System Max Iterations', Found )
     IF ( .NOT.Found ) THEN
        CALL WARN(SolverName,'No > Nonlinear System Max Iterations < found. Setting 1')
        NonlinearIterMax = 1
     END IF

     NonlinearIterMin = GetInteger(   SolverParams, &
                     'Nonlinear System Min Iterations', Found )
     IF ( .NOT.Found ) THEN        
        CALL WARN(SolverName,'No >Nonlinear System Min Iterations< found. Setting 1')
        NonlinearIterMin = 1
     ELSE IF (NonlinearIterMin > NonlinearIterMax) THEN
        CALL WARN(SolverName,&
             '>Nonlinear System Min Iterations< is exceeding >Nonlinear System Max Iterations<.')
         CALL WARN(SolverName,&
             'First is being reset to the latter.')
        NonlinearIterMin = NonlinearIterMax
     END IF

     ExpVariableName = GetString(SolverParams , 'Exported Variable 1', Found )
     IF (.NOT.Found) &
        CALL FATAL(SolverName,'No value > Exported Variable 1 < found in Solver')

     !------------------------------------------------------------------------------
     !       non-linear system iteration loop
     !------------------------------------------------------------------------------
     totat = 0; totst = 0
     DO iter=1,NonlinearIterMax
        ! Assembly of the bulk elements:
        !-------------------------------
        !------------------------------------------------------------------------------
        ! print out some information
        !------------------------------------------------------------------------------
        at  = CPUTime()
        at0 = RealTime()

        CALL Info( SolverName, ' ', Level=4 )
        CALL Info( SolverName, ' ', Level=4 )
        CALL Info( SolverName, '-------------------------------------',Level=4 )
        WRITE( Message,'(A,I3,A,I3)') &
             'Nonlinear iteration no.', iter,' of max',NonlinearIterMax
        CALL Info( SolverName, Message, Level=4 )
        CALL Info( SolverName, '-------------------------------------',Level=4 )
        CALL Info( SolverName, ' ', Level=4 )
        CALL Info( SolverName, 'Starting Assembly...', Level=4 )


        CALL DefaultInitialize()
        Active = GetNOFActive()
        DO t = 1, Active  
           !------------------------------------------------------------------------------
           ! write some info on status of assembly
           !------------------------------------------------------------------------------
           IF ( RealTime() - at0 > 1.0 ) THEN
!             WRITE(Message,'(a,i3,a)' ) '   Assembly: ', INT(100.0 - 100.0 * &
!                  (Active-t) / &
!                  (1.0*Active)), ' % done'
!
!             CALL Info( SolverName, Message, Level=5 )

              at0 = RealTime()
           END IF
           !------------------------------------------------------------------------------
           ! assign pointers and get number of nodes in element
           !------------------------------------------------------------------------------  
           Element => GetActiveElement(t)
           n  = GetElementNOfNodes(Element)
           nd = GetElementNOfDOFs(Element)

           Material => GetMaterial(Element)
           Equation => GetEquation(Element)
           BodyForce => GetBodyForce(Element)

           !------------------------------------------------------------------------------         
           LOAD(1:n) = GetReal( BodyForce, TRIM(VariableName) // ' Source', Found )    

           !------------------------------------------------------------------------------
           ! Get convection and mesh velocity
           CALL GetLocalALEVelocity(Velo,MeshVelo,SolverName,Material,&
                Equation,Solver,Model,Element)

           !--------------------------
           ! get reaction coefficient
           !--------------------------
           Gamma(1:n)  = GetReal( Material, TRIM(VariableName)//' Gamma', Found )

           CALL LocalMatrix(MASS, STIFF, FORCE, LOAD, Velo, Gamma, Element, n,nd) 
           IF ( Transient ) CALL Default1stOrderTime(MASS, STIFF, FORCE)
           CALL DefaultUpdateEquations(STIFF, FORCE)
        END DO


        ! Assembly of the face terms:
        !----------------------------
        FORCE = 0.0_dp
        DO t=1,NumberOfFaces
           Face => Faces(t)
           IF ( .NOT. ActiveBoundaryElement(Face) ) CYCLE

           P1  => Face % BoundaryInfo % Left
           P2 => Face % BoundaryInfo % Right
           IF ( ASSOCIATED(P2) .AND. ASSOCIATED(P1) ) THEN
              n  = GetElementNOFNodes(Face)
              n1 = GetElementNOFNodes(P1)
              n2 = GetElementNOFNodes(P2)

              nd = GetElementNOFDOFs(Face)
              nd1 = GetElementNOFDOFs(P1)
              nd2 = GetElementNOFDOFs(P2)

              !------------------------------------------------------------------------------
              ! Get convection and mesh velocity
              !------------------------------------------------------------------------------ 
              Material => GetMaterial(P1)
              Equation => GetEquation(P1)          
              CALL GetLocalALEVelocity(Velo,MeshVelo,SolverName,Material,&
                   Equation,Solver,Model,Face)

              CALL LocalJumps( STIFF,Face,n,nd,P1,n1,nd1,P2,n2,nd2,Velo )
              CALL DefaultUpdateEquations( STIFF, FORCE, Face )
           END IF
        END DO

        ! Loop over the boundary elements:
        !---------------------------------
        DO t=1,Mesh % NumberOfBoundaryElements
           Element => GetBoundaryElement(t)
           IF( .NOT. ActiveBoundaryElement() )  CYCLE
           IF( GetElementFamily(Element) < dim ) CYCLE 

           ParentElement => Element % BoundaryInfo % Left
           IF ( .NOT. ASSOCIATED( ParentElement ) ) &
                ParentElement => Element % BoundaryInfo % Right

           n1  = GetElementNOFnodes(ParentElement)
           n   = GetElementNOFNodes(Element)

           nd  = GetElementNOFDOFs(Element)
           nd1 = GetElementNOFDOFs(ParentElement)
           !------------------------------------------------------------------------------
           ! Get convection and mesh velocity
           !------------------------------------------------------------------------------ 
           Material => GetMaterial(ParentElement)
           Equation => GetEquation(ParentElement)        
           CALL GetLocalALEVelocity(Velo,MeshVelo,SolverName,Material,&
                Equation,Solver,Model,Element)

           BC => GetBC()
           LOAD = 0.0_dp
           Found = .FALSE.
           IF ( ASSOCIATED(BC) ) THEN
             LOAD(1:n) = GetReal(BC, Solver % Variable % Name, Found)
           END IF

           MASS = 0.0_dp
           CALL LocalMatrixBoundary(  STIFF, FORCE, LOAD, &
                Element, n, nd, ParentElement, n1, nd1, Velo, Found )

           IF ( Transient ) CALL Default1stOrderTime(MASS, STIFF, FORCE)
           CALL DefaultUpdateEquations(STIFF, FORCE)
        END DO

        CALL DefaultFinishAssembly()
        CALL Info( SolverName, 'Assembly done', Level=4 )

        !------------------------------------------------------------------------------
        !     Solve the system and check for convergence
        !------------------------------------------------------------------------------
        at = CPUTime() - at
        st = CPUTime()

        ! Solve the system:
        !------------------
        Norm = DefaultSolve()

        st = CPUTIme()-st
        totat = totat + at
        totst = totst + st
        WRITE(Message,'(a,i4,a,F8.2,F8.2)') 'iter: ',iter,' Assembly: (s)', at, totat
        CALL Info( SolverName, Message, Level=4 )
        WRITE(Message,'(a,i4,a,F8.2,F8.2)') 'iter: ',iter,' Solve:    (s)', st, totst
        CALL Info( SolverName, Message, Level=4 )

        RelativeChange = Solver % Variable % NonlinChange 
        
        IF ( Solver % Variable % NonlinConverged == 1 )  THEN 
           WRITE(Message,'(A,I6,A,I6,A)') &
                'Nonlinear iteration converged after ', iter, &
                ' out of max ',NonlinearIterMax,' iterations'
           CALL INFO(SolverName,Message)
           EXIT
        ELSE IF ((iter .EQ. NonlinearIterMax) .AND. (NonlinearIterMax > 1)) THEN
           CALL WARN(SolverName,'Maximum nonlinear iterations reached, but system not converged')
        END IF

     !-----------------------------------------------
     END DO ! End of nonlinear iteration loop
     !----------------------------------------------


     ! Average the elemental results to nodal values:
     !-----------------------------------------------
     Var => VariableGet( Mesh % Variables,TRIM(ExpVariableName))
     IF ( ASSOCIATED( Var ) ) THEN
       n1 = Mesh % NumberOfNodes
       ALLOCATE( Ref(n1) )
       Ref = 0
       Var % Type = Variable_on_nodes

       IF ( ASSOCIATED( Var % Perm, Solver % Variable % Perm ) ) THEN
         ALLOCATE( Var % Perm(SIZE(Solver % Variable % Perm))  )
         Var % Perm = 0
         DO i = 1,n1
            Var % Perm(i) = i
         END DO
       END IF

       Var % Values = 0.0d0
       DO t=1,Active
          Element => GetActiveElement(t) 
          n = GetElementDOFs(Indexes)
          n = GetElementNOFNodes()
          DO i=1,n
             k = Element % NodeIndexes(i)
             Var % Values(k) = Var % Values(k) + &
               Solver % Variable % Values( Solver % Variable % Perm(Indexes(i)) )
             Ref(k) = Ref(k) + 1
          END DO
       END DO

       WHERE( Ref > 0 )
         Var % Values(1:n1) = Var % Values(1:n1) / Ref
       END WHERE
       DEALLOCATE( Ref )
    ELSE
       WRITE(Message,'(A,A,A)') 'Exported Variable >',TRIM(VariableName) //   'Nodal Result','< not found'
       CALL FATAL(SolverName,Message)
    END IF

   CONTAINS

!------------------------------------------------------------------------------      
     SUBROUTINE LocalMatrix(MASS, STIFF, FORCE, LOAD, Velo, Gamma, Element, n,nd)
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: MASS(:,:), STIFF(:,:), FORCE(:), &
                  LOAD(:), Velo(:,:), Gamma(:)
       INTEGER :: n,nd
       TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
       REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3)
       REAL(KIND=dp) :: detJ,U,V,W,S,A,L,cu(3),g
       LOGICAL :: Stat
       INTEGER :: i,p,q,t,dim
       TYPE(GaussIntegrationPoints_t) :: IntegStuff
       TYPE(Nodes_t), SAVE :: Nodes
!------------------------------------------------------------------------------
       dim = CoordinateSystemDimension()

       FORCE = 0.0_dp
       STIFF = 0.0_dp
       MASS  = 0.0_dp

       CALL GetElementNodes(Nodes, Element)
!------------------------------------------------------------------------------
!      Numerical integration
!------------------------------------------------------------------------------
       IntegStuff = GaussPoints(Element)
 
       DO t=1,IntegStuff % n
         U = IntegStuff % u(t)
         V = IntegStuff % v(t)
         W = IntegStuff % w(t)
         S = IntegStuff % s(t)
!------------------------------------------------------------------------------
!        Basis function values & derivatives at the integration point
!------------------------------------------------------------------------------
         stat = ElementInfo( Element, Nodes, U, V, W, detJ, &
                 Basis, dBasisdx )

         S = S * detJ
         L = SUM( LOAD(1:n) *  Basis(1:n) )
         g = SUM( Basis(1:n) * Gamma(1:n) )

         cu = 0.0_dp
         DO i=1,dim
           cu(i) = SUM(Basis(1:n) * Velo(i,1:n))
         END DO
!------------------------------------------------------------------------------
!        The advection-reaction equation: dc/dt + grad(u . c) + gamma c = s
!------------------------------------------------------------------------------
         DO p=1,nd
            DO q=1,nd
              MASS(p,q)  = MASS(p,q)  + s * Basis(q) * Basis(p)
              STIFF(p,q) = STIFF(p,q) + s * g * Basis(q) * Basis(p)
              DO i=1,dim
                STIFF(p,q) = STIFF(p,q) - s * cu(i) * Basis(q) * dBasisdx(p,i)
              END DO
            END DO
         END DO
         FORCE(1:nd) = FORCE(1:nd) + s*L*Basis(1:nd)
!------------------------------------------------------------------------------
      END DO
!------------------------------------------------------------------------------
     END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
    SUBROUTINE FindParentUVW(Face, nFace, Parent, nParent, U, V, W, Basis)
!------------------------------------------------------------------------------
      IMPLICIT NONE
      TYPE(Element_t) :: Face, Parent
      INTEGER :: nFace, nParent
      REAL( KIND=dp ) :: U, V, W, Basis(:)
!------------------------------------------------------------------------------
      INTEGER :: i,j
      REAL(KIND=dp) :: ParentU(nFace), ParentV(nFace), ParentW(nFace)
!------------------------------------------------------------------------------
      DO i = 1,nFace
        DO j = 1,nParent
          IF (Face % NodeIndexes(i) == Parent % NodeIndexes(j)) THEN
            ParentU(i) = Parent % Type % NodeU(j)
            ParentV(i) = Parent % Type % NodeV(j)
            ParentW(i) = Parent % Type % NodeW(j)
            EXIT
          END IF
        END DO
      END DO
      U = SUM(Basis(1:nFace)*ParentU(1:nFace))
      V = SUM(Basis(1:nFace)*ParentV(1:nFace))
      W = SUM(Basis(1:nFace)*ParentW(1:nFace))
!------------------------------------------------------------------------------      
    END SUBROUTINE FindParentUVW
!------------------------------------------------------------------------------      


!------------------------------------------------------------------------------
    SUBROUTINE LocalJumps(STIFF,Face,n,nd,P1,n1,nd1,P2,n2,nd2,Velo)
!------------------------------------------------------------------------------
      IMPLICIT NONE
      REAL(KIND=dp) :: STIFF(:,:), Velo(:,:)
      INTEGER :: n,n1,n2,nd,nd1,nd2
      TYPE(Element_t), POINTER :: Face, P1, P2
!------------------------------------------------------------------------------
      REAL(KIND=dp) :: Basis(nd),P1Basis(nd1),P2Basis(nd2)
      REAL(KIND=dp) :: Jump(nd1+nd2), Average(nd1+nd2)
      REAL(KIND=dp) :: detJ, U, V, W, S, Udotn, xx, yy
      LOGICAL :: Stat
      INTEGER :: i, j, p, q, dim, t, nFace, nParent
      TYPE(GaussIntegrationPoints_t) :: IntegStuff
      REAL(KIND=dp) :: Normal(3), cu(3), LeftOut(3)

      TYPE(Nodes_t), SAVE :: FaceNodes, P1Nodes, P2Nodes
!------------------------------------------------------------------------------
      dim = CoordinateSystemDimension()
      STIFF = 0.0_dp

      CALL GetElementNodes(P1Nodes, P1)
      CALL GetElementNodes(P2Nodes, P2)
      CALL GetElementNodes(FaceNodes, Face)
!------------------------------------------------------------------------------
!     Numerical integration over the edge
!------------------------------------------------------------------------------
      IntegStuff = GaussPoints(Face)

      LeftOut(1) = SUM(P1Nodes % x(1:n1)) / n1
      LeftOut(2) = SUM(P1Nodes % y(1:n1)) / n1
      LeftOut(3) = SUM(P1Nodes % z(1:n1)) / n1
      LeftOut(1) = SUM(FaceNodes % x(1:n)) / n - LeftOut(1)
      LeftOut(2) = SUM(FaceNodes % y(1:n)) / n - LeftOut(2)
      LeftOut(3) = SUM(FaceNodes % z(1:n)) / n - LeftOut(3)

      DO t=1,IntegStuff % n
        U = IntegStuff % u(t)
        V = IntegStuff % v(t)
        W = IntegStuff % w(t)
        S = IntegStuff % s(t)

        ! Basis function values & derivatives at the integration point:
        !--------------------------------------------------------------
        stat = ElementInfo(Face, FaceNodes, U, V, W, detJ,Basis)
        S = S * detJ

        Normal = NormalVector(Face, FaceNodes, U, V, .FALSE.)
        IF (SUM(LeftOut*Normal)<0) Normal = -Normal

        ! Find basis functions for the parent elements:
        ! ---------------------------------------------
        CALL FindParentUVW(Face,n,P1,n1,U,V,W,Basis)
        stat = ElementInfo(P1, P1Nodes, U, V, W, detJ, P1Basis)

        CALL FindParentUVW(Face,n,P2,n2,U,V,W,Basis)
        stat = ElementInfo(P2, P2Nodes, U, V, W, detJ, P2Basis)

        ! Integrate jump terms:
        ! ---------------------
        Jump(1:nd1) = P1Basis(1:nd1)
        Jump(nd1+1:nd1+nd2) = -P2Basis(1:nd2)

        Average(1:nd1) = P1Basis(1:nd1) / 2
        Average(nd1+1:nd1+nd2) = P2Basis(1:nd2) / 2

        cu = 0.0_dp
        DO i=1,dim
          cu(i) = SUM( Velo(i,1:n) * Basis(1:n) )
        END DO
        Udotn = SUM( Normal * cu )

        DO p=1,nd1+nd2
          DO q=1,nd1+nd2
            STIFF(p,q) = STIFF(p,q) + s * Udotn * Average(q) * Jump(p)
            STIFF(p,q) = STIFF(p,q) + s * ABS(Udotn)/2 * Jump(q) * Jump(p)
          END DO
        END DO
      END DO
!------------------------------------------------------------------------------
    END SUBROUTINE LocalJumps
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
    SUBROUTINE LocalMatrixBoundary( STIFF, FORCE, LOAD, &
        Element, n, nd, ParentElement, np, npd,Velo, InFlowBC )
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: STIFF(:,:),  FORCE(:), LOAD(:), Velo(:,:)
     INTEGER :: n, np,nd,npd
     LOGICAL :: InFlowBC
     TYPE(Element_t), POINTER :: Element, ParentElement
!------------------------------------------------------------------------------
     REAL(KIND=dp) :: Basis(nd), ParentBasis(npd)
     INTEGER :: i,j,k,m,p,q,t,dim

     REAL(KIND=dp) :: Normal(3), g, L, Udotn, cu(3), detJ,U,V,W,S
     LOGICAL :: Stat, Inflow
     TYPE(GaussIntegrationPoints_t) :: IntegStuff

     TYPE(Nodes_t) :: Nodes, ParentNodes
!------------------------------------------------------------------------------
     dim = CoordinateSystemDimension()
     FORCE = 0.0_dp
     STIFF = 0.0_dp
 
     CALL GetElementNodes(Nodes, Element)
     CALL GetElementNodes(ParentNodes, ParentElement)

     Normal = NormalVector( Element, Nodes, 0.0_dp, 0.0_dp, .TRUE. ) 
     DO i=1,3
       cu(i) = SUM(Velo(i,1:n)) / n
     END DO
     Inflow = InFlowBC .AND. SUM( Normal * cu ) < 0.0_dp

     ! Numerical integration:
     !-----------------------
     IntegStuff = GaussPoints(Element)

     DO t=1,IntegStuff % n
       U = IntegStuff % u(t)
       V = IntegStuff % v(t)
       W = IntegStuff % w(t)
       S = IntegStuff % s(t)

       Normal = NormalVector(Element, Nodes, U, V, .TRUE.) 

       ! Basis function values & derivatives at the integration point:
       ! -------------------------------------------------------------
       stat = ElementInfo(Element, Nodes, U, V, W, detJ,Basis)
       S = S * detJ

       CALL FindParentUVW(Element, n, ParentElement, np, U, V, W, Basis)
       stat = ElementInfo( ParentElement, ParentNodes, U, V, W, &
            detJ, ParentBasis)

       L = SUM(LOAD(1:n) * Basis(1:n))
       cu = 0.0_dp
       DO i=1,dim
         cu(i)  = SUM(Velo(i,1:n) * Basis(1:n))
       END DO
       Udotn = SUM(Normal*cu)

       DO p = 1,npd
         IF ( Inflow ) THEN
            FORCE(p) = FORCE(p) - s*Udotn*L*ParentBasis(p)
         ELSE
           DO q=1,npd
             STIFF(p,q) = STIFF(p,q) + s*Udotn*ParentBasis(q)*ParentBasis(p)
           END DO
         END IF
       END DO
     END DO
!------------------------------------------------------------------------------
   END SUBROUTINE LocalMatrixBoundary
!------------------------------------------------------------------------------
!
!------------------------------------------------------------------------------
   SUBROUTINE GetLocalALEVelocity(Velo,MeshVelo,SolverName,Material,&
        Equation,Solver,Model,Element)
     IMPLICIT NONE
     !------------------------------------------------------------------------------
     REAL (KIND=dp) :: Velo(:,:), MeshVelo(:,:)
     CHARACTER(LEN=MAX_NAME_LEN) :: SolverName
     TYPE(ValueList_t), POINTER :: Material,Equation
     TYPE(Solver_t), TARGET :: Solver
     TYPE(Model_t), TARGET :: Model
     TYPE(Element_t),POINTER :: Element
     !------------------------------------------------------------------------------
     CHARACTER(LEN=MAX_NAME_LEN) :: ConvectionFlag, FlowSolName
     INTEGER :: i,j,k,N,FlowDOFs
     INTEGER, POINTER :: FlowPerm(:)
     REAL(KIND=dp), POINTER :: FlowSolution(:)
     TYPE(Variable_t), POINTER :: FlowSol
     LOGICAL :: Found
     !------------------------------------------------------------------------------
     n  = GetElementNOFNodes( Element )
     ConvectionFlag = GetString( Equation, 'Convection', Found )
     IF (.NOT. Found) &
          CALL FATAL(SolverName, 'No string for keyword >Convection< found in Equation')
     Velo = 0.0d00
     ! constant (i.e., in section Material given) velocity
     !---------------------------------------------------
     IF ( ConvectionFlag == 'constant' ) THEN
        Velo(1,1:N) = GetReal( Material, 'Convection Velocity 1', Found, Element )
        IF (.NOT.Found) Velo(1,1:N) = 0.0d0
        Velo(2,1:N) = GetReal( Material, 'Convection Velocity 2', Found, Element )
        IF (.NOT.Found) Velo(2,1:N) = 0.0d0
        Velo(3,1:N) = GetReal( Material, 'Convection Velocity 3', Found, Element )
        IF (.NOT.Found) Velo(3,1:N) = 0.0d0
        ! computed velocity
        !------------------Equation => GetEquation()
     ELSE IF (ConvectionFlag == 'computed' ) THEN
        FlowSolName =  GetString( Equation,'Flow Solution Name', Found)
        IF(.NOT.Found) THEN        
           CALL WARN(SolverName,'Keyword >Flow Solution Name< not found in section >Equation<')
           CALL WARN(SolverName,'Taking default value >Flow Solution<')
           WRITE(FlowSolName,'(A)') 'Flow Solution'
        END IF
        FlowSol => VariableGet( Solver % Mesh % Variables, FlowSolName )
        IF ( ASSOCIATED( FlowSol ) ) THEN
           FlowPerm     => FlowSol % Perm
           FlowDOFs     =  FlowSol % DOFs
           FlowSolution => FlowSol % Values
        ELSE
           WRITE(Message,'(A,A,A)') &
                'Convection flag set to >computed<, but no variable >',FlowSolName,'< found'
           CALL FATAL(SolverName,Message)              
        END IF


        DO i=1,n
           k = FlowPerm(Element % NodeIndexes(i))
           IF ( k > 0 ) THEN
              ! Pressure = FlowSolution(FlowDOFs*k)
              
              SELECT CASE( FlowDOFs )
              CASE(2)
                 Velo(1,i) = FlowSolution( FlowDOFs*k-1 )
                 Velo(2,i) = 0.0d0
                 Velo(3,i) = 0.0d0
              CASE(3)
                 Velo(1,i) = FlowSolution( FlowDOFs*k-2 )
                 Velo(2,i) = FlowSolution( FlowDOFs*k-1 )
                 Velo(3,i) = 0.0d0
              CASE(4)
                 Velo(1,i) = FlowSolution( FlowDOFs*k-3 )
                 Velo(2,i) = FlowSolution( FlowDOFs*k-2 )
                 Velo(3,i) = FlowSolution( FlowDOFs*k-1 )
              END SELECT
           END IF
        END DO
     ELSE IF (ConvectionFlag == 'none' ) THEN
        Velo = 0.0d0
     ELSE  
        WRITE(Message,'(A,A,A)') 'Convection flag >', ConvectionFlag ,'< not recognised'
        CALL FATAL(SolverName,Message) 
     END IF
     !-------------------------------------------------
     ! Add mesh velocity (if any) for ALE formulation
     !-------------------------------------------------
     MeshVelo = 0.0d0
     CALL GetVectorLocalSolution( MeshVelo, 'Mesh Velocity', Element)
     IF (ANY( MeshVelo /= 0.0d0 )) THEN
        DO i=1,FlowDOFs
           Velo(i,1:N) = Velo(i,1:N) - MeshVelo(i,1:N)
        END DO
     END IF
   END SUBROUTINE GetLocalALEVelocity

!------------------------------------------------------------------------------
 END SUBROUTINE AdvectionReactionSolver
!------------------------------------------------------------------------------

  FUNCTION Viscosity( Model, n, fii ) RESULT(r)
   USE Types
   USE SolverUtils

   IMPLICIT NONE

   TYPE(Model_t) :: Model
   INTEGER :: i,j,k,n, body_id

   REAL(KIND=dp) :: x,y,r,fii,dfii,t,visc0,visc1,fstep
   LOGICAL :: Visited = .FALSE., GotIt


   SAVE Visited, visc1, visc0, dfii

   IF(.NOT. Visited) THEN
     body_id = Model % CurrentElement % Bodyid    
     k = ListGetInteger( Model % Bodies( body_id ) % Values, 'Material' )
     visc0 = ListGetConstReal(Model % Materials(k) % Values,'Inside Viscosity')
     visc1 = ListGetConstReal(Model % Materials(k) % Values,'Outside Viscosity')
     dfii = ListGetConstReal(Model % Materials(k) % Values,'Levelset Bandwidth')
     Visited = .TRUE.
   END IF

   t = fii / dfii
   IF(t < -1.0) THEN
     fstep = 0.0d0
   ELSE IF(t > 1.0) THEN
     fstep = 1.0d0
   ELSE
     fstep = 0.75d0 * (t - t**3.0d0/3) + 0.5d0
   END IF

   r = (visc0-visc1) * fstep + visc1

 END FUNCTION Viscosity



  FUNCTION Density( Model, n, fii ) RESULT(r)
   USE Types
   USE SolverUtils

   IMPLICIT NONE

   TYPE(Model_t) :: Model
   INTEGER :: i,j,k,n, body_id

   REAL(KIND=dp) :: x,y,r,fii,dfii,t,dens0,dens1,fstep
   LOGICAL :: Visited = .FALSE., GotIt


   SAVE Visited, dens1, dens0, dfii

   IF(.NOT. Visited) THEN
     body_id = Model % CurrentElement % Bodyid    
     k = ListGetInteger( Model % Bodies( body_id ) % Values, 'Material' )
     dens0 = ListGetConstReal(Model % Materials(k) % Values,'Inside Density')
     dens1 = ListGetConstReal(Model % Materials(k) % Values,'Outside Density')
     dfii = ListGetConstReal(Model % Materials(k) % Values,'Levelset Bandwidth')
     Visited = .TRUE.
   END IF

   t = fii / dfii
   IF(t < -1.0) THEN
     fstep = 0.0d0
   ELSE IF(t > 1.0) THEN
     fstep = 1.0d0
   ELSE
     fstep = 0.75d0 * (t - t**3.0d0/3) + 0.5d0
   END IF

   r = (dens0-dens1) * fstep + dens1

 END FUNCTION Density

  FUNCTION InitDist( Model, n, t ) RESULT(f)
    USE Types
    USE SolverUtils
    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    LOGICAL :: Visited = .FALSE., GotIt
    INTEGER :: n
    REAL(KIND=dp) :: t,x,y,a1,a2,f
    
    SAVE Visited, a1, a2

    IF(.NOT. Visited) THEN
      a1 = 5.0_dp
      a2 = 10.0_dp
      Visited = .TRUE.
    END IF
    
    f = 0.0_dp

    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    

    ! cut-off Gaussian
    ! f = MIN(1.0_dp, a1*EXP(-a2*(x**2+y**2)))

    ! sharp cylinder
    IF( (x-0.5)**2 + y**2 < 0.3**2 ) f = 1.0_dp

    ! sharp square
    ! IF( ABS(x-0.5) < 0.3 .AND. ABS(y) < 0.3 ) f = 1.0_dp


  END FUNCTION InitDist

SUBROUTINE TrescaSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils
  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
  TYPE(Variable_t), POINTER :: Stress, Tresca
  INTEGER, POINTER :: StressPerm(:), TrescaPerm(:)
  INTEGER :: i, j, nodes, StressDOFs, TrescaDOFs, ok
  REAL(KIND=dp), POINTER :: StressValues(:), TrescaValues(:)
  REAL(KIND=dp) :: StressComponent(6), Matrix(3,3), Eigs(3), Work(8)
  REAL(KIND=dp) :: SigmaMax, SigmaMin
  SAVE TrescaValues
!------------------------------------------------------------------------------

  ! Get stress tensor:
  !--------------------
  Stress => VariableGet( Solver % Mesh % Variables, 'Stress' )
  
  IF( ASSOCIATED(Stress) ) THEN
     StressPerm => Stress % Perm
     StressDOFs = Stress % DOFs
     StressValues => Stress % Values
  ELSE
     STOP 'Error: Stress was not found'
  END IF

  IF( StressDOFs /= 6 ) THEN
     STOP 'Error: Unexpected number of DOFs for stress'
  END IF

  nodes = SIZE( StressValues ) / StressDOFs

  ! Introduce Tresca stress:
  !--------------------------
  Tresca => VariableGet( Solver % Mesh % Variables, 'Tresca' )

  IF( .NOT.ASSOCIATED(Tresca) ) THEN
     TrescaPerm => StressPerm
     TrescaDOFs = 1
     ALLOCATE( TrescaValues( nodes ) )
     CALL VariableAdd( Solver % Mesh % Variables, Solver % Mesh, &
          Solver, 'Tresca', TrescaDOFs, TrescaValues, TrescaPerm )
  END IF

  ! Compute Tresca stress in node points:
  !--------------------------------------
  DO i = 1, nodes
     DO j = 1, StressDOFs
        StressComponent(j) = StressValues(StressDOFs*(i-1)+j)
     END DO

     Matrix(1,1) = StressComponent(1)
     Matrix(2,2) = StressComponent(2)
     Matrix(3,3) = StressComponent(3)
     Matrix(1,2) = StressComponent(4)
     Matrix(2,3) = StressComponent(5)
     Matrix(1,3) = StressComponent(6)

     CALL DSYEV('N', 'U',  3, Matrix, 3, Eigs, Work, 8, ok)

     IF( ok /= 0 ) THEN
        STOP 'Error: DSYEV failed'
     END IF

     SigmaMax = MAXVAL( Eigs )
     SigmaMin = MINVAL( Eigs )

     TrescaValues(i) = SigmaMax - SigmaMin
  END DO

END SUBROUTINE TrescaSolver
!------------------------------------------------------------------------------

!/*****************************************************************************/
! *
! *  Elmer, A Finite Element Software for Multiphysical Problems
! *
! *  Copyright 1st April 1995 - , CSC - IT Center for Science Ltd., Finland
! * 
! *  This program is free software; you can redistribute it and/or
! *  modify it under the terms of the GNU General Public License
! *  as published by the Free Software Foundation; either version 2
! *  of the License, or (at your option) any later version.
! * 
! *  This program is distributed in the hope that it will be useful,
! *  but WITHOUT ANY WARRANTY; without even the implied warranty of
! *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! *  GNU General Public License for more details.
! *
! *  You should have received a copy of the GNU General Public License
! *  along with this program (in file fem/GPL-2); if not, write to the 
! *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
! *  Boston, MA 02110-1301, USA.
! *
! *****************************************************************************/
! *
! * Compute the L2 errors of the mixed solution of the Poisson equation
! * in a special case.
! *
! *
! *  Authors: Mika Malinen
! *  Email:   mika.malinen@csc.fi
! *  Web:     http://www.csc.fi/elmer
! *  Address: CSC - IT Center for Science Ltd.
! *           Keilaranta 14
! *           02101 Espoo, Finland 
! *
! *  Original Date: March 12, 2019
! *
!******************************************************************************

!------------------------------------------------------------------------------
SUBROUTINE IntegrateError(Model, Solver, dt, TransientSimulation)
!------------------------------------------------------------------------------
  USE DefUtils
  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Model_t) :: Model
  TYPE(Solver_t) :: Solver
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(ValueList_t), POINTER :: SolverPars, TargetSolverPars
  TYPE(Solver_t), POINTER :: TargetSolver
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(Element_t),POINTER :: Element

  LOGICAL :: AllocationsDone = .FALSE., Found, SecondFamily

  CHARACTER(LEN=MAX_NAME_LEN) :: TargetEq, Eq
 
  INTEGER, ALLOCATABLE :: Indices(:)  
  INTEGER :: i, istat, nlen
  INTEGER :: n, nb, np, nd, t, dim

  REAL(KIND=dp), ALLOCATABLE :: SolDOFs(:)
  REAL(KIND=dp) :: PresErr, FluxErr, EK(2), SolNorm, FluxNorm

  SAVE SolDOFs, Indices, AllocationsDone
!------------------------------------------------------------------------------
  SolverPars => GetSolverParams()

  !
  ! Get pointer to the solver the variable of which is used to integrate 
  ! the error:
  !

  TargetEq = ListGetString(SolverPars, 'Target Equation', UnfoundFatal=.TRUE.)
  nlen = LEN_TRIM(TargetEq)
  TargetSolver => NULL()
  DO i=1,Model % NumberOfSolvers
    Eq = ListGetString(Model % Solvers(i) % Values, 'Equation', Found)
    IF (Found) THEN
      IF (nlen == LEN_TRIM(Eq)) THEN
        IF (TargetEq(1:nlen) == Eq(1:nlen)) TargetSolver => Model % Solvers(i)
      END IF
    END IF
  END DO
  IF (.NOT. ASSOCIATED(TargetSolver)) CALL Fatal('ComputeError', &
      'Target Equation does not exist')

  TargetSolverPars => GetSolverParams(TargetSolver)
  SecondFamily = GetLogical(TargetSolverPars, 'Second Kind Basis', Found)
  dim = CoordinateSystemDimension()


  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  Mesh => GetMesh()
  IF ( .NOT. AllocationsDone ) THEN
     N = Mesh % MaxElementDOFs
     ALLOCATE(SolDOFs(N), Indices(N), STAT=istat)
     IF (istat /= 0) THEN
        CALL Fatal( 'ComputeError', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF
  
  PresErr = 0.0d0
  FluxErr = 0.0d0
  SolNorm = 0.0d0
  FluxNorm = 0.0d0
  DO t=1,TargetSolver % NumberOfActiveElements

    Element => GetActiveElement(t, TargetSolver)
    n  = GetElementNOFNodes(Element)
    nd = GetElementDOFs(Indices, Element, TargetSolver)
    nb = size(Element % BubbleIndexes(:))

    np = n * TargetSolver % Def_Dofs(GetElementFamily(Element), &
        Element % BodyId, 1)

    DO i=1,nd
      SolDOFs(i) = TargetSolver % Variable % Values(TargetSolver % Variable % &
          Perm(Indices(i)))
    END DO

    CALL ElementwiseError(SolDofs, Element, n, nd, nb, np, dim, EK, SolNorm, &
        FluxNorm, SecondFamily)

    PresErr = PresErr + EK(1)
    FluxErr = FluxErr + EK(2)

  END DO
  WRITE (*, '(A,E16.8)') 'L2 Scalar Error = ', SQRT(ParallelReduction(PresErr))/SQRT(ParallelReduction(SolNorm))
  WRITE (*, '(A,E16.8)') 'L2 Flux Error =', SQRT(ParallelReduction(FluxErr))/SQRT(ParallelReduction(FluxNorm))

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE ElementwiseError(SolDOFs, Element, n, nd, nb, np, dim, EK, &
      SolNorm, FluxNorm, SecondFamily)
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: SolDOFs(:)
    TYPE(Element_t), POINTER :: Element
    INTEGER :: n, nd, nb, np, dim
    REAL(KIND=dp) :: EK(2), SolNorm, FluxNorm
    LOGICAL :: SecondFamily
!------------------------------------------------------------------
    TYPE(Nodes_t), SAVE :: Nodes
    TYPE(GaussIntegrationPoints_t) :: IP
    INTEGER :: i, p, t
    LOGICAL :: Stat
    REAL(KIND=dp) :: FaceBasis(nd-nb,3), DivFaceBasis(nd-nb), Basis(n)
    REAL(KIND=dp) :: uq, vq, wq, sq
    REAL(KIND=dp) :: xq, yq, zq, DetJ, sol, gradsol(dim), fluxsol(dim)


!---------------------------------------------------------------------------
    IF (nb /= 1) CALL Fatal('ComputeError', 'One bubble DOF assumed')

    CALL GetElementNodes( Nodes )

    EK = 0.0d0

    SELECT CASE( GetElementFamily(Element) )
    CASE(3)
      IP = GaussPointsTriangle(3, PReferenceElement=.TRUE.)
    CASE(5)
      IP = GaussPointsTetra(4, PReferenceElement=.TRUE.)
    CASE DEFAULT
      CALL Fatal('ComputeError', 'A simplicial mesh assumed currently')
    END SELECT 

    DO t=1,IP % n
       stat = FaceElementInfo(Element, Nodes, IP % U(t), IP % V(t), &
           IP % W(t), detF=detJ, Basis=Basis, FBasis=FaceBasis, &
           DivFBasis=DivFaceBasis, BDM = SecondFamily, ApplyPiolaTransform=.TRUE.)
       
       xq = SUM( Nodes % x(1:n) * Basis(1:n) )
       yq = SUM( Nodes % y(1:n) * Basis(1:n) )
       zq = SUM( Nodes % z(1:n) * Basis(1:n) )      
    
       sol = 16.0d0*(xq-xq**2) * (yq-yq**2)
       gradsol(1) = 16.0d0 * (1.0d0 -2.0d0*xq) * (yq-yq**2)
       gradsol(2) = 16.0d0 * (1.0d0 -2.0d0*yq) * (xq-xq**2)

       ! For computing the error of the  scalar field:
       SolNorm = SolNorm + sol**2 * detJ * IP % s(t)
       EK(1) = EK(1) + (sol - SolDOFs(nd))**2 * detJ * IP % s(t) 


       FluxNorm = FluxNorm + SUM( gradsol(1:dim)*gradsol(1:dim) ) * detJ * IP % s(t)

       FluxSol = 0.0d0
       DO p = 1,nd-np-nb
         i = np + p
         FluxSol(1:dim) = FluxSol(1:dim) + FaceBasis(p,1:dim) * SolDOFs(i)
       END DO

       EK(2) = EK(2) + SUM( (gradsol(1:dim) - fluxsol(1:dim))**2 ) * &
            detJ * IP % s(t) 
          
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE ElementwiseError
!-----------------------------------------------------------------------------


!------------------------------------------------------------------------------
END SUBROUTINE IntegrateError
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!> Compare keyword strategies with and without a Handle. 
!> This test for real valued keywords.
!------------------------------------------------------------------------------
SUBROUTINE KeywordCompare( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  LOGICAL :: Found
  INTEGER :: t, NoActive
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Material, BodyForce
  TYPE(ValueHandle_t) :: RealVal_h
  INTEGER :: i, TimeSweeps, key
  REAL(KIND=dp) :: OldCounter(10),NewCounter(10)
#ifndef USE_ISO_C_BINDINGS
  REAL(KIND=dp) :: CPUTime,RealTime
#endif
  REAL(KIND=dp) :: OldTimes(10), NewTimes(10), PseudoNorm, Val


  REAL(KIND=dp), ALLOCATABLE :: Basis(:), RealVal(:), DetJVec(:), BasisVec(:,:)
  REAL(KIND=dp) :: DetJ, RealVal_AtIp
  REAL(KIND=dp), POINTER :: RealValVec(:)
  TYPE(GaussIntegrationPoints_t) :: IP
  TYPE(Nodes_t) :: Nodes
  INTEGER :: elem, n, ngp
  INTEGER, POINTER :: Indexes(:)
  LOGICAL :: Stat
  CHARACTER(LEN=20) :: KeywordName
  
  SAVE Nodes


  
  CALL Info( 'KeywordCompare','')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')
  CALL Info( 'KeywordCompare','Comparing keyword strategies for real vec values')

  Mesh => GetMesh()

  ! These allocations assume that each element has similar integration rule.
  ! Don't take this as generic!
  Element => GetActiveElement(1)
  IP = GaussPoints( Element )   
  ngp = IP % n
  n = GetElementNOFNodes( Element )

  ! Allocate for the old way
  ALLOCATE( Basis(n), RealVal(n) )

  ! Allocate for the new way
  ALLOCATE( BasisVec(ngp,n), DetJVec(ngp) )
  
  
  NoActive = GetNOFActive()
  TimeSweeps = ListGetInteger( Solver % Values,'Timer Sweeps')

  OldTimes = 0.0_dp
  NewTimes = 0.0_dp
  OldCounter = 0.0_dp
  NewCounter = 0.0_dp


  CALL Info('KeywordCompare','Starting real value keyword comparision')
  OldTimes(1) = RealTime()



  DO key = 1, 10
    PRINT *,'Testing keyword number:',key
    KeywordName = 'Float Value '//TRIM(I2S(key))

    OldTimes(key) = RealTime()  
    DO i=1,TimeSweeps
      DO elem=1,NoActive
        Element => GetActiveElement(elem)
        Material => GetMaterial()
        
        CALL GetElementNodes( Nodes )
        n  = GetElementNOFNodes()
        indexes => Element % NodeIndexes
        
        RealVal(1:n) = ListGetReal( Material,KeywordName,n,Indexes,Found )

        IP = GaussPoints( Element )
        DO t=1,IP % n
          stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis )
          RealVal_AtIp = SUM( Basis(1:n) * RealVal(1:n) )
          OldCounter(key) = OldCounter(key) +  RealVal_AtIp * IP % s(t)
        END DO
      END DO
    END DO
    OldTimes(key) = RealTime() - OldTimes(key)
    

    NewTimes(key) = RealTime()  

    
    CALL ListInitElementKeyword( RealVal_h,'Material',KeywordName )
      
    DO i=1,TimeSweeps
      DO elem=1,NoActive
        Element => GetActiveElement(elem)

        CALL GetElementNodesVec( Nodes )
        n  = GetElementNOFNodes( Element )      
        IP = GaussPoints( Element )
        
        ! Number of gaussian integration points
        ngp = IP % n
        
        ! Compute values of all basis functions at all integration points
        stat = ElementInfoVec( Element, Nodes, ngp, &
            IP % U, IP % V, IP % W, DetJVec, n, BasisVec )
        
        RealValVec => ListGetElementRealVec( RealVal_h, ngp, BasisVec, Element, Found ) 
        NewCounter(key) = NewCounter(key) + SUM( RealValVec(1:ngp) * IP % s(1:ngp) )
      END DO
    END DO
    NewTimes(key) = RealTime() - NewTimes(key)

    PRINT *,'Compare integrals:', OldCounter(key), NewCounter(key), &
        NewCounter(key)/OldCounter(key)
    PRINT *,'Compare time consumptions:',OldTimes(key),NewTimes(key)
    PRINT *,'Speed-up for RealVec:',OldTimes(key)/NewTimes(key)
  END DO

 
  PseudoNorm = 1.0_dp * SUM(NewCounter) / SUM(OldCounter)
  PRINT *,'PseudoNorm:',PseudoNorm

  Solver % Variable % Values = PseudoNorm
  Solver % Variable % Norm = PseudoNorm
   
      
  CALL Info( 'KeywordCompare','Add done')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')


END SUBROUTINE KeywordCompare

SUBROUTINE LinearFormsAssembly( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Unit test for linear form / vectorized basis function computation
!  routines in Elmer
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
    USE DefUtils
    USE LinearForms
    USE ISO_C_BINDING
#ifdef _OPENMP
    USE omp_lib
#endif
!------------------------------------------------------------------------------
    IMPLICIT NONE
!------------------------------------------------------------------------------
    TYPE(Model_t) :: Model
    TYPE(Solver_t) :: Solver

    REAL(KIND=dp) :: dt
    LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
    REAL(KIND=dp), PARAMETER :: tol1d = 1D-12, tol2d=1D-12, tol3d=1D-12
    REAL(KIND=dp) :: float_P
    INTEGER :: nerror, netest, P
    LOGICAL :: Found
    
    nerror = 0
    float_P = ListGetCReal(GetSolverParams(), 'P', Found)
    IF (.NOT. Found) float_P = 6.0_dp
    P = NINT(float_P)
    
    ! 1D tests
    netest = TestLineElement(Solver, P, tol1d)
    IF (netest /= 0) THEN
       CALL Warn('LinearFormsAssembly','Line element contained errors')
    END IF
    nerror = nerror + netest
    
    ! ! 2D tests 
    netest = TestTriangleElement(Solver, P, tol2d)
    IF (netest /= 0) THEN
      CALL Warn('LinearFormsAssembly','Triangle element contained errors')
    END IF
    nerror = nerror + netest
    
    netest = TestQuadElement(Solver, P, tol2d)
    IF (netest /= 0) THEN
      CALL Warn('LinearFormsAssembly','Quad element contained errors')
    END IF
    nerror = nerror + netest

    ! ! 3D tests
    netest = TestTetraElement(Solver, P, tol3d)
    IF (netest /= 0) THEN
      CALL Warn('LinearFormsAssembly','Tetra element contained errors')
    END IF
    nerror = nerror + netest

    netest = TestWedgeElement(Solver, P, tol3d)
    IF (netest /= 0) THEN
      CALL Warn('LinearFormsAssembly','Wedge element contained errors')
    END IF
    nerror = nerror + netest

    netest = TestBrickElement(Solver, P, tol3d)
    IF (netest /= 0) THEN
      CALL Warn('LinearFormsAssembly','Brick element contained errors')
    END IF
    nerror = nerror + netest

    ! Build solution norm for error checking
    Solver % Variable % Norm = REAL(1+nerror,dp)
    Solver % Variable % Values = REAL(1+nerror,dp)
    
CONTAINS

  FUNCTION TestLineElement(Solver, P, tol) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    INTEGER, INTENT(IN) :: P
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror
    
    nerror = TestElement(Solver, 202, P, tol)
  END FUNCTION TestLineElement
  
  FUNCTION TestTriangleElement(Solver, P, tol) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    INTEGER, INTENT(IN) :: P
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror
    
    nerror = TestElement(Solver, 303, P, tol)
  END FUNCTION TestTriangleElement

  FUNCTION TestQuadElement(Solver, P, tol) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    INTEGER, INTENT(IN) :: P
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror
    
    nerror = TestElement(Solver, 404, P, tol)
  END FUNCTION TestQuadElement

  FUNCTION TestTetraElement(Solver, P, tol) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    INTEGER, INTENT(IN) :: P
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror
    
    nerror = TestElement(Solver, 504, P, tol)
  END FUNCTION TestTetraElement

  FUNCTION TestWedgeElement(Solver, P, tol) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    INTEGER, INTENT(IN) :: P
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror
    
    nerror = TestElement(Solver, 706, P, tol)
  END FUNCTION TestWedgeElement

  FUNCTION TestBrickElement(Solver, P, tol) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    INTEGER, INTENT(IN) :: P
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror
    
    nerror = TestElement(Solver, 808, P, tol)
  END FUNCTION TestBrickElement
  
  FUNCTION TestElement(Solver, ecode, P, tol) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    INTEGER, INTENT(IN) :: ecode
    INTEGER, INTENT(IN) :: P
    REAL(kind=dp), INTENT(IN) :: tol

    TYPE(Element_t), POINTER :: Element, SingleElement
    TYPE(Mesh_t), POINTER :: NewMesh, OldMesh
    REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:), FORCE(:), &
            STIFFvec(:,:), FORCEvec(:)

    INTEGER :: i, j, k, l, q, nerror, nbasis, nndof, allocstat, tag, nthr, &
            nbasisvec, ndbasisdxvec, rep, dim, lm_eval, lm_eval_vec, NumGP

    INTEGER, PARAMETER :: NREP = 100
    REAL(kind=dp) :: t_start, t_end, t_tot, t_startvec, t_endvec, t_tot_vec
    TYPE(GaussIntegrationPoints_t) :: Quadrature
    
    nerror = 0
    lm_eval = 0
    lm_eval_vec = 0
    t_tot = REAL(0,dp)
    t_tot_vec = REAL(0,dp)

    ! Create a mesh with a single element
    OldMesh => Solver % Mesh
    NewMesh => NULL()
    CALL AllocateMeshAndPElement(NewMesh, ecode, P, SingleElement)
    Solver % Mesh => NewMesh

    ! Insert P element definitions to Solver mapping (sets P elements as "active")
    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = ecode / 100
      Solver % Def_Dofs(tag,1,6) = P
    END IF
    IF (ecode==404) THEN
      Quadrature = GaussPointsQuad((P+1)**2)
    ELSE
      Quadrature = GaussPoints(SingleElement, PReferenceElement=.TRUE.)
    END IF
    NumGP = Quadrature % N
    
    !$OMP PARALLEL SHARED(Solver, SingleElement, ecode, tol) &
    !$OMP PRIVATE(STIFF, FORCE, STIFFvec, FORCEvec, &
    !$OMP         LOAD, Element, nndof, nbasis, &
    !$OMP         allocstat, rep, t_start, t_end, &
    !$OMP         t_startvec, t_endvec) &
    !$OMP REDUCTION(+:nerror,t_tot,t_tot_vec,lm_eval,lm_eval_vec) &
    !$OMP DEFAULT(NONE)
    
    ! Construct a temporary element based on the one created previously
    Element => ClonePElement(SingleElement)

    nndof = Element % Type % NumberOfNodes
    nbasis = nndof + GetElementNOFDOFs( Element )
    
    ! Reserve workspace
    ALLOCATE(STIFF(nbasis, nbasis), FORCE(nbasis), &
            STIFFvec(nbasis, nbasis), FORCEvec(nbasis), &
            LOAD(nndof), &
            STAT=allocstat)
    IF (allocstat /= 0) THEN
      CALL Fatal('LinearForms',&
              'Storage allocation for local matrices failed')
    END IF
    
    ! Initialize artificial load vector
    LOAD = REAL(1,dp)
    
    ! Warmup
    CALL LocalMatrix( STIFF, FORCE, LOAD, Element, nndof, nbasis)
    !$OMP BARRIER
    t_start = ftimer()
    DO rep=1,NREP
      ! Construct local matrix
!DIR$ NOINLINE
      CALL LocalMatrix( STIFF, FORCE, LOAD, Element, nndof, nbasis)
    END DO
    t_end = ftimer()
    lm_eval = NREP
    
    ! Warmup
    CALL LocalMatrixVec( STIFFvec, FORCEvec, LOAD, Element, nndof, nbasis)
    !$OMP BARRIER
    t_startvec = ftimer()
    DO rep=1,NREP
      ! Construct local matrix
!DIR$ NOINLINE
      CALL LocalMatrixVec( STIFFvec, FORCEvec, LOAD, Element, nndof, nbasis)
    END DO
    t_endvec = ftimer()
    lm_eval_vec = NREP

    nerror = TestLocalMatrix(nbasis, STIFF, STIFFvec, tol)
    nerror = nerror + TestLocalForce(nbasis, FORCE, FORCEvec, tol)

    t_tot = t_end - t_start
    t_tot_vec = t_endvec - t_startvec

    CALL DeallocatePElement(Element)
    DEALLOCATE(STIFF, FORCE, STIFFvec, FORCEvec, LOAD)

    !$OMP END PARALLEL

    ! Normalize the times / thread
    nthr = 1
    !$ nthr = omp_get_max_threads()
    t_tot = t_tot / nthr
    t_tot_vec = t_tot_vec / nthr
    CALL PrintTestData(SingleElement, NumGP, t_tot, lm_eval, &
            t_tot_vec, lm_eval_vec)

    CALL DeallocateTemporaryMesh(NewMesh)
    Solver % Mesh => OldMesh
    CALL DeallocatePElement(SingleElement)

    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = ecode / 100
      Solver % Def_Dofs(tag,1,6) = 0
    END IF
  END FUNCTION TestElement
  
  SUBROUTINE LocalMatrix( STIFF, FORCE, LOAD, Element, n, nd )
    IMPLICIT NONE
    REAL(KIND=dp) CONTIG :: STIFF(:,:), FORCE(:)
    REAL(KIND=dp) CONTIG, INTENT(IN) :: LOAD(:)
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),DetJ,LoadAtIP,Weight
    LOGICAL :: Stat
    INTEGER :: i,j,t,p,q,dim
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t), SAVE :: Nodes
    !$OMP THREADPRIVATE(Nodes)
!------------------------------------------------------------------------------
    CALL GetReferenceElementNodes( Nodes, Element )
    STIFF = 0.0d0
    FORCE = 0.0d0

    dim = Element % Type % Dimension
    !Numerical integration:
    !----------------------
    IF (Element % TYPE % ElementCode / 100 == 4) THEN
      IP = GaussPointsQuad((Element % PDefs % P+1)**2)
    ELSE
      IP = GaussPoints( Element, PReferenceElement=.TRUE. )
    END IF

    DO t=1,IP % n

      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
                           IP % W(t), detJ, Basis, dBasisdx)
      
      ! The source term at the integration point:
      !------------------------------------------
      LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )
      Weight = IP % s(t) * DetJ
      ! STIFF=STIFF+(grad u, grad v)
      STIFF(1:nd,1:nd) = STIFF(1:nd,1:nd) + Weight * &
            MATMUL( dBasisdx(1:nd,1:dim), TRANSPOSE( dBasisdx(1:nd,1:dim) ) )
      
      DO p=1,nd
        DO q=1,nd
          ! STIFF=STIFF+(grad u,v)
          ! -----------------------------------
          STIFF (p,q) = STIFF(p,q) + Weight * SUM(dBasisdx(q,1:dim)) * Basis(p)

          ! STIFF=STIFF+(u,v)
          STIFF(p,q) = STIFF(p,q) + Weight * Basis(q) * Basis(p)
        END DO
      END DO
      
      FORCE(1:nd) = FORCE(1:nd) + IP % s(t) * DetJ * LoadAtIP * Basis(1:nd)
    END DO
  END SUBROUTINE LocalMatrix

  SUBROUTINE LocalMatrixVec( STIFF, FORCE, LOAD, Element, n, nd )
!------------------------------------------------------------------------------
    IMPLICIT NONE
    REAL(KIND=dp) CONTIG :: STIFF(:,:), FORCE(:)
    REAL(KIND=dp) CONTIG, INTENT(IN) :: LOAD(:)
    INTEGER, INTENT(IN) :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    LOGICAL :: Stat
    INTEGER :: i, j, ngp, allocstat, gp
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t), SAVE :: Nodes
    REAL(KIND=dp), ALLOCATABLE, SAVE :: Basis(:,:), dBasisdx(:,:,:), &
            DetJ(:), LoadAtIPs(:)
    !$OMP THREADPRIVATE(Nodes, Basis, dBasisdx, DetJ, LoadAtIPs)
!------------------------------------------------------------------------------
    CALL GetReferenceElementNodes( Nodes, Element )

    STIFF = REAL(0, dp)
    FORCE = REAL(0, dp)

    ! Get integration points
    IF (Element % TYPE % ElementCode / 100 == 4) THEN
      IP = GaussPointsQuad((Element % PDefs % P+1)**2)
    ELSE
      IP = GaussPoints( Element, PReferenceElement=.TRUE. )
    END IF
    ngp = IP % n

    ! Reserve workspace
    IF (.NOT. ALLOCATED(Basis)) THEN
      ALLOCATE(Basis(ngp,nd), dBasisdx(ngp,nd,3), &
              DetJ(ngp), LoadAtIPs(ngp), STAT=allocstat)
      IF (allocstat /= 0) THEN
        CALL Fatal('LocalMatrixVec',&
                   'Storage allocation for local element basis failed')
      END IF
    ELSE IF (SIZE(Basis,1) /= ngp .OR. SIZE(Basis,2) /= nd) THEN
      DEALLOCATE(Basis, dBasisdx, DetJ, LoadAtIPs)
      ALLOCATE(Basis(ngp,nd), dBasisdx(ngp,nd,3), &
              DetJ(ngp), LoadAtIPs(ngp), STAT=allocstat)
      IF (allocstat /= 0) THEN
        CALL Fatal('LocalMatrixVec',&
                'Storage allocation for local element basis failed')
      END IF
    END IF
    
    ! Compute values of all basis functions at all integration points
    stat = ElementInfoVec( Element, Nodes, ngp, &
            IP % U, IP % V, IP % W, DetJ, SIZE(Basis,2), Basis, dBasisdx )

        
    ! Compute actual integration weights (recycle memory space of DetJ)
    DO i=1,ngp
       DetJ(i) = Ip % s(i)*Detj(i)
    END DO

    ! STIFF=STIFF+(grad u, grad u)
    CALL LinearForms_GradUdotGradU(ngp, nd, Element % TYPE % DIMENSION, &
             dBasisdx, DetJ, STIFF)
    ! STIFF=STIFF+(u,u)
    CALL LinearForms_UdotU(ngp, nd, Element % TYPE % DIMENSION, Basis, DetJ, STIFF)
    ! STIFF=STIFF+(grad u,v)
    CALL LinearForms_GradUdotU(ngp, nd, Element % TYPE % DIMENSION, dBasisdx, Basis, DetJ, STIFF)
    
    ! Source terms at IPs
    !------------------------------------------
    ! LoadAtIPs(1:ngp) = MATMUL( Basis(1:ngp,1:n), LOAD(1:n) )
    CALL LinearForms_ProjectToU(ngp, n, Basis, LOAD, LoadAtIPs)

    ! FORCE=FORCE+(u,f)
    CALL LinearForms_UdotF(ngp, nd, Basis, DetJ, LoadAtIPs, FORCE)
  END SUBROUTINE LocalMatrixVec

  FUNCTION TestLocalMatrix(nbasis, STIFF1, STIFF2, tol) RESULT(nerror)
    IMPLICIT NONE

    INTEGER, INTENT(IN) :: nbasis
    REAL(KIND=dp) CONTIG, INTENT(IN) :: STIFF1(:,:), STIFF2(:,:)
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror

    INTEGER :: i, j, dim

    nerror = 0
    ! Test element of local matrix 
    DO j=1,nbasis
      DO i=1,nbasis
        IF (ABS(STIFF1(i,j)-STIFF2(i,j)) >= tol) THEN
          nerror = nerror + 1
          WRITE (*,*) 'STIFF:', i,j,STIFF1(i,j), STIFF2(i,j)
        END IF
      END DO
    END DO
  END FUNCTION TestLocalMatrix
  
  FUNCTION TestLocalForce(nbasis, FORCE1, FORCE2, tol) RESULT(nerror)
    IMPLICIT NONE

    INTEGER, INTENT(IN) :: nbasis
    REAL(KIND=dp) CONTIG, INTENT(IN) :: FORCE1(:), FORCE2(:)
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror

    INTEGER :: i, dim

    nerror = 0
    ! Test element of local force vector
    DO i=1,nbasis
      IF (ABS(FORCE1(i)-FORCE2(i)) >= tol) THEN
        nerror = nerror + 1
        WRITE (*,*) 'FORCE:', i, FORCE1(i), FORCE2(i)
      END IF
    END DO
  END FUNCTION TestLocalForce

  SUBROUTINE GetReferenceElementNodes( ElementNodes, Element )
     TYPE(Nodes_t), TARGET :: ElementNodes
     TYPE(Element_t) :: Element

     INTEGER :: i, n, padn, sz, astat

     n = Element % TYPE % NumberOfNodes
     padn = n

     ! TODO: Implement padding
     IF (.NOT. ALLOCATED( ElementNodes % xyz)) THEN
       ! Deallocate old storage
       IF (ASSOCIATED(ElementNodes % x)) DEALLOCATE(ElementNodes % x) 
       IF (ASSOCIATED(ElementNodes % y)) DEALLOCATE(ElementNodes % y) 
       IF (ASSOCIATED(ElementNodes % z)) DEALLOCATE(ElementNodes % z) 

       ! Allocate new storage
       ALLOCATE(ElementNodes % xyz(padn,3))
       ElementNodes % xyz = REAL(0,dp)
       ElementNodes % x => ElementNodes % xyz(1:n,1)
       ElementNodes % y => ElementNodes % xyz(1:n,2)
       ElementNodes % z => ElementNodes % xyz(1:n,3)
     ELSE IF (SIZE(ElementNodes % xyz, 1)<padn) THEN
       DEALLOCATE(ElementNodes % xyz)
       ALLOCATE(ElementNodes % xyz(padn,3))
       ElementNodes % xyz = REAL(0,dp)
       ElementNodes % x => ElementNodes % xyz(1:n,1)
       ElementNodes % y => ElementNodes % xyz(1:n,2)
       ElementNodes % z => ElementNodes % xyz(1:n,3)
     ELSE
       ElementNodes % x => ElementNodes % xyz(1:n,1)
       ElementNodes % y => ElementNodes % xyz(1:n,2)
       ElementNodes % z => ElementNodes % xyz(1:n,3)
       sz = SIZE(ElementNodes % xyz,1)
       SELECT CASE(Element % TYPE % DIMENSION)
       CASE(1)
         DO i=n+1,sz
           ElementNodes % xyz(i,1) = REAL(0,dp)
         END DO
         DO i=1,sz
           ElementNodes % xyz(i,2) = REAL(0,dp)
           ElementNodes % xyz(i,3) = REAL(0,dp)
         END DO
       CASE(2)
         DO i=n+1,sz
           ElementNodes % xyz(i,1) = REAL(0,dp)
           ElementNodes % xyz(i,2) = REAL(0,dp)
         END DO
         DO i=1,sz
           ElementNodes % xyz(i,3) = REAL(0,dp)
         END DO
       CASE(3)
         DO i=n+1,sz
           ElementNodes % xyz(i,1) = REAL(0,dp)
           ElementNodes % xyz(i,2) = REAL(0,dp)
           ElementNodes % xyz(i,3) = REAL(0,dp)
         END DO
       CASE DEFAULT
         CALL Fatal('GetReferenceElementNodes','Unsupported element dimension')
       END SELECT
     END IF

     IF (isPElement(Element)) THEN
       CALL GetRefPElementNodes(Element % Type, &
               ElementNodes % x, &
               ElementNodes % y, & 
               ElementNodes % z)
     ELSE
       IF (ALLOCATED(Element % Type % NodeU)) THEN
         !DIR$ IVDEP
         DO i=1,n
           ElementNodes % x(i) = Element % Type % NodeU(i)
         END DO
       END IF
       IF (ALLOCATED(Element % Type % NodeV)) THEN
         !DIR$ IVDEP
         DO i=1,n
           ElementNodes % y(i) = Element % Type % NodeV(i)
         END DO
       END IF
       IF (ALLOCATED(Element % Type % NodeW)) THEN
         !DIR$ IVDEP
         DO i=1,n
           ElementNodes % z(i) = Element % Type % NodeW(i)
         END DO
       END IF
     END IF
  END SUBROUTINE GetReferenceElementNodes

  SUBROUTINE PrintTestData(Element, ngp, t_n1, evals1, t_n2, evals2)
  
    IMPLICIT NONE
    TYPE(Element_t) :: Element
    INTEGER, INTENT(IN) :: ngp, evals1, evals2
    REAL(kind=dp), INTENT(IN) :: t_n1, t_n2

    WRITE (*,'(A,I0)') 'Element type=', Element % TYPE % ElementCode
    IF (ASSOCIATED(Element % PDefs)) THEN
      WRITE (*,'(A,I0)') 'Element polynomial degree=', Element % PDefs % P
    END IF
    WRITE (*,'(A,L1)') 'Active P element=', isActivePElement(Element)
    WRITE (*,'(A,I0)') 'Element number of nodes=', Element % TYPE % NumberOfNodes
    WRITE (*,'(A,I0)') 'Element number of nonnodal dofs=', GetElementNOFDOFs(Element)
    WRITE (*,'(A,I0)') 'Element number of bubble dofs=', GetElementNOFBDOFs()
    WRITE (*,'(A,I0)') 'Number of Gauss points=', ngp
    WRITE (*,'(A,I0)') 'Nodal basis, number of local matrix evaluations=', evals1
    WRITE (*,'(A,F12.9)') 'Nodal  basis, local matrix assembly t(s):', t_n1
    WRITE (*,'(A,F12.2)') 'Nodal  basis, local matrix evaluations/sec:', evals1/t_n1
    WRITE (*,'(A,I0)') 'Vector basis, number of local matrix evaluations=', evals2 
    WRITE (*,'(A,F12.9)') 'Vector basis, local matrix assembly t(s):', t_n2
    WRITE (*,'(A,F12.2)') 'Vector basis, local matrix evaluations/sec:', evals2/t_n2

  END SUBROUTINE PrintTestData
  
  SUBROUTINE AllocateMeshAndPElement(Mesh, ElementCode, P, PElement)
    IMPLICIT NONE
    
    TYPE(Mesh_t), POINTER :: Mesh
    INTEGER, INTENT(IN) :: ElementCode, P
    TYPE(Element_t), POINTER :: PElement
    INTEGER :: node, edge, face, astat

    ! Allocate a mesh with a single element
    Mesh => AllocateMesh()
    ALLOCATE(Mesh % Elements(1), STAT=astat)
    IF (astat /= 0) THEN
      CALL Fatal('AllocateMeshAndElement','Allocation of mesh element failed')
    END IF
    Mesh % NumberOfBulkElements = 1

    ! Construct P element
    PElement => AllocateElement()
    PElement % ElementIndex = 1
    PElement % BodyId = 1
    PElement % Type => GetElementType( ElementCode )
    CALL AllocatePDefinitions(PElement)

    ! Add element node indexes to element
    ALLOCATE(PElement % NodeIndexes(PElement % Type % NumberOfNodes), STAT=astat)
    IF (astat /= 0) THEN
      CALL Fatal('AllocateMeshAndElement','Allocation of node indices failed')
    END IF
    PElement % NodeIndexes(:) = [(node, node=1,PElement % Type % NumberOfNodes)]

    IF (PElement % Type % Dimension > 1) THEN
      ! Add element edge indexes to element
      ALLOCATE(PElement % EdgeIndexes(PElement % Type % NumberOfEdges), STAT=astat)
      IF (astat /= 0) THEN
        CALL Fatal('AllocateMeshAndElement','Allocation of edge indices failed')
      END IF
      PElement % EdgeIndexes(:) = [(edge, edge=1,PElement % Type % NumberOfEdges)]
      
      ! Add all element edges to mesh
      ALLOCATE(Mesh % Edges(PElement % Type % NumberOfEdges), STAT=astat)
      IF (astat /= 0) THEN
        CALL Fatal('AllocateMeshAndElement','Allocation of mesh edges failed')
      END IF
      Mesh % NumberOfEdges = PElement % Type % NumberOfEdges
      ! Mesh % MinEdgeDofs = HUGE(Mesh % MinEdgeDofs)
      Mesh % MinEdgeDofs = 0
      Mesh % MaxEdgeDofs = 0
      DO edge=1,PElement % Type % NumberOfEdges
        CALL InitializePElement(Mesh % Edges(edge))
        ! Allocate edge element (always 202, even in 3D)
        Mesh % Edges(edge) % Type => GetElementType(202, .FALSE.)
        CALL AllocatePDefinitions(Mesh % Edges(edge))
        Mesh % Edges(edge) % PDefs % P = P
        Mesh % Edges(edge) % PDefs % isEdge = .TRUE.
        Mesh % Edges(edge) % PDefs % GaussPoints = (P+1) ** Mesh % Edges(edge) % Type % DIMENSION
        Mesh % Edges(edge) % PDefs % LocalNumber = edge
        Mesh % Edges(edge) % BDOFs = GetBubbleDofs(Mesh % Edges(edge), P)
        Mesh % MinEdgeDofs = MIN(Mesh % MinEdgeDofs, Mesh % Edges(edge) % BDOFs)
        Mesh % MaxEdgeDofs = MAX(Mesh % MaxEdgeDofs, Mesh % Edges(edge) % BDOFs)
      END DO
    END IF

    IF (PElement % Type % Dimension > 2) THEN
      ! Add element face indexes to element
      ALLOCATE(PElement % FaceIndexes(PElement % Type % NumberOfFaces))
      IF (astat /= 0) THEN
        CALL Fatal('AllocateMeshAndElement','Allocation of face indices failed')
      END IF
      PElement % FaceIndexes(:) = [(face, face=1,PElement % Type % NumberOfFaces)]
      
      ! Add element faces to mesh
      ALLOCATE(Mesh % Faces(PElement % Type % NumberOfFaces), STAT=astat)
      IF (astat /= 0) THEN
        CALL Fatal('AllocateMeshAndElement','Allocation of mesh faces failed')
      END IF
      Mesh % NumberOfFaces = PElement % Type % NumberOfFaces
      Mesh % MinFaceDofs = HUGE(Mesh % MinFaceDofs)
      Mesh % MaxFaceDofs = 0
      DO face=1,PElement % Type % NumberOfFaces
        CALL InitializePElement(Mesh % Faces(face))
        ! Allocate edge element (always 303 or 404, depending on element)
        SELECT CASE (ElementCode/100)
        CASE(5)
          Mesh % Faces(face) % Type => GetElementType(303, .FALSE.)
        CASE(6)
          IF ( face == 1 ) THEN
            Mesh % Faces(Face) % Type => GetElementType( 404, .FALSE. )
          ELSE
            Mesh % Faces(Face) % Type => GetElementType( 303, .FALSE. )
          END IF
        CASE(7)
          IF ( face <= 2 ) THEN
            Mesh % Faces(Face) % Type => GetElementType( 303, .FALSE. )
          ELSE
            Mesh % Faces(Face) % Type => GetElementType( 404, .FALSE. )
          END IF
        CASE(8)
          Mesh % Faces(Face) % Type => GetElementType( 404, .FALSE.)
        CASE DEFAULT
          CALL Fatal('AllocateMeshAndElement','Unknown element type')
        END SELECT
        CALL AllocatePDefinitions(Mesh % Faces(face))
        Mesh % Faces(face) % PDefs % P = P
        Mesh % Faces(face) % PDefs % isEdge = .TRUE.
        Mesh % Faces(face) % PDefs % GaussPoints = (P+1) ** Mesh % Faces(face) % Type % DIMENSION
        Mesh % Faces(face) % PDefs % LocalNumber = face
        Mesh % Faces(face) % BDOFs = GetBubbleDofs(Mesh % Faces(face), P)
        Mesh % MinFaceDofs = MAX(Mesh % MinFaceDofs, Mesh % Faces(face) % BDOFs)
        Mesh % MaxFaceDofs = MAX(Mesh % MaxFaceDofs, Mesh % Faces(face) % BDOFs)
      END DO
    END IF 

    PElement % BDofs = GetBubbleDofs( PElement, P )
    PElement % PDefs % P = P
    IF (ElementCode == 504) THEN
      PElement % PDefs % TetraType = 1
    ELSE
      PElement % PDefs % TetraType = 0
    END IF
    PElement % PDefs % isEdge = .FALSE.
    ! Set max element dofs to mesh
    Mesh % MaxElementDOFs = PElement % Type % NumberOfNodes + &
           PElement % Type % NumberOfEdges * Mesh % MaxEdgeDOFs + &
           PElement % Type % NumberOfFaces * Mesh % MaxFaceDOFs + &
           PElement % BDOFs

    PElement % PDefs % GaussPoints = (P+1) ** PElement % Type % DIMENSION
  END SUBROUTINE AllocateMeshAndPElement

  SUBROUTINE InitializePElement(Element)
    IMPLICIT NONE
    TYPE(Element_t) :: Element

    Element % BDOFs    =  0
    Element % NDOFs    =  0
    Element % BodyId   = 1
    Element % Splitted =  0
    Element % hK = 0
    Element % ElementIndex = 0
    Element % StabilizationMk = 0
    NULLIFY( Element % TYPE )
    NULLIFY( Element % PDefs )
    NULLIFY( Element % BubbleIndexes )
    NULLIFY( Element % DGIndexes )
    NULLIFY( Element % NodeIndexes )
    NULLIFY( Element % EdgeIndexes )
    NULLIFY( Element % FaceIndexes )
    NULLIFY( Element % BoundaryInfo )
  END SUBROUTINE InitializePElement

  FUNCTION ClonePElement(Element) RESULT(ClonedElement)
    IMPLICIT NONE
    TYPE(Element_t), POINTER :: Element, ClonedElement
    
    ALLOCATE(ClonedElement)
    CALL InitializePElement(ClonedElement)
    ClonedElement % BDOFs = Element % BDOFs
    ClonedElement % NDOFs =  Element % NDOFs
    ClonedElement % BodyId = Element % BodyId
    ClonedElement % Splitted = Element % Splitted 
    ClonedElement % hK = Element % hK
    ClonedElement % ElementIndex = Element % ElementIndex
    ClonedElement % StabilizationMk = Element % StabilizationMk
    ClonedElement % Type => Element % Type
    IF (ASSOCIATED(Element % PDefs)) THEN
      CALL AllocatePDefinitions(ClonedElement)
      ClonedElement % PDefs % P = Element % PDefs % P
      ClonedElement % PDefs % TetraType = Element % PDefs % TetraType
      ClonedElement % PDefs % isEdge = Element % PDefs % isEdge
      ClonedElement % PDefs % GaussPoints = Element % PDefs % GaussPoints
      ClonedElement % PDefs % pyramidQuadEdge = Element % PDefs % pyramidQuadEdge
      ClonedElement % PDefs % localNumber = Element % PDefs % localNumber
    END IF
    IF (ASSOCIATED( Element % NodeIndexes )) THEN
      ALLOCATE(ClonedElement % NodeIndexes( SIZE(Element % NodeIndexes)))
      ClonedElement % NodeIndexes(:) = Element % NodeIndexes(:)
    END IF
    IF (ASSOCIATED( Element % EdgeIndexes )) THEN
      ALLOCATE(ClonedElement % EdgeIndexes( SIZE(Element % EdgeIndexes)))
      ClonedElement % EdgeIndexes(:) = Element % EdgeIndexes(:)
    END IF
    IF (ASSOCIATED( Element % FaceIndexes )) THEN
      ALLOCATE(ClonedElement % FaceIndexes( SIZE(Element % FaceIndexes)))
      ClonedElement % FaceIndexes(:) = Element % FaceIndexes(:)
    END IF
  END FUNCTION ClonePElement
  
  SUBROUTINE DeallocatePElement(PElement)
    IMPLICIT NONE
    
    TYPE(Element_t), POINTER :: PElement

    IF (ASSOCIATED(PElement % PDefs)) DEALLOCATE(PElement % PDefs)
    IF (ASSOCIATED(PElement % NodeIndexes)) DEALLOCATE(PElement % NodeIndexes)
    IF (ASSOCIATED(PElement % EdgeIndexes)) DEALLOCATE(PElement % EdgeIndexes)
    IF (ASSOCIATED(PElement % FaceIndexes)) DEALLOCATE(PElement % FaceIndexes)
    DEALLOCATE(PElement)
  END SUBROUTINE DeallocatePElement

  SUBROUTINE DeallocateTemporaryMesh(Mesh)
    IMPLICIT NONE
 
     TYPE(Mesh_t), POINTER :: Mesh
     INTEGER :: edge, face

     IF (ASSOCIATED(Mesh % Elements)) DEALLOCATE(Mesh % Elements)
     DO edge=1,Mesh % NumberOfEdges
       IF (ASSOCIATED(Mesh % Edges(edge) % PDefs)) DEALLOCATE(Mesh % Edges(edge) % PDefs)
     END DO
     IF (ASSOCIATED(Mesh % Edges)) DEALLOCATE(Mesh % Edges)
     DO face=1,Mesh % NumberOfFaces
       IF (ASSOCIATED(Mesh % Faces(face) % PDefs)) DEALLOCATE(Mesh % Faces(face) % PDefs)
     END DO
     IF (ASSOCIATED(Mesh % Faces)) DEALLOCATE(Mesh % Faces)

     DEALLOCATE( Mesh % Nodes )
     DEALLOCATE( Mesh ) 
  END SUBROUTINE DeallocateTemporaryMesh
  
  ! Portable wall-clock timer
  FUNCTION ftimer() RESULT(timerval)
    IMPLICIT NONE
    
    REAL(KIND=dp) :: timerval
    INTEGER(KIND=8) :: t, rate
    
#ifdef _OPENMP
    timerval = OMP_GET_WTIME()
#else
    CALL SYSTEM_CLOCK(t,count_rate=rate)
    timerval = REAL(t,dp)/rate
#endif
  END FUNCTION ftimer

!------------------------------------------------------------------------------
END SUBROUTINE LinearFormsAssembly
!------------------------------------------------------------------------------

! The additional terms in the induction equation
! due to a time harmonic vertical field B_ac = B0 sin(wt) e_y

FUNCTION appliedB( model,n,t ) RESULT(c1)
   USE types

   TYPE(model_t) :: model
   INTEGER :: n
   REAL(KIND=dp) :: t,c1
   REAL(KIND=dp), PARAMETER :: B0=0.0001_dp, f=3_dp

! B_ac for nabla x ( v x B )
   c1 = B0 * SIN(2.0_dp*PI*f*t)

 END FUNCTION appliedB

FUNCTION applieddBdt( model,n,t ) RESULT(c2)
   USE types

   TYPE(model_t) :: model
   INTEGER :: n
   REAL(KIND=dp) :: t,c2,w
   REAL(KIND=dp), PARAMETER :: B0=0.0001_dp, f=3_dp

   w = 2.0_dp * PI * f
! -@B_ac/@t
   c2 = - B0 * w * COS(w*t)

 END FUNCTION applieddBdt

!
! *  Authors: Mika Malinen
! *  Email:   mika.malinen@csc.fi
! *  Original Date: March 8, 2019
!
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
  SUBROUTINE stvenant_kirchhoff(STRESS, STATEV, DDSDDE, SSE, SPD, SCD, &
       rpl, ddsddt, drplde, drpldt, STRAN, DSTRAN, TIME, DTIME, TEMP, dTemp, &
       predef, dpred, CMNAME, NDI, NSHR, NTENS, NSTATEV, PROPS, NPROPS, &
       coords, drot, pnewdt, celent, DFRGRD0, DFRGRD1, NOEL, NPT, layer, kspt, &
       kstep, kinc)
!------------------------------------------------------------------------------
    USE Types
    IMPLICIT NONE

    REAL(KIND=dp), INTENT(INOUT) :: STRESS(NTENS)
    ! Requirement for Elmer: At the time of calling the Cauchy stress T_n before
    ! the time/load increment is given
    ! Requirement for umat:  The stress T_{n+1}^{(k)} corresponding to the 
    ! current approximation of the strain increment (DSTRAN) must be returned. 
    ! If the strain increment is defined to be zero in the beginning of the
    ! nonlinear iteration, Elmer will generate a candidate for the strain increment
    ! by assuming purely elastic increment characterized by DDSDDE.

    REAL(KIND=dp), INTENT(INOUT) :: STATEV(NSTATEV)
    ! Requirement for Elmer: The state variables Q_n as specified at the 
    ! previous time/load level for converged solution are given.
    ! Requirement for umat:  The state variables Q_{n+1}^{(k)} corresponding to 
    ! the current approximation of the strain increment must be returned. If 
    ! convergence is attained, these values will be saved and associated with the 
    ! converged solution (cf. the input values)

    REAL(KIND=dp), INTENT(OUT) :: DDSDDE(NTENS,NTENS)
    ! The derivative of (Cauchy) stress response function with respect to the 
    ! strain evaluated for the current approximation must be returned

    REAL(KIND=dp), INTENT(INOUT) :: SSE, SPD, SCD
    ! Requirement for Elmer: Provide specific strain energy (sse), plastic 
    ! dissipation (spd) and creep dissipation (scd) at the previous time/load 
    ! level (these are supposed to be declared to be state variables)
    ! Requirement for umat:  The values of the energy variables corresponding to 
    ! the current approximation may be returned

    REAL(KIND=dp), INTENT(OUT) :: rpl
    ! The mechanical heating power (volumetric)

    REAL(KIND=dp), INTENT(OUT) :: ddsddt(NTENS), drplde(NTENS), drpldt

    REAL(KIND=dp), INTENT(IN) :: STRAN(NTENS)
    ! This gives the strains before the time/load increment.
    ! The strain can be computed from the deformation gradient, so this
    ! argument can be considered to be redundant. Elmer provides
    ! this information anyway. Abaqus assumes that the logarithmic strain 
    ! is used, but Elmer may also use other strain measures.

    REAL(KIND=dp), INTENT(IN) :: DSTRAN(NTENS)
    ! The current candidate for the strain increment to obtain the current 
    ! candidate for the stress. In principle this could be computed from the 
    ! deformation gradient; cf. the variable stran.

    REAL(KIND=dp), INTENT(IN) :: TIME(2)
    ! Both entries give time before the time/load increment (the time for the last
    ! converged solution

    REAL(KIND=dp), INTENT(IN) :: DTIME
    ! The time increment

    REAL(KIND=dp), INTENT(IN) :: TEMP
    ! Temperature before the time/load increment

    REAL(KIND=dp), INTENT(IN) :: dtemp
    ! Temperature increment associated wíth the time/load increment. Currently
    ! Elmer assumes isothermal conditions during the load increment.

    REAL(KIND=dp), INTENT(IN) :: predef(1), dpred(1)
    ! These are just dummy variables for Elmer

    CHARACTER(len=80), INTENT(IN) :: CMNAME
    ! The material model name

    INTEGER, INTENT(IN) :: NDI
    ! The number of direct stress components

    INTEGER, INTENT(IN) :: NSHR
    ! The number of the engineering shear strain components

    INTEGER, INTENT(IN) :: NTENS 
    ! The size of the array containing the stress or strain components

    INTEGER, INTENT(IN) :: NSTATEV
    ! The number of state variables associated with the material model

    REAL(KIND=dp), INTENT(IN) :: PROPS(NPROPS)
    ! An array of material constants

    INTEGER, INTENT(IN) :: NPROPS
    ! The number of the material constants

    REAL(KIND=dp), INTENT(IN) :: coords(3)
    ! The coordinates of the current point could be specified

    REAL(KIND=dp), INTENT(IN) :: drot(3,3)
    ! No support for keeping track of rigid body rotations 
    ! (the variable is initialized to the identity)

    REAL(KIND=dp), INTENT(INOUT) :: pnewdt
    ! Currently, suggesting a new size of time increment does not make any impact

    REAL(KIND=dp), INTENT(IN) :: celent
    ! The element size is not yet provided by Elmer

    REAL(KIND=dp), INTENT(IN) :: DFRGRD0(3,3)
    ! The deformation gradient before the time/load increment (at the previous 
    ! time/load level for converged solution)

    REAL(KIND=dp), INTENT(IN) :: DFRGRD1(3,3)
    ! The deformation gradient corresponding to the current approximation
    ! (cf. the return value of STRESS variable) 

    INTEGER, INTENT(IN) :: NOEL
    ! The element number

    INTEGER, INTENT(IN) :: NPT
    ! The integration point number

    INTEGER, INTENT(IN) :: layer, kspt, kstep, kinc
    ! kstep and kinc could be provided to give information on the incrementation
    ! procedure
!------------------------------------------------------------------------------

    INTEGER :: i, j, k

    REAL(KIND=dp) :: SymBasis(6,3,3)
    REAL(KIND=dp) :: Identity(3,3), B(3,3), C(3,3), Strain(3,3), S(3,3), Sigma(3,3)
    REAL(KIND=dp) :: WorkMat(3,3)
    REAL(KIND=dp) :: StrainVec(ntens), Stress2(ntens)
    REAL(KIND=dp) :: DetDefG
    REAL(KIND=dp) :: nu, E, LambdaLame, MuLame

!------------------------------------------------------------------------------

    SymBasis(1,1:3,1:3) = RESHAPE((/ 1,0,0,0,0,0,0,0,0 /),(/ 3,3 /))
    SymBasis(2,1:3,1:3) = RESHAPE((/ 0,0,0,0,1,0,0,0,0 /),(/ 3,3 /))
    SymBasis(3,1:3,1:3) = RESHAPE((/ 0,0,0,0,0,0,0,0,1 /),(/ 3,3 /)) 
    SymBasis(4,1:3,1:3) = RESHAPE((/ 0.0d0,0.5d0,0.0d0,0.5d0,0.0d0,0.0d0,0.0d0,0.0d0,0.0d0 /),(/ 3,3 /))
    SymBasis(5,1:3,1:3) = RESHAPE((/ 0.0d0,0.0d0,0.5d0,0.0d0,0.0d0,0.0d0,0.5d0,0.0d0,0.0d0 /),(/ 3,3 /))
    SymBasis(6,1:3,1:3) = RESHAPE((/ 0.0d0,0.0d0,0.0d0,0.0d0,0.0d0,0.5d0,0.0d0,0.5d0,0.0d0 /),(/ 3,3 /))
    Identity(1:3,1:3) = RESHAPE((/ 1,0,0,0,1,0,0,0,1 /),(/ 3,3 /))

    B = MATMUL(dfrgrd1, TRANSPOSE(dfrgrd1))
    C = MATMUL(TRANSPOSE(dfrgrd1), dfrgrd1)
    ! This example uses the Lagrangian (Green-St Venant) strain tensor:
    Strain = 0.5d0 * (C - Identity)
      
    DO i=1,ndi
      StrainVec(i) = Strain(i,i)
    END DO
    DO i=1,nshr
      SELECT CASE(i)
      CASE(1)
        StrainVec(ndi+i) = Strain(1,2)+Strain(2,1)
      CASE(2)
        StrainVec(ndi+i) = Strain(1,3)+Strain(3,1)
      CASE(3)
        StrainVec(ndi+i) = Strain(2,3)+Strain(3,2)
      END SELECT
    END DO

    DetDefG = Dfrgrd1(1,1) * ( Dfrgrd1(2,2)*Dfrgrd1(3,3) - Dfrgrd1(2,3)*Dfrgrd1(3,2) ) + &
        Dfrgrd1(1,2) * ( Dfrgrd1(2,3)*Dfrgrd1(3,1) - Dfrgrd1(2,1)*Dfrgrd1(3,3) ) + &
        Dfrgrd1(1,3) * ( Dfrgrd1(2,1)*Dfrgrd1(3,2) - Dfrgrd1(2,2)*Dfrgrd1(3,1) )

    ! Get Young's modulus and the Poisson ratio:
    E = Props(2)
    nu = Props(3)
    
    LambdaLame = E * nu / ( (1.0d0+nu) * (1.0d0-2.0d0*nu) )
    MuLame = E / (2.0d0 * (1.0d0 + nu))

    ! --------------------------------------------------------------------------------
    ! Here we compute the current stress directly by using the 
    ! supplied deformation gradient, so that the strain increment is not used. 
    ! In addition, since it seems that the exact differentiation of the response function 
    ! for the Cauchy stress cannot be done in a straightforward manner, we now make only
    ! a partial approximation. The Cauchy stress is given by
    ! 
    !     sigma(F) = 1/det(F) F S(E(F)) F^T
    !
    ! We however consider only the depedence on the strain as
    !
    !     sigma(.) = 1/det(F) F S(.) F^T
    !
    ! This simplification makes the nonlinear iteration to be an inexact Newton 
    ! method whose performance may deteriorate for large strains. If the convergence is 
    ! attained, the solution nevertheless obeys the St. Venant-Kirchhoff law since
    ! there are no approximations in the computation of the residual.
    ! --------------------------------------------------------------------------------
    ! The constitutive matrix relating the second Piola-Kirchhoff stress and
    ! the strain tensor:
    ddsdde = 0.0d0
    ddsdde(1:ndi,1:ndi) = LambdaLame
    DO i=1,ntens
      ddsdde(i,i) = ddsdde(i,i) + MuLame
    END DO
    DO i=1,ndi
      ddsdde(i,i) = ddsdde(i,i) + MuLame
    END DO
    Stress2 = MATMUL(ddsdde,StrainVec)

    ! The second Piola-Kirchhoff stress in the tensor form:
    S = 0.0d0
    DO i=1,ndi
      S = S + Stress2(i)*SymBasis(i,:,:)
    END DO
    DO i=1,nshr
      S = S + 2.0d0 * Stress2(ndi+i) * SymBasis(ndi+i,:,:)
    END DO

    ! The Cauchy stress tensor:
    Sigma = 1.0d0/DetDefG * MATMUL(dfrgrd1, MATMUL(S,TRANSPOSE(dfrgrd1)))

    DO i=1,ndi
      Stress(i) = Sigma(i,i)
    END DO
    DO i=1,nshr
      SELECT CASE(i)
      CASE(1)
        Stress(ndi+i) = Sigma(1,2)
      CASE(2)
        Stress(ndi+i) = Sigma(1,3)
      CASE(3)
        Stress(ndi+i) = Sigma(2,3)
      END SELECT
    END DO

    ! The derivative: The part corresponding to lambda * tr(E) I
    ddsdde = 0.0d0
    WorkMat = LambdaLame * 1/DetDefG * B
    DO i=1,ndi
      DO j=1,ndi
        ddsdde(j,i) = ddsdde(j,i) + WorkMat(j,j)
      END DO
      DO j=1,nshr
        SELECT CASE(j)
        CASE(1)
          ddsdde(ndi+j,i) = ddsdde(ndi+j,i) + WorkMat(1,2)
        CASE(2)
          ddsdde(ndi+j,i) = ddsdde(ndi+j,i) + WorkMat(1,3)
        CASE(3)
          ddsdde(ndi+j,i) = ddsdde(ndi+j,i) + WorkMat(2,3)
        END SELECT
      END DO
    END DO

    ! The rest corresponding to  2 * mu * E
    DO i=1,ndi
      WorkMat = 2.0d0 * MuLame * 1/DetDefG * MATMUL(dfrgrd1, MATMUL(SymBasis(i,:,:), TRANSPOSE(dfrgrd1)))
      DO j=1,ndi
        ddsdde(j,i) = ddsdde(j,i) + WorkMat(j,j)
      END DO
      DO j=1,nshr
        SELECT CASE(j)
        CASE(1)
          ddsdde(ndi+j,i) = ddsdde(ndi+j,i) + WorkMat(1,2)
        CASE(2)
          ddsdde(ndi+j,i) = ddsdde(ndi+j,i) + WorkMat(1,3)
        CASE(3)
          ddsdde(ndi+j,i) = ddsdde(ndi+j,i) + WorkMat(2,3)
        END SELECT
      END DO
    END DO

    DO i=1,nshr
      WorkMat = 2.0d0 * MuLame * 1/DetDefG * MATMUL(dfrgrd1, MATMUL(SymBasis(ndi+i,:,:), TRANSPOSE(dfrgrd1)))
      DO j=1,ndi
        ddsdde(j,ndi+i) = ddsdde(j,ndi+i) + 1.0d0 * WorkMat(j,j)
      END DO
      DO j=1,nshr
        SELECT CASE(j)
        CASE(1)
          ddsdde(ndi+j,ndi+i) = ddsdde(ndi+j,ndi+i) + 1.0d0 * WorkMat(1,2)
        CASE(2)
          ddsdde(ndi+j,ndi+i) = ddsdde(ndi+j,ndi+i) + 1.0d0 * WorkMat(1,3)
        CASE(3)
          ddsdde(ndi+j,ndi+i) = ddsdde(ndi+j,ndi+i) + 1.0d0 * WorkMat(2,3)
        END SELECT
      END DO
    END DO

!------------------------------------------------------------------------------
  END SUBROUTINE stvenant_kirchhoff
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!> Compare keyword strategies with and without a Handle. 
!> This test for logical, integer, and string.
!------------------------------------------------------------------------------
SUBROUTINE KeywordCompare( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  LOGICAL :: Found
  INTEGER :: t, NoActive
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Material, BodyForce
  TYPE(ValueHandle_t) :: LogA_h, LogB_h, LogC_h, LogD_h
  TYPE(ValueHandle_t) :: IntA_h, IntB_h, IntC_h, IntD_h
  TYPE(ValueHandle_t) :: StrA_h, StrB_h
  LOGICAL :: LogA, LogB, LogC, LogD
  INTEGER :: IntA, IntB, IntC, IntD
  CHARACTER(LEN=MAX_NAME_LEN) :: StrA, StrB     

  INTEGER :: i, TimeSweeps
  INTEGER :: OldCounter(4),NewCounter(4)
#ifndef USE_ISO_C_BINDINGS
  REAL(KIND=dp) :: CPUTime,RealTime
#endif
  REAL(KIND=dp) :: OldTimes(4), NewTimes(4), PseudoNorm
  
  ! Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  CALL Info( 'KeywordCompare','')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')
  CALL Info( 'KeywordCompare','Comparing keyword strategies')

  Mesh => GetMesh()

  
  NoActive = GetNOFActive()
  TimeSweeps = ListGetInteger( Solver % Values,'Timer Sweeps')

  OldTimes = 0.0_dp
  NewTimes = 0.0_dp
  OldCounter = 0
  NewCounter = 0


  CALL Info('KeywordCompare','Starting logical comparision')
  OldTimes(1) = RealTime()
  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetActiveElement(t)
      Material => GetMaterial()
      BodyForce => GetBodyForce()

      LogA = ListGetLogical( Material,'Logical Value A',Found )
      LogB = ListGetLogical( Material,'Logical Value B',Found )
      LogC = ListGetLogical( Material,'Logical Value C',Found )
      LogD = ListGetLogical( BodyForce,'Logical Value D',Found )

      IF( LogA ) OldCounter(1) = OldCounter(1) + 1
      IF( LogB ) OldCounter(1) = OldCounter(1) + 1
      IF( LogC ) OldCounter(1) = OldCounter(1) + 1
      IF( LogD ) OldCounter(1) = OldCounter(1) + 1
    END DO
  END DO
  OldTimes(1) = RealTime() - OldTimes(1)


  NewTimes(1) = RealTime()  
  CALL ListInitElementKeyword( LogA_h,'Material','Logical Value A' )
  CALL ListInitElementKeyword( LogB_h,'Material','Logical Value B' )
  CALL ListInitElementKeyword( LogC_h,'Material','Logical Value C')
  CALL ListInitElementKeyword( LogD_h,'Body Force','Logical Value D' )

  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetActiveElement(t)

      LogA = ListGetElementLogical( LogA_h, Element, Found )
      LogB = ListGetElementLogical( LogB_h, Element, Found )
      LogC = ListGetElementLogical( LogC_h, Found = Found )
      LogD = ListGetElementLogical( LogD_h )

      IF( LogA ) NewCounter(1) = NewCounter(1) + 1
      IF( LogB ) NewCounter(1) = NewCounter(1) + 1
      IF( LogC ) NewCounter(1) = NewCounter(1) + 1
      IF( LogD ) NewCounter(1) = NewCounter(1) + 1
    END DO
  END DO
  NewTimes(1) = RealTime() - NewTimes(1)



  CALL Info('KeywordCompare','Starting integer comparision')
  OldTimes(2) = RealTime()
  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetActiveElement(t)
      Material => GetMaterial()
      BodyForce => GetBodyForce()

      IntA = ListGetInteger( Material,'Integer Value A',Found )
      IntB = ListGetInteger( Material,'Integer Value B',Found )
      IntC = ListGetInteger( Material,'Integer Value C',Found )
      IntD = ListGetInteger( BodyForce,'Integer Value D',Found )

      OldCounter(2) = OldCounter(2) + IntA + IntB + IntC + IntD
    END DO
  END DO
  OldTimes(2) = RealTime() - OldTimes(2)


  NewTimes(2) = RealTime() 
  CALL ListInitElementKeyword( LogA_h,'Material','Integer Value A' )
  CALL ListInitElementKeyword( LogB_h,'Material','Integer Value B' )
  CALL ListInitElementKeyword( LogC_h,'Material','Integer Value C')
  CALL ListInitElementKeyword( LogD_h,'Body Force','Integer Value D' )

  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetActiveElement(t)

      IntA = ListGetElementInteger( LogA_h, Element, Found )
      IntB = ListGetElementInteger( LogB_h, Element, Found )
      IntC = ListGetElementInteger( LogC_h, Found = Found )
      IntD = ListGetElementInteger( LogD_h )

      NewCounter(2) = NewCounter(2) + IntA + IntB + IntC + IntD
    END DO
  END DO
  NewTimes(2) = RealTime() - NewTimes(2)



  CALL Info('KeywordCompare','Starting string comparision')
  OldTimes(3) = RealTime()
  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetActiveElement(t)
      Material => GetMaterial()
      BodyForce => GetBodyForce()

      StrA = ListGetString( Material,'String Value A',Found )
      StrB = ListGetString( Material,'String Value B',Found )

      IF( StrA == 'str target a' ) OldCounter(3) = OldCounter(3) + 1 
      IF( StrB == 'str target b' ) OldCounter(3) = OldCounter(3) + 1 
    END DO
  END DO
  OldTimes(3) = RealTime() - OldTimes(3)



  NewTimes(3) = RealTime()
  CALL ListInitElementKeyword( StrA_h,'Material','String Value A' )
  CALL ListInitElementKeyword( StrB_h,'Material','String Value B' )

  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetActiveElement(t)

      StrA = ListGetElementString( StrA_h, Element, Found )
      StrB = ListGetElementString( StrB_h, Element, Found )

      IF( StrA == 'str target a' ) NewCounter(3) = NewCounter(3) + 1 
      IF( StrB == 'str target b' ) NewCounter(3) = NewCounter(3) + 1 
    END DO
  END DO
  NewTimes(3) = RealTime() - NewTimes(3)


  NewTimes(4) = RealTime()   
  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetActiveElement(t)

      LogA = ListCompareElementString( StrA_h, 'str target a',Element, Found )
      LogB = ListCompareElementString( StrB_h, 'str target b',Element, Found )

      IF( LogA ) NewCounter(4) = NewCounter(4) + 1 
      IF( LogB ) NewCounter(4) = NewCounter(4) + 1 
    END DO
  END DO
  NewTimes(4) = RealTime() - NewTimes(4) 

  ! There is no old comparison for ListCompareelementString
  OldTimes(4) = OldTimes(3)
  OldCounter(4) = OldCounter(3)

  !PRINT *,'Old Counter:',OldCounter
  !PRINT *,'New Counter:',NewCounter

  PRINT *,'Speed-up for Logical:           ',OldTimes(1)/NewTimes(1)
  PRINT *,'Speed-up for Integer:           ',OldTimes(2)/NewTimes(2)
  PRINT *,'Speed-up for String:            ',OldTimes(3)/NewTimes(3)
  PRINT *,'Speed-up for String comparison: ',OldTimes(4)/NewTimes(4)

  PseudoNorm = 1.0_dp * SUM(NewCounter) / SUM(OldCounter)
  PRINT *,'PseudoNorm:',PseudoNorm

  Solver % Variable % Values = PseudoNorm
  Solver % Variable % Norm = PseudoNorm
   
      
  CALL Info( 'KeywordCompare','Add done')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')


END SUBROUTINE KeywordCompare

! Density (\rho) and density sensitivity to pressure (d\rho/dp) for ideal gases
! Formulas defined around reference pressure. 

FUNCTION GasDensity( Model, n, dpres ) RESULT( rho)
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: dpres, rho

  REAL(KIND=dp) :: Pres0, Rho0, Ratio, InvRatio
  LOGICAL :: Visited  = .FALSE.
  TYPE(ValueList_t), POINTER :: Material
  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp) :: pres, comp

  SAVE Visited, Pres0, Rho0, Ratio, InvRatio


  IF( .NOT. Visited ) THEN
    Mesh => GetMesh()

    Material => GetMaterial( Mesh % Elements(1) )

    Ratio = ListGetCReal( Material,'Specific Heat Ratio')
    InvRatio = 1.0_dp / Ratio
    Rho0 = ListGetCReal( Material,'Equilibrium Density')
    Pres0 = ListGetCReal( Material,'Equilibrium Pressure')

    Visited = .TRUE.
  END IF

  rho = Rho0 * ( dpres/pres0 + 1.0_dp )**InvRatio     

END FUNCTION GasDensity


FUNCTION GasDrhodp( Model, n, dpres ) RESULT( drhodp )
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: dpres, drhodp

  REAL(KIND=dp) :: Pres0, Rho0, Ratio, InvRatio
  LOGICAL :: Visited  = .FALSE.
  TYPE(ValueList_t), POINTER :: Material
  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp) :: coeff, pres, rho, comp

  SAVE Visited, Pres0, Rho0, Ratio, InvRatio, Coeff


  IF( .NOT. Visited ) THEN
    Material => GetMaterial()
    Mesh => GetMesh()
    Ratio = ListGetCReal( Material,'Specific Heat Ratio')
    InvRatio = 1.0_dp / Ratio
    Rho0 = ListGetCReal( Material,'Equilibrium Density')
    Pres0 = ListGetCReal( Material,'Equilibrium Pressure')

    Coeff = Rho0 / ( Ratio * Pres0**InvRatio )

    Visited = .TRUE.
  END IF

  drhodp = Coeff * (dpres+pres0)**(InvRatio-1)

END FUNCTION GasDrhodp

SUBROUTINE HeatCondUniso( Model, n, t, f )
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t
  REAL(KIND=dp) :: f(:,:)  ! this size needs to be consistent with the sif file!

!  REAL(KIND=dp) :: x,y,z
!  TYPE(Mesh_t), POINTER :: Mesh
    
!  Mesh => GetMesh()
!  x = Mesh % Nodes % x(n)   
!  y = Mesh % Nodes % y(n)   
!  z = Mesh % Nodes % z(n)   

  PRINT *,'size',t,SIZE(f)

  f(1,1) = 1.0_dp + t / 5.0_dp
  f(1,2) = 0.0_dp 
  f(2,1) = 0.0_dp
  f(2,2) = 20.0_dp - 2.0_dp * t
  
END SUBROUTINE HeatCondUniso

!------------------------------------------------------------------------------
!> Compare keyword strategies with and without a Handle. 
!> This test for real valued keywords.
!------------------------------------------------------------------------------
SUBROUTINE KeywordCompare( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  LOGICAL :: Found
  INTEGER :: t, NoActive
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Material, BodyForce
  TYPE(ValueHandle_t) :: RealVal_h
  INTEGER :: i, TimeSweeps, key
  REAL(KIND=dp) :: OldCounter(10),NewCounter(10)
#ifndef USE_ISO_C_BINDINGS
  REAL(KIND=dp) :: CPUTime,RealTime
#endif
  REAL(KIND=dp) :: OldTimes(10), NewTimes(10), PseudoNorm, Val
  
  
  REAL(KIND=dp), ALLOCATABLE :: Basis(:), OldValAtIp(:,:)
  REAL(KIND=dp), POINTER :: RealVal(:,:,:) => NULL(), NewValAtIp(:,:)
  REAL(KIND=dp) :: DetJ
  TYPE(GaussIntegrationPoints_t) :: IP
  TYPE(Nodes_t) :: Nodes
  INTEGER :: elem, n, fdim, n1, n2, i1, i2, rdim
  INTEGER, POINTER :: Indexes(:)
  LOGICAL :: Stat
  CHARACTER(LEN=20) :: KeywordName
  
  SAVE Nodes, RealVal

  ALLOCATE( RealVal(1,1,1) )
  
  CALL Info( 'KeywordCompare','')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')
  CALL Info( 'KeywordCompare','Comparing keyword strategies for real values')

  Mesh => GetMesh()

  n = 20
  ALLOCATE( Basis(n), OldValAtIp(3,3) )
  
  
  NoActive = GetNOFActive()
  TimeSweeps = ListGetInteger( Solver % Values,'Timer Sweeps')

  OldTimes = 0.0_dp
  NewTimes = 0.0_dp
  OldCounter = 0.0_dp
  NewCounter = 0.0_dp


  CALL Info('KeywordCompare','Starting real value keyword comparision')
  OldTimes(1) = RealTime()

  DO key = 1, 10
    KeywordName = 'Float Value '//TRIM(I2S(key))
    PRINT *,'Testing keyword: '//TRIM(KeywordName)
    
    OldTimes(key) = RealTime()  
    DO i=1,TimeSweeps
      DO elem=1,NoActive
        Element => GetActiveElement(elem)
        Material => GetMaterial()
        
        CALL GetElementNodes( Nodes )
        n  = GetElementNOFNodes()
        indexes => Element % NodeIndexes

        
        CALL ListGetRealArray( Material,KeywordName,RealVal,N,Indexes,Found )

        IF(.NOT. Found ) CYCLE
        
        n1 = SIZE( RealVal, 1 )
        n2 = SIZE( RealVal, 2 ) 

        
        IP = GaussPoints( Element )
        DO t=1,IP % n
          stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis )

          DO i1=1,n1
            DO i2=1,n2
              OldValAtIp(i1,i2) = SUM( Basis(1:n) * RealVal(i1,i2,1:n) )
            END DO
          END DO

          OldCounter(key) = OldCounter(key) +  SUM(OldValAtIp(1:n1,1:n2)) * IP % s(t) 
        END DO
      END DO
    END DO
    OldTimes(key) = RealTime() - OldTimes(key)

    

    NewTimes(key) = RealTime()  
    
    CALL ListInitElementKeyword( RealVal_h,'Material',KeywordName )
      
    DO i=1,TimeSweeps
      DO elem=1,NoActive
        Element => GetActiveElement(elem)

        CALL GetElementNodes( Nodes )
        n  = GetElementNOFNodes()      

        IP = GaussPoints( Element )
        DO t=1,IP % n
          stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis )
          Val = ListGetElementReal( RealVal_h, Basis, Element, Found, Rdim = Rdim, Rtensor = NewValAtIp )          
          IF(.NOT. Found ) CYCLE
          
          IF( Rdim == 0 ) CALL Fatal('KeywordCompare','All test keywords here should be tensors!')
          
          NewCounter(key) = NewCounter(key) + SUM( NewValAtIp ) * IP % s(t)
        END DO

      END DO
    END DO
    NewTimes(key) = RealTime() - NewTimes(key)

    PRINT *,'Compare integrals:', OldCounter(key), NewCounter(key), &
        NewCounter(key)/OldCounter(key)
    PRINT *,'Compare time consumptions:',OldTimes(key),NewTimes(key),&
        OldTimes(key)/NewTimes(key)
  END DO


  PseudoNorm = 1.0_dp * SUM(NewCounter) / SUM(OldCounter)
  PRINT *,'PseudoNorm:',PseudoNorm

  Solver % Variable % Values = PseudoNorm
  Solver % Variable % Norm = PseudoNorm
   
      
  CALL Info( 'KeywordCompare','Add done')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')


END SUBROUTINE KeywordCompare

!-------------------------------------------------------------
! Gives the x(or y) component of tangential reaction force
! multiplied by a friction coefficient.
!
! The subroutine is needed because when we use the model for 
! friction force where the nodal loads in normal direction is
! multiplied by a friction coefficient we end in problems for
! normal-tangential coordinate system. There we need to eliminate
! the tangential reaction force from the loads.
!-------------------------------------------------------------
  FUNCTION TangentForce( Model, n, t ) RESULT(f)
    USE DefUtils
    IMPLICIT NONE

    TYPE(Model_t) :: Model
    INTEGER :: n
    REAL(KIND=dp) :: t,f
!-------------------------------------------------------------
    INTEGER :: i,j,LoadDofs
    REAL(KIND=dp) :: Normal(3), Force(3),NormalForce,Mu
    TYPE(Element_t), POINTER :: Element
    TYPE(Nodes_t) :: ElementNodes
    TYPE(Variable_t), POINTER :: LoadVar
    INTEGER, POINTER :: LoadPerm(:)
    REAL(KIND=dp), POINTER :: LoadValues(:)
    LOGICAL :: Visited = .FALSE.

    SAVE Visited, ElementNodes, LoadPerm, LoadDofs, LoadValues


    IF( .NOT. Visited ) THEN
      LoadVar => VariableGet( Model % Variables,'Displacement Loads')
      IF( .NOT. ASSOCIATED( LoadVar ) ) THEN
        CALL Fatal('TangentForce','No > Displacement Loads < given!')
      END IF
      LoadDofs = LoadVar % Dofs
      IF( LoadDofs /= 2 ) THEN
        CALL Fatal('TangentForce','Implemented only for 2D!')
      END IF

      LoadValues => LoadVar % Values
      LoadPerm => LoadVar % Perm
    END IF

    Mu = 0.5_dp

    Element => Model % CurrentElement       
    CALL GetElementNodes( ElementNodes, Element )
    Normal = NormalVector( Element, ElementNodes, 0.0d0, 0.0d0 )

    Force = 0.0_dp
    DO i=1,LoadDofs
      j = LoadPerm(n)
      IF( j == 0 ) CYCLE
      Force(i) = LoadValues( LoadDofs * (j-1) + i )
    END DO

    ! This sign convention seems to be consistent for outer normals
    NormalForce = -SUM( Force * Normal ) 

    f = Mu * NormalForce

  END FUNCTION TangentForce
!-------------------------------------------------------------

SUBROUTINE PoissonSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the Poisson equation!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element

  LOGICAL :: AllocationsDone = .FALSE., Found

  INTEGER :: n, t, istat, active
  REAL(KIND=dp) :: Norm

  TYPE(ValueList_t), POINTER :: BodyForce
  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:), FORCE(:)

  SAVE STIFF, LOAD, FORCE, AllocationsDone
!------------------------------------------------------------------------------

  Mesh => GetMesh()

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     N = Mesh % MaxElementNodes ! just big enough for elemental arrays
     ALLOCATE( FORCE(N), LOAD(N), STIFF(N,N), STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'PoissonSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

   !Initialize the system and do the assembly:
   !------------------------------------------
   CALL DefaultInitialize()

   active = GetNOFActive()
   DO t=1,active
      Element => GetActiveElement(t)
      n = GetElementNOFNodes()

      LOAD = 0.0d0
      BodyForce => GetBodyForce()
      IF ( ASSOCIATED(BodyForce) ) &
         Load(1:n) = GetReal( BodyForce, 'Source', Found )

      !Get element local matrix and rhs vector:
      !----------------------------------------
      CALL LocalMatrix(  STIFF, FORCE, LOAD, Element, n )

      !Update global matrix and rhs vector from local matrix & vector:
      !---------------------------------------------------------------
      CALL DefaultUpdateEquations( STIFF, FORCE )
   END DO

   CALL DefaultFinishAssembly()
   CALL DefaultDirichletBCs()
   Norm = DefaultSolve()

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, LOAD, Element, n )
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: STIFF(:,:), FORCE(:), LOAD(:)
    INTEGER :: n
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(n),dBasisdx(n,3),DetJ,LoadAtIP
    LOGICAL :: Stat
    INTEGER :: t
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    FORCE = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
       ! Basis function values & derivatives at the integration point:
       !--------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
               IP % W(t),  detJ, Basis, dBasisdx )

       ! The source term at the integration point:
       !------------------------------------------
       LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )

       ! Finally, the elemental matrix & vector:
       !----------------------------------------
       STIFF(1:n,1:n) = STIFF(1:n,1:n) + IP % s(t) * DetJ * &
            MATMUL( dBasisdx, TRANSPOSE( dBasisdx ) )
       FORCE(1:n) = FORCE(1:n) + IP % s(t) * DetJ * LoadAtIP * Basis(1:n)
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------
END SUBROUTINE PoissonSolver
!------------------------------------------------------------------------------

FUNCTION Source( Model, n, f ) RESULT(h)
   USE Lists
   TYPE(Model_t) :: Model
   INTEGER :: n
   REAL(KIND=dp) :: f, h, x, s

   INTEGER :: i, Step, OldStep = -1
   TYPE(Variable_t), POINTER :: T, P

    T => VariableGet( Model % Variables, 'Time' )
    Step = NINT( T % Values(1) )

    P => VariableGet( Model % Variables, 'Potential' )

!   First check the previous result
!   -------------------------------
    IF ( Step>1 .AND. Step /= OldStep ) THEN
       DO i=1,Model % NumberOfNodes
          x = Model % Nodes % x(i)
          s = P % Values( P % Perm(i) )
          SELECT CASE(Step)
             CASE(2) ! can we solve a zero field ?
                IF ( s /= 0 ) &
                   CALL Fatal( 'Source', 'Not able to integrate a zero field ?')
             CASE(3) ! how about a  parabola ?
                IF ( ABS(s+(x**2-PI*x)/2) > 1.0d-10 ) &
                   CALL Fatal( 'Source', 'Not able to integrate parabola ?' )
             CASE(4) ! how about a third degree polynomial
                IF ( ABS(s+(x**3-PI**2*x)/6) > 1.0d-10 ) &
                   CALL Fatal( 'Source', 'Not able to integrate 3d deg polynomial?' )
             CASE(5) ! how about a sine
                IF ( ABS(s-2*sin(x)) > 1.0d-4 ) &
                   CALL Fatal( 'Source', 'Not able to integrate sine?' )
          END SELECT
       END DO
       OldStep = Step
    END IF

!   Then define new one
!   -------------------
    x = Model % Nodes % x(n)

    SELECT CASE(Step)
       CASE(1) ! can we solve a zero field ?
          h = 0
       CASE(2) ! how about a  parabola ?
          h = 1
       CASE(3) ! how about a third degree polynomial
          h = x
       CASE(4) ! how about a sine
          h = f
       CASE(5) ! how about a sine
          h = f
    END SELECT
END FUNCTION Source

SUBROUTINE EdgeElementSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the best approximation of the vector field U = (0,0,xy^3/6+yx^3/6)
!  with respect to the energy norm using H(curl)-conforming basis functions. 
!  Additionally, compute the relative error of the solution using
!  the energy norm. Here the energy norm corresponds to the operator 
!  I + curl curl. This solver can thus be used for checking that
!  the convergence rate is quadratic as expected.
 
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Found
  TYPE(Element_t), POINTER :: Element
  TYPE(Nodes_t) :: Nodes
  TYPE(ValueList_t), POINTER :: BodyForce, Material, BC
  TYPE(Variable_t), POINTER :: Var

  REAL(KIND=dp) :: Norm, u, v, w, Err, EK, SolNorm, MatPar = 1.0d-0

  INTEGER :: n, ne, nf, nb, np, nd, t, istat, i, j, k, l, active, dim

  REAL(KIND=dp), ALLOCATABLE :: LOAD(:,:), Acoef(:)
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), FORCE(:)

  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(Matrix_t), POINTER :: A

  LOGICAL :: stat, PiolaVersion, ErrorEstimation, UseTabulatedBasis
  LOGICAL :: UseEnergyNorm

  INTEGER, ALLOCATABLE :: Indices(:)

  SAVE STIFF, LOAD, FORCE, Acoef, AllocationsDone, Nodes, Indices
!------------------------------------------------------------------------------

  PiolaVersion = .TRUE.
  dim = CoordinateSystemDimension()

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  Mesh => GetMesh()

  IF ( .NOT. AllocationsDone ) THEN
     N = Mesh % MaxElementDOFs  ! just big enough
     ALLOCATE( FORCE(N), LOAD(6,N), STIFF(N,N), &
          Acoef(N), Indices(N), STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'EdgeElementSolver', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF
  
  Solver % Matrix % COMPLEX = .FALSE.
  A => GetMatrix()

  ErrorEstimation = GetLogical( GetSolverParams(), 'Error Computation', Found)
  UseEnergyNorm = GetLogical( GetSolverParams(), 'Use Energy Norm', Found)
!  UseTabulatedBasis = GetLogical( GetSolverParams(), 'Tabulate Basis', Found)
  UseTabulatedBasis = .FALSE.

  !-----------------------
  ! System assembly:
  !----------------------
  active = GetNOFActive()
  CALL DefaultInitialize()

  DO t=1,active
     Element => GetActiveElement(t)
     n  = GetElementNOFNodes() ! The number of nodes corresponding to the background mesh
     nd = GetElementNOFDOFs()  
     nb = GetElementNOFBDOFs()

     LOAD = 0.0d0
     IF (.FALSE.) THEN     
        BodyForce => GetBodyForce()
        IF ( ASSOCIATED(BodyForce) ) THEN
           Load(1,1:n) = GetReal( BodyForce, 'Body Source 1', Found )
           Load(2,1:n) = GetReal( BodyForce, 'Body Source 2', Found )
           Load(3,1:n) = GetReal( BodyForce, 'Body Source 3', Found )
        END IF
     END IF

     Acoef(1:n) = 1.0d0
     IF (.FALSE.) THEN
        Material => GetMaterial( Element )
        IF ( ASSOCIATED(Material) ) THEN
           Acoef(1:n) = GetReal( Material, 'Conductivity', Found )
           IF (.NOT. Found) CALL Fatal( 'NedelecSolve', 'Conductivity must be specified' )
        END IF
     END IF

     !Get element local matrix and rhs vector:
     !----------------------------------------
     CALL LocalMatrix( STIFF, FORCE, LOAD, Acoef, Element, n, nd+nb, dim, UseTabulatedBasis)

     !Update global matrix and rhs vector from local matrix & vector:
     !---------------------------------------------------------------
     CALL DefaultUpdateEquations( STIFF, FORCE )

  END DO

  CALL DefaultFinishBulkAssembly()
  CALL DefaultFinishAssembly()

  CALL DefaultDirichletBCs()

  Norm = DefaultSolve()  

  !-------------------------------------------------------------------
  ! Compute the error norm for the model problem considered. Note that
  ! this part has not been modified to support the option
  ! Tabulate Basis = Logical True.
  !--------------------------------------------------------------------
  IF (ErrorEstimation) THEN
     Err = 0.0d0
     SolNorm = 0.0d0
     DO t=1,Solver % NumberOfActiveElements
        Element => GetActiveElement(t)
        n  = GetElementNOFNodes()
        nd = GetElementDOFs( Indices )

        Load(1,1:nd) = Solver % Variable % Values( Solver % Variable % &
             Perm(Indices(1:nd)) )

        CALL MyComputeError(Load, Element, n, nd, dim, Err, SolNorm, UseEnergyNorm)
     END DO

     WRITE (*, '(A,E16.8)') 'Error Norm = ', SQRT(ParallelReduction(Err))/SQRT(ParallelReduction(SolNorm))
  END IF

CONTAINS




!---------------------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, LOAD, Acoef, Element, n, nd, dim, UseTabulatedBasis)
!---------------------------------------------------------------------------------------------
    REAL(KIND=dp) :: STIFF(:,:), FORCE(:), LOAD(:,:), Acoef(:)
    TYPE(Element_t), POINTER :: Element
    INTEGER :: n, nd, dim
    LOGICAL :: UseTabulatedBasis 
    !------------------------------------------------------------------------------
    REAL(KIND=dp) :: nu
    REAL(KIND=dp) :: EBasis(nd,3), CurlEBasis(nd,3), F(3,3), G(3,3)
    REAL(KIND=dp) :: dBasisdx(n,3)
    REAL(KIND=dp) :: Basis(n), DetJ, xq, yq, zq, uq, vq, wq, sq
    LOGICAL :: Stat, Found
    INTEGER :: t, i, j, p, q, np

    TYPE(GaussIntegrationPoints_t) :: IP
    TYPE(Nodes_t), SAVE :: Nodes
    ! ----------------------------------------------------------------------------
    INTEGER :: PermVec(nd)
    REAL(KIND=dp) :: SignVec(nd)
    REAL(KIND=dp) :: ReadyBasis(nd,3), ReadyCurlBasis(nd,3)

    LOGICAL, SAVE :: BricksVisited = .FALSE., PrismsVisited = .FALSE.
    LOGICAL, SAVE :: PyramidsVisited = .FALSE., TetraVisited = .FALSE.

    REAL(KIND=dp), TARGET :: TetraBasis(6,12), TetraCurlBasis(6,12)
    REAL(KIND=dp), TARGET :: PyramidBasis(10,36), PyramidCurlBasis(10,36)
    REAL(KIND=dp), TARGET :: PrismBasis(15,54), PrismCurlBasis(15,54)
    REAL(KIND=dp), TARGET :: BrickBasis(27,81), BrickCurlBasis(27,81)
    REAL(KIND=dp), POINTER :: BasisTable(:,:), CurlBasisTable(:,:)

    SAVE PrismBasis, PrismCurlBasis, BrickBasis, BrickCurlBasis
    SAVE TetraBasis, TetraCurlBasis, PyramidBasis, PyramidCurlBasis
    !------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )

    STIFF = 0.0d0
    FORCE = 0.0d0

    !-------------------------------------
    ! Numerical integration over element:
    !-------------------------------------
    IP = GaussPoints(Element, EdgeBasis=.TRUE., PReferenceElement=PiolaVersion, &
         EdgeBasisDegree=2)    

    IF (UseTabulatedBasis .AND. PiolaVersion) THEN
       !----------------------------------------------------------------------------
       ! Obtain the data for permuting basis function positions and applying 
       ! sign reversions. This data is the same for all integration points.
       ! If elements of this type has not yet been visited, tabulate basis
       ! function values to avoid the recomputation.
       !----------------------------------------------------------------------------
       IF ( (GetElementFamily() == 5 .AND. TetraVisited) .OR. &
            (GetElementFamily() == 6 .AND. PyramidsVisited) .OR. &
            (GetElementFamily() == 7 .AND. PrismsVisited) .OR. &            
            (GetElementFamily() == 8 .AND. BricksVisited) ) THEN
          CALL ReorderingAndSignReversionsData(Element,Nodes,PermVec,SignVec)

       ELSE
          !---------------------------------------------------------------------------
          ! The first visit for this element type, tabulate the basis function values.
          !---------------------------------------------------------------------------
          CALL ReorderingAndSignReversionsData(Element,Nodes,PermVec,SignVec)
          DO t=1,IP % n
             stat = EdgeElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
                  IP % W(t), DetF=detJ, Basis=Basis, EdgeBasis=EBasis, RotBasis=CurlEBasis, &
                  ApplyPiolaTransform = .FALSE.)
             !------------------------------------------------------------------------
             ! Revert order and sign changes to the reference element default
             ! and tabulate the values for later usage
             !------------------------------------------------------------------------
             DO i=1,nd
                EBasis(i,1:3) = SignVec(i) * EBasis(i,1:3)
                CurlEBasis(i,1:3) = SignVec(i) * CurlEBasis(i,1:3)
             END DO

             SELECT CASE( GetElementFamily() )
             CASE(5)
                DO i=1,nd
                   j = PermVec(i)
                   TetraBasis(i,(t-1)*3+1:(t-1)*3+3) = EBasis(j,1:3)
                   TetraCurlBasis(i,(t-1)*3+1:(t-1)*3+3) = CurlEBasis(j,1:3)               
                END DO
             CASE(6)
                DO i=1,nd
                   j = PermVec(i)
                   PyramidBasis(i,(t-1)*3+1:(t-1)*3+3) = EBasis(j,1:3)
                   PyramidCurlBasis(i,(t-1)*3+1:(t-1)*3+3) = CurlEBasis(j,1:3)               
                END DO
             CASE(7)
                DO i=1,nd
                   j = PermVec(i)
                   PrismBasis(i,(t-1)*3+1:(t-1)*3+3) = EBasis(j,1:3)
                   PrismCurlBasis(i,(t-1)*3+1:(t-1)*3+3) = CurlEBasis(j,1:3)               
                END DO
             CASE(8)
                DO i=1,nd
                   j = PermVec(i)
                   BrickBasis(i,(t-1)*3+1:(t-1)*3+3) = EBasis(j,1:3)
                   BrickCurlBasis(i,(t-1)*3+1:(t-1)*3+3) = CurlEBasis(j,1:3)               
                END DO
             END SELECT
                
          END DO

          SELECT CASE( GetElementFamily() )
          CASE(5)
             TetraVisited = .true.
             CALL Info( 'EdgeElementSolver', 'TETRAHEDRAL BASIS FUNCTIONS WERE TABULATED', Level=10)
             WRITE(Message,'(A,I2)') 'Integration points ', IP % n
             CALL Info('EdgeElementSolver', Message, Level=10) 
          CASE(6)
             PyramidsVisited = .TRUE.
             CALL Info( 'EdgeElementSolve', 'PYRAMIDICAL BASIS FUNCTIONS WERE TABULATED', Level=10)
             WRITE(Message,'(A,I2)') 'Integration points ', IP % n
             CALL Info('EdgeElementSolver', Message, Level=10) 
          CASE(7)
             PrismsVisited = .TRUE.
             CALL Info( 'EdgeElementSolve', 'PRISM BASIS FUNCTIONS WERE TABULATED', Level=10)
             WRITE(Message,'(A,I2)') 'Integration points ', IP % n
             CALL Info('EdgeElementSolver', Message, Level=10) 
          CASE(8)
             BricksVisited = .TRUE.
             CALL Info( 'EdgeElementSolve', 'BRICK BASIS FUNCTIONS WERE TABULATED', Level=10)
             WRITE(Message,'(A,I2)') 'Integration points ', IP % n
             CALL Info('EdgeElementSolver', Message, Level=10) 
          END SELECT
       END IF
    END IF
    
    np = 0  ! Set np = n, if nodal dofs are employed; otherwise set np = 0

    DO t=1,IP % n

       IF (PiolaVersion) THEN
          IF (UseTabulatedBasis) THEN
             SELECT CASE(Element % TYPE % ElementCode / 100)
             CASE(5)
                BasisTable => TetraBasis(1:6,(t-1)*3+1:(t-1)*3+3)
                CurlBasisTable => TetraCurlBasis(1:6,(t-1)*3+1:(t-1)*3+3)
             CASE(6)
                BasisTable => PyramidBasis(1:10,(t-1)*3+1:(t-1)*3+3)
                CurlBasisTable => PyramidCurlBasis(1:10,(t-1)*3+1:(t-1)*3+3)                
             CASE(7)
                BasisTable => PrismBasis(1:15,(t-1)*3+1:(t-1)*3+3)
                CurlBasisTable => PrismCurlBasis(1:15,(t-1)*3+1:(t-1)*3+3) 
             CASE(8)
                BasisTable => BrickBasis(1:27,(t-1)*3+1:(t-1)*3+3)
                CurlBasisTable => BrickCurlBasis(1:27,(t-1)*3+1:(t-1)*3+3)                   
             CASE DEFAULT
                CALL Fatal( 'EdgeElementSolver', 'THE BASIS FUNCTIONS FOR THIS ELEMENT TYPE NONTABULATED' )
             END SELECT
             !----------------------------------------------------------------
             ! Permute, apply sign reversions and apply the Piola transform via
             ! calling EdgeElementInfo:
             !----------------------------------------------------------------
             DO i=1,nd
                ReadyBasis(PermVec(i),1:3) = BasisTable(i,1:3)
                ReadyCurlBasis(PermVec(i),1:3) = CurlBasisTable(i,1:3)
             END DO
             DO i=1,nd 
                ReadyBasis(i,1:3) = SignVec(i) * ReadyBasis(i,1:3)
                ReadyCurlBasis(i,1:3) = SignVec(i) * ReadyCurlBasis(i,1:3)
             END DO
             stat = EdgeElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
                  IP % W(t), DetF=detJ, Basis=Basis, EdgeBasis=EBasis, &
                  RotBasis=CurlEBasis, ApplyPiolaTransform = .TRUE., &
                  ReadyEdgeBasis=ReadyBasis, ReadyRotBasis = ReadyCurlBasis) 

          ELSE
             stat = EdgeElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
                  IP % W(t), detF=detJ, Basis=Basis, EdgeBasis=EBasis, &
                  RotBasis=CurlEBasis, ApplyPiolaTransform = .TRUE., &
                  BasisDegree = 2)
          END IF

       ELSE
          stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
               IP % W(t), detJ, Basis, dBasisdx )
          CALL GetEdgeBasis(Element, EBasis, CurlEBasis, Basis, dBasisdx)
       END IF

       xq = SUM( Nodes % x(1:n) * Basis(1:n) )
       yq = SUM( Nodes % y(1:n) * Basis(1:n) )
       zq = SUM( Nodes % z(1:n) * Basis(1:n) )

       !nu = SUM( Basis(1:n) * Acoef(1:n) )
 
       !----------------------------------------------------------------
       ! The following branch could be used to produce the 
       ! Galerkin projection of a solution component for visualization.
       !------------------------------------------------------------------
       IF (np > 0) THEN
          DO p = 1,n
             DO q = 1,n       
                STIFF(p,q) = STIFF(p,q) + Basis(p) * Basis(q) * detJ * IP % s(t)    
             END DO

             DO q = 1,nd-np
                j = np + q
                STIFF(p,j) = STIFF(p,j) - EBasis(q,3) * Basis(p) * detJ * IP % s(t)
             END DO
          END DO
       END IF

       !--------------------------------------------------------------
       ! The equations for H(curl)-conforming part...
       !---------------------------------------------------------------
       DO p = 1,nd-np
          !----------------------------
          ! The inner product (u,v)_E
          !----------------------------
          i = np + p
          DO q = 1,nd-np
             j = np + q
             STIFF(i,j) = STIFF(i,j) + 1.0d0 * &
                  SUM( EBasis(q,1:dim) * EBasis(p,1:dim) ) * detJ * IP % s(t) + &
                  MatPar * SUM( CurlEBasis(q,1:dim) * CurlEBasis(p,1:dim) ) * detJ * IP % s(t)
          END DO
          
          !----------------------------------------
          ! RHS corresponding to the exact solution 
          !----------------------------------------
          FORCE(i) = FORCE(i) +  (0.0d0) * EBasis(p,1) * detJ * IP % s(t) + &
               (0.0d0)* EBasis(p,2) * detJ * IP % s(t) + &
               1.0d0/6.0d0*(yq*xq**3+xq*yq**3) * EBasis(p,3) * detJ * IP % s(t) + &
               MatPar * (1.0d0/6.0d0*xq**3+xq*yq**2/2.0d0) * CurlEBasis(p,1) * detJ * IP % s(t) + &
               MatPar * (-1.0d0/6.0d0*yq**3-yq*xq**2/2.0d0) * CurlEBasis(p,2) * detJ * IP % s(t) + &
               MatPar * (0.0d0) * CurlEBasis(p,3) * detJ * IP % s(t)
          
       END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------



!----------------------------------------------------------------------------------
  SUBROUTINE MyComputeError(LOAD, Element, n, nd, dim, EK, SolNorm, UseEnergyNorm)
!----------------------------------------------------------------------------------
    REAL(KIND=dp) :: Load(:,:), EK, SolNorm
    TYPE(Element_t), POINTER :: Element    
    INTEGER :: n, nd, dim
    LOGICAL :: UseEnergyNorm
!--------------------------------------------------------------------------------
    REAL(KIND=dp) :: EBasis(nd,3), CurlEBasis(nd,3)
    REAL(KIND=dp) :: Basis(n), DetJ, xq, yq, zq, uq, vq, wq, sq, &
         u(3), rotu(3), sol(3), rotsol(3), e(3), rote(3), F(3,3), G(3,3)
    REAL(KIND=dp) :: dBasisdx(n,3)
    LOGICAL :: Stat, Found
    INTEGER :: t, i, j, p, q, np
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t), SAVE :: Nodes
    !------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )

    !-------------------------------------
    ! Numerical integration over element:
    !-------------------------------------
    IP = GaussPoints(Element, EdgeBasis=.TRUE., PReferenceElement=PiolaVersion, EdgeBasisDegree=2) 

    np = 0  ! Set np = n, if nodal dofs are employed; otherwise set np = 0

    DO t=1,IP % n

       IF (PiolaVersion) THEN
          stat = EdgeElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
               IP % W(t), F, G, detJ, Basis, EBasis, CurlEBasis, ApplyPiolaTransform = .TRUE., BasisDegree=2)
       ELSE
          stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
               IP % W(t), detJ, Basis, dBasisdx )
          CALL GetEdgeBasis(Element, EBasis, CurlEBasis, Basis, dBasisdx)
       END IF

       xq = SUM( Nodes % x(1:n) * Basis(1:n) )
       yq = SUM( Nodes % y(1:n) * Basis(1:n) )
       zq = SUM( Nodes % z(1:n) * Basis(1:n) )

       u(1) = SUM( Load(1,np+1:nd) * EBasis(1:nd-np,1) )
       u(2) = SUM( Load(1,np+1:nd) * EBasis(1:nd-np,2) )
       u(3) = SUM( Load(1,np+1:nd) * EBasis(1:nd-np,3) )

       rotu(1) = SUM( Load(1,np+1:nd) * CurlEBasis(1:nd-np,1) )
       rotu(2) = SUM( Load(1,np+1:nd) * CurlEBasis(1:nd-np,2) )
       rotu(3) = SUM( Load(1,np+1:nd) * CurlEBasis(1:nd-np,3) )       

       ! Compute the square of the energy norm of the solution and error:
       sol = 0.0d0
       sol(1) = 0.0d0
       sol(2) = 0.0d0
       sol(3) = 1.0d0/6.0d0*(yq*xq**3 + xq*yq**3)
       rotsol(1:3) = 0.0d0
       rotsol(1) = rotsol(1) + 1.0d0/6.0d0*xq**3+xq*yq**2/2.0d0
       rotsol(2) = rotsol(2) - 1.0d0/6.0d0*yq**3-yq*xq**2/2.0d0
       e(:) = sol(:) - u(:)  
       rote(:) = rotsol(:) - rotu(:)

       IF (UseEnergyNorm) THEN
          ! Energy norm 
          SolNorm = SolNorm + (SUM( Sol(1:3) * Sol(1:3) ) + MatPar * SUM( rotsol(1:3) * rotsol(1:3) )) * detJ
          EK = EK + (SUM( e(1:3) * e(1:3) ) + MatPar * SUM( rote(1:3) * rote(1:3) )) * detJ
       ELSE
          ! L2 norm
          SolNorm = SolNorm + SUM( Sol(1:3) * Sol(1:3) )* detJ
          EK = EK + SUM( e(1:3) * e(1:3) )* detJ
       END IF
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE MyComputeError
!-----------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE EdgeElementSolver
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
!> Compare keyword strategies with and without a Handle. 
!> This test for real valued keywords.
!------------------------------------------------------------------------------
SUBROUTINE KeywordCompare( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  LOGICAL :: Found
  INTEGER :: t, NoActive
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Material, BodyForce
  TYPE(ValueHandle_t) :: RealValLua_h, RealValMatc_h
  INTEGER :: i, key
  REAL(KIND=dp) :: OldCounter(10),NewCounter(10), DiffCounter(10)
#ifndef USE_ISO_C_BINDINGS
  REAL(KIND=dp) :: CPUTime,RealTime
#endif
  REAL(KIND=dp) :: PseudoNorm, Val
  
  
  REAL(KIND=dp), ALLOCATABLE :: Basis(:), OldValAtIp_lua(:,:), OldValAtIp_matc(:,:)
  REAL(KIND=dp), POINTER :: RealVal_lua(:,:,:) => NULL(), realval_matc(:,:,:), &
      ValAtIp_lua(:,:) => NULL(), ValAtIp_matc(:,:) => NULL(), realval_lua_vec(:,:) => NULL(), &
      RealVal_matc_vec(:,:) => NULL()
  REAL(KIND=dp) :: DetJ
  TYPE(GaussIntegrationPoints_t) :: IP
  TYPE(Nodes_t) :: Nodes
  INTEGER :: elem, n, fdim, n1, n2, i1, i2, rdim
  INTEGER, POINTER :: Indexes(:)
  LOGICAL :: Stat
  CHARACTER(LEN=13) :: KeywordName_lua, keywordname_matc
  CHARACTER(len=8) :: suffixes = 'abcdefgh'
  
  SAVE Nodes

  
  CALL Info( 'KeywordCompare','')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')
  CALL Info( 'KeywordCompare','Comparing keyword strategies for real values')

  Mesh => GetMesh()

  n = 20
  ALLOCATE( Basis(n), OldValAtIp_lua(3,3), OldValAtIp_matc(3,3), &
      realval_lua(1,1,1), realval_matc(1,1,1), realval_lua_vec(1,1), realval_matc_vec(1,1) ) 
  
  
  NoActive = GetNOFActive()

  PseudoNorm = 0.0_dp

  CALL Info('KeywordCompare','Starting real value keyword comparision')

  OldCounter = 0.0_dp
  NewCounter = 0.0_dp
  DiffCounter = 0.0_dp
  DO key = 1, 4, 2 ! Test odd keys with ListGetRealVec TODO: should fail {{{
    call set_keyword_names()
    PRINT *,'Testing keywords: '//TRIM(KeywordName_lua) // ' and ' // trim(KeywordName_matc)
    ! CALL ListInitElementKeyword( RealVal_h,'Material',KeywordName_lua )

    ! Skipping for now since it fails
    
    DO elem=1,NoActive
      Element => GetActiveElement(elem)
      Material => GetMaterial()

      CALL GetElementNodes( Nodes )
      n  = GetElementNOFNodes()
      indexes => Element % NodeIndexes
      ALLOCATE(realval_matc_vec(3,N), realval_lua_vec(3,N))

      Found = .false.
      CALL ListGetRealVector( Material, KeywordName_lua,  RealVal_lua_vec,  N, Indexes, Found )
      IF(.NOT. Found ) then
        print *, '>'// KeywordName_Lua //'< not found'
        CYCLE
      end if
      CALL ListGetRealVector( Material, KeywordName_matc, RealVal_matc_vec, N, Indexes, Found )
      IF(.NOT. Found ) then
        print *, '>'// KeywordName_matc //'< not found'
        CYCLE
      end if


      n1 = SIZE( RealVal_lua_vec, 1 )
      n2 = 1

      IP = GaussPoints( Element )
      DO t=1,IP % n
        stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), detJ, Basis )

        DO i1=1,n1
          DO i2=1,n2
            OldValAtIp_lua(i1,i2) = SUM( Basis(1:n) * RealVal_lua_vec(i1,1:n) )
            OldValAtIp_matc(i1,i2) = SUM( Basis(1:n) * RealVal_matc_vec(i1,1:n) )
          END DO
        END DO

        newcounter(key) = Newcounter(key)+  SUM(OldValAtIp_lua(1:n1,1:n2)) * IP % s(t) 
        oldcounter(key) = oldcounter(key)+  SUM(OldValAtIp_matc(1:n1,1:n2)) * IP % s(t) 
        DiffCounter(key) = DiffCounter(key) +  SUM(OldValAtIp_lua(1:n1,1:n2)-OldValAtIp_matc(1:n1,1:n2)) * IP % s(t) 
      END DO
    END DO

    call printit()
    PseudoNorm = PseudoNorm + (2.0_dp*DiffCounter(key) / (NewCounter(key) + OldCounter(key)))
  END DO ! }}}

  DiffCounter = 0.0_dp
  NewCounter = 0.0_dp
  OldCOunter = 0.0_dp
  DO key = 1, 4 ! test all values with ListGetRealArray {{{
    call set_keyword_names()
    PRINT *,'Testing keywords: '//TRIM(KeywordName_lua) // ' and ' // trim(KeywordName_matc)
    ! CALL ListInitElementKeyword( RealVal_h,'Material',KeywordName_lua )

    DO elem=1,NoActive
      Element => GetActiveElement(elem)
      Material => GetMaterial()

      CALL GetElementNodes( Nodes )
      n  = GetElementNOFNodes()
      indexes => Element % NodeIndexes


      CALL ListGetRealArray( Material,KeywordName_lua,RealVal_lua,N,Indexes,Found )
      CALL ListGetRealArray( Material,KeywordName_matc,RealVal_matc,N,Indexes,Found )

      IF(.NOT. Found ) CYCLE

      n1 = SIZE( RealVal_lua, 1 )
      n2 = SIZE( RealVal_lua, 2 ) 


      IP = GaussPoints( Element )
      DO t=1,IP % n
        stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), detJ, Basis )

        DO i1=1,n1
          DO i2=1,n2
            OldValAtIp_lua(i1,i2) = SUM( Basis(1:n) * RealVal_lua(i1,i2,1:n) )
            OldValAtIp_matc(i1,i2) = SUM( Basis(1:n) * RealVal_matc(i1,i2,1:n) )
          END DO
        END DO

        newcounter(key) = Newcounter(key)+  SUM(OldValAtIp_lua(1:n1,1:n2)) * IP % s(t) 
        oldcounter(key) = oldcounter(key)+  SUM(OldValAtIp_matc(1:n1,1:n2)) * IP % s(t) 
        DiffCounter(key) = DiffCounter(key) +  SUM(OldValAtIp_lua(1:n1,1:n2)-OldValAtIp_matc(1:n1,1:n2)) * IP % s(t) 
      END DO
    END DO

    call printit()
    PseudoNorm = PseudoNorm + (2.0_dp*DiffCounter(key) / (NewCounter(key) + OldCounter(key)))
  END DO ! }}}
  ! PseudoNorm = PseudoNorm + sum(2.0_dp*DiffCounter(1:4) / (NewCounter(1:4) + OldCounter(1:4)))

  DiffCounter = 0.0_dp
  NewCounter = 0.0_dp
  OldCOunter = 0.0_dp
  DO key = 1, 4 ! use handles {{{ 
    call set_keyword_names()
    ! KeywordName_lua = 'Float Value '//TRIM(I2S(key))
    ! KeywordName_matc = 'Float Value '//TRIM(I2S(key+4))
    PRINT *,'Testing keywords using handles: '//TRIM(KeywordName_lua) // ' and ' // trim(KeywordName_matc)

    CALL ListInitElementKeyword( RealValLua_h,'Material',KeywordName_lua )
    CALL ListInitElementKeyword( RealValMatc_h,'Material',KeywordName_matc )

    DO elem=1,NoActive
      Element => GetActiveElement(elem)
      Material => GetMaterial()

      CALL GetElementNodes( Nodes )
      n  = GetElementNOFNodes()
      indexes => Element % NodeIndexes



      IF(.NOT. Found ) CYCLE

      n1 = SIZE( RealVal_lua, 1 )
      n2 = SIZE( RealVal_lua, 2 ) 

      IP = GaussPoints( Element )
      DO t=1,IP % n
        stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
            IP % W(t), detJ, Basis )
        Val = ListGetElementReal( RealValLua_h, Basis, Element, Found, Rdim = Rdim, Rtensor = ValAtIp_lua )
        Val = ListGetElementReal( RealValMatc_h, Basis, Element, Found, Rdim = Rdim, Rtensor = ValAtIp_matc )

        DO i1=1,n1
          DO i2=1,n2
            OldValAtIp_lua(i1,i2) = SUM( Basis(1:n) * RealVal_lua(i1,i2,1:n) )
            OldValAtIp_matc(i1,i2) = SUM( Basis(1:n) * RealVal_matc(i1,i2,1:n) )
          END DO
        END DO

        newcounter(key) = Newcounter(key)+  SUM(OldValAtIp_lua(1:n1,1:n2)) * IP % s(t) 
        oldcounter(key) = oldcounter(key)+  SUM(OldValAtIp_matc(1:n1,1:n2)) * IP % s(t) 
        DiffCounter(key) = DiffCounter(key) +  SUM(OldValAtIp_lua(1:n1,1:n2)-OldValAtIp_matc(1:n1,1:n2)) * IP % s(t) 
      END DO
    END DO

    call printit()
    PseudoNorm = PseudoNorm + (2.0_dp*DiffCounter(key) / (NewCounter(key) + OldCounter(key)))
  END DO ! }}}


  ! PseudoNorm = PseudoNorm + sum(2.0_dp*DiffCounter(1:4) / (NewCounter(1:4) + OldCounter(1:4)))
  PRINT *,'PseudoNorm:',PseudoNorm

  Solver % Variable % Values = PseudoNorm
  Solver % Variable % Norm = PseudoNorm
   
      
  CALL Info( 'KeywordCompare','Add done')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')

  contains
    subroutine set_keyword_names()
      KeywordName_lua = 'Float Value '//suffixes(key:key)
      KeywordName_matc = 'Float Value '//suffixes(key+4:key+4)
    end subroutine

    subroutine printit()
      print *,'Compare integrals (old, new, rel diff):', oldcounter(key), newcounter(key), &
          2.0_dp*DiffCounter(key)  / (NewCounter(key) + OldCounter(key))
    end subroutine

END SUBROUTINE KeywordCompare

!------------------------------------------------------------------------------
!> Compare keyword strategies with and without a Handle. 
!> This test for logical, integer, and string.
!------------------------------------------------------------------------------
SUBROUTINE KeywordCompare( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  LOGICAL :: Found
  INTEGER :: t, NoActive
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Material, BodyForce
  TYPE(ValueHandle_t) :: A_h, B_h, C_h, D_h
  LOGICAL :: ValL, StrL
  INTEGER :: ValI
  REAL(KIND=dp) :: ValR 
  CHARACTER(LEN=MAX_NAME_LEN) :: ValC

  INTEGER :: i, TimeSweeps
  INTEGER :: OldCounter(4),NewCounter(4)
#ifndef USE_ISO_C_BINDINGS
  REAL(KIND=dp) :: CPUTime,RealTime
#endif
  REAL(KIND=dp) :: OldTime, NewTime, PseudoNorm
  TYPE(ValueList_t), POINTER :: BC

  
  ! Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  CALL Info( 'KeywordCompare','')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')
  CALL Info( 'KeywordCompare','Comparing keyword strategies for BCs')

  Mesh => GetMesh()

  
  NoActive = GetNOFBoundaryElements()
  TimeSweeps = ListGetInteger( Solver % Values,'Timer Sweeps')

  OldTime = 0.0_dp
  NewTime = 0.0_dp
  OldCounter = 0
  NewCounter = 0

  
  CALL Info('KeywordCompare','Starting bc keyword comparision')
  OldTime = RealTime()
  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetBoundaryElement(t)
      IF( .NOT. ActiveBoundaryElement()) CYCLE
      
      CurrentModel % CurrentElement => Element
      BC => GetBC(Element)
      
      IF(.NOT. ASSOCIATED( BC ) ) CYCLE
      
      ValL = ListGetLogical( BC,'Logical Value A',Found )
      ValI = ListGetInteger( BC,'Integer Value B',Found )
      ValR = ListGetCReal( BC,'Float Value C',Found )
      ValC = ListGetString( BC,'String Value D',Found )
      StrL = ( ValC == 'string target d') 
      
      IF( ValL ) OldCounter(1) = OldCounter(1) + 1
      OldCounter(2) = OldCounter(2) + ValI
      OldCounter(3) = OldCounter(3) + ValR
      IF( StrL ) OldCounter(4) = OldCounter(4) + 1 
    END DO
  END DO
  OldTime = RealTime() - OldTime
  CALL Info('KeywordCompare','finished testing old keyword style')


  NewTime = RealTime()  
  CALL ListInitElementKeyword( A_h,'Boundary Condition','Logical Value A' )
  CALL ListInitElementKeyword( B_h,'Boundary Condition','Integer Value B' )
  CALL ListInitElementKeyword( C_h,'Boundary Condition','Float Value C' )
  CALL ListInitElementKeyword( D_h,'Boundary Condition','String Value D' )

  DO i=1,TimeSweeps
    DO t=1,NoActive
      Element => GetBoundaryElement(t)
      IF( .NOT. ActiveBoundaryElement()) CYCLE
     
      ValL = ListGetElementLogical( A_h, Element, Found )
      ValI = ListGetElementInteger( B_h, Element, Found )
      ValR = ListGetElementReal( C_h, Found = Found )
      StrL = ListCompareElementString( D_h, 'string target d',Element, Found )
      
      IF( ValL ) NewCounter(1) = NewCounter(1) + 1
      NewCounter(2) = NewCounter(2) + ValI
      NewCounter(3) = NewCounter(3) + ValR
      IF( StrL ) NewCounter(4) = NewCounter(4) + 1
    END DO
  END DO
  NewTime = RealTime() - NewTime


  PRINT *,'Old Counter:',OldCounter
  PRINT *,'New Counter:',NewCounter

  PRINT *,'Speed-up for BC operations:           ',OldTime / NewTime

  PseudoNorm = 1.0_dp * SUM(NewCounter) / SUM(OldCounter)
  PRINT *,'PseudoNorm:',PseudoNorm

  Solver % Variable % Values = PseudoNorm
  Solver % Variable % Norm = PseudoNorm
        
  CALL Info( 'KeywordCompare','Add done')
  CALL Info( 'KeywordCompare','----------------------------------------------------------')


END SUBROUTINE KeywordCompare

SUBROUTINE StokesSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
! A Navier-Stokes solver for Q1/Q0 elemnt
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Newton = .FALSE., Found, Convect
  TYPE(Element_t),POINTER :: Element

  INTEGER :: i,j,k,l,n, nb, nd, t, istat, dim, BDOFs=1,Active, dofs
  REAL(KIND=dp) :: Norm = 0, PrevNorm, RelC, Pressure

  TYPE(ValueList_t), POINTER :: BodyForce, Material
  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp), ALLOCATABLE, SAVE :: STIFF(:,:), LOAD(:,:), &
    FORCE(:), rho(:), mu(:), Velocity(:,:), MASS(:,:)

  TYPE(Variable_t), POINTER :: P

  INTEGER, ALLOCATABLE, SAVE :: Indexes(:), pCount(:)
!------------------------------------------------------------------------------

   dim = CoordinateSystemDimension()
   Mesh => GetMesh()
   DOFs = Solver % Variable % DOFs

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     n = (dim+1)*(Mesh % MaxElementDOFs+BDOFs)  ! just big enough for elemental arrays
     ALLOCATE( FORCE(n), LOAD(n,4), STIFF(n,n), MASS(n,n), &
         rho(n), mu(n), Velocity(dim+1,n), Indexes(n),STAT=istat )

     IF ( istat /= 0 ) THEN
        CALL Fatal( 'StokesSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

  Convect = GetLogical( GetSolverParams(), 'Convect', Found )
  IF ( .NOT. Found ) Convect = .TRUE.

  Velocity = 0.0d0

  P => VariableGet( Mesh % Variables, 'aPressure' )
  IF ( .NOT. ASSOCIATED(P) .OR. DOFs>dim  ) P=>NULL()

  IF ( ASSOCIATED(P) ) THEN
    ALLOCATE( pCount(SIZE(P % Values)) )
    pCount = 0
    P % Values = 0.0_dp
  END IF

  !Initialize the system and do the assembly:
  !------------------------------------------
  Active = GetNOFActive()
  CALL DefaultInitialize()
  DO t=1,Active
     Element => GetActiveElement(t)
     n  = GetElementNOFNodes()
     nb = GetElementNOFBDOFs()
     nd = GetElementDOFs(Indexes)

     ! Volume forces:
     !---------------
     BodyForce => GetBodyForce()
     LOAD = 0.0d0
     IF ( ASSOCIATED(BodyForce) ) THEN
        Load(1:n,1) = GetReal( BodyForce, 'Source x', Found )
        Load(1:n,2) = GetReal( BodyForce, 'Source y', Found )
        Load(1:n,3) = GetReal( BodyForce, 'Source z', Found )
     END IF

     ! Material parameters:
     !---------------------
     Material => GetMaterial()
     rho(1:n) = GetReal( Material, 'Density' )
     mu(1:n)  = GetReal( Material, 'Viscosity' )

     ! Get previous elementwise velocity iterate:
     !-------------------------------------------
     CALL GetVectorLocalSolution( Velocity )

     ! Get element local matrix and rhs vector:
     !-----------------------------------------
     CALL LocalMatrix(  MASS, STIFF, FORCE, LOAD, rho, mu, &
         Velocity, Element, n, nd, nd+nb, dim )

     IF ( TransientSimulation ) &
       CALL Default1stOrderTime( MASS, STIFF, FORCE )

     IF (n==nd) THEN
       IF ( ASSOCIATED(P) ) THEN
         k = n*dim
         Pressure = 0._dp
         DO j=1,DOFs
           DO i=1,n
             l = DOFs*(i-1)+j
             Pressure = Pressure - Velocity(j,i)*STIFF(k+1,l)
           END DO
         END DO
         Pressure = Pressure / STIFF(k+1,k+1)
         P % Values(P % Perm(Indexes(1:n))) = &
           P % Values(P % Perm(Indexes(1:n))) + Pressure
         pCount(P % Perm(Indexes(1:n))) = pCount(P % Perm(Indexes(1:n)))+1
       END IF
       CALL LCondensateP( n*DOFs,STIFF )
     END IF

     ! Update global matrix and rhs vector from local matrix & vector:
     !----------------------------------------------------------------
     CALL DefaultUpdateEquations( STIFF, FORCE )
  END DO
  
  CALL DefaultFinishAssembly()
  CALL DefaultDirichletBCs()

  PrevNorm = Norm
  Norm = DefaultSolve()

  IF ( ASSOCIATED(P) ) THEN
    IF ( nd>n ) THEN
      DO t=1,GetNOFActive()
        Element => GetActiveElement(t)
        n  = GetElementNOFNodes()
        nb = GetElementNOFBDOFs()
        nd = GetElementDOFs(Indexes)

        k=DOFs*(Solver % Variable % Perm(Indexes(nd))-1)+1
        Pressure = Solver % Variable % Values(k)

        P % Values(P % Perm(Indexes(1:n))) = &
          P % Values(P % Perm(Indexes(1:n))) + Pressure
        pCount(P % Perm(Indexes(1:n))) = pCount(P % Perm(Indexes(1:n)))+1
     END DO
    END IF

    WHERE( pCount>0 ) 
      P % Values = P % Values / PCount
    END WHERE
    DEALLOCATE( pCount )
  END IF

  RELC = 2.0d0 * ABS(PrevNorm - Norm) / (PrevNorm + Norm)
  IF ( RELC < 1.0d-2 ) Newton = .TRUE.

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  MASS, STIFF, FORCE, LOAD, Nodalrho, &
     Nodalmu, NodalVelo, Element, n, nd, ntot, dim )
!------------------------------------------------------------------------------
    REAL(KIND=dp), TARGET :: MASS(:,:), STIFF(:,:), FORCE(:), LOAD(:,:)
    REAL(KIND=dp) :: Nodalmu(:), Nodalrho(:), NodalVelo(:,:)
    INTEGER :: dim, n, nd, ntot
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(ntot),dBasisdx(ntot,3), &
               DetJ,LoadAtIP(dim+1),Velo(dim), Grad(dim,dim)
    REAL(KIND=dp), POINTER :: A(:,:), F(:),M(:,:)
    LOGICAL :: Stat
    INTEGER :: t, i, j, k, l, p, q
    TYPE(GaussIntegrationPoints_t) :: IP

    REAL(KIND=dp) :: mu = 1.0d0, rho = 1.0d0, s, c

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    MASS  = 0.0d0
    FORCE = 0.0d0

    ! Numerical integration:
    !-----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
       ! Basis function values & derivatives at the integration point:
       !--------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
               IP % W(t),  detJ, Basis, dBasisdx )

       s = IP % s(t) * detJ

       ! Material parameters at the integration point:
       !----------------------------------------------
       mu  = SUM( Basis(1:n) * Nodalmu(1:n) )
       rho = SUM( Basis(1:n) * Nodalrho(1:n) )

       ! Previous velocity at the integration point:
       !--------------------------------------------
       Velo = MATMUL( NodalVelo(1:dim,1:n), Basis(1:n) )
       Grad = MATMUL( NodalVelo(1:dim,1:n), dBasisdx(1:n,1:dim) )

       ! The source term at the integration point:
       !------------------------------------------
       LoadAtIP(1:dim+1) = MATMUL( Basis(1:n), LOAD(1:n,1:dim+1) )
       IF ( Convect .AND. Newton ) THEN
         LoadAtIp(1:dim) = LoadAtIp(1:dim) + rho * MATMUL(Grad,Velo)
       END IF

       ! Finally, the elemental matrix & vector:
       !----------------------------------------
       l = dim*n + 1
       DO p=1,n
         DO q=1,n
           i = dim * (p-1)
           j = dim * (q-1)
           A => STIFF(i+1:i+dim,j+1:j+dim)
           M => MASS(i+1:i+dim,j+1:j+dim)
           DO i=1,dim
             M(i,i) = M(i,i) + s * rho * Basis(q) * Basis(p)
             DO j = 1,dim
               A(i,i) = A(i,i) + s * mu * dBasisdx(q,j) * dBasisdx(p,j)
               A(i,j) = A(i,j) + s * mu * dBasisdx(q,i) * dBasisdx(p,j)
               IF ( Convect ) THEN
                 A(i,i) = A(i,i) + s * rho * Velo(j) * dBasisdx(q,j) * Basis(p)
                 IF ( Newton ) THEN
                    A(i,j) = A(i,j) + s * rho * Grad(i,j) * Basis(q) * Basis(p)
                 END IF
               END IF
             END DO
           END DO
         END DO

         j = dim*(p-1)
         DO i=1,dim
           STIFF(j+i,l) = STIFF(j+i,l) - s * dBasisdx(p,i)
           STIFF(l,j+i) = STIFF(l,j+i) + s * rho * dBasisdx(p,i)
         END DO
         i = dim*(p-1)
         F => FORCE(i+1:i+dim)
         F = F + s * LoadAtIP(1:dim) * Basis(p) 
       END DO
       STIFF(l,l) = STIFF(l,l) + s * 1.d-8
    END DO

    DO p = n+1,ntot
      DO j=2,DOFs
        i = dim*(p-1)+j
        FORCE(i)   = 0.0d0
        MASS(:,i)  = 0.0d0
        MASS(i,:)  = 0.0d0
        STIFF(i,:) = 0.0d0
        STIFF(:,i) = 0.0d0
        STIFF(i,i) = 1.0d0
      END DO
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
  SUBROUTINE LCondensateP( n,K )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  DESCRIPTION:
!     Subroutine for condensation of pressure dof,
!     Modifies given stiffness matrix.
!
!  ARGUMENTS:
!    INTEGER :: n
!      INPUT: Sum of nodal, edge and face degrees of freedom 
!
!    REAL(Kind=dp) :: K(:,:)
!      INOUT: Local stiffness matrix
!
!******************************************************************************
!------------------------------------------------------------------------------

    INTEGER :: n
    REAL(KIND=dp) :: K(:,:), Kbl(1,n), Klb(n,1), Kbb

    Kbb = K(n+1,n+1)
    Kbl(1,1:n) = K(n+1,1:n)
    Klb(1:n,1) = K(1:n,n+1)
    K(1:n,1:n) = K(1:n,1:n) - MATMUL(Klb,Kbl)/Kbb
!------------------------------------------------------------------------------
  END SUBROUTINE LCondensateP
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
END SUBROUTINE StokesSolver
!------------------------------------------------------------------------------

  FUNCTION LeftWall( Model, n, t ) RESULT(f)

    USE Types
    USE SolverUtils
    USE Lists
    USE Integration
    USE ElementDescription
    USE ElementUtils
    USE DefUtils

    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    INTEGER :: n
    REAL(KIND=dp) :: t,f
!-----------------------------------------------------
    LOGICAL :: Visited = .FALSE.,Found, FixedArea, IsLeftWall
    INTEGER :: i,j,Nopt,Power1,Nleft,Nboth,nstart,nfin
    REAL(KIND=dp) :: x,y,fi
    TYPE(Variable_t), POINTER :: OptSol
    REAL(KIND=dp), POINTER :: Opt(:)

    SAVE Visited, Opt, Nopt, Power1, Nleft, Nboth, nstart, nfin, FixedArea
    
    IsLeftWall = .TRUE.

    IF(.NOT. Visited) THEN
      FixedArea = ListGetLogical( Model % Simulation,'Fixed Area',Found)
      OptSol => VariableGet( Model % Variables, 'opt' )
      IF( ASSOCIATED( OptSol ) ) THEN
        Opt => OptSol % Values
        Nopt = SIZE( Opt )
      ELSE
        ALLOCATE( Opt(10) )
        
        ! Shorter names may be needed for some uses
        IF(.FALSE.) THEN
           Opt(1) = ListGetConstReal( Model % Simulation,'Left Wall B1',Found)
           Opt(3) = ListGetConstReal( Model % Simulation,'Left Wall B2',Found)
           Opt(5) = ListGetConstReal( Model % Simulation,'Left Wall B3',Found)
           Opt(7) = ListGetConstReal( Model % Simulation,'Left Wall B4',Found)
           Opt(9) = ListGetConstReal( Model % Simulation,'Left Wall B5',Found)
           
           Opt(2) = ListGetConstReal( Model % Simulation,'Right Wall B1',Found)
           Opt(4) = ListGetConstReal( Model % Simulation,'Right Wall B2',Found)
           Opt(6) = ListGetConstReal( Model % Simulation,'Right Wall B3',Found)
           Opt(8) = ListGetConstReal( Model % Simulation,'Right Wall B4',Found)
           Opt(10) = ListGetConstReal( Model % Simulation,'Right Wall B5',Found)
        ELSE
           Opt(1) = ListGetConstReal( Model % Simulation,'LB1',Found)
           Opt(3) = ListGetConstReal( Model % Simulation,'LB2',Found)
           Opt(5) = ListGetConstReal( Model % Simulation,'LB3',Found)
           Opt(7) = ListGetConstReal( Model % Simulation,'LB4',Found)
           Opt(9) = ListGetConstReal( Model % Simulation,'LB5',Found)
           
           Opt(2) = ListGetConstReal( Model % Simulation,'RB1',Found)
           Opt(4) = ListGetConstReal( Model % Simulation,'RB2',Found)
           Opt(6) = ListGetConstReal( Model % Simulation,'RB3',Found)
           Opt(8) = ListGetConstReal( Model % Simulation,'RB4',Found)
           Opt(10) = ListGetConstReal( Model % Simulation,'RB5',Found)  
        END IF



        IF( FixedArea ) THEN
          Nopt = 9
          Opt(2:9) = Opt(3:10)
        ELSE
          Nopt = 10
        END IF
      END IF

      Visited = .TRUE.

      Power1 = 2
      IF( FixedArea ) THEN
        nstart = 2
      ELSE
        nstart = 3
      END IF

      Nfin = Nopt
    END IF

    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    
    y = 1 - y
        
    f = 0.0_dp    
    IF( IsLeftWall .OR. FixedArea ) THEN
      f = f + Opt(1) * y 
    ELSE
      f = f + Opt(2) * y
    END IF
    
    i = Power1
    IF( IsLeftWall ) THEN
      DO j=nstart,nfin,2
        fi = (i+1)*y**i - i*y**(i-1)
        f = f + Opt(j) * fi
        i = i + 1
      END DO
    ELSE
      DO j=nstart,nfin,2
        fi = (i+1)*y**i - i*y**(i-1)
        f = f + Opt(j+1) * fi
        i = i + 1
      END DO
    END IF


!    PRINT *,'y',y,'dx',f,'Opt',Power1,Opt

  END FUNCTION LeftWall



  FUNCTION RightWall( Model, n, t ) RESULT(f)

    USE Types
    USE SolverUtils
    USE Lists
    USE Integration
    USE ElementDescription
    USE ElementUtils
    USE DefUtils

    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    INTEGER :: n
    REAL(KIND=dp) :: t,f
!-----------------------------------------------------
    LOGICAL :: Visited = .FALSE.,Found, FixedArea, IsLeftWall
    INTEGER :: i,j,Nopt,Power1,Nleft,Nboth,nstart,nfin
    REAL(KIND=dp) :: x,y,fi
    TYPE(Variable_t), POINTER :: OptSol
    REAL(KIND=dp), POINTER :: Opt(:)

    SAVE Visited, Opt, Nopt, Power1, Nleft, Nboth, nstart, nfin, FixedArea
    
    IsLeftWall = .FALSE.

    IF(.NOT. Visited) THEN
      FixedArea = ListGetLogical( Model % Simulation,'Fixed Area',Found)
      OptSol => VariableGet( Model % Variables, 'opt' )
  
      IF( ASSOCIATED( OptSol ) ) THEN
        Opt => OptSol % Values
        Nopt = SIZE( Opt )
      ELSE
        ALLOCATE( Opt(10) )
        
        IF(.FALSE.) THEN
           Opt(1) = ListGetConstReal( Model % Simulation,'Left Wall B1',Found)
           Opt(3) = ListGetConstReal( Model % Simulation,'Left Wall B2',Found)
           Opt(5) = ListGetConstReal( Model % Simulation,'Left Wall B3',Found)
           Opt(7) = ListGetConstReal( Model % Simulation,'Left Wall B4',Found)
           Opt(9) = ListGetConstReal( Model % Simulation,'Left Wall B5',Found)
           
           Opt(2) = ListGetConstReal( Model % Simulation,'Right Wall B1',Found)
           Opt(4) = ListGetConstReal( Model % Simulation,'Right Wall B2',Found)
           Opt(6) = ListGetConstReal( Model % Simulation,'Right Wall B3',Found)
           Opt(8) = ListGetConstReal( Model % Simulation,'Right Wall B4',Found)
           Opt(10) = ListGetConstReal( Model % Simulation,'Right Wall B5',Found)
        ELSE
           Opt(1) = ListGetConstReal( Model % Simulation,'LB1',Found)
           Opt(3) = ListGetConstReal( Model % Simulation,'LB2',Found)
           Opt(5) = ListGetConstReal( Model % Simulation,'LB3',Found)
           Opt(7) = ListGetConstReal( Model % Simulation,'LB4',Found)
           Opt(9) = ListGetConstReal( Model % Simulation,'LB5',Found)
           
           Opt(2) = ListGetConstReal( Model % Simulation,'RB1',Found)
           Opt(4) = ListGetConstReal( Model % Simulation,'RB2',Found)
           Opt(6) = ListGetConstReal( Model % Simulation,'RB3',Found)
           Opt(8) = ListGetConstReal( Model % Simulation,'RB4',Found)
           Opt(10) = ListGetConstReal( Model % Simulation,'RB5',Found)  
        END IF



        IF( FixedArea ) THEN
          Nopt = 9
          Opt(2:9) = Opt(3:10)
        ELSE
          Nopt = 10
        END IF
      END IF

      Visited = .TRUE.

      Power1 = 2
      IF( FixedArea ) THEN
        nstart = 2
      ELSE
        nstart = 3
      END IF

      Nfin = Nopt
    END IF

    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    
    y = 1 - y
        
    f = 0.0_dp    
    IF( IsLeftWall .OR. FixedArea ) THEN
      f = f + Opt(1) * y 
    ELSE
      f = f + Opt(2) * y
    END IF
    
    i = Power1
    IF( IsLeftWall ) THEN
      DO j=nstart,nfin,2
        fi = (i+1)*y**i - i*y**(i-1)
        f = f + Opt(j) * fi
        i = i + 1
      END DO
    ELSE
      DO j=nstart,nfin,2
        fi = (i+1)*y**i - i*y**(i-1)
        f = f + Opt(j+1) * fi
        i = i + 1
      END DO
    END IF


!    PRINT *,'y',y,'dx',f,'Opt',Power1,Opt

  END FUNCTION RightWall

!-----------------------------------------------------------------------------
!> A prototype solver for advection-diffusion-reaction equation.
!> This equation is generic and intended for education purposes
!> but may also serve as a starting point for more complex solvers.
!> Version supporting multithreading and SIMD friendly ElmerSolver
!> kernels. 
!------------------------------------------------------------------------------
SUBROUTINE AdvDiffSolver_evol( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  REAL(KIND=dp) :: Norm
  INTEGER :: n, nb, nd, t, active
  INTEGER :: iter, maxiter, nColours, col, totelem, nthr
  LOGICAL :: Found, VecAsm, InitHandles
!------------------------------------------------------------------------------
  
  maxiter = ListGetInteger( GetSolverParams(),&
      'Nonlinear System Max Iterations',Found,minv=1)
  IF(.NOT. Found ) maxiter = 1

  nthr = 1
  !$ nthr = omp_get_max_threads()

  ! Nonlinear iteration loop:
  !--------------------------
  DO iter=1,maxiter

    ! System assembly:
    !----------------
    CALL DefaultInitialize()

    totelem = 0

    nColours = GetNOFColours(Solver)
    VecAsm = (nColours > 1) .OR. (nthr == 1)
    
    CALL ResetTimer('ThreadedAssembly')

    !$OMP PARALLEL &
    !$OMP SHARED(Solver, Active, nColours, VecAsm) &
    !$OMP PRIVATE(t, Element, n, nd, nb,col, InitHandles) &
    !$OMP REDUCTION(+:totelem) DEFAULT(NONE)
   
    DO col=1,nColours
      
      !$OMP SINGLE
      CALL Info('ModelPDEthreaded','Assembly of colour: '//TRIM(I2S(col)),Level=10)
      Active = GetNOFActive(Solver)
      !$OMP END SINGLE

      InitHandles = .TRUE.
      !$OMP DO
      DO t=1,Active
        Element => GetActiveElement(t)
        totelem = totelem + 1
        n  = GetElementNOFNodes(Element)
        nd = GetElementNOFDOFs(Element)
        nb = GetElementNOFBDOFs(Element)
        CALL LocalMatrixVec(  Element, n, nd+nb, nb, VecAsm, InitHandles )
      END DO
      !$OMP END DO
    END DO
    !$OMP END PARALLEL 

    CALL CheckTimer('ThreadedAssembly',Delete=.TRUE.)
    totelem = 0

    CALL DefaultFinishBulkAssembly()

    nColours = GetNOFBoundaryColours(Solver)
    VecAsm = (nColours > 1) .OR. (nthr == 1)

    CALL ResetTimer('ThreadedBCAssembly')
    
    !$OMP PARALLEL &
    !$OMP SHARED(Active, Solver, nColours, VecAsm) &
    !$OMP PRIVATE(t, Element, n, nd, nb, col, InitHandles) & 
    !$OMP REDUCTION(+:totelem) DEFAULT(NONE)
    DO col=1,nColours
       !$OMP SINGLE
       CALL Info('ModelPDEthreaded','Assembly of boundary colour: '//TRIM(I2S(col)),Level=10)
       Active = GetNOFBoundaryActive(Solver)
       !$OMP END SINGLE

       InitHandles = .TRUE. 
       !$OMP DO
       DO t=1,Active
          Element => GetBoundaryElement(t)
          ! WRITE (*,*) Element % ElementIndex
          totelem = totelem + 1
          IF(ActiveBoundaryElement(Element)) THEN
             n  = GetElementNOFNodes(Element)
             nd = GetElementNOFDOFs(Element)
             nb = GetElementNOFBDOFs(Element)
             CALL LocalMatrixBC(  Element, n, nd+nb, nb, VecAsm, InitHandles )
          END IF
       END DO
       !$OMP END DO
    END DO
    !$OMP END PARALLEL

    CALL CheckTimer('ThreadedBCAssembly',Delete=.TRUE.)
        
    CALL DefaultFinishBoundaryAssembly()
    CALL DefaultFinishAssembly()
    CALL DefaultDirichletBCs()

    ! And finally, solve:
    !--------------------
    Norm = DefaultSolve()

    IF( Solver % Variable % NonlinConverged == 1 ) EXIT

  END DO

CONTAINS

! Assembly of the matrix entries arising from the bulk elements. SIMD version.
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrixVec( Element, n, nd, nb, VecAsm, InitHandles )
!------------------------------------------------------------------------------
    USE LinearForms
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: n, nd, nb
    TYPE(Element_t), POINTER :: Element
    LOGICAL, INTENT(IN) :: VecAsm
    LOGICAL, INTENT(INOUT) :: InitHandles
!------------------------------------------------------------------------------
    REAL(KIND=dp), ALLOCATABLE, SAVE :: Basis(:,:),dBasisdx(:,:,:), DetJ(:)
    REAL(KIND=dp), ALLOCATABLE, SAVE :: MASS(:,:), STIFF(:,:), FORCE(:)
    REAL(KIND=dp), SAVE, POINTER :: DiffCoeff(:), ConvCoeff(:), ReactCoeff(:), &
        TimeCoeff(:), SourceCoeff(:), Velo1Coeff(:), Velo2Coeff(:), Velo3Coeff(:)
    REAL(KIND=dp), SAVE, POINTER  :: VeloCoeff(:,:)
    REAL(KIND=dp) :: Weight
    LOGICAL :: Stat,Found
    INTEGER :: i,t,p,q,dim,ngp,allocstat
    TYPE(GaussIntegrationPoints_t) :: IP
    TYPE(Nodes_t), SAVE :: Nodes

    TYPE(ValueHandle_t), SAVE :: SourceCoeff_h, DiffCoeff_h, ReactCoeff_h, TimeCoeff_h, ConvCoeff_h, &
        Velo1Coeff_h, Velo2Coeff_h, Velo3Coeff_h
    
    !$OMP THREADPRIVATE(Basis, dBasisdx, DetJ, &
    !$OMP               MASS, STIFF, FORCE, Nodes, &
    !$OMP               SourceCoeff_h, DiffCoeff_h, ReactCoeff_h, TimeCoeff_h, &
    !$OMP               ConvCoeff_h, Velo1Coeff_h, Velo2Coeff_h, Velo3Coeff_h, &
    !$OMP               SourceCoeff, DiffCoeff, ReactCoeff, TimeCoeff, &
    !$OMP               ConvCoeff, Velo1Coeff, Velo2Coeff, Velo3Coeff, VeloCoeff )
    !DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, DetJ
    !DIR$ ATTRIBUTES ALIGN:64 :: MASS, STIFF, FORCE
!------------------------------------------------------------------------------

    ! This InitHandles flag might be false on threaded 1st call
    IF( InitHandles ) THEN
      CALL ListInitElementKeyword( SourceCoeff_h,'Body Force','Field Source')
      CALL ListInitElementKeyword( DiffCoeff_h,'Material','Diffusion Coefficient')
      CALL ListInitElementKeyword( ReactCoeff_h,'Material','Reaction Coefficient')
      CALL ListInitElementKeyword( TimeCoeff_h,'Material','Time Derivative Coefficient')
      CALL ListInitElementKeyword( ConvCoeff_h,'Material','Convection Coefficient')
      CALL ListInitElementKeyword( Velo1Coeff_h,'Material','Convection Velocity 1')
      CALL ListInitElementKeyword( Velo2Coeff_h,'Material','Convection Velocity 2')
      CALL ListInitElementKeyword( Velo3Coeff_h,'Material','Convection Velocity 3')
      InitHandles = .FALSE.
    END IF

    
    dim = CoordinateSystemDimension()
    IP = GaussPoints( Element )
    ngp = IP % n

    ! Deallocate storage if needed
    IF (ALLOCATED(Basis)) THEN
      IF (SIZE(Basis,1) < ngp .OR. SIZE(Basis,2) < nd) &
            DEALLOCATE(Basis,dBasisdx, DetJ, MASS, STIFF, FORCE, VeloCoeff )
    END IF

    ! Allocate storage if needed
    IF (.NOT. ALLOCATED(Basis)) THEN
      ALLOCATE(Basis(ngp,nd), dBasisdx(ngp,nd,3), DetJ(ngp), &
          MASS(nd,nd), STIFF(nd,nd), FORCE(nd), VeloCoeff(ngp,3), STAT=allocstat)
      
      IF (allocstat /= 0) THEN
        CALL Fatal('ModelPDEthreaded::LocalMatrix','Local storage allocation failed')
      END IF
    END IF

    CALL GetElementNodesVec( Nodes, UElement=Element )

    ! Initialize
    MASS  = 0._dp
    STIFF = 0._dp
    FORCE = 0._dp

    ! Numerical integration:
    ! Compute basis function values and derivatives at integration points
    !--------------------------------------------------------------
    stat = ElementInfoVec( Element, Nodes, ngp, IP % U, IP % V, IP % W, detJ, &
         SIZE(Basis,2), Basis, dBasisdx )

    ! Compute actual integration weights (recycle the memory space of DetJ)
    DO t=1,ngp
      DetJ(t) = IP % s(t) * Detj(t)
    END DO

    ! diffusion term     
    ! STIFF=STIFF+(D*grad(u),grad(v))
    DiffCoeff => ListGetElementRealVec( DiffCoeff_h, ngp, Basis, Element, Found ) 
    IF( Found ) THEN
      CALL LinearForms_GradUdotGradU(ngp, nd, Element % TYPE % DIMENSION, dBasisdx, DetJ, STIFF, DiffCoeff )
    END IF

    ! reaction term 
    ! STIFF=STIFF+(R*u,v)
    ReactCoeff => ListGetElementRealVec( ReactCoeff_h, ngp, Basis, Element, Found ) 
    IF( Found ) THEN    
      CALL LinearForms_UdotU(ngp, nd, Element % TYPE % DIMENSION, Basis, DetJ, STIFF, ReactCoeff )
    END IF
    
    ! time derivative
    ! MASS=MASS+(rho*du/dt,v)
    TimeCoeff => ListGetElementRealVec( TimeCoeff_h, ngp, Basis, Element, Found ) 
    IF( Found ) THEN
      CALL LinearForms_UdotU(ngp, nd, Element % TYPE % DIMENSION, Basis, DetJ, MASS, TimeCoeff )
    END IF
      
    ! FORCE=FORCE+(u,f)
    SourceCoeff => ListGetElementRealVec( SourceCoeff_h, ngp, Basis, Element, Found ) 
    IF( Found ) THEN
      CALL LinearForms_UdotF(ngp, nd, Basis, DetJ, SourceCoeff, FORCE)
    END IF

    
    ! advection term
    ! STIFF=STIFF+(C*grad(u),v)
    ConvCoeff => ListGetElementRealVec( ConvCoeff_h, ngp, Basis, Element, Found ) 
    IF( Found ) THEN    
      Velo1Coeff => ListGetElementRealVec( Velo1Coeff_h, ngp, Basis, Element, Found ) 
      IF( Found ) VeloCoeff(1:ngp,1) = Velo1Coeff(1:ngp)
      ! This does not work
      !VeloCoeff(:,1) => Velo1Coeff(:) etc.

      Velo2Coeff => ListGetElementRealVec( Velo2Coeff_h, ngp, Basis, Element, Found ) 
      IF( Found ) VeloCoeff(1:ngp,2) = Velo2Coeff(1:ngp)

      IF( dim == 3 ) THEN
        Velo3Coeff => ListGetElementRealVec( Velo3Coeff_h, ngp, Basis, Element, Found ) 
        IF( Found ) VeloCoeff(1:ngp,3) = Velo3Coeff(1:ngp)
      END IF
      
      CALL LinearForms_GradUdotU(ngp, nd, Element % TYPE % DIMENSION, dBasisdx, Basis, DetJ, STIFF, &
          ConvCoeff, VeloCoeff )
    END IF          

    
    IF(TransientSimulation) CALL Default1stOrderTime(MASS,STIFF,FORCE,UElement=Element)
    CALL LCondensate( nd-nb, nb, STIFF, FORCE )
    CALL DefaultUpdateEquations(STIFF,FORCE,UElement=Element, VecAssembly=VecAsm)
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrixVec
!------------------------------------------------------------------------------


  ! Assembly of the matrix entries arising from the Neumann and Robin conditions
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrixBC( Element, n, nd, nb, VecAsm, InitHandles )
!------------------------------------------------------------------------------
    IMPLICIT NONE
    INTEGER :: n, nd, nb
    TYPE(Element_t), POINTER :: Element
    LOGICAL :: VecAsm
    LOGICAL, INTENT(INOUT) :: InitHandles
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Flux(n), RobinCoeff(n), Ext_t(n), F,C,Ext, Weight
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),DetJ,LoadAtIP
    REAL(KIND=dp) :: STIFF(nd,nd), FORCE(nd), LOAD(n)
    LOGICAL :: Stat,Found
    INTEGER :: i,t,p,q,dim
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(ValueList_t), POINTER :: BC
       
    TYPE(Nodes_t) :: Nodes
    TYPE(ValueHandle_t), SAVE :: Flux_h, Robin_h, Ext_h

    SAVE Nodes
    !$OMP THREADPRIVATE(Nodes,Flux_h,Robin_h,Ext_h)
!------------------------------------------------------------------------------
    BC => GetBC(Element)
    IF (.NOT.ASSOCIATED(BC) ) RETURN

    IF( InitHandles ) THEN
      CALL ListInitElementKeyword( Flux_h,'Boundary Condition','Field Flux')
      CALL ListInitElementKeyword( Robin_h,'Boundary Condition','Robin Coefficient')
      CALL ListInitElementKeyword( Ext_h,'Boundary Condition','External Field')
      InitHandles = .FALSE.
    END IF
    
    dim = CoordinateSystemDimension()

    CALL GetElementNodes( Nodes, UElement=Element )
    STIFF = 0._dp
    FORCE = 0._dp
    LOAD = 0._dp
           

    ! Numerical integration:
    !-----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis, dBasisdx )

      Weight = IP % s(t) * DetJ

      ! Evaluate terms at the integration point:
      !------------------------------------------

      ! Given flux:
      ! -----------
      F = ListGetElementReal( Flux_h, Basis, Element, Found )
      ! IF( Found ) THEN
        ! FORCE(1:nd) = FORCE(1:nd) + Weight * F * Basis(1:nd)
      ! END IF

      ! Robin condition (C*(u-u_0)):
      ! ---------------------------
      C = ListGetElementReal( Robin_h, Basis, Element, Found )
      ! print *, element % elementindex, t, c, ext, F 

      ! IF( Found ) THEN
        Ext = ListGetElementReal( Ext_h, Basis, Element, Found )
        DO p=1,nd
          DO q=1,nd
            STIFF(p,q) = STIFF(p,q) + Weight * C * Basis(q) * Basis(p)
          END DO
        END DO
        FORCE(1:nd) = FORCE(1:nd) + Weight * (F+C * Ext) * Basis(1:nd)
      ! END IF
    END DO
    
    CALL DefaultUpdateEquations(STIFF,FORCE,UElement=Element,VecAssembly=VecAsm)
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrixBC
!------------------------------------------------------------------------------


! Perform static condensation in case bubble dofs are present
!------------------------------------------------------------------------------
  SUBROUTINE LCondensate( N, Nb, K, F )
!------------------------------------------------------------------------------
    USE LinearAlgebra
    INTEGER :: N, Nb
    REAL(KIND=dp) :: K(:,:),F(:),Kbb(Nb,Nb), &
         Kbl(Nb,N), Klb(N,Nb), Fb(Nb)

    INTEGER :: m, i, j, l, p, Ldofs(N), Bdofs(Nb)

    IF ( Nb <= 0 ) RETURN

    Ldofs = (/ (i, i=1,n) /)
    Bdofs = (/ (i, i=n+1,n+nb) /)

    Kbb = K(Bdofs,Bdofs)
    Kbl = K(Bdofs,Ldofs)
    Klb = K(Ldofs,Bdofs)
    Fb  = F(Bdofs)

    CALL InvertMatrix( Kbb,nb )

    F(1:n) = F(1:n) - MATMUL( Klb, MATMUL( Kbb, Fb  ) )
    K(1:n,1:n) = K(1:n,1:n) - MATMUL( Klb, MATMUL( Kbb, Kbl ) )
!------------------------------------------------------------------------------
  END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE AdvDiffSolver_evol
!------------------------------------------------------------------------------

FUNCTION SphereDistance( Model, n, t ) RESULT(f)
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t, f

  LOGICAL :: Visited = .FALSE.
  REAL(KIND=dp) :: x,y,z
  TYPE(Mesh_t), POINTER :: Mesh
  
  SAVE Visited, Mesh
  
  IF( .NOT. Visited ) THEN
    Mesh => GetMesh()
    Visited = .TRUE.
  END IF

  x = Mesh % Nodes % x(n)   
  y = Mesh % Nodes % y(n)   
  z = Mesh % Nodes % z(n)   

  f = SQRT(x*x+y*y+z*z)
  
END FUNCTION SphereDistance

!/*****************************************************************************/
! *
! *  Elmer, A Finite Element Software for Multiphysical Problems
! *
! *  Copyright 1st April 1995 - , CSC - IT Center for Science Ltd., Finland
! * 
! *  This program is free software; you can redistribute it and/or
! *  modify it under the terms of the GNU General Public License
! *  as published by the Free Software Foundation; either version 2
! *  of the License, or (at your option) any later version.
! * 
! *  This program is distributed in the hope that it will be useful,
! *  but WITHOUT ANY WARRANTY; without even the implied warranty of
! *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! *  GNU General Public License for more details.
! *
! *  You should have received a copy of the GNU General Public License
! *  along with this program (in file fem/GPL-2); if not, write to the 
! *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
! *  Boston, MA 02110-1301, USA.
! *
! *****************************************************************************/
!
!/******************************************************************************
! *
! *  Authors: Peter R�back, Juha Ruokolainen
! *  Email:   Peter.Raback@csc.fi
! *  Web:     http://www.csc.fi/elmer
! *  Address: CSC - IT Center for Science Ltd.
! *           Keilaranta 14
! *           02101 Espoo, Finland 
! *
! *  Original Date: 20.06.2007
! *
! *****************************************************************************/

!------------------------------------------------------------------------------
!> Solver for computing average normals for nodes using the Galerkin method.
!> For real meshes the direction of the normal is discrete for curved surfaces
!> and this solution should give a smoother normal direction. 
!> \ingroup Solvers
!------------------------------------------------------------------------------
SUBROUTINE NormalSolver( Model,Solver,dt,Transient )
!------------------------------------------------------------------------------

  USE CoordinateSystems
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t), TARGET :: Solver
  LOGICAL ::  Transient
  REAL(KIND=dp) :: dt
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------
  TYPE(ValueList_t),POINTER :: SolverParams
  CHARACTER(LEN=MAX_NAME_LEN) :: Vname, VarName, CondName
  INTEGER :: i,j,k,dim,DOFs
  LOGICAL :: ConstantBulkMatrix, ConstantBulkMatrixInUse, CSymmetry
  LOGICAL :: GotIt, Visited = .FALSE., SetD
  REAL(KIND=dp) :: Unorm, Totnorm, nrm
  REAL(KIND=dp), ALLOCATABLE, TARGET :: ForceVector(:,:)
  REAL(KIND=dp), POINTER  CONTIG  :: SaveRHS(:)
  REAL(KIND=dp) :: at0,at1,at2

  TYPE(Variable_t), POINTER :: NrmSol

  REAL(KIND=dp), ALLOCATABLE :: Values(:)
  
  SAVE Visited

 
  CALL Info( 'NormalSolver', '-------------------------------------',Level=4 )
  CALL Info( 'NormalSolver', 'Computing the normals',Level=4 )
  CALL Info( 'NormalSolver', '-------------------------------------',Level=4 )

  dim = CoordinateSystemDimension()
!------------------------------------------------------------------------------
!    Get variables needed for solution
!------------------------------------------------------------------------------
  IF ( .NOT. ASSOCIATED( Solver % Matrix ) ) RETURN
  IF ( COUNT( Solver % Variable % Perm > 0 ) <= 0 ) RETURN


  SolverParams => GetSolverParams()

  VarName = GetString(SolverParams,'Normals Result Variable',GotIt )
  IF(.NOT. GotIt) THEN
    CALL Fatal('NormalSolver','> Normals Result Variable < not found!')
  END IF

  NrmSol => VariableGet( Solver % Mesh % Variables,  VarName )
  IF(ASSOCIATED(NrmSol)) THEN
     Dofs = NrmSol % DOFs
     IF(Dofs /= DIM) THEN
       CALL Fatal('NormalSolver','The normals should have DOFs equal to DIM')
     END IF
  ELSE
    CALL DefaultVariableAdd( VarName, dim, Var = NrmSol ) 
  END IF
  

  CSymmetry = CurrentCoordinateSystem() == AxisSymmetric .OR. &
      CurrentCoordinateSystem() == CylindricSymmetric
  
  at0 = RealTime()
  
  ConstantBulkMatrix = GetLogical( SolverParams, 'Constant Bulk Matrix', GotIt )
  ConstantBulkMatrixInUse = ConstantBulkMatrix .AND. &
      ASSOCIATED(Solver % Matrix % BulkValues)
  
  IF ( ConstantBulkMatrixInUse ) THEN
    Solver % Matrix % Values = Solver % Matrix % BulkValues        
  ELSE
    CALL DefaultInitialize()
  END IF

  ALLOCATE(ForceVector(SIZE(Solver % Matrix % RHS),dim))  
  ForceVector = 0.0_dp
  SaveRHS => Solver % Matrix % RHS
!    
  CALL BulkAssembly()
  CALL DefaultFinishBulkAssembly()

  !No flux BCs for this solver
  CALL DefaultFinishAssembly()

  at1 = RealTime()
  WRITE(Message,* ) 'Assembly Time: ',at1-at0
  CALL Info( 'NormalSolver', Message, Level=5 )
!        
!------------------------------------------------------------------------------     
  SetD = GetLogical(GetSolverParams(), 'Set Dirichlet Conditions',GotIt)
  IF ( SetD ) THEN
    ALLOCATE(Values(SIZE(Solver % Matrix % Values)))
    Vname = Solver % Variable % Name
    Values = Solver % Matrix % Values
  END IF
  DO i=1,dim
    Solver % Matrix % RHS => ForceVector(:,i)

    IF ( SetD ) THEN
      Solver % Variable % Name = TRIM(VarName) // ' ' // TRIM(I2S(i))
      Solver % Matrix % Values = Values
      CALL DefaultDirichletBCs()
      Solver % Variable % Name = Vname
    ELSE
      CALL DefaultDirichletBCs()
    END IF

    Solver % Variable % Values = 0._dp
    UNorm = DefaultSolve()

    DO j=1,Solver % Matrix % NumberOfRows
      NrmSol % Values(DOFs*(j-1)+i) = Solver % Variable % Values(j)
    END DO
    Solver % Matrix % RHS => SaveRHS
  END DO
  IF ( SetD ) DEALLOCATE(Values)

  DO i=1,Solver % Matrix % NumberOFRows
    nrm = 0.0_dp
    DO j=1,dim
      k = DOFs*(i-1)+j
      nrm = nrm + NrmSol % Values(k)**2
    END DO
    IF ( nrm > 0 ) THEN
      nrm = 1.0_dp / SQRT(nrm)
      DO j=1,dim
        k = DOFs*(i-1)+j
        NrmSol % Values(k) = nrm*NrmSol % Values(k)
      END DO
    END IF
  END DO
!------------------------------------------------------------------------------     
 
  DEALLOCATE( ForceVector )
  Solver % Matrix % RHS => SaveRHS
  
  at2 = RealTime()
  WRITE(Message,* ) 'Solution Time: ',at2-at1
  CALL Info( 'NormalSolver', Message, Level=5 )
  
CONTAINS


!------------------------------------------------------------------------------
  SUBROUTINE BulkAssembly()
!------------------------------------------------------------------------------
       
    REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), FORCE(:,:), Basis(:)
    REAL(KIND=dp) :: Weight,Normal(3),detJ

    LOGICAL :: Found

    INTEGER :: elem,t,i,j,p,q,n,nd, Rank

    TYPE(Element_t), POINTER :: Element
    TYPE(Nodes_t), SAVE :: Nodes
    TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
    
    n = MAX( Solver % Mesh % MaxElementDOFs, Solver % Mesh % MaxElementNodes )
    ALLOCATE( STIFF(n,n), FORCE(dim,n), Basis(n) )

    DO elem = 1,Solver % NumberOfActiveElements
      ! Element information
      ! ---------------------
      Element => GetActiveElement(elem)
      CALL GetElementNodes( Nodes )
      nd = GetElementNOFDOFs()
      n  = GetElementNOFNodes()
      
      ! Integrate local stresses:
      ! -------------------------
      IntegStuff = GaussPoints( Element )
      STIFF  = 0.0_dp
      FORCE  = 0.0_dp

      DO t=1,IntegStuff % n
        Found = ElementInfo( Element, Nodes, IntegStuff % u(t), &
           IntegStuff % v(t), IntegStuff % w(t), detJ, Basis )
        
        Weight = IntegStuff % s(t) * detJ
        IF ( CSymmetry ) Weight = Weight * &
              SUM( Basis(1:n) * Nodes % x(1:n) )
        
        IF ( .NOT. ConstantBulkMatrixInUse ) THEN
          DO p=1,nd
            DO q=1,nd
              STIFF(p,q) = STIFF(p,q) + Weight * Basis(q) * Basis(p)
            END DO
          END DO
        END IF
        
        IF (.TRUE.) THEN
          Normal(1) = SUM(Nodes % x(1:n) * Basis(1:n))
          Normal(2) = 0.0d0
          Normal(3) = SUM(Nodes % z(1:n) * Basis(1:n)) - 1.0d0
          Normal = Normal/sqrt(SUM(Normal(:)**2))
        ELSE
          Normal = NormalVector( Element, Nodes, &
              IntegStuff % u(t), IntegStuff % v(t), .TRUE. )
        END IF

        DO i=1,dim
          FORCE(i,1:nd) = FORCE(i,1:nd) + Weight*Normal(i)*Basis(1:nd)
        END DO
      END DO
      
!------------------------------------------------------------------------------
!      Update global matrices from local matrices 
!------------------------------------------------------------------------------
      IF ( .NOT. ConstantBulkMatrixInUse ) THEN
        Solver % Matrix % RHS => SaveRHS
        CALL DefaultUpdateEquations( STIFF, FORCE(1,1:nd) )
      END IF

      DO i=1,dim
        Solver % Matrix % RHS => ForceVector(:,i)
        CALL DefaultUpdateForce( FORCE(i,1:nd) )
      END DO
    END DO
    
    DEALLOCATE( STIFF, FORCE, Basis )
!------------------------------------------------------------------------------
  END SUBROUTINE BulkAssembly
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE NormalSolver
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
!> Initialization for the primary solver: NormalSolver.
!> \ingroup Solvers
!------------------------------------------------------------------------------
  SUBROUTINE NormalSolver_Init( Model,Solver,dt,Transient )
!------------------------------------------------------------------------------
    USE DefUtils

    TYPE(Model_t)  :: Model
    TYPE(Solver_t) :: Solver
    REAL(KIND=dp) :: DT
    LOGICAL :: Transient
!------------------------------------------------------------------------------
    INTEGER :: dim
    TYPE(ValueList_t), POINTER :: SolverParams
    CHARACTER(LEN=MAX_NAME_LEN) :: VarName
    LOGICAL :: Found
!------------------------------------------------------------------------------
    SolverParams => GetSolverParams()
    dim = CoordinateSystemDimension()

    IF ( .NOT. ListCheckPresent( SolverParams,'Variable') ) THEN
      CALL ListAddString( SolverParams, 'Variable','-nooutput nrm_temp' )
    END IF
    
    VarName = GetString(SolverParams,'Normals Result Variable', Found )
    IF( .NOT. Found ) THEN
      CALL ListAddString( SolverParams,'Normals Result Variable','Normals')
      CALL ListAddString( SolverParams,  'Exported Variable 1', 'Normals[Normals:2]' )
    END IF

    CALL ListAddInteger( SolverParams, 'Time derivative order', 0 )
!------------------------------------------------------------------------------
  END SUBROUTINE NormalSolver_Init
!------------------------------------------------------------------------------

SUBROUTINE DifferenceSolver(Model, Solver, dt, TransientSimulation)
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Computes the difference between two scalar fields.
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils
  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(ValueList_t), POINTER :: SolverParams
  CHARACTER(LEN=MAX_NAME_LEN) :: SenderName, F1name, F2name, MeshName
  TYPE(Variable_t), POINTER :: F1, F2, Difference
  LOGICAL :: Found, AllocationsDone
  INTEGER :: n, t
  TYPE(Element_t), POINTER :: Element
  REAL(KIND=dp), ALLOCATABLE :: F1loc(:), F2loc(:)
  REAL(KIND=dp) :: L2nrm, L2nrmloc, L2nrmf1, L2nrmf1loc, L2nrmf2, L2nrmf2loc
  REAL(KIND=dp) :: H1nrm, H1nrmloc, H1nrmf1, H1nrmf1loc, H1nrmf2, H1nrmf2loc
  SAVE F1loc, F2loc, AllocationsDone
!------------------------------------------------------------------------------
  SenderName = 'DifferenceSolve'

  ! Print mesh name:
  !------------------
  MeshName = Solver % Mesh % Name

  WRITE(Message, *) 'Functions are interpolated using mesh: ', TRIM(MeshName)

  CALL Info(SenderName, Message)

  ! Allocate local storage:
  !-------------------------
  IF(.NOT. AllocationsDone .OR. Solver % Mesh % Changed) THEN
     n = Solver % Mesh % MaxElementDOFs

     IF(AllocationsDone) THEN
        DEALLOCATE(F1loc, F2loc)
     END IF

     ALLOCATE(F1loc(n), F2loc(n))

     AllocationsDone = .TRUE.
  END IF

  ! Fetch first scalar function:
  !------------------------------
  SolverParams => GetSolverParams()
  
  F1name = GetString(SolverParams, "F1", Found)
  
  IF(.NOT.Found) THEN
     WRITE(Message, *) 'F1 not found (name unspecified)'
     CALL Fatal(SenderName, Message)
  END IF

  F1 => VariableGet(Solver % Mesh % Variables, F1name)

  IF(.NOT.ASSOCIATED(F1)) THEN
     WRITE(Message, *) 'F1 not found: ', TRIM(F1name)
     CALL Fatal(SenderName, Message)
  ELSE
     WRITE(Message, *) 'F1: "', TRIM(F1name), '" interpolated on ', MeshName
     CALL Info(SenderName, Message)     
  END IF

  ! Fetch second scalar function:
  !-------------------------------
  F2name = GetString(SolverParams, "F2", Found)

  IF(.NOT.Found) THEN
     WRITE(Message, *) 'F2 not found (name unspecified)'
     CALL Fatal(SenderName, Message)
  END IF

  F2 => VariableGet(Solver % Mesh % Variables, F2name)

  IF(.NOT.ASSOCIATED(F2)) THEN
     WRITE(Message, *) 'F2 not found: ', TRIM(F2name)
     CALL Fatal(SenderName, Message)
  ELSE
     WRITE(Message, *) 'F2: "', TRIM(F2name), '" interpolated on ', MeshName
     CALL Info(SenderName, Message)     
  END IF

  ! Compute the difference:
  !-------------------------
  Difference => Solver % Variable
  Difference % Values = F1 % Values - F2 % Values

  ! Compute norms:
  !----------------
  L2nrm = 0.0d0
  L2nrmf1 = 0.0d0
  L2nrmf2 = 0.0d0

  H1nrm = 0.0d0
  H1nrmf1 = 0.0d0
  H1nrmf2 = 0.0d0

  DO t = 1, GetNofActive()
     Element => GetActiveElement(t)
     n = GetElementNOFNodes(Element)

     CALL GetScalarLocalSolution(F1loc, F1name)
     CALL GetScalarLocalSolution(F2loc, F2name)
     
     CALL Compute(Element, n, F1loc, F2loc, &
          L2nrmloc, L2nrmf1loc, L2nrmf2loc, &
          H1nrmloc, H1nrmf1loc, H1nrmf2loc)

     L2nrm = L2nrm + L2nrmloc
     L2nrmf1 = L2nrmf1 + L2nrmf1loc
     L2nrmf2 = L2nrmf2 + L2nrmf2loc

     H1nrm = H1nrm + H1nrmloc
     H1nrmf1 = H1nrmf1 + H1nrmf1loc
     H1nrmf2 = H1nrmf2 + H1nrmf2loc
  END DO

  L2nrm = SQRT(L2nrm)
  L2nrmf1 = SQRT(L2nrmf1)
  L2nrmf2 = SQRT(L2nrmf2)

  H1nrm = SQRT(H1nrm)
  H1nrmf1 = SQRT(H1nrmf1)
  H1nrmf2 = SQRT(H1nrmf2)

  WRITE(Message, *) '|| F1 - F2 || =', L2nrm
  CALL Info(SenderName, Message)
  WRITE(Message, *) '|| F1 || =', L2nrmf1
  CALL Info(SenderName, Message)
  WRITE(Message, *) '|| F2 || =', L2nrmf2
  CALL Info(SenderName, Message)

  WRITE(Message, *) '|| grad(F1 - F2) || =', H1nrm
  CALL Info(SenderName, Message)
  WRITE(Message, *) '|| grad F1 || =', H1nrmf1
  CALL Info(SenderName, Message)
  WRITE(Message, *) '|| grad F2 || =', H1nrmf2
  CALL Info(SenderName, Message)

CONTAINS

  SUBROUTINE Compute(Element, n, F1, F2, &
       L2nrm, L2nrmf1, L2nrmf2, &
       H1nrm, H1nrmf1, H1nrmf2)

    TYPE(Element_t), POINTER :: Element
    INTEGER :: n
    REAL(KIND=dp) :: F1(:), F2(:)
    REAL(KIND=dp) :: L2nrm, L2nrmf1, L2nrmf2
    REAL(KIND=dp) :: H1nrm, H1nrmf1, H1nrmf2

    TYPE(GaussIntegrationPoints_t) :: IP
    REAL(KIND=dp) :: detJ, Basis(n), dBasisdx(n, 3)
    REAL(KIND=dp) :: F1atIP, F2atIP
    REAL(KIND=dp) :: gradF1atIP(n), gradF2atIP(n)
    INTEGER :: t, i
    LOGICAL :: stat
    TYPE(Nodes_t) :: Nodes
    SAVE Nodes

    CALL GetElementNodes(Nodes)

    IP = GaussPoints(Element)

    L2nrm = 0.0d0
    L2nrmf1 = 0.0d0
    L2nrmf2 = 0.0d0

    H1nrm = 0.0d0
    H1nrmf1 = 0.0d0
    H1nrmf2 = 0.0d0

    DO t = 1, IP % n
       stat = ElementInfo(Element, Nodes, &
            IP % U(t), IP % V(t), IP % W(t), &
            detJ, Basis, dBasisdx)

       F1atIP = SUM( F1(1:n) * Basis(1:n) )
       F2atIP = SUM( F2(1:n) * Basis(1:n) )

       gradF1atIP(1:3) = MATMUL(TRANSPOSE(dBasisdx(1:n,1:3)), F1(1:n) )
       gradF2atIP(1:3) = MATMUL(TRANSPOSE(dBasisdx(1:n,1:3)), F2(1:n) )

       L2nrm = L2nrm + (F1atIP - F2atIP)**2 * IP % s(t) * detJ
       L2nrmf1 = L2nrmf1 + F1atIP**2 * IP % s(t) * detJ
       L2nrmf2 = L2nrmf2 + F2atIP**2 * IP % s(t) * detJ

       DO i = 1, 3
          H1nrm = H1nrm + (gradF1atIP(i) - gradF2atIP(i))**2 * IP % s(t) * detJ
          H1nrmf1 = H1nrmf1 + gradF1atIP(i)**2 * IP % s(t) * detJ
          H1nrmf2 = H1nrmf2 + gradF2atIP(i)**2 * IP % s(t) * detJ
       END DO

    END DO

  END SUBROUTINE Compute

END SUBROUTINE DifferenceSolver

! Returns a piecewise linear profile such that each control point may be
! a function of time or some other global variable.
!--------------------------------------------------------------------------
FUNCTION TimeProfile( Model, n, tx ) RESULT( f )
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: tx, f

  INTEGER :: tn, tn0 = -1, m, i
  LOGICAL :: Found
  TYPE(ValueListEntry_t), POINTER :: ptr
  TYPE(ValueList_t), POINTER :: BC
  CHARACTER(LEN=MAX_NAME_LEN) :: Name

  SAVE tn0, ptr, Name

  BC => GetBC()
  tn = GetTimestep()

  IF( tn /= tn0 ) THEN
    tn0 = tn

    Name = "Timeprofile"
    
    ptr => ListFind(BC,Name,Found)
    IF(.NOT. Found ) CALL Fatal('TimeProfile','Could not find item: '//TRIM(Name))

    IF( ptr % TYPE /= LIST_TYPE_VARIABLE_SCALAR ) THEN
      CALL Fatal('TimeProfile','Item should be variable scalar: '//TRIM(Name))        
    END IF
    
    IF ( ptr % PROCEDURE /= 0 ) THEN
      CALL Fatal('TimeProfile','Item should not be a function: '//TRIM(Name))             
    END IF
      
    m = SIZE( ptr % Fvalues(1,1,:) )
    
    DO i=1,m
      f = ListGetCReal(BC,TRIM(Name)//' point '//TRIM(I2S(i)),UnfoundFatal=.TRUE.)
      ptr % Fvalues(1,1,i) = f
    END DO

    PRINT *,'Updated temperature profile: ',ptr % Fvalues(1,1,:)
  END IF
    
  f = InterpolateCurve( ptr % TValues,ptr % FValues(1,1,:), &
      tx, ptr % CubicCoeff )

END FUNCTION TimeProfile
  

FUNCTION TravellingHeatSource( Model, n, t ) RESULT(f)
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t, f


  INTEGER :: timestep, prevtimestep = -1
  REAL(KIND=dp) :: Alpha, Coeff, Speed, Dist, Dist0, &
      Time, x, y, z, s, sper, r
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Params
  LOGICAL :: Found, NewTimestep
  
  SAVE Mesh, Params, prevtimestep, time, Alpha, Coeff, Speed, Dist, &
      Dist0
  
  timestep = GetTimestep()
  NewTimestep = ( timestep /= prevtimestep )

  IF( NewTimestep ) THEN
    Mesh => GetMesh()
    Params => Model % Simulation
    time = GetTime()
    Alpha = GetCReal(Params,'Heat source width')
    Coeff = GetCReal(Params,'Heat source coefficient')
    Speed = GetCReal(Params,'Heat source speed')
    Dist = GetCReal(Params,'Heat source distance')
    Dist0 = GetCReal(Params,'Heat source initial position', Found)
    prevtimestep = timestep
  END IF

  x = Mesh % Nodes % x(n)   
  y = Mesh % Nodes % y(n)   
  z = Mesh % Nodes % z(n)   

  s = Dist0 + time * Speed  
  sper = MODULO( s, 2 * Dist ) 
  IF( sper > Dist ) sper = 2 * Dist - sper

  r = x-sper
  ! in 3D this could be the radius
  ! r = SQRT((x-s)**2 + y**2)
  
  f = Coeff * EXP( -2*r**2 / Alpha**2 )
    
END FUNCTION TravellingHeatSource


FUNCTION FixedHeatSource( Model, n, t ) RESULT(f)
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t, f


  INTEGER :: timestep, prevtimestep = -1
  REAL(KIND=dp) :: Alpha, Coeff, Dist0, &
      Time, x, y, z, r
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Params
  LOGICAL :: Found, NewTimestep
  
  SAVE Mesh, Params, prevtimestep, time, Alpha, Coeff, Dist0
  
  timestep = GetTimestep()
  NewTimestep = ( timestep /= prevtimestep )

  IF( NewTimestep ) THEN
    Mesh => GetMesh()
    Params => Model % Simulation
    time = GetTime()
    Alpha = GetCReal(Params,'Heat source width')
    Coeff = GetCReal(Params,'Heat source coefficient')
    Dist0 = GetCReal(Params,'Heat source initial position', Found)
    prevtimestep = timestep
  END IF

  x = Mesh % Nodes % x(n)   
  y = Mesh % Nodes % y(n)   
  z = Mesh % Nodes % z(n)   

  ! not a function of time
  r = x-Dist0

  ! in 3D this could be the radius
  ! r = SQRT((x-s)**2 + y**2)
  
  f = Coeff * EXP( -2*r**2 / Alpha**2 )
    
END FUNCTION FixedHeatSource


FUNCTION TravellingSlabVelo( Model, n, t ) RESULT(f)
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t, f


  INTEGER :: timestep, prevtimestep = -1
  REAL(KIND=dp) :: Alpha, Coeff, Speed, Dist, Dist0, &
      Time, x, y, z, s, sper, r
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: Params
  LOGICAL :: Found, NewTimestep
  
  SAVE Mesh, Params, prevtimestep, time, Alpha, Coeff, Speed, Dist, &
      Dist0
  
  timestep = GetTimestep()
  NewTimestep = ( timestep /= prevtimestep )

  IF( NewTimestep ) THEN
    Mesh => GetMesh()
    Params => Model % Simulation
    time = GetTime()
    Speed = GetCReal(Params,'Heat source speed')
    Dist = GetCReal( Params,'Heat source distance')
    prevtimestep = timestep
  END IF

  x = Mesh % Nodes % x(n)   
  y = Mesh % Nodes % y(n)   
  z = Mesh % Nodes % z(n)   

  s = Dist0 + time * Speed  
  sper = MODULO( s, 2 * Dist ) 

  IF( sper > Dist ) THEN
    sper = 2 * Dist - sper
    f = Speed
  ELSE
    f = -Speed
  END IF
    
END FUNCTION TravellingSlabVelo

!-----------------------------------------------------------------------------
!> A prototype solver for advection-diffusion-reaction equation.
!> This equation is generic and intended for education purposes
!> but may also serve as a starting point for more complex solvers.
!> Version supporting multithreading and SIMD friendly ElmerSolver
!> kernels. 
!------------------------------------------------------------------------------
SUBROUTINE AdvDiffSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  REAL(KIND=dp) :: Norm
  INTEGER :: n, nb, nd, t, active
  INTEGER :: iter, maxiter, nColours, col, totelem, nthr
  LOGICAL :: Found, VecAsm
!------------------------------------------------------------------------------
  
  maxiter = ListGetInteger( GetSolverParams(),&
      'Nonlinear System Max Iterations',Found,minv=1)
  IF(.NOT. Found ) maxiter = 1

  nthr = 1
  !$ nthr = omp_get_max_threads()

  ! Nonlinear iteration loop:
  !--------------------------
  DO iter=1,maxiter

    ! System assembly:
    !----------------
    CALL DefaultInitialize()

    totelem = 0

    nColours = GetNOFColours(Solver)
    VecAsm = (nColours > 1) .OR. (nthr == 1)

    CALL ResetTimer('ThreadedAssembly')

    !$OMP PARALLEL &
    !$OMP SHARED(Solver, Active, nColours, &
    !$OMP        VecAsm) &
    !$OMP PRIVATE(t, Element, n, nd, nb,col) &
    !$OMP REDUCTION(+:totelem) DEFAULT(NONE)
    DO col=1,nColours

       !$OMP SINGLE
       CALL Info('ModelPDEthreaded','Assembly of colour: '//TRIM(I2S(col)),Level=10)
       Active = GetNOFActive(Solver)
       !$OMP END SINGLE

       !$OMP DO
       DO t=1,Active
          Element => GetActiveElement(t)
          totelem = totelem + 1
          n  = GetElementNOFNodes(Element)
          nd = GetElementNOFDOFs(Element)
          nb = GetElementNOFBDOFs(Element)
          CALL LocalMatrixVec(  Element, n, nd+nb, nb, VecAsm )
       END DO
       !$OMP END DO
    END DO
    !$OMP END PARALLEL 

    CALL CheckTimer('ThreadedAssembly',Delete=.TRUE.)
    totelem = 0

    CALL DefaultFinishBulkAssembly()

    nColours = GetNOFBoundaryColours(Solver)
    VecAsm = (nColours > 1) .OR. (nthr == 1)

    CALL ResetTimer('ThreadedBCAssembly')
    
    !$OMP PARALLEL &
    !$OMP SHARED(Active, Solver, nColours, VecAsm) &
    !$OMP PRIVATE(t, Element, n, nd, nb, col) & 
    !$OMP REDUCTION(+:totelem) DEFAULT(NONE)
    DO col=1,nColours
       !$OMP SINGLE
       CALL Info('ModelPDEthreaded','Assembly of boundary colour: '//TRIM(I2S(col)),Level=10)
       Active = GetNOFBoundaryActive(Solver)
       !$OMP END SINGLE

       !$OMP DO
       DO t=1,Active
          Element => GetBoundaryElement(t)
          ! WRITE (*,*) Element % ElementIndex
          totelem = totelem + 1
          IF(ActiveBoundaryElement(Element)) THEN
             n  = GetElementNOFNodes(Element)
             nd = GetElementNOFDOFs(Element)
             nb = GetElementNOFBDOFs(Element)
             CALL LocalMatrixBC(  Element, n, nd+nb, nb, VecAsm )
          END IF
       END DO
       !$OMP END DO
    END DO
    !$OMP END PARALLEL

    CALL CheckTimer('ThreadedBCAssembly',Delete=.TRUE.)
        
    CALL DefaultFinishBoundaryAssembly()
    CALL DefaultFinishAssembly()
    CALL DefaultDirichletBCs()

    ! And finally, solve:
    !--------------------
    Norm = DefaultSolve()

    IF( Solver % Variable % NonlinConverged == 1 ) EXIT

  END DO

CONTAINS

! Assembly of the matrix entries arising from the bulk elements. SIMD version.
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrixVec( Element, n, nd, nb, VecAsm )
!------------------------------------------------------------------------------
    USE LinearForms
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: n, nd, nb
    TYPE(Element_t), POINTER :: Element
    LOGICAL, INTENT(IN) :: VecAsm
!------------------------------------------------------------------------------

    REAL(KIND=dp), ALLOCATABLE, TARGET, SAVE :: Coeffs(:,:), CoeffsInBasis(:,:)
    INTEGER, PARAMETER :: DIFF_IND = 1, CONV_IND = 2, REACT_IND= 3, TIME_IND = 4, &
         LOAD_IND = 5, VELO_IND = 6
    REAL(KIND=dp), ALLOCATABLE, SAVE :: Basis(:,:),dBasisdx(:,:,:), DetJ(:)
    REAL(KIND=dp), ALLOCATABLE, SAVE :: MASS(:,:), STIFF(:,:), FORCE(:)
    REAL(KIND=dp), POINTER CONTIG :: diff_coeff(:), conv_coeff(:), react_coeff(:), &
         time_coeff(:), Load(:), Velo(:,:), LoadAtIp(:), &
         DiffInBasis(:), ReactInBasis(:), ConvInBasis(:), VeloInBasis(:,:), rho(:)
    REAL(KIND=dp) :: Weight
    LOGICAL :: Stat,Found
    INTEGER :: i,t,p,q,dim,ngp,allocstat
    TYPE(GaussIntegrationPoints_t) :: IP
    TYPE(ValueList_t), POINTER :: BodyForce, Material
    TYPE(Nodes_t), SAVE :: Nodes
    !$OMP THREADPRIVATE(Coeffs, CoeffsInBasis, Basis, dBasisdx, DetJ, &
    !$OMP               MASS, STIFF, FORCE, Nodes)
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, DetJ, Coeffs, CoeffsInBasis
!DIR$ ATTRIBUTES ALIGN:64 :: MASS, STIFF, FORCE
!------------------------------------------------------------------------------

    dim = CoordinateSystemDimension()
    IP = GaussPoints( Element )
    ngp = IP % n

    ! Deallocate storage if needed
    IF (ALLOCATED(Basis)) THEN
       IF (SIZE(Basis,1) < ngp .OR. SIZE(Basis,2) < nd) &
            DEALLOCATE(Basis,dBasisdx, DetJ, Coeffs, CoeffsInBasis, &
            MASS, STIFF, FORCE)
    END IF

    ! Allocate storage if needed
    IF (.NOT. ALLOCATED(Basis)) THEN
       ALLOCATE(Basis(ngp,nd), dBasisdx(ngp,nd,3), DetJ(ngp), &
            Coeffs(n,VELO_IND+2), CoeffsInBasis(ngp,VELO_IND+2), &
            MASS(nd,nd), STIFF(nd,nd), FORCE(nd), STAT=allocstat)
       IF (allocstat /= 0) THEN
          CALL Fatal('ModelPDEthreaded::LocalMatrix','Local storage allocation failed')
       END IF
    END IF

    CALL GetElementNodesVec( Nodes, UElement=Element )

    ! Set up pointers to coefficients and to their projections in basis
    Load => Coeffs(1:n,LOAD_IND)
    diff_coeff => Coeffs(1:n,DIFF_IND)
    react_coeff => Coeffs(1:n,REACT_IND)
    conv_coeff => Coeffs(1:n,CONV_IND)
    time_coeff => Coeffs(1:n,TIME_IND)
    Velo => Coeffs(:,VELO_IND:VELO_IND+2)
    
    LoadAtIP => CoeffsInBasis(1:ngp,LOAD_IND)
    DiffInBasis => CoeffsInBasis(1:ngp,DIFF_IND)
    ReactInBasis => CoeffsInBasis(1:ngp,REACT_IND)
    ConvInBasis => CoeffsInBasis(1:ngp,CONV_IND)
    rho => CoeffsInBasis(1:ngp, TIME_IND)
    VeloInBasis => CoeffsInBasis(:,VELO_IND:VELO_IND+2)
    
    ! Initialize
    MASS  = 0._dp
    STIFF = 0._dp
    FORCE = 0._dp
    Load = 0._dp

    BodyForce => GetBodyForce(Element)
    IF ( ASSOCIATED(BodyForce) ) THEN
      CALL GetRealValues( BodyForce, 'field source', Load, Found, UElement=Element )
    END IF

    Material => GetMaterial(Element)

    CALL GetRealValues(Material, 'diffusion coefficient', diff_coeff, &
         Found, UElement=Element)
    IF (.NOT. Found) diff_coeff = 0._dp

    CALL GetRealValues(Material, 'reaction coefficient', react_coeff, &
         Found, UElement=Element)
    IF (.NOT. Found) react_coeff = 0._dp

    CALL GetRealValues(Material, 'convection coefficient', conv_coeff, &
         Found, UElement=Element)
    IF (.NOT. Found) conv_coeff = 0._dp

    CALL GetRealValues(Material, 'time derivative coefficient', time_coeff, &
         Found, UElement=Element)
    IF (.NOT. Found) time_coeff = 0._dp
    
    Velo = 0._dp
    DO i=1,dim
      ! Velo(1:n,i)=GetReal(Material,'convection velocity '//TRIM(I2S(i)),Found)
      CALL GetRealValues(Material, 'convection velocity '//TRIM(I2S(i)), Coeffs(1:n,VELO_IND+i-1), &
           Found, UElement=Element)
      IF (.NOT. Found) Coeffs(1:n,VELO_IND+i-1) = 0._dp
    END DO

    ! Numerical integration:
    ! Compute basis function values and derivatives at integration points
    !--------------------------------------------------------------
    stat = ElementInfoVec( Element, Nodes, ngp, IP % U, IP % V, IP % W, detJ, &
         SIZE(Basis,2), Basis, dBasisdx )

    ! Project all coefficients to the basis. On exit, CoeffsInBasis contains
    ! projections as (D, C, R, rho, LoadAtIP, a)
    CALL LinearForms_ProjectToU(ngp, n, Basis, Coeffs, CoeffsInBasis)
    
    ! The above call is equivalent to performing the loop
    ! DO t=1,IP % n
    !    D(t) = SUM(Basis(t,1:n)*diff_coeff(1:n))
    !    C(t) = SUM(Basis(t,1:n)*conv_coeff(1:n))
    !    R(t) = SUM(Basis(,t1:n)*react_coeff(1:n))   
    !    rho(t) = SUM(Basis(t,1:n)*time_coeff(1:n))
    !    LoadAtIP(t) = SUM( Basis(t,1:n) * LOAD(1:n) )
    !    DO i=1,dim
    !       a(t,i) = SUM(Velo(1:n,i)*Basis(t,1:n))
    !    END DO
    ! END DO
    
    ! Compute actual integration weights (recycle the memory space of DetJ)
    DO t=1,ngp
       DetJ(t) = IP % s(t)*Detj(t)
    END DO

    ! diffusion term 
    ! STIFF=STIFF+(D*grad(u),grad(v))
    CALL LinearForms_GradUdotGradU(ngp, nd, Element % TYPE % DIMENSION, dBasisdx, DetJ, STIFF, diff_coeff)
    ! reaction term 
    ! STIFF=STIFF+(R*u,v)
    CALL LinearForms_UdotU(ngp, nd, Element % TYPE % DIMENSION, Basis, DetJ, STIFF, ReactInBasis)
    ! advection term
    ! STIFF=STIFF+(C*grad(u),v)
    CALL LinearForms_GradUdotU(ngp, nd, Element % TYPE % DIMENSION, dBasisdx, Basis, DetJ, STIFF, &
         ConvInBasis, VeloInBasis)
    ! time derivative
    ! MASS=MASS+(rho*du/dt,v)
    CALL LinearForms_UdotU(ngp, nd, Element % TYPE % DIMENSION, Basis, DetJ, MASS, rho)

    ! FORCE=FORCE+(u,f)
    CALL LinearForms_UdotF(ngp, nd, Basis, DetJ, LoadAtIP, FORCE)

    ! The above calls are equivalent to 
    ! DO t=1,IP % n
       ! Weight = IP % s(t) * DetJ(t)
       ! Weight = DetJ(t)

      ! diffusion term (D*grad(u),grad(v)):
      ! -----------------------------------
      ! STIFF(1:nd,1:nd) = STIFF(1:nd,1:nd) + Weight * &
      !        D(t) * MATMUL( dBasisdx(t,1:nd,1:dim), TRANSPOSE( dBasisdx(t,1:nd,1:dim ) ))
      ! DO p=1,nd
      !   DO q=1,nd
          ! advection term (C*grad(u),v)
          ! -----------------------------------
          ! STIFF (p,q) = STIFF(p,q) + Weight * &
          !    C(t) * SUM(a(t,1:dim)*dBasisdx(t,q,1:dim)) * Basis(t,p)

          ! DO d=1,dim
          !   STIFF(p,q) = STIFF(p,q) + Weight * &
          !         C(t) * a(t,d)*dBasisdx(t,q,d) * Basis(t,p)
          ! END DO
          
          ! reaction term (R*u,v)
          ! -----------------------------------
          ! STIFF(p,q) = STIFF(p,q) + Weight * R(t)*Basis(t,q) * Basis(t,p)

          ! time derivative (rho*du/dt,v):
          ! ------------------------------
          ! MASS(p,q) = MASS(p,q) + Weight * rho(t) * Basis(t,q) * Basis(t,p)
      !  END DO
      ! END DO

      ! FORCE(1:nd) = FORCE(1:nd) + Weight * LoadAtIP(t) * Basis(t,1:nd)
    ! END DO

    IF(TransientSimulation) CALL Default1stOrderTime(MASS,STIFF,FORCE,UElement=Element)
    CALL LCondensate( nd-nb, nb, STIFF, FORCE )
    CALL DefaultUpdateEquations(STIFF,FORCE,UElement=Element, VecAssembly=VecAsm)
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrixVec
!------------------------------------------------------------------------------

! Assembly of the matrix entries arising from the Neumann and Robin conditions
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrixBC( Element, n, nd, nb, VecAsm )
!------------------------------------------------------------------------------
    IMPLICIT NONE
    INTEGER :: n, nd, nb
    TYPE(Element_t), POINTER :: Element
    LOGICAL :: VecAsm
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Flux(n), RobinCoeff(n), Ext_t(n), F,C,Ext, Weight
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),DetJ,LoadAtIP
    REAL(KIND=dp) :: STIFF(nd,nd), FORCE(nd), LOAD(n)
    LOGICAL :: Stat,Found
    INTEGER :: i,t,p,q,dim
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(ValueList_t), POINTER :: BC

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
    !$OMP THREADPRIVATE(Nodes)
!------------------------------------------------------------------------------
    BC => GetBC(Element)
    IF (.NOT.ASSOCIATED(BC) ) RETURN

    dim = CoordinateSystemDimension()

    CALL GetElementNodes( Nodes, UElement=Element )
    STIFF = 0._dp
    FORCE = 0._dp
    LOAD = 0._dp

    CALL GetRealValues(BC,'field flux', Flux, Found, UElement=Element )
    IF (.NOT. Found) Flux = 0._dp

    CALL GetRealValues(BC,'robin coefficient', RobinCoeff, Found, UElement=Element )
    IF (.NOT. Found) RobinCoeff = 0._dp

    CALL GetRealValues(BC,'external field', Ext_t, Found, UElement=Element )
    IF (.NOT. Found) Ext_t = 0._dp

    ! Numerical integration:
    !-----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis, dBasisdx )

      Weight = IP % s(t) * DetJ

      ! Evaluate terms at the integration point:
      !------------------------------------------

      ! Given flux:
      ! -----------
      F = SUM(Basis(1:n)*flux(1:n))

      ! Robin condition (C*(u-u_0)):
      ! ---------------------------
      C = SUM(Basis(1:n)*RobinCoeff(1:n))
      Ext = SUM(Basis(1:n)*Ext_t(1:n))

      DO p=1,nd
        DO q=1,nd
          STIFF(p,q) = STIFF(p,q) + Weight * C * Basis(q) * Basis(p)
        END DO
      END DO

      FORCE(1:nd) = FORCE(1:nd) + Weight * (F + C*Ext) * Basis(1:nd)
    END DO
    CALL DefaultUpdateEquations(STIFF,FORCE,UElement=Element,VecAssembly=VecAsm)
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrixBC
!------------------------------------------------------------------------------

! Perform static condensation in case bubble dofs are present
!------------------------------------------------------------------------------
  SUBROUTINE LCondensate( N, Nb, K, F )
!------------------------------------------------------------------------------
    USE LinearAlgebra
    INTEGER :: N, Nb
    REAL(KIND=dp) :: K(:,:),F(:),Kbb(Nb,Nb), &
         Kbl(Nb,N), Klb(N,Nb), Fb(Nb)

    INTEGER :: m, i, j, l, p, Ldofs(N), Bdofs(Nb)

    IF ( Nb <= 0 ) RETURN

    Ldofs = (/ (i, i=1,n) /)
    Bdofs = (/ (i, i=n+1,n+nb) /)

    Kbb = K(Bdofs,Bdofs)
    Kbl = K(Bdofs,Ldofs)
    Klb = K(Ldofs,Bdofs)
    Fb  = F(Bdofs)

    CALL InvertMatrix( Kbb,nb )

    F(1:n) = F(1:n) - MATMUL( Klb, MATMUL( Kbb, Fb  ) )
    K(1:n,1:n) = K(1:n,1:n) - MATMUL( Klb, MATMUL( Kbb, Kbl ) )
!------------------------------------------------------------------------------
  END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE AdvDiffSolver
!------------------------------------------------------------------------------

SUBROUTINE PressureSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!
!  A Navier-Stokes solver with pressure projection, the pressure part
!  15/12/2003, Juha
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Newton = .FALSE., Found
  TYPE(Element_t),POINTER :: Element

  INTEGER :: n, nb, nd, t, istat, dim, active
  REAL(KIND=dp) :: Norm = 0, PrevNorm, RelC, PressureRelax

  TYPE(Variable_t), POINTER :: PressureVariable
  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:,:), FORCE(:), Velocity(:,:)

  SAVE STIFF, LOAD, FORCE, Velocity, AllocationsDone
!------------------------------------------------------------------------------

  dim = CoordinateSystemDimension()
  Mesh => GetMesh()

  ! Allocate some permanent storage, this is done first time only:
  !---------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     N = Mesh % MaxElementDOFs  ! just big enough for elemental arrays
     ALLOCATE( FORCE(N), STIFF(N,N), Velocity(dim,N), STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'PressureSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

  ! Initialize the system and do the assembly:
  !-------------------------------------------
  active = GetNOFActive()
  CALL DefaultInitialize()
  DO t=1,active
     Element => GetActiveElement(t)
     n  = GetElementNOFNodes()
     nd = GetElementNOFDOFs()
     nb = GetElementNOFBDOFs()

     ! Get previous elementwise velocity iterate:
     !-------------------------------------------
     CALL GetVectorLocalSolution( Velocity, 'VelocityTot' )

     ! Get element local matrix and rhs vector:
     !-----------------------------------------
     CALL LocalMatrix(  STIFF, FORCE,  Velocity, &
            Element, n, nd, nd+nb, dim )
     IF ( nb>0 ) CALL LCondensate( nd, nb, STIFF, FORCE )

     ! Update global matrix and rhs vector from local matrix & vector:
     !----------------------------------------------------------------
     CALL DefaultUpdateEquations( STIFF, FORCE )
  END DO
  CALL DefaultFinishAssembly()
  CALL DefaultDirichletBCs()
  
!------------------------------------------------------------------------------

  ! Solve the system:
  !------------------
  Norm = DefaultSolve()

  PressureRelax = GetConstReal( GetSolverParams(), 'Pressure Relax', Found )
  IF ( .NOT. Found ) PressureRelax = 1.0d0

  PressureVariable => VariableGet( Mesh % Variables, 'PressureTot')
  PressureVariable % Values = PressureVariable % Values + &
       PressureRelax * Solver % Variable % Values

!------------------------------------------------------------------------------

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, NodalVelo, Element, n, nd, ntot, dim )
!------------------------------------------------------------------------------
    REAL(KIND=dp), TARGET :: STIFF(:,:), FORCE(:)
    REAL(KIND=dp) :: NodalVelo(:,:)
    INTEGER :: dim, n, nd, ntot
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(ntot),dBasisdx(ntot,3), &
                  DetJ, divU
    REAL(KIND=dp), POINTER :: A(:,:), F(:)
    LOGICAL :: Stat
    INTEGER :: t, i, j, k, l, p, q
    TYPE(GaussIntegrationPoints_t) :: IP

    REAL(KIND=dp) :: s, c

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    FORCE = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element,ntot )
    DO t=1,IP % n
       ! Basis function values & derivatives at the integration point:
       !--------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
        IP % W(t),  detJ, Basis, dBasisdx )

       s = IP % s(t) * detJ

       ! Previous velocity at the integration point:
       !--------------------------------------------
       DivU = 0.0d0
       DO i=1,dim
          DivU = DivU + SUM( NodalVelo(i,1:nd) * dBasisdx(1:nd,i) )
       END DO

       ! Finally, the elemental matrix & vector:
       !----------------------------------------
       STIFF(1:ntot,1:ntot) = STIFF(1:ntot,1:ntot) + s * &
           MATMUL( dBasisdx, TRANSPOSE(dBasisdx) )
       FORCE(1:ntot) = FORCE(1:ntot) - s * DivU * Basis
    END DO
!   DO i=n+1,nd
!     FORCE(i)   = 0
!     STIFF(i,i) = 1
!   END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


!------------------------------------------------------------------------------
   SUBROUTINE LCondensate( N, nb, K, F )
!------------------------------------------------------------------------------
      USE LinearAlgebra
      INTEGER :: N, nb, dim
      REAL(KIND=dp) :: K(:,:),F(:), Kbb(Nb,Nb), &
       Kbl(nb,n),Klb(n,nb),Fb(nb)

      INTEGER :: m, i, j, l, p, Cdofs(n), Bdofs(nb)

      DO i=1,n
        CDOFs(i) = i
      END DO

      DO i=1,nb
        BDOFs(i) = i+n
      END DO

      Kbb = K(Bdofs,Bdofs)
      Kbl = K(Bdofs,Cdofs)
      Klb = K(Cdofs,Bdofs)
      Fb  = F(Bdofs)

      CALL InvertMatrix( Kbb,Nb )

      F(1:n) = F(1:n) - MATMUL( Klb, MATMUL( Kbb, Fb ) )
      K(1:n,1:n) = K(1:n,1:n) - MATMUL( Klb, MATMUL( Kbb,Kbl ) )
!------------------------------------------------------------------------------
    END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE PressureSolver
!------------------------------------------------------------------------------

FUNCTION FunA( Model, n, t ) RESULT( s )
  USE DefUtils
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t,s
  
  s = t
  
END FUNCTION FunA


FUNCTION FunB( Model, n, t ) RESULT( s )
  USE DefUtils
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t,s
  REAL(KIND=dp) :: xx,yy
  
  xx = Model % Nodes % x(n)
  yy = Model % Nodes % y(n)

  s = xx + yy
  
END FUNCTION FunB


FUNCTION FunC( Model, n, x  )  RESULT ( s ) 
  USE DefUtils
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: x(*), s

  s = x(1)**4 + x(2)**4

END FUNCTION FunC

FUNCTION MySource( Model, n, tx ) RESULT(f)
  USE DefUtils

  IMPLICIT NONE

  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: tx(2), f

  !PRINT *,'tx:',tx
  
  f = SIN(tx(1)+tx(2))
    
END FUNCTION MySource

!-----------------------------------------------------------------------------
!> A prototype solver for advection-diffusion-reaction equation,
!> This equation is generic and intended for education purposes
!> but may also serve as a starting point for more complex solvers.
!------------------------------------------------------------------------------
SUBROUTINE AdvDiffSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  REAL(KIND=dp) :: Norm
  INTEGER :: n, nb, nd, t, active
  INTEGER :: iter, maxiter, dim
  LOGICAL :: Found
!------------------------------------------------------------------------------
  TYPE(ValueHandle_t) :: Load_h, FieldSource_h, DiffCoeff_h, ReactCoeff_h, ConvCoeff_h, &
      TimeCoeff_h, ConvVelo1_h, ConvVelo2_h, ConvVelo3_h, &
      BCFlux_h, BCCoeff_h, BCExt_h
      
  CALL ListInitElementKeyword( Load_h,'Body Force','Field Source')
  CALL ListInitElementKeyword( DiffCoeff_h,'Material','Diffusion Coefficient')
  CALL ListInitElementKeyword( ReactCoeff_h,'Material','Reaction Coefficient')
  CALL ListInitElementKeyword( ConvCoeff_h,'Material','Convection Coefficient')
  CALL ListInitElementKeyword( TimeCoeff_h,'Material','Time Derivative Coefficient')
  CALL ListInitElementKeyword( ConvVelo1_h,'Material','Convection Velocity 1')
  CALL ListInitElementKeyword( ConvVelo2_h,'Material','Convection Velocity 2')
  CALL ListInitElementKeyword( ConvVelo3_h,'Material','Convection Velocity 3')

  CALL ListInitElementKeyword( BCFlux_h,'Boundary Condition','Field Flux')
  CALL ListInitElementKeyword( BCCoeff_h,'Boundary Condition','Robin Coefficient')
  CALL ListInitElementKeyword( BCExt_h,'Boundary Condition','External Field')
  
  CALL DefaultStart()
  
  maxiter = ListGetInteger( GetSolverParams(),&
      'Nonlinear System Max Iterations',Found,minv=1)
  IF(.NOT. Found ) maxiter = 1

  dim = CoordinateSystemDimension()


  
  ! Nonlinear iteration loop:
  !--------------------------
  DO iter=1,maxiter

    ! System assembly:
    !----------------
    CALL DefaultInitialize()
    Active = GetNOFActive()
    DO t=1,Active
      Element => GetActiveElement(t)
      n  = GetElementNOFNodes()
      nd = GetElementNOFDOFs()
      nb = GetElementNOFBDOFs()
      CALL LocalMatrix(  Element, n, nd+nb )
    END DO

    CALL DefaultFinishBulkAssembly()

    Active = GetNOFBoundaryElements()
    DO t=1,Active
      Element => GetBoundaryElement(t)
      IF(ActiveBoundaryElement()) THEN
        n  = GetElementNOFNodes()
        nd = GetElementNOFDOFs()
        nb = GetElementNOFBDOFs()
        CALL LocalMatrixBC(  Element, n, nd+nb )
      END IF
    END DO

    CALL DefaultFinishBoundaryAssembly()
    CALL DefaultFinishAssembly()
    CALL DefaultDirichletBCs()

    ! And finally, solve:
    !--------------------
    Norm = DefaultSolve()

    IF( Solver % Variable % NonlinConverged > 0 ) EXIT

  END DO

  CALL DefaultFinish()
  
CONTAINS

! Assembly of the matrix entries arising from the bulk elements
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix( Element, n, nd )
!------------------------------------------------------------------------------
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: D,C,R, rho,Velo(3,n),a(3), Weight
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),DetJ,LoadAtIP
    REAL(KIND=dp) :: MASS(nd,nd), STIFF(nd,nd), FORCE(nd)
    LOGICAL :: Stat,Found
    INTEGER :: i,t,p,q
    TYPE(GaussIntegrationPoints_t) :: IP
    TYPE(ValueList_t), POINTER :: BodyForce, Material
    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------


    CALL GetElementNodes( Nodes )
    MASS  = 0._dp
    STIFF = 0._dp
    FORCE = 0._dp
    a = 0.0_dp
    
    ! Numerical integration:
    !-----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis, dBasisdx )

      ! The source term at the integration point:
      !------------------------------------------
      LoadAtIP = ListGetElementReal( Load_h, Basis, Element, Found ) 
      rho = ListGetElementReal( TimeCoeff_h, Basis, Element, Found ) 

      a(1) = ListGetElementReal( ConvVelo1_h, Basis, Element, Found ) 
      a(2) = ListGetElementReal( ConvVelo2_h, Basis, Element, Found ) 
      IF( dim == 3 ) THEN
        a(3) = ListGetElementReal( ConvVelo3_h, Basis, Element, Found ) 
      END IF
        
      D = ListGetElementReal( DiffCoeff_h, Basis, Element, Found ) 
      C = ListGetElementReal( ConvCoeff_h, Basis, Element, Found ) 
      R = ListGetElementReal( ReactCoeff_h, Basis, Element, Found ) 

      Weight = IP % s(t) * DetJ

      ! diffusion term (D*grad(u),grad(v)):
      ! -----------------------------------
      STIFF(1:nd,1:nd) = STIFF(1:nd,1:nd) + Weight * &
             D * MATMUL( dBasisdx, TRANSPOSE( dBasisdx ) )

      DO p=1,nd
        DO q=1,nd
          ! advection term (C*grad(u),v)
          ! -----------------------------------
          STIFF (p,q) = STIFF(p,q) + Weight * &
             C * SUM(a(1:dim)*dBasisdx(q,1:dim)) * Basis(p)

          ! reaction term (R*u,v)
          ! -----------------------------------
          STIFF(p,q) = STIFF(p,q) + Weight * R*Basis(q) * Basis(p)

          ! time derivative (rho*du/dt,v):
          ! ------------------------------
          MASS(p,q) = MASS(p,q) + Weight * rho * Basis(q) * Basis(p)
        END DO
      END DO

      FORCE(1:nd) = FORCE(1:nd) + Weight * LoadAtIP * Basis(1:nd)
    END DO

    IF(TransientSimulation) CALL Default1stOrderTime(MASS,STIFF,FORCE)
    CALL LCondensate( nd-nb, nb, STIFF, FORCE )
    CALL DefaultUpdateEquations(STIFF,FORCE)
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------


! Assembly of the matrix entries arising from the Neumann and Robin conditions
!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrixBC( Element, n, nd )
!------------------------------------------------------------------------------
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Flux(n), Coeff(n), F,C,Ext, Weight
    REAL(KIND=dp) :: Basis(nd),DetJ,LoadAtIP
    REAL(KIND=dp) :: STIFF(nd,nd), FORCE(nd)
    LOGICAL :: Stat,Found
    INTEGER :: i,t,p,q,dim
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(ValueList_t), POINTER :: BC

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    BC => GetBC()
    IF (.NOT.ASSOCIATED(BC) ) RETURN

    CALL GetElementNodes( Nodes )
    STIFF = 0._dp
    FORCE = 0._dp

    ! Numerical integration:
    !-----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
              IP % W(t), detJ, Basis )

      Weight = IP % s(t) * DetJ

      ! Evaluate terms at the integration point:
      !------------------------------------------

      ! Given flux:
      ! -----------
      F = ListGetElementReal( BCFlux_h, Basis, Element, Found ) 

      ! Robin condition (C*(u-u_0)):
      ! ---------------------------
      C = ListGetElementReal( BCCoeff_h, Basis, Element, Found ) 
      Ext = ListGetElementReal( BCExt_h, Basis, Element, Found ) 

      DO p=1,nd
        DO q=1,nd
          STIFF(p,q) = STIFF(p,q) + Weight * C * Basis(q) * Basis(p)
        END DO
      END DO

      FORCE(1:nd) = FORCE(1:nd) + Weight * (F + C*Ext) * Basis(1:nd)
    END DO
    CALL DefaultUpdateEquations(STIFF,FORCE)
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrixBC
!------------------------------------------------------------------------------

! Perform static condensation in case bubble dofs are present
!------------------------------------------------------------------------------
  SUBROUTINE LCondensate( N, Nb, K, F )
!------------------------------------------------------------------------------
    USE LinearAlgebra
    INTEGER :: N, Nb
    REAL(KIND=dp) :: K(:,:),F(:),Kbb(Nb,Nb), &
         Kbl(Nb,N), Klb(N,Nb), Fb(Nb)

    INTEGER :: m, i, j, l, p, Ldofs(N), Bdofs(Nb)

    IF ( Nb <= 0 ) RETURN

    Ldofs = (/ (i, i=1,n) /)
    Bdofs = (/ (i, i=n+1,n+nb) /)

    Kbb = K(Bdofs,Bdofs)
    Kbl = K(Bdofs,Ldofs)
    Klb = K(Ldofs,Bdofs)
    Fb  = F(Bdofs)

    CALL InvertMatrix( Kbb,nb )

    F(1:n) = F(1:n) - MATMUL( Klb, MATMUL( Kbb, Fb  ) )
    K(1:n,1:n) = K(1:n,1:n) - MATMUL( Klb, MATMUL( Kbb, Kbl ) )
!------------------------------------------------------------------------------
  END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE AdvDiffSolver
!------------------------------------------------------------------------------

SUBROUTINE PoissonSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Solve the Poisson equation!
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Found
  TYPE(Element_t),POINTER :: Element

  REAL(KIND=dp) :: Norm,  Energy
  INTEGER :: i,j,n, nb, nd, t, istat, Active

  TYPE(ValueList_t), POINTER :: BodyForce,BC
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:), FORCE(:), &
               NEWX(:), NEWY(:), POT(:)

  TYPE(Matrix_t), POINTER :: A
  TYPE(Mesh_t),   POINTER :: Mesh

  SAVE STIFF, LOAD, FORCE, POT, AllocationsDone
!------------------------------------------------------------------------------

  ! Allocate some permanent storage, this is done first time only:
  ! --------------------------------------------------------------
  Mesh => GetMesh()

  IF ( .NOT. AllocationsDone ) THEN
     N = Mesh % MaxElementDOFs
     ALLOCATE( FORCE(N), LOAD(N), STIFF(N,N), POT(N), STAT=istat )
     IF ( istat /= 0 ) THEN
        CALL Fatal( 'PoissonSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

   n = SIZE( Mesh % Nodes % x )
   ALLOCATE( NEWX(n),NEWY(n) )
   NEWX = Mesh % Nodes % x
   NEWY = Mesh % Nodes % y

   LOAD=0
   Active = GetNOFActive()
   CALL DefaultInitialize()
   DO t=1,Active
     Element => GetActiveElement(t)
     nd = GetElementNOFDOFs(  Element )
     n  = GetElementNOFNodes( Element )
     CALL LocalMatrix(  STIFF, FORCE, LOAD, Element, n, nd )
     CALL DefaultUpdateEquations( STIFF, FORCE )
   END DO
   CALL DefaultFinishAssembly()

   Element => GetBoundaryElement(1)
   BC => GetBC()

   CALL ListAddConstReal( BC,'Potential',0.0d0,GetProcAddr("Poisson circx") )
   CALL DefaultDirichletBCs()
   Norm = DefaultSolve()
   NEWX = Solver % Variable % Values(Solver % Variable % Perm)

   CALL DefaultInitialize()
   DO t=1,Active
     Element => GetActiveElement(t)
     nd = GetElementNOFDOFs(  Element )
     n  = GetElementNOFNodes( Element )
     CALL LocalMatrix(  STIFF, FORCE, LOAD, Element, n, nd )
     CALL DefaultUpdateEquations( STIFF, FORCE )
   END DO
   CALL DefaultFinishAssembly()
   CALL ListAddConstReal( BC,'Potential',0.0d0,GetProcAddr("Poisson circy") )
   CALL DefaultDirichletBCs()
   Norm = DefaultSolve()
   NEWY = Solver % Variable % Values(Solver % Variable % Perm)

   Mesh % Nodes % x = NEWX
   Mesh % Nodes % y = NEWY
   DEALLOCATE( NEWX,NEWY )

   ! System assembly:
   ! ----------------
   CALL DefaultInitialize()
   DO t=1,active
      Element => GetActiveElement(t)
      n  = GetElementNOFNodes()
      nd = GetElementNOFDOFs()

      BodyForce => GetBodyForce()
      LOAD = 0.0d0
      IF ( ASSOCIATED(BodyForce) ) &
        Load(1:n) = GetReal( BodyForce, 'Source', Found )

      CALL LocalMatrix(  STIFF, FORCE, LOAD, Element, n, nd )
      CALL DefaultUpdateEquations( STIFF, FORCE )
   END DO
   CALL DefaultFinishAssembly()
   CALL ListAddConstReal( BC,'Potential',0.0d0)
   CALL DefaultDirichletBCs()
   Norm = DefaultSolve()

   Energy  = 0.0d0
   LOAD    = 0.0d0
   DO t=1,active
      Element => GetActiveElement(t)
      nd = GetElementNOFDOFs()
      n  = GetElementNOFNodes()
      CALL LocalMatrix( STIFF, FORCE, LOAD, Element, n, nd )
      CALL GetScalarLocalSolution(POT)
      Energy = Energy + SUM( POT*MATMUL(STIFF,POT) )
   END DO
   PRINT*,Energy
   A => GetMatrix()
   PRINT*,'DOFs, Error in energy: ',A % NumberOfRows, ABS(Energy-PI/2.0d0)

CONTAINS


!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, LOAD, Element, n, nd )
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: STIFF(:,:), FORCE(:), LOAD(:)
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(nd),dBasisdx(nd,3),ddBasisddx(nd,3,3),DetJ,LoadAtIP
    LOGICAL :: Stat
    INTEGER :: i,t
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    FORCE = 0.0d0

    !Numerical integration:
    !----------------------
    IP = GaussPoints( Element )
    DO t=1,IP % n
      ! Basis function values & derivatives at the integration point:
      !--------------------------------------------------------------
      stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
                IP % W(t), detJ, Basis, dBasisdx )

      ! The source term at the integration point:
      !------------------------------------------
      LoadAtIP = SUM( Basis(1:n) * LOAD(1:n) )

      ! Finally, the elemental matrix & vector:
      !----------------------------------------
      STIFF(1:nd,1:nd) = STIFF(1:nd,1:nd) + IP % s(t) * DetJ * &
             MATMUL( dBasisdx, TRANSPOSE(dBasisdx) )
      FORCE(1:nd) = FORCE(1:nd) + IP % s(t) * DetJ * LoadAtIP * Basis(1:nd)
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE PoissonSolver
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
FUNCTION CircX(Model,x,y,z) RESULT(s)
!------------------------------------------------------------------------------
  USE Types
  TYPE(Model_t) :: Model
  REAL(KIND=dp)::x,y,z,s,r

  r = SQRT(x**2 + y**2 )
  s = 0.0d0
  IF ( r /= 0.0d0 ) s = SQRT(2.0d0)*x/r
!------------------------------------------------------------------------------
END FUNCTION CircX
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
FUNCTION CircY(Model,x,y,z) RESULT(s)
!------------------------------------------------------------------------------
  USE Types
  TYPE(Model_t) :: Model
  REAL(KIND=dp)::x,y,z,s,r

  r = SQRT(x**2 + y**2 )
  s = 0.0d0
  IF ( r /= 0.0d0 ) s = SQRT(2.0d0)*y/r
!------------------------------------------------------------------------------
END FUNCTION CircY
!------------------------------------------------------------------------------

SUBROUTINE H1BasisEvaluation( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Unit test for new H1 basis function routines in Elmer
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
    USE DefUtils
    USE ISO_C_BINDING
!------------------------------------------------------------------------------
    IMPLICIT NONE
!------------------------------------------------------------------------------
    TYPE(Model_t) :: Model
    TYPE(Solver_t) :: Solver

    REAL(KIND=dp) :: dt
    LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
    REAL(kind=dp), PARAMETER :: tol1d = 1E-12, tol2d=1E-12, tol3d=1E-12
    INTEGER :: nerror, netest, P
    INTEGER, PARAMETER :: MaxP = 6
    nerror = 0

    ! 1D tests
    DO P=1,MaxP
      netest = TestLineElement(Solver, tol1d, P)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Line element contained errors')
        EXIT
      END IF
      nerror = nerror + netest
    END DO
    
    ! 2D tests 
    DO P=1,MaxP
      netest = TestTriangleElement(Solver, tol2d, P, .FALSE.)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Triangle element contained errors')
      END IF
      nerror = nerror + netest
    END DO

    ! 2D element in a 3D mesh
    DO P=1,MaxP
      netest = TestTriangleElement(Solver, tol2d, P, .TRUE.)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Triangle face element contained errors')
      END IF
      nerror = nerror + netest
    END DO
    
    DO P=1,MaxP
      netest = TestQuadElement(Solver, tol2d, P, .FALSE.)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Quad element contained errors')
      END IF
      nerror = nerror + netest
    END DO

    ! 2D element in a 3D mesh
    DO P=1,MaxP
      netest = TestQuadElement(Solver, tol2d, P, .TRUE.)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Quad face element contained errors')
      END IF
      nerror = nerror + netest
    END DO

    ! 3D tests
    DO P=1,MaxP
      netest = TestTetraElement(Solver, tol3d, P)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Tetra element contained errors')
      END IF
      nerror = nerror + netest
    END DO

    DO P=1,MaxP
      netest = TestWedgeElement(Solver, tol3d, P)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Wedge element contained errors')
      END IF
      nerror = nerror + netest
    END DO

    DO P=1,MaxP
      netest = TestBrickElement(Solver, tol3d, P)
      IF (netest /= 0) THEN
        CALL Warn('H1BasisEvaluation','Brick element contained errors')
      END IF
      nerror = nerror + netest
    END DO

    ! Build solution norm for error checking
    Solver % Variable % Norm = REAL(1+nerror,dp)
    Solver % Variable % Values = REAL(1+nerror,dp)
    
CONTAINS

  FUNCTION TestLineElement(Solver, tol, P) RESULT(nerror)
    IMPLICIT NONE

    TYPE(Solver_t) :: Solver
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER, INTENT(IN) :: P

    TYPE(Element_t), POINTER :: Element
    TYPE( GaussIntegrationPoints_t ) :: GP
    REAL(KIND=dp), ALLOCATABLE :: Basis(:,:), dBasisdx(:,:,:), &
          BasisVec(:,:), dBasisdxVec(:,:,:), UWrk(:), VWrk(:), WWrk(:), &
          UBlk(:), VBlk(:), WBlk(:), BasisBlk(:,:), dBasisdxBlk(:,:,:)

    INTEGER :: i, j, ngp, nerror, nbasis, nndof, nbdof, allocstat, &
            nbasisvec, ndbasisdxvec, rep, dim, perm, q, tag, ll, lln, ncl
    INTEGER, PARAMETER :: NREP = 100, BubblePerm = 2
    REAL(kind=dp) :: t_start, t_end, t_startvec, t_endvec, &
            t_start_tmp, t_tot_n, t_totvec_n, &
            t_tot_b, t_totvec_b
    LOGICAL :: Invert(BubblePerm)
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, BasisVec, dBasisdxVec, BasisBlk, dBasisdxBlk
!DIR$ ATTRIBUTES ALIGN:64 :: UWrk, VWrk, WWrk, UBlk, VBlk, WBlk

    nerror = 0
    Element => AllocatePElement(Solver % Mesh, 202, P)
    ! Insert P element definitions to Solver mapping (sets P elements as "active")
    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = Element % Type % ElementCode / 100
      Solver % Def_Dofs(tag,1,6) = P
    END IF

    GP = GaussPoints(Element)

    nndof = Element % Type % NumberOfNodes
    nbdof = Element % BDofs
    nbasis = nndof + nbdof * BubblePerm
    ngp = GP % N

    ! Reserve workspace for finite element basis
    ALLOCATE(Basis(ngp,nbasis), dBasisdx(ngp,nbasis,3), &
            BasisVec(ngp,nbasis), dBasisdxVec(ngp,nbasis,3), &
            UWrk(ngp), VWrk(ngp), WWrk(ngp), &
            UBlk(VECTOR_BLOCK_LENGTH), &
            VBlk(VECTOR_BLOCK_LENGTH), &
            WBlk(VECTOR_BLOCK_LENGTH), &
            BasisBlk(VECTOR_BLOCK_LENGTH,nbasis), &
            dBasisdxBlk(VECTOR_BLOCK_LENGTH,nbasis,3), &
            STAT=allocstat)
    IF (allocstat /= 0) THEN
      CALL Fatal('H1BasisEvaluation',&
              'Storage allocation for local element basis failed')
    END IF

    ! Copy Gauss points to local arrays
    UWrk(1:ngp) = GP % U(1:ngp)
    VWrk(1:ngp) = GP % V(1:ngp)
    WWrk(1:ngp) = GP % W(1:ngp)

    ! Initialize arrays
    Basis = 0
    dBasisdx = 0
    Invert(1:2) = [.FALSE., .TRUE.]

    t_tot_n = REAL(0,dp)
    t_tot_b = REAL(0,dp)
    t_start = ftimer()
    DO rep=1,NREP
      ! Nodal basis 
      t_start_tmp=ftimer()
      DO i=1,ngp
        CALL NodalBasisFunctions1D( Basis(i,1:nndof), Element, UWrk(i))
        CALL NodalFirstDerivatives1D( dBasisdx(i,1:nndof,1:3), Element, UWrk(i))
      END DO
      t_tot_n=t_tot_n+(ftimer()-t_start_tmp)

      ! Bubble basis (with and without inversion)
      IF (P>1) THEN
        q = 2
        t_start_tmp=ftimer()
        DO perm=1,BubblePerm
          DO j=1, Element % BDOFs
            q = q + 1
            DO i=1,ngp
              Basis(i,q) = LineBubblePBasis(j+1, UWrk(i),Invert(perm))
              dBasisdx(i,q,1) = dLineBubblePBasis(j+1, UWrk(i), Invert(perm))
            END DO
          END DO
        END DO
        t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
      END IF
    END DO
    t_end = ftimer()
    
    ! Initialize arrays
    BasisVec = 0
    dBasisdxVec = 0

    t_totvec_n = REAL(0,dp)
    t_totvec_b = REAL(0,dp)
    t_startvec = ftimer()
    DO rep=1,NREP
      ! Block over Gauss points
      DO ll=1,ngp,VECTOR_BLOCK_LENGTH
        nbasisvec = 0
        ndbasisdxvec = 0

        lln = MIN(ll+VECTOR_BLOCK_LENGTH-1,ngp)
        ncl = lln-ll+1
        UBlk(1:ncl)=UWrk(ll:lln)
        
        t_start_tmp=ftimer()
        CALL H1Basis_LineNodal(ncl, UBlk, SIZE(BasisBlk,2), BasisBlk, nbasisvec)
        CALL H1Basis_dLineNodal(ncl, UBlk, SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
        t_totvec_n=t_totvec_n+(ftimer()-t_start_tmp)

        IF (P > 1) THEN
          t_start_tmp=ftimer()
          DO perm=1,BubblePerm
            CALL H1Basis_LineBubbleP(ncl, UBlk, P, SIZE(BasisBlk,2), BasisBlk, nbasisvec, Invert(perm))
            CALL H1Basis_dLineBubbleP(ncl, UBlk, P, SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, &
                    Invert(perm))
          END DO
          t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
        END IF

        BasisVec(ll:lln,1:nbasisvec)=BasisBlk(1:ncl,1:nbasisvec)
        dBasisdxVec(ll:lln,1:ndbasisdxvec,1:3)=dBasisdxBlk(1:ncl,1:ndbasisdxvec,1:3)
      END DO
    END DO
    t_endvec = ftimer()

    CALL PrintTestData(Element, ngp, nrep, nbdof, &
            t_tot_n, t_tot_b, t_end-t_start, &
            t_totvec_n, t_totvec_b, t_endvec-t_startvec)

    nerror = TestBasis(ngp, nbasis, Element % TYPE % DIMENSION, Basis, BasisVec, &
            dBasisdx, dBasisdxVec, tol)

    CALL DeallocatePElement(Element)
    DEALLOCATE(Basis, dBasisdx, BasisVec, dBasisdxVec, UWrk, VWrk, WWrk, UBlk, VBlk, WBlk, &
          BasisBlk, dBasisdxBlk)
  END FUNCTION TestLineElement

  FUNCTION TestTriangleElement(Solver, tol, P, isEdge) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER, INTENT(IN) :: P
    LOGICAL :: isEdge

    TYPE(Element_t), POINTER :: Element
    TYPE( GaussIntegrationPoints_t ) :: GP
    REAL(KIND=dp), ALLOCATABLE :: Basis(:,:), dBasisdx(:,:,:), &
          BasisVec(:,:), dBasisdxVec(:,:,:), UWrk(:), VWrk(:), WWrk(:), &
          UBlk(:), VBlk(:), WBlk(:), BasisBlk(:,:), dBasisdxBlk(:,:,:)

    INTEGER :: i, j, k, l, q, ndof, ngp, nerror, nbasis, nndof, nedof, nfdof, &
            nbdof, allocstat, nbasisvec, ndbasisdxvec, rep, dim, perm, tag, ll, lln, ncl
    INTEGER, PARAMETER :: NREP = 100, EdgePerm = 2, BubblePerm=3
    REAL(kind=dp) :: t_start, t_end, t_startvec, t_endvec, &
            t_start_tmp, t_tot_n, t_totvec_n, t_tot_e, t_totvec_e, &
            t_tot_f, t_totvec_f, t_tot_b, t_totvec_b
    
    INTEGER :: EdgeDir(H1Basis_MaxPElementEdgeNodes,&
                       H1Basis_MaxPElementEdges,&
                       EdgePerm), EdgeP(H1Basis_MaxPElementEdges), &
               BubbleDir(H1Basis_MaxPElementFaceNodes, &
                       BubblePerm)
    LOGICAL :: InvertEdge(3, EdgePerm)
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, BasisVec, dBasisdxVec, BasisBlk, dBasisdxBlk
!DIR$ ATTRIBUTES ALIGN:64 :: UWrk, VWrk, WWrk, UBlk, VBlk, WBlk

    nerror = 0
    Element => AllocatePElement(Solver % Mesh, 303, P)
    ! Insert P element definitions to Solver mapping (sets P elements as "active")
    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = Element % Type % ElementCode / 100
      Solver % Def_Dofs(tag,1,6) = P
    END IF
    GP = GaussPoints(Element)
    
    nndof = Element % Type % NumberOfNodes
    nedof = GetEdgeDOFs( Element, P )
    IF (isEdge) THEN
      nbdof = Element % BDofs*BubblePerm
    ELSE
      nbdof = Element % BDofs
    END IF
    nbasis = nndof + 3*nedof*EdgePerm + nbdof
    ngp = GP % N

    ! Reserve workspace for finite element basis
    ALLOCATE(Basis(ngp,nbasis), dBasisdx(ngp,nbasis,3), &
            BasisVec(ngp,nbasis), dBasisdxVec(ngp,nbasis,3), &
            UWrk(ngp), VWrk(ngp), WWrk(ngp), &
            UBlk(VECTOR_BLOCK_LENGTH), &
            VBlk(VECTOR_BLOCK_LENGTH), &
            WBlk(VECTOR_BLOCK_LENGTH), &
            BasisBlk(VECTOR_BLOCK_LENGTH,nbasis), &
            dBasisdxBlk(VECTOR_BLOCK_LENGTH,nbasis,3), &
            STAT=allocstat)
    IF (allocstat /= 0) THEN
      CALL Fatal('H1BasisEvaluation',&
              'Storage allocation for local element basis failed')
    END IF
    
    ! Copy Gauss points to local arrays
    UWrk(1:ngp) = GP % U(1:ngp)
    VWrk(1:ngp) = GP % V(1:ngp)
    WWrk(1:ngp) = GP % W(1:ngp)

    ! Initialize arrays
    Basis = 0
    dBasisdx = 0
    DO i=1,3
      EdgeDir(1:2,i,1)=getTriangleEdgeMap(i)
    END DO
    ! Invert direction
    DO i=1,3
      EdgeDir(2:1:-1,i,2)=EdgeDir(1:2,i,1)
    END DO
    InvertEdge(:,1) = .FALSE.
    InvertEdge(:,2) = .TRUE.

    ! Initialize bubble mappings if needed
    IF (isEdge) THEN
      BubbleDir(1:3,1)=[ 1,2,3 ]
      DO i=2,BubblePerm
        BubbleDir(1:3,i)=CSHIFT(BubbleDir(1:3,1),i-1)
      END DO
    END IF

    EdgeP = P

    t_tot_n = REAL(0,dp)
    t_tot_e = REAL(0,dp)
    t_tot_b = REAL(0,dp)
    t_start = ftimer()
    DO rep=1,NREP
      ! Nodal basis
      t_start_tmp=ftimer()
      DO ndof=1,nndof
        DO i=1,ngp
          Basis(i,ndof) = TriangleNodalPBasis(ndof, UWrk(i), VWrk(i))
          dBasisdx(i,ndof,1:2) = dTriangleNodalPBasis(ndof, UWrk(i), VWrk(i))
        END DO
      END Do
      t_tot_n=t_tot_n+(ftimer()-t_start_tmp)

      ! Edge basis
      IF (P>1) THEN
        t_start_tmp=ftimer()
        q = 3
        DO perm=1,EdgePerm
          DO i=1,3
            DO ndof=1,nedof
              q=q+1
              DO k=1,ngp
                Basis(k,q) = TriangleEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), &
                                                InvertEdge(i,perm))
                dBasisdx(k,q,1:2) = dTriangleEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), &
                                                InvertEdge(i,perm))
              END DO
            END DO
          END DO
        END DO
        t_tot_e=t_tot_e+(ftimer()-t_start_tmp)
      END IF
        
      ! Bubble basis
      IF (P>2) THEN
        IF (.NOT. isEdge) THEN
          t_start_tmp=ftimer()
          DO i = 0,p-3
            DO j = 0,p-i-3
              q = q + 1
              DO k = 1, ngp
                Basis(k, q) = TriangleBubblePBasis(i,j,UWrk(k), GP % v(k))
                dBasisdx(k, q, 1:2) = dTriangleBubblePBasis(i,j,GP % u(k), GP % v(k))  
              END DO
            END DO
          END DO
          t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
        ELSE
          t_start_tmp=ftimer()
          DO perm=1,BubblePerm
            DO i = 0,p-3
              DO j = 0,p-i-3
                q = q + 1
                DO k = 1, ngp
                  Basis(k, q) = TriangleEBubblePBasis(i,j,UWrk(k), GP % v(k), &
                          BubbleDir(1:3,perm))
                  dBasisdx(k, q, 1:2) = dTriangleEBubblePBasis(i,j,GP % u(k), GP % v(k), &
                          BubbleDir(1:3,perm))  
                END DO
              END DO
            END DO
          END DO
          t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
        END IF
      END IF
    END DO ! NREP
    t_end = ftimer()
    
    ! Initialize arrays
    BasisVec = 0
    dBasisdxVec = 0

    t_totvec_n = REAL(0,dp)
    t_totvec_e = REAL(0,dp)
    t_totvec_b = REAL(0,dp)
    t_startvec = ftimer()
    DO rep=1,NREP
      ! Block over Gauss points
      DO ll=1,ngp,VECTOR_BLOCK_LENGTH
        nbasisvec = 0
        ndbasisdxvec = 0

        lln = MIN(ll+VECTOR_BLOCK_LENGTH-1,ngp)
        ncl = lln-ll+1
        UBlk(1:ncl)=UWrk(ll:lln)
        VBlk(1:ncl)=VWrk(ll:lln)
      
        t_start_tmp=ftimer()
        CALL H1Basis_TriangleNodalP(ncl, UBlk, VBlk, SIZE(BasisBlk,2), BasisBlk, nbasisvec)
        CALL H1Basis_dTriangleNodalP(ncl, UBlk, VBlk, SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
        t_totvec_n=t_totvec_n+(ftimer()-t_start_tmp)
        
        IF (P > 1) THEN
          t_start_tmp=ftimer()
          DO perm=1,EdgePerm
            CALL H1Basis_TriangleEdgeP(ncl, UBlk, VBlk, EdgeP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, EdgeDir(:,:,perm))
            CALL H1Basis_dTriangleEdgeP(ncl, UBlk, VBlk, EdgeP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, EdgeDir(:,:,perm))
          END DO
          t_totvec_e=t_totvec_e+(ftimer()-t_start_tmp)
        END IF

        IF (P > 2) THEN
          IF (.NOT. isEdge) THEN
            t_start_tmp=ftimer()
            CALL H1Basis_TriangleBubbleP(ncl, UBlk, VBlk, P, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec)
            CALL H1Basis_dTriangleBubbleP(ncl, UBlk, VBlk, P, &
                SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
            t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
          ELSE
            t_start_tmp=ftimer()
            DO perm=1,BubblePerm
              CALL H1Basis_TriangleBubbleP(ncl, UBlk, VBlk, P, &
                      SIZE(BasisBlk,2), BasisBlk, nbasisvec, BubbleDir(1:3,perm))
              CALL H1Basis_dTriangleBubbleP(ncl, UBlk, VBlk, P, &
                      SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, BubbleDir(1:3,perm))
            END DO
            t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
          END IF
        END IF

        BasisVec(ll:lln,1:nbasisvec)=BasisBlk(1:ncl,1:nbasisvec)
        dBasisdxVec(ll:lln,1:ndbasisdxvec,1:3)=dBasisdxBlk(1:ncl,1:ndbasisdxvec,1:3)
      END DO
    END DO
    t_endvec = ftimer()

    CALL PrintTestData(Element, ngp, nrep, 3*nedof+nbdof, &
            t_tot_n, t_tot_e+t_tot_b, t_end-t_start, &
            t_totvec_n, t_totvec_e+t_totvec_b, t_endvec-t_startvec)

    nerror = TestBasis(ngp, nbasis, Element % TYPE % DIMENSION, Basis, BasisVec, &
            dBasisdx, dBasisdxVec, tol)

    CALL DeallocatePElement(Element)
    DEALLOCATE(Basis, dBasisdx, BasisVec, dBasisdxVec, UWrk, VWrk, WWrk, UBlk, VBlk, WBlk, &
          BasisBlk, dBasisdxBlk)
  END FUNCTION TestTriangleElement
  
  FUNCTION TestQuadElement(Solver, tol, P, isEdge) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER, INTENT(IN) :: P
    LOGICAL :: isEdge

    TYPE(Element_t), POINTER :: Element
    TYPE( GaussIntegrationPoints_t ) :: GP
    REAL(KIND=dp), ALLOCATABLE :: Basis(:,:), dBasisdx(:,:,:), &
          BasisVec(:,:), dBasisdxVec(:,:,:), UWrk(:), VWrk(:), WWrk(:), &
          UBlk(:), VBlk(:), WBlk(:), BasisBlk(:,:), dBasisdxBlk(:,:,:)

    INTEGER :: i, j, k, l, q, ndof, ngp, nerror, nbasis, nndof, nedof, nbdof, allocstat, &
            nbasisvec, ndbasisdxvec, rep, dim, perm, tag, ll, lln, ncl
    INTEGER, PARAMETER :: NREP = 100, EdgePerm = 2, BubblePerm = 4
    REAL(kind=dp) :: t_start, t_end, t_startvec, t_endvec, &
            t_start_tmp, t_tot_n, t_totvec_n, &
            t_tot_e, t_totvec_e, t_tot_b, t_totvec_b
    INTEGER :: EdgeDir(H1Basis_MaxPElementEdgeNodes,&
                       H1Basis_MaxPElementEdges,&
                       EdgePerm), EdgeP(H1Basis_MaxPElementEdges),&
               BubbleDir(H1Basis_MaxPElementFaceNodes,BubblePerm)
    LOGICAL :: InvertEdge(4, EdgePerm)
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, BasisVec, dBasisdxVec, BasisBlk, dBasisdxBlk
!DIR$ ATTRIBUTES ALIGN:64 :: UWrk, VWrk, WWrk, UBlk, VBlk, WBlk

    nerror = 0
    Element => AllocatePElement(Solver % Mesh, 404, P)
    ! Insert P element definitions to Solver mapping (sets P elements as "active")
    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = Element % Type % ElementCode / 100
      Solver % Def_Dofs(tag,1,6) = P
    END IF

    GP = GaussPointsQuad((P+1)**2)
    
    nndof = Element % Type % NumberOfNodes
    nedof = getEdgeDOFs( Element, P )
    IF (isEdge) THEN
      nbdof = Element % BDofs*BubblePerm
    ELSE
      nbdof = Element % BDofs
    END IF
    nbasis = nndof + 4*nedof*EdgePerm + nbdof
    ngp = GP % N

    ! Reserve workspace for finite element basis
    ALLOCATE(Basis(ngp,nbasis), dBasisdx(ngp,nbasis,3), &
            BasisVec(ngp,nbasis), dBasisdxVec(ngp,nbasis,3), &
            UWrk(ngp), VWrk(ngp), WWrk(ngp), &
            UBlk(VECTOR_BLOCK_LENGTH), &
            VBlk(VECTOR_BLOCK_LENGTH), &
            WBlk(VECTOR_BLOCK_LENGTH), &
            BasisBlk(VECTOR_BLOCK_LENGTH,nbasis), &
            dBasisdxBlk(VECTOR_BLOCK_LENGTH,nbasis,3), &
            STAT=allocstat)
    IF (allocstat /= 0) THEN
      CALL Fatal('H1BasisEvaluation',&
              'Storage allocation for local element basis failed')
    END IF
    
    ! Copy Gauss points to local arrays
    UWrk(1:ngp) = GP % U(1:ngp)
    VWrk(1:ngp) = GP % V(1:ngp)
    WWrk(1:ngp) = GP % W(1:ngp)

    ! Initialize arrays
    Basis = 0
    dBasisdx = 0
    DO i=1,4
      EdgeDir(1:2,i,1)=getQuadEdgeMap(i)
    END DO
    ! Invert direction
    DO i=1,4
      EdgeDir(2:1:-1,i,2)=EdgeDir(1:2,i,1)
    END DO
    InvertEdge(:,1) = .FALSE.
    InvertEdge(:,2) = .TRUE.

    ! Initialize face mappings if needed
    IF (isEdge) THEN
      BubbleDir(1:4,1)=[ 1,2,3,4 ]
      DO i=2,BubblePerm
        BubbleDir(1:4,i)=CSHIFT(BubbleDir(1:4,1),i-1)
      END DO
    END IF

    EdgeP = P
    
    t_tot_n = REAL(0,dp)
    t_tot_e = REAL(0,dp)
    t_tot_b = REAL(0,dp)
    t_start = ftimer()
    DO rep=1,NREP
      ! Nodal basis 
      t_start_tmp=ftimer()
      DO i=1,ngp
        CALL NodalBasisFunctions2D( Basis(i,1:nndof), Element, UWrk(i), VWrk(i))
        CALL NodalFirstDerivatives2D( dBasisdx(i,1:nndof,1:3), Element, UWrk(i), VWrk(i))
      END DO
      t_tot_n=t_tot_n+(ftimer()-t_start_tmp)

      IF (P>1) THEN
        ! Edge basis
        t_start_tmp=ftimer()
        q = 4
        DO perm=1,EdgePerm
          DO i=1,4
            DO ndof=1,nedof
              q=q+1
              DO k=1,ngp
                Basis(k,q) = QuadEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), InvertEdge(i,perm))
                dBasisdx(k,q,1:2) = dQuadEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), InvertEdge(i,perm))
              END DO
            END DO
          END DO
        END DO
        t_tot_e=t_tot_e+(ftimer()-t_start_tmp)
      END IF

      ! Bubble basis 
      IF (P > 3) THEN
        IF (.NOT. isEdge) THEN
          t_start_tmp=ftimer()
          DO i=2,(p-2)
            DO j=2,(p-i)
              q = q + 1
              DO k = 1, ngp
                Basis(k, q) = QuadBubblePBasis(i,j,UWrk(k),VWrk(k))
                dBasisdx(k, q, 1:2) = dQuadBubblePBasis(i,j,UWrk(k),VWrk(k))
              END DO
            END DO
          END DO
          t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
        ELSE
          t_start_tmp=ftimer()
          DO perm=1,BubblePerm
            DO i=2,(p-2)
              DO j=2,(p-i)
                q = q + 1
                DO k = 1, ngp
                  Basis(k, q) = QuadBubblePBasis(i,j,UWrk(k),VWrk(k),&
                          BubbleDir(1:4,perm))
                  dBasisdx(k, q, 1:2) = dQuadBubblePBasis(i,j,UWrk(k),VWrk(k),&
                          BubbleDir(1:4,perm))
                END DO
              END DO
            END DO
          END DO
          t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
        END IF
      END IF
    END DO
    t_end = ftimer()
    
    ! Initialize arrays
    BasisVec = 0
    dBasisdxVec = 0

    t_totvec_n = REAL(0,dp)
    t_totvec_e = REAL(0,dp)
    t_totvec_b = REAL(0,dp)
    t_startvec = ftimer()
    DO rep=1,NREP
      ! Block over Gauss points
      DO ll=1,ngp,VECTOR_BLOCK_LENGTH
        nbasisvec = 0
        ndbasisdxvec = 0

        lln = MIN(ll+VECTOR_BLOCK_LENGTH-1,ngp)
        ncl = lln-ll+1
        UBlk(1:ncl)=UWrk(ll:lln)
        VBlk(1:ncl)=VWrk(ll:lln)
      
        t_start_tmp=ftimer()
        CALL H1Basis_QuadNodal(ncl, UBlk, VBlk, SIZE(BasisBlk,2), BasisBlk, nbasisvec)
        CALL H1Basis_dQuadNodal(ncl, UBlk, VBlk, SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
        t_totvec_n=t_totvec_n+(ftimer()-t_start_tmp)
        
        IF (P > 1) THEN
          ! Edge basis
          t_start_tmp=ftimer()
          DO perm=1,EdgePerm
            CALL H1Basis_QuadEdgeP(ncl, UBlk, VBlk, EdgeP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, EdgeDir(:,:,perm))
            CALL H1Basis_dQuadEdgeP(ncl, UBlk, VBlk, EdgeP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, EdgeDir(:,:,perm))
          END DO
          t_totvec_e=t_totvec_e+(ftimer()-t_start_tmp)
        END IF

        IF (P > 3) THEN
          IF (.NOT. isEdge) THEN
            t_start_tmp=ftimer()
            CALL H1Basis_QuadBubbleP(ncl, UBlk, VBlk, P, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec)
            
            CALL H1Basis_dQuadBubbleP(ncl, UBlk, VBlk, P, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
            t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
          ELSE
            t_start_tmp=ftimer()
            DO perm=1,BubblePerm
              CALL H1Basis_QuadBubbleP(ncl, UBlk, VBlk, P, &
                      SIZE(BasisBlk,2), BasisBlk, nbasisvec, BubbleDir(1:4,perm))
              
              CALL H1Basis_dQuadBubbleP(ncl, UBlk, VBlk, P, &
                      SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, BubbleDir(1:4,perm))
            END DO
            t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
          END IF
        END IF

        BasisVec(ll:lln,1:nbasisvec)=BasisBlk(1:ncl,1:nbasisvec)
        dBasisdxVec(ll:lln,1:ndbasisdxvec,1:3)=dBasisdxBlk(1:ncl,1:ndbasisdxvec,1:3)
      END DO
    END DO
    t_endvec = ftimer()
    
    CALL PrintTestData(Element, ngp, nrep, 4*nedof+nbdof,&
            t_tot_n, t_tot_e+t_tot_b, t_end-t_start, &
            t_totvec_n, t_totvec_e+t_totvec_b, t_endvec-t_startvec)

    nerror = TestBasis(ngp, nbasis, Element % TYPE % DIMENSION, Basis, BasisVec, &
            dBasisdx, dBasisdxVec, tol)

    CALL DeallocatePElement(Element)
    DEALLOCATE(Basis, dBasisdx, BasisVec, dBasisdxVec, UWrk, VWrk, WWrk, UBlk, VBlk, WBlk, &
          BasisBlk, dBasisdxBlk)
  END FUNCTION TestQuadElement

  FUNCTION TestTetraElement(Solver, tol, P) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER, INTENT(IN) :: P

    TYPE(Element_t), POINTER :: Element
    TYPE( GaussIntegrationPoints_t ) :: GP
    REAL(KIND=dp), ALLOCATABLE :: Basis(:,:), dBasisdx(:,:,:), &
          BasisVec(:,:), dBasisdxVec(:,:,:), UWrk(:), VWrk(:), WWrk(:), &
          UBlk(:), VBlk(:), WBlk(:), BasisBlk(:,:), dBasisdxBlk(:,:,:)

    INTEGER :: i, j, k, l, q, ndof, nedof, nfdof, ngp, nerror, nbasis, nndof, nbdof, allocstat, &
            nbasisvec, ndbasisdxvec, rep, dim, tag, perm, ll, lln, ncl
    INTEGER, PARAMETER :: NREP = 100, EdgePerm=2, FacePerm=2
    REAL(kind=dp) :: t_start, t_end, t_startvec, t_endvec, &
          t_start_tmp, t_tot_n, t_totvec_n, &
          t_tot_e, t_totvec_e, t_tot_f, t_totvec_f, t_tot_b, t_totvec_b
    INTEGER :: EdgeDir(H1Basis_MaxPElementEdgeNodes,&
                       H1Basis_MaxPElementEdges,&
                       EdgePerm), EdgeP(H1Basis_MaxPElementEdges), &
               FaceDir(H1Basis_MaxPElementFaceNodes, &
                       H1Basis_MaxPElementFaces, &
                       FacePerm), FaceP(H1Basis_MaxPElementFaces), &
               TetraType(H1Basis_MaxPElementEdges, EdgePerm)
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, BasisVec, dBasisdxVec, BasisBlk, dBasisdxBlk
!DIR$ ATTRIBUTES ALIGN:64 :: UWrk, VWrk, WWrk, UBlk, VBlk, WBlk

    nerror = 0
    Element => AllocatePElement(Solver % Mesh, 504, P)
    ! Insert P element definitions to Solver mapping (sets P elements as "active")
    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = Element % Type % ElementCode / 100
      Solver % Def_Dofs(tag,1,6) = P
    END IF

    GP = GaussPoints(Element)
    
    nndof = Element % Type % NumberOfNodes
    nedof = getEdgeDOFs( Element, P )
    nfdof = getFaceDOFs( Element, P )
    nbdof = Element % BDofs
    nbasis = nndof + 6*nedof*EdgePerm + 4*nfdof*FacePerm + nbdof 
    ngp = GP % N

    ! Reserve workspace for finite element basis
    ALLOCATE(Basis(ngp,nbasis), dBasisdx(ngp,nbasis,3), &
            BasisVec(ngp,nbasis), dBasisdxVec(ngp,nbasis,3), &
            UWrk(ngp), VWrk(ngp), WWrk(ngp), &
            UBlk(VECTOR_BLOCK_LENGTH), &
            VBlk(VECTOR_BLOCK_LENGTH), &
            WBlk(VECTOR_BLOCK_LENGTH), &
            BasisBlk(VECTOR_BLOCK_LENGTH,nbasis), &
            dBasisdxBlk(VECTOR_BLOCK_LENGTH,nbasis,3), &
            STAT=allocstat)
    IF (allocstat /= 0) THEN
      CALL Fatal('H1BasisEvaluation',&
              'Storage allocation for local element basis failed')
    END IF
    
    ! Copy Gauss points to local arrays
    UWrk(1:ngp) = GP % U(1:ngp)
    VWrk(1:ngp) = GP % V(1:ngp)
    WWrk(1:ngp) = GP % W(1:ngp)

    ! Initialize arrays
    Basis = 0
    dBasisdx = 0
    ! Tetra type 1 and 2
    DO perm=1,EdgePerm
      DO i=1,6
        EdgeDir(1:2,i,perm)=getTetraEdgeMap(i,perm)
      END DO
    END DO
    FaceDir = 0
    DO perm=1,FacePerm
      DO i=1,4
        FaceDir(1:3,i,perm)=getTetraFaceMap(i,perm)
      END DO
    END DO
    TetraType(:,1) = 1
    TetraType(:,2) = 2
    EdgeP = P
    FaceP = P
    
    t_tot_n = REAL(0,dp)
    t_tot_e = REAL(0,dp)
    t_tot_f = REAL(0,dp)
    t_tot_b = REAL(0,dp)
    t_start = ftimer()
    DO rep=1,NREP
      ! Nodal basis 
      t_start_tmp=ftimer()
      DO ndof=1,nndof
        DO i=1,ngp
          Basis(i,ndof) = TetraNodalPBasis(ndof, UWrk(i), VWrk(i), WWrk(i))
          dBasisdx(i,ndof,1:3) = dTetraNodalPBasis(ndof, UWrk(i), VWrk(i), WWrk(i))
        END DO
      END Do
      t_tot_n=t_tot_n+(ftimer()-t_start_tmp)

      IF (P > 1) THEN
        ! Edge basis
        t_start_tmp=ftimer()
        q = 4
        DO perm=1,EdgePerm
          DO i=1,6
            DO ndof=1,nedof
              q= q + 1
              DO k=1,ngp
                Basis(k,q) = TetraEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), WWrk(k), TetraType(i,perm))
                dBasisdx(k,q,1:3) = dTetraEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), WWrk(k), TetraType(i,perm))
              END DO
            END DO
          END DO
        END DO
        t_tot_e=t_tot_e+(ftimer()-t_start_tmp)
      END IF

      ! Face basis
      IF (P > 2) THEN
        t_start_tmp=ftimer()
        DO perm=1,FacePerm
          DO i=1,4
            DO j=0,p-3
              DO k=0,p-j-3
                q= q + 1
                DO l=1,ngp
                  Basis(l,q) = TetraFacePBasis(i, j, k, UWrk(l), VWrk(l), WWrk(l), TetraType(i,perm))
                  dBasisdx(l,q,1:3) = dTetraFacePBasis(i, j, k, UWrk(l), VWrk(l), WWrk(l), TetraType(i,perm))
                END DO
              END DO
            END DO
          END DO
        END DO
        t_tot_f=t_tot_e+(ftimer()-t_start_tmp)
      END IF

      ! Bubble basis 
      IF (P > 3) THEN
        t_start_tmp=ftimer()
        DO i=0,p-4
          DO j=0,p-i-4
            DO k=0,p-i-j-4
              q = q + 1
              DO l = 1, ngp
                Basis(l, q) = TetraBubblePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l))
                dBasisdx(l, q, 1:3) = dTetraBubblePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l))  
              END DO
            END DO
          END DO
        END DO
        t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
      END IF
    END DO
    t_end = ftimer()
    
    ! Initialize arrays
    BasisVec = 0
    dBasisdxVec = 0

    t_totvec_n = REAL(0,dp)
    t_totvec_e = REAL(0,dp)
    t_totvec_f = REAL(0,dp)
    t_totvec_b = REAL(0,dp)
    t_startvec = ftimer()
    DO rep=1,NREP
      ! Block over Gauss points
      DO ll=1,ngp,VECTOR_BLOCK_LENGTH
        nbasisvec = 0
        ndbasisdxvec = 0

        lln = MIN(ll+VECTOR_BLOCK_LENGTH-1,ngp)
        ncl = lln-ll+1
        UBlk(1:ncl)=UWrk(ll:lln)
        VBlk(1:ncl)=VWrk(ll:lln)
        WBlk(1:ncl)=WWrk(ll:lln)
      
        t_start_tmp=ftimer()
        CALL H1Basis_TetraNodalP(ncl, UBlk, VBlk, WBLk, SIZE(BasisBlk,2), BasisBlk, nbasisvec)
        CALL H1Basis_dTetraNodalP(ncl, UBlk, VBlk, WBlk, SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
        t_totvec_n=t_totvec_n+(ftimer()-t_start_tmp)

        IF (P > 1) THEN
          t_start_tmp=ftimer()
          DO perm=1,EdgePerm
            CALL H1Basis_TetraEdgeP(ncl, UBlk, VBlk, WBlk, EdgeP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, EdgeDir(:,:,perm))
            CALL H1Basis_dTetraEdgeP(ncl, UBlk, VBlk, WBlk, EdgeP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, EdgeDir(:,:,perm))
          END DO
          t_totvec_e=t_totvec_e+(ftimer()-t_start_tmp)
        END IF
        IF (P > 2) THEN
          t_start_tmp=ftimer()
          DO perm=1,FacePerm
            CALL H1Basis_TetraFaceP(ncl, UBlk, VBlk, WBlk, FaceP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, FaceDir(:,:,perm))
            CALL H1Basis_dTetraFaceP(ncl, UBlk, VBlk, WBlk, FaceP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, FaceDir(:,:,perm))
          END DO
          t_totvec_f=t_totvec_f+(ftimer()-t_start_tmp)
        END IF
        IF (P > 3) THEN
          t_start_tmp=ftimer()
          CALL H1Basis_TetraBubbleP(ncl, UBlk, VBlk, WBlk, P, &
                  SIZE(BasisBlk,2), BasisBlk, nbasisvec)
          CALL H1Basis_dTetraBubbleP(ncl, UBlk, VBlk, WBlk, P, &
                  SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
          t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
        END IF

        BasisVec(ll:lln,1:nbasisvec)=BasisBlk(1:ncl,1:nbasisvec)
        dBasisdxVec(ll:lln,1:ndbasisdxvec,1:3)=dBasisdxBlk(1:ncl,1:ndbasisdxvec,1:3)
      END DO
    END DO
    t_endvec = ftimer()

    CALL PrintTestData(Element, ngp, nrep, 6*nedof+4*nfdof+nbdof, &
            t_tot_n, t_tot_e+t_tot_f+t_tot_b, t_end-t_start, &
            t_totvec_n, t_totvec_e+t_totvec_f+t_totvec_b, t_endvec-t_startvec)

    nerror = TestBasis(ngp, nbasis, Element % TYPE % DIMENSION, Basis, BasisVec, &
            dBasisdx, dBasisdxVec, tol)

    CALL DeallocatePElement(Element)
    DEALLOCATE(Basis, dBasisdx, BasisVec, dBasisdxVec, UWrk, VWrk, WWrk, UBlk, VBlk, WBlk, &
          BasisBlk, dBasisdxBlk)
  END FUNCTION TestTetraElement

  
  FUNCTION TestWedgeElement(Solver, tol, P) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER, INTENT(IN) :: P

    TYPE(Element_t), POINTER :: Element
    TYPE( GaussIntegrationPoints_t ) :: GP
    REAL(KIND=dp), ALLOCATABLE :: Basis(:,:), dBasisdx(:,:,:), &
          BasisVec(:,:), dBasisdxVec(:,:,:), UWrk(:), VWrk(:), WWrk(:), &
          UBlk(:), VBlk(:), WBlk(:), BasisBlk(:,:), dBasisdxBlk(:,:,:)

    INTEGER :: i, j, k, l, q, ngp, nerror, nbasis, nndof, nedof, &
          nfdof, nbdof, allocstat, perm, &
          nbasisvec, ndbasisdxvec, rep, dim, tag, ndof, ll, lln, ncl
    INTEGER, PARAMETER :: NREP = 100, EdgePerm=2, FacePerm=4
    REAL(kind=dp) :: t_start, t_end, t_startvec, t_endvec, &
            t_start_tmp, t_tot_n, t_totvec_n, &
            t_tot_e, t_totvec_e, t_tot_f, t_totvec_f, t_tot_b, t_totvec_b
    INTEGER :: EdgeDir(H1Basis_MaxPElementEdgeNodes,&
                       H1Basis_MaxPElementEdges,&
                       EdgePerm), EdgeP(H1Basis_MaxPElementEdges), &
               FaceDir(H1Basis_MaxPElementFaceNodes, &
                       H1Basis_MaxPElementFaces, &
                       FacePerm), FaceP(H1Basis_MaxPElementFaces)
    INTEGER :: direction(H1Basis_MaxPElementFaceNodes), tmp
    LOGICAL :: InvertEdge(9, EdgePerm), invert
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, BasisVec, dBasisdxVec, BasisBlk, dBasisdxBlk
!DIR$ ATTRIBUTES ALIGN:64 :: UWrk, VWrk, WWrk, UBlk, VBlk, WBlk
    
    nerror = 0
    Element => AllocatePElement(Solver % Mesh, 706, P)
    ! Insert P element definitions to Solver mapping (sets P elements as "active")
    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = Element % Type % ElementCode / 100
      Solver % Def_Dofs(tag,1,6) = P
    END IF

    GP = GaussPoints(Element)
    
    nndof = Element % Type % NumberOfNodes
    nedof = getEdgeDOFs( Element, P )
    nfdof = 2*getFaceDofs( Element, P, 1)+3*getFaceDOFs( Element, P, 3 )
    nbdof = Element % BDofs
    nbasis = nndof + 9*nedof*EdgePerm + nfdof*FacePerm + nbdof
    ngp = GP % N

    ! Reserve workspace for finite element basis
    ALLOCATE(Basis(ngp,nbasis), dBasisdx(ngp,nbasis,3), &
            BasisVec(ngp,nbasis), dBasisdxVec(ngp,nbasis,3), &
            UWrk(ngp), VWrk(ngp), WWrk(ngp), &
            UBlk(VECTOR_BLOCK_LENGTH), &
            VBlk(VECTOR_BLOCK_LENGTH), &
            WBlk(VECTOR_BLOCK_LENGTH), &
            BasisBlk(VECTOR_BLOCK_LENGTH,nbasis), &
            dBasisdxBlk(VECTOR_BLOCK_LENGTH,nbasis,3), &
            STAT=allocstat)
    IF (allocstat /= 0) THEN
      CALL Fatal('H1BasisEvaluation',&
              'Storage allocation for local element basis failed')
    END IF
    
    ! Copy Gauss points to local arrays
    UWrk(1:ngp) = GP % U(1:ngp)
    VWrk(1:ngp) = GP % V(1:ngp)
    WWrk(1:ngp) = GP % W(1:ngp)

    ! Initialize arrays
    Basis = 0
    dBasisdx = 0
    DO i=1,9
      EdgeDir(1:2,i,1)=getWedgeEdgeMap(i)
    END DO
    ! Invert direction
    DO i=1,9
      EdgeDir(2:1:-1,i,2)=EdgeDir(1:2,i,1)
    END DO
    InvertEdge(:,1) = .FALSE.
    InvertEdge(:,2) = .TRUE.

    DO i=1,5
      FaceDir(1:4,i,1)=getWedgeFaceMap(i)
    END DO
    DO j=2,FacePerm
      DO i=1,2
        FaceDir(1:3,i,j)=CSHIFT(FaceDir(1:3,i,1), j-1)
      END DO
      DO i=3,5
        FaceDir(1:4,i,j)=CSHIFT(FaceDir(1:4,i,1), j-1)
      END DO
    END DO

    EdgeP = P
    FaceP = P

    t_tot_n = REAL(0,dp)
    t_tot_e = REAL(0,dp)
    t_tot_f = REAL(0,dp)
    t_tot_b = REAL(0,dp)
    
    t_start = ftimer()
    DO rep=1,NREP
      ! Nodal basis 
      t_start_tmp=ftimer()
      DO ndof=1,nndof
        DO i=1,ngp
          Basis(i,ndof) = WedgeNodalPBasis(ndof, UWrk(i), VWrk(i), WWrk(i))
          dBasisdx(i,ndof,1:3) = dWedgeNodalPBasis(ndof, UWrk(i), VWrk(i), WWrk(i))
        END DO
      END Do
      t_tot_n=t_tot_n+(ftimer()-t_start_tmp)

      IF (P > 1) THEN
        ! Edge basis
        t_start_tmp=ftimer()
        q = 6
        DO perm=1,EdgePerm
          DO i=1,9
            DO ndof=1,nedof
              q=q+1
              DO k=1,ngp
                Basis(k,q) = WedgeEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), WWrk(k), &
                        InvertEdge(i,perm))
                dBasisdx(k,q,1:3) = dWedgeEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), WWrk(k), &
                        InvertEdge(i,perm))
              END DO
            END DO
          END DO
        END DO
        t_tot_e=t_tot_e+(ftimer()-t_start_tmp)
      END IF

      IF (P > 2) THEN
        ! Face basis
        t_start_tmp=ftimer()
        DO perm=1,FacePerm
          ! Triangle faces
          DO i=1,2
            DO j=0,p-3
              DO k=0,p-j-3
                q = q + 1
                DO l=1,ngp
                  Basis(l,q) = WedgeFacePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l), &
                          FaceDir(1:4,i,perm))
                  dBasisdx(l,q,1:3) = dWedgeFacePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l), &
                          FaceDir(1:4,i,perm))
                END DO
              END DO
            END DO
          END DO
          ! Square faces
          DO i=3,5
            ! First and second node must form an edge in the upper or lower triangle
            direction(1:4) = FaceDir(1:4,i,perm)
            invert=.FALSE. 
            IF (.NOT. wedgeOrdering(direction)) THEN
              invert = .TRUE.
              tmp = direction(2)
              direction(2) = direction(4)
              direction(4) = tmp
            END IF
            
            DO j=2,p-2
              DO k=2,p-j
                q = q + 1
                IF (.NOT. invert) THEN
                  DO l=1,ngp
                    Basis(l,q) = WedgeFacePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l), &
                            direction)
                    dBasisdx(l,q,1:3) = dWedgeFacePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l), &
                            direction)
                  END DO
                ELSE
                  DO l=1,ngp
                    Basis(l,q) = WedgeFacePBasis(i,k,j,UWrk(l), VWrk(l), WWrk(l), &
                          direction)
                    dBasisdx(l,q,1:3) = dWedgeFacePBasis(i,k,j,UWrk(l), VWrk(l), WWrk(l), &
                            direction)
                  END DO
                END IF
              END DO
            END DO
          END DO
        END DO
        t_tot_f=t_tot_f+(ftimer()-t_start_tmp)
      END IF
      
      ! Bubble basis 
      IF (P > 4) THEN
        t_start_tmp=ftimer()
        DO i=0,p-5
          DO j=0,p-5-i
            DO k=2,p-3-i-j
              q = q + 1
              DO l = 1, ngp
                Basis(l, q) = WedgeBubblePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l))
                dBasisdx(l, q, 1:3) = dWedgeBubblePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l))  
              END DO
            END DO
          END DO
        END DO
        t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
      END IF
    END DO
    t_end = ftimer()
    
    ! Initialize arrays
    BasisVec = 0
    dBasisdxVec = 0

    t_totvec_n = REAL(0,dp)
    t_totvec_e = REAL(0,dp)
    t_totvec_f = REAL(0,dp)
    t_totvec_b = REAL(0,dp)    
    t_startvec = ftimer()
    DO rep=1,NREP
      ! Block over Gauss points
      DO ll=1,ngp,VECTOR_BLOCK_LENGTH
        nbasisvec = 0
        ndbasisdxvec = 0

        lln = MIN(ll+VECTOR_BLOCK_LENGTH-1,ngp)
        ncl = lln-ll+1
        UBlk(1:ncl)=UWrk(ll:lln)
        VBlk(1:ncl)=VWrk(ll:lln)
        WBlk(1:ncl)=WWrk(ll:lln)
        
        nbasisvec = 0
        ndbasisdxvec = 0
        t_start_tmp=ftimer()
        CALL H1Basis_WedgeNodalP(ncl, UBlk, VBlk, WBlk, SIZE(BasisBlk,2), BasisBlk, nbasisvec)
        CALL H1Basis_dWedgeNodalP(ncl, UBlk, VBlk, WBlk, SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
        t_totvec_n=t_totvec_n+(ftimer()-t_start_tmp)
        IF (P > 1) THEN
          t_start_tmp=ftimer()
          DO perm=1,EdgePerm
            CALL H1Basis_WedgeEdgeP(ncl, UBlk, VBlk, WBlk, EdgeP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, EdgeDir(:,:,perm))
            CALL H1Basis_dWedgeEdgeP(ncl, UBlk, VBlk, WBlk, EdgeP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, EdgeDir(:,:,perm))
          END DO
          t_totvec_e=t_totvec_e+(ftimer()-t_start_tmp)    
        END IF
        IF (P > 2) THEN
          t_start_tmp=ftimer()
          DO perm=1,FacePerm
            CALL H1Basis_WedgeFaceP(ncl, UBlk, VBlk, WBlk, FaceP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, FaceDir(:,:,perm))
            CALL H1Basis_dWedgeFaceP(ncl, UBlk, VBlk, WBlk, FaceP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, FaceDir(:,:,perm))
          END DO
          t_totvec_f=t_totvec_f+(ftimer()-t_start_tmp)    
        END IF
        IF (P > 4) THEN
          t_start_tmp=ftimer()
          CALL H1Basis_WedgeBubbleP(ncl, UBlk, VBlk, WBlk, P, &
                  SIZE(BasisBlk,2), BasisBlk, nbasisvec)
          CALL H1Basis_dWedgeBubbleP(ncl, UBlk, VBlk, WBlk, P, &
                  SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
          t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
        END IF

        BasisVec(ll:lln,1:nbasisvec)=BasisBlk(1:ncl,1:nbasisvec)
        dBasisdxVec(ll:lln,1:ndbasisdxvec,1:3)=dBasisdxBlk(1:ncl,1:ndbasisdxvec,1:3)        
      END DO
    END DO
    t_endvec = ftimer()
    
    CALL PrintTestData(Element, ngp, nrep, 9*nedof+nfdof+nbdof, &
          t_tot_n, t_tot_e+t_tot_f+t_tot_b, t_end-t_start, &
          t_totvec_n, t_totvec_e+t_totvec_f+t_totvec_b, t_endvec-t_startvec)

    nerror = TestBasis(ngp, nbasis, Element % TYPE % DIMENSION, Basis, BasisVec, &
            dBasisdx, dBasisdxVec, tol)

    CALL DeallocatePElement(Element)
    DEALLOCATE(Basis, dBasisdx, BasisVec, dBasisdxVec, UWrk, VWrk, WWrk, UBlk, VBlk, WBlk, &
          BasisBlk, dBasisdxBlk)
  END FUNCTION TestWedgeElement  
  
  FUNCTION TestBrickElement(Solver, tol, P) RESULT(nerror)
    IMPLICIT NONE
    
    TYPE(Solver_t) :: Solver
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER, INTENT(IN) :: P

    TYPE(Element_t), POINTER :: Element
    TYPE( GaussIntegrationPoints_t ) :: GP
    REAL(KIND=dp), ALLOCATABLE :: Basis(:,:), dBasisdx(:,:,:), &
          BasisVec(:,:), dBasisdxVec(:,:,:), UWrk(:), VWrk(:), WWrk(:), &
          UBlk(:), VBlk(:), WBlk(:), BasisBlk(:,:), dBasisdxBlk(:,:,:)

    INTEGER :: i, j, k, l, q, ngp, nerror, nbasis, nndof, nedof, &
            nfdof, nbdof, allocstat, perm, &
            nbasisvec, ndbasisdxvec, rep, dim, tag, ndof, ll, lln, ncl
    INTEGER, PARAMETER :: NREP = 100, EdgePerm=2, FacePerm=4
    REAL(kind=dp) :: t_start, t_end, t_startvec, t_endvec, &
            t_start_tmp, t_tot_n, t_totvec_n, &
            t_tot_e, t_totvec_e, t_tot_f, t_totvec_f, t_tot_b, t_totvec_b
    INTEGER :: EdgeDir(H1Basis_MaxPElementEdgeNodes,&
                       H1Basis_MaxPElementEdges,&
                       EdgePerm), EdgeP(H1Basis_MaxPElementEdges), &
               FaceDir(H1Basis_MaxPElementFaceNodes, &
                       H1Basis_MaxPElementFaces, &
                       FacePerm), FaceP(H1Basis_MaxPElementFaces)
    LOGICAL :: InvertEdge(12, EdgePerm)
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, BasisVec, dBasisdxVec, BasisBlk, dBasisdxBlk
!DIR$ ATTRIBUTES ALIGN:64 :: UWrk, VWrk, WWrk, UBlk, VBlk, WBlk

    nerror = 0
    Element => AllocatePElement(Solver % Mesh, 808, P)
    ! Insert P element definitions to Solver mapping (sets P elements as "active")
    IF (ALLOCATED(Solver % Def_Dofs)) THEN
      tag = Element % Type % ElementCode / 100
      Solver % Def_Dofs(tag,1,6) = P
    END IF

    GP = GaussPoints(Element)
    
    nndof = Element % Type % NumberOfNodes
    nedof = getEdgeDOFs( Element, P )
    nfdof = getFaceDOFs( Element, P )
    nbdof = Element % BDofs
    nbasis = nndof + 12*nedof*EdgePerm + 6*nfdof*FacePerm + nbdof
    ngp = GP % N

    ! Reserve workspace for finite element basis
    ALLOCATE(Basis(ngp,nbasis), dBasisdx(ngp,nbasis,3), &
            BasisVec(ngp,nbasis), dBasisdxVec(ngp,nbasis,3), &
            UWrk(ngp), VWrk(ngp), WWrk(ngp), &
            UBlk(VECTOR_BLOCK_LENGTH), &
            VBlk(VECTOR_BLOCK_LENGTH), &
            WBlk(VECTOR_BLOCK_LENGTH), &
            BasisBlk(VECTOR_BLOCK_LENGTH,nbasis), &
            dBasisdxBlk(VECTOR_BLOCK_LENGTH,nbasis,3), &
            STAT=allocstat)
    IF (allocstat /= 0) THEN
      CALL Fatal('H1BasisEvaluation',&
              'Storage allocation for local element basis failed')
    END IF
    
    ! Copy Gauss points to local arrays
    UWrk(1:ngp) = GP % U(1:ngp)
    VWrk(1:ngp) = GP % V(1:ngp)
    WWrk(1:ngp) = GP % W(1:ngp)

    ! Initialize arrays
    Basis = 0
    dBasisdx = 0
    DO i=1,12
      EdgeDir(1:2,i,1)=getBrickEdgeMap(i)
    END DO
    ! Invert direction
    DO i=1,12
      EdgeDir(2:1:-1,i,2)=EdgeDir(1:2,i,1)
    END DO
    InvertEdge(:,1) = .FALSE.
    InvertEdge(:,2) = .TRUE.

    DO i=1,6
      FaceDir(1:4,i,1)=getBrickFaceMap(i)
    END DO
    DO j=2,FacePerm
      DO i=1,6
        FaceDir(1:4,i,j)=CSHIFT(FaceDir(1:4,i,1), j-1)
      END DO
    END DO

    EdgeP = P
    FaceP = P

    t_tot_n = REAL(0,dp)
    t_tot_e = REAL(0,dp)
    t_tot_f = REAL(0,dp)
    t_tot_b = REAL(0,dp)
    t_start = ftimer()
    DO rep=1,NREP
      ! Nodal basis 
      t_start_tmp=ftimer()
      DO i=1,ngp
        CALL NodalBasisFunctions3D( Basis(i,1:nndof), Element, &
                UWrk(i), VWrk(i), WWrk(i))
        CALL NodalFirstDerivatives3D( dBasisdx(i,1:nndof,1:3), Element, &
                UWrk(i), VWrk(i), WWrk(i))
      END DO
      t_tot_n=t_tot_n+(ftimer()-t_start_tmp)

      ! Edge basis
      IF (P > 1) THEN
        t_start_tmp=ftimer()
        q = 8
        DO perm=1,EdgePerm
          DO i=1,12
            DO ndof=1,nedof
              q=q+1
              DO k=1,ngp
                Basis(k,q) = BrickEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), WWrk(k), &
                        InvertEdge(i,perm))
                dBasisdx(k,q,1:3) = dBrickEdgePBasis(i, ndof+1, UWrk(k), VWrk(k), WWrk(k), &
                        InvertEdge(i,perm))
              END DO
            END DO
          END DO
        END DO
        t_tot_e=t_tot_e+(ftimer()-t_start_tmp)
      END IF

      IF (P > 3) THEN
        ! Face basis
        t_start_tmp=ftimer()
        DO perm=1,FacePerm
          DO i=1,6
            DO j=2,FaceP(i)-2
              DO k=2,FaceP(i)-j
                q = q + 1
                DO l=1,ngp
                  Basis(l,q) = BrickFacePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l), &
                          FaceDir(1:4,i,perm))
                  dBasisdx(l,q,1:3) = dBrickFacePBasis(i,j,k,UWrk(l), VWrk(l), WWrk(l), &
                          FaceDir(1:4,i,perm))
                END DO
              END DO
            END DO
          END DO
        END DO
        t_tot_f=t_tot_f+(ftimer()-t_start_tmp)
      END IF

      ! Bubble basis 
      IF (P > 5) THEN
        t_start_tmp=ftimer()
        DO i=2,p-4
          DO j=2,p-i-2
            DO k=2,p-i-j
              q = q + 1
              DO l=1,ngp
                Basis(l,q) = BrickBubblePBasis(i,j,k, &
                        UWrk(l), VWrk(l), WWrk(l))
                dBasisdx(l,q,:) = dBrickBubblePBasis(i,j,k, &
                        UWrk(l), VWrk(l), WWrk(l))
              END DO
            END DO
          END DO
        END DO
        t_tot_b=t_tot_b+(ftimer()-t_start_tmp)
      END IF
    END DO
    t_end = ftimer()
    
    ! Initialize arrays
    BasisVec = 0
    dBasisdxVec = 0

    t_totvec_n = REAL(0,dp)
    t_totvec_e = REAL(0,dp)
    t_totvec_f = REAL(0,dp)
    t_totvec_b = REAL(0,dp)
    t_startvec = ftimer()
    DO rep=1,NREP
      ! Block over Gauss points
      DO ll=1,ngp,VECTOR_BLOCK_LENGTH
        nbasisvec = 0
        ndbasisdxvec = 0

        lln = MIN(ll+VECTOR_BLOCK_LENGTH-1,ngp)
        ncl = lln-ll+1
        UBlk(1:ncl)=UWrk(ll:lln)
        VBlk(1:ncl)=VWrk(ll:lln)
        WBlk(1:ncl)=WWrk(ll:lln)
        
        t_start_tmp=ftimer()
        CALL H1Basis_BrickNodal(ncl, UBlk, VBlk, WBlk, SIZE(BasisBlk,2), BasisBlk, nbasisvec)
        CALL H1Basis_dBrickNodal(ncl, UBlk, VBlk, WBlk, SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
        t_totvec_n=t_totvec_n+(ftimer()-t_start_tmp)

        IF (P > 1) THEN
          t_start_tmp=ftimer()
          DO perm=1,EdgePerm
            CALL H1Basis_BrickEdgeP(ncl, UBlk, VBlk, WBlk, EdgeP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, EdgeDir(:,:,perm))
            CALL H1Basis_dBrickEdgeP(ncl, UBlk, VBlk, WBlk, EdgeP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, EdgeDir(:,:,perm))
          END DO
          t_totvec_e=t_totvec_e+(ftimer()-t_start_tmp)
        END IF

        IF (P > 3) THEN
          t_start_tmp=ftimer()
          DO perm=1,FacePerm
            CALL H1Basis_BrickFaceP(ncl, UBlk, VBlk, WBlk, FaceP, &
                    SIZE(BasisBlk,2), BasisBlk, nbasisvec, FaceDir(:,:,perm))
            CALL H1Basis_dBrickFaceP(ncl, UBlk, VBlk, WBlk, FaceP, &
                    SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec, FaceDir(:,:,perm))
          END DO
          t_totvec_f=t_totvec_f+(ftimer()-t_start_tmp)
        END IF

        IF (P > 5) THEN
          t_start_tmp=ftimer()
          CALL H1Basis_BrickBubbleP(ncl, UBlk, VBlk, WBlk, P, &
                  SIZE(BasisBlk,2), BasisBlk, nbasisvec)
          CALL H1Basis_dBrickBubbleP(ncl, UBlk, VBlk, WBlk, P, &
                  SIZE(dBasisdxBlk,2), dBasisdxBlk, ndbasisdxvec)
          t_totvec_b=t_totvec_b+(ftimer()-t_start_tmp)
        END IF

        BasisVec(ll:lln,1:nbasisvec)=BasisBlk(1:ncl,1:nbasisvec)
        dBasisdxVec(ll:lln,1:ndbasisdxvec,1:3)=dBasisdxBlk(1:ncl,1:ndbasisdxvec,1:3)
      END DO
    END DO
    t_endvec = ftimer()

    CALL PrintTestData(Element, ngp, nrep, 12*nedof+6*nfdof+nbdof, &
            t_tot_n, t_tot_e+t_tot_f+t_tot_b, t_end-t_start, &
            t_totvec_n, t_totvec_e+t_totvec_f+t_totvec_b, t_endvec-t_startvec)

    nerror = TestBasis(ngp, nbasis, Element % TYPE % DIMENSION, Basis, BasisVec, &
            dBasisdx, dBasisdxVec, tol)

    CALL DeallocatePElement(Element)
    DEALLOCATE(Basis, dBasisdx, BasisVec, dBasisdxVec, UWrk, VWrk, WWrk, UBlk, VBlk, WBlk, &
          BasisBlk, dBasisdxBlk)
  END FUNCTION TestBrickElement

  FUNCTION TestBasis(ngp, nbasis, ndim, Basis1, Basis2, dBasisdx1, dBasisdx2, tol) RESULT(nerror)
    IMPLICIT NONE

    INTEGER, INTENT(IN) :: ngp, nbasis, ndim
    REAL(KIND=dp) CONTIG, INTENT(IN) :: Basis1(:,:), Basis2(:,:), &
            dBasisdx1(:,:,:), dBasisdx2(:,:,:)
    REAL(kind=dp), INTENT(IN) :: tol
    INTEGER :: nerror

    INTEGER :: i, j, dim

    WRITE (*,'(A)') 'TestBasis: Testing basis functions versus reference implementation.'
    WRITE (*,'(3(A,I0))') 'TestBasis: ngp=', ngp, ', nbasis=', nbasis, &
            ', ndim=', ndim

    nerror = 0
    ! Test basis
    DO j=1,nbasis
      DO i=1,ngp
        IF (ABS(Basis1(i,j)-Basis2(i,j)) >= tol) THEN
          nerror = nerror + 1
          WRITE (*,*) 'Basis:', i,j,Basis1(i,j), Basis2(i,j)
        END IF
      END DO
    END DO
    ! Test derivatives
    DO dim=1, ndim
      DO j=1,nbasis
        DO i=1,ngp
          IF (ABS(dBasisdx1(i,j,dim)-dBasisdx2(i,j,dim)) >= tol) THEN
            nerror = nerror + 1
            WRITE (*,*) 'dBasisdx:', i,j,dim, dBasisdx1(i,j,dim), dBasisdx2(i,j,dim)
          END IF
        END DO
      END DO
    END DO

    IF (nerror == 0) THEN
      WRITE (*,'(A,ES12.3)') 'TestBasis: Passed without errors, tol=', tol
    ELSE
      WRITE (*,'(A,ES12.3)') 'TestBasis: Failed with errors, tol=', tol
    END IF
  END FUNCTION TestBasis

  SUBROUTINE PrintTestData(Element, ngp, nrep, nndofs, t_n1, t_b1, t_tot1, &
          t_n2, t_b2, t_tot2)
  
    IMPLICIT NONE
    TYPE(Element_t) :: Element
    INTEGER, INTENT(IN) :: ngp, nrep, nndofs
    REAL(kind=dp), INTENT(IN) :: t_n1, t_b1, t_tot1, t_n2, t_b2, t_tot2

    WRITE (*,'(A,I0)') 'Element type=', Element % TYPE % ElementCode
    IF (ASSOCIATED(Element % PDefs)) THEN
      WRITE (*,'(A,I0)') 'Element polynomial degree=', Element % PDefs % P
    END IF
    WRITE (*,'(A,I0)') 'Element number of nodes=', Element % TYPE % NumberOfNodes
    WRITE (*,'(A,I0)') 'Element number of nonnodal dofs=', nndofs
    WRITE (*,'(A,I0)') 'Element number of bubble dofs=', GetElementNOFBDOFs()
    WRITE (*,'(A,I0)') 'Number of Gauss points=', ngp
    WRITE (*,'(A,I0)') 'Number of repetitions=', nrep
    WRITE (*,'(A,3F12.9)') 'Nodal  basis, nodal/bubble/total t(s):', t_n1, &
            t_b1, t_tot1
    WRITE (*,'(A,3F12.9)') 'Vector basis, nodal/bubble/total t(s):', t_n2, &
            t_b2, t_tot2

  END SUBROUTINE PrintTestData
  
  FUNCTION AllocatePElement(Mesh, ElementCode, P) RESULT(PElement)
    IMPLICIT NONE
    
    TYPE(Mesh_t) :: Mesh
    INTEGER, INTENT(IN) :: ElementCode, P
    TYPE(Element_t), POINTER :: PElement


    ! Construct P element
    PElement => AllocateElement()
    PElement % Type => GetElementType( ElementCode )
    CALL AllocatePDefinitions(PElement)

    PElement % BDofs = GetBubbleDofs( PElement, P )
    PElement % PDefs % P = P
    PElement % PDefs % GaussPoints = (P+1) ** PElement % Type % DIMENSION
  END FUNCTION AllocatePElement

  SUBROUTINE DeallocatePElement(PElement)
    IMPLICIT NONE
    
    TYPE(Element_t), POINTER :: PElement

    DEALLOCATE(PElement % PDefs)
    DEALLOCATE(PElement)
  END SUBROUTINE DeallocatePElement

  ! Portable wall-clock timer
  FUNCTION ftimer() RESULT(timerval)
    IMPLICIT NONE
    
    REAL(KIND=dp) :: timerval
    INTEGER(KIND=8) :: t, rate
    
#ifdef _OPENMP
    timerval = OMP_GET_WTIME()
#else
    CALL SYSTEM_CLOCK(t,count_rate=rate)
    timerval = REAL(t,dp)/rate
#endif
  END FUNCTION ftimer

!------------------------------------------------------------------------------
END SUBROUTINE H1BasisEvaluation
!------------------------------------------------------------------------------

SUBROUTINE MeshColour_init( Model,Solver,dt,TransientSimulation )
    USE DefUtils
    IMPLICIT NONE
!------------------------------------------------------------------------------
    TYPE(Model_t) :: Model
    TYPE(Solver_t) :: Solver
    REAL(KIND=dp) :: dt
    LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
    TYPE(ValueList_t), POINTER :: Params
    INTEGER :: NormInd
    LOGICAL :: Found

    Params => GetSolverParams()

    NormInd = ListGetInteger( Params,'Norm Variable Index',Found)
    IF( NormInd > 0 ) THEN
      IF( .NOT. ListCheckPresent( Params,'Variable') ) THEN
        CALL ListAddString( Solver % Values,'Variable',&
                '-nooutput -global meshcolour_var')
      END IF
    END IF
    
END SUBROUTINE MeshColour_init

SUBROUTINE MeshColour( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
!  Test multithreaded mesh colouring routines in Elmer
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
    USE DefUtils
    USE ISO_C_BINDING
    !------------------------------------------------------------------------------
    IMPLICIT NONE
    !------------------------------------------------------------------------------
    TYPE(Model_t) :: Model
    TYPE(Solver_t) :: Solver

    REAL(KIND=dp) :: dt
    LOGICAL :: TransientSimulation

    !------------------------------------------------------------------------------
    ! Local variables
    !------------------------------------------------------------------------------
    TYPE(Element_t), POINTER :: Element
    TYPE(Mesh_t), POINTER :: Mesh

    TYPE(Graph_t) :: DualGraph 
    TYPE(GraphColour_t) :: GraphColouring
    TYPE(Graph_t) :: ColourIndexList

#ifdef HAVE_METIS
    TYPE(VertexMap_t), TARGET :: DualGraphVM
#endif
    REAL(kind=dp) :: t_start, t_end

    INTEGER :: nerror, nerror_metis, nerror_colour, nerror_clist

    nerror = 0
    Mesh => GetMesh()

    ! Create dual mesh
    t_start = ftimer()
    CALL ElmerMeshToDualGraph(Mesh, DualGraph)
    t_end = ftimer()
    WRITE (*,'(A,ES12.3,A)') 'Dual graph creation total: ', t_end - t_start, ' sec.'

    ! Verify dual mesh with Metis (for completeness, 
    ! not compiled in by default)
#ifdef HAVE_METIS
    t_start = ftimer()
    CALL VertexMapFromArray(DualGraphVM, DualGraph % n, &
            DualGraph % ptr, DualGraph % ind)
    WRITE (*,'(A,ES12.3,A)') 'Vertex map creation from array total: ', t_end - t_start, ' sec.'
    CALL MeshToDualMetisVerify(Mesh, DualGraphVM, nerror_metis)
    nerror = nerror + nerror_metis
    CALL VertexMapDeleteAll(DualGraphVM)
#endif 

    ! Colour mesh
    t_start = ftimer()
    CALL ElmerGraphColour(DualGraph, GraphColouring)
    t_end = ftimer()
    WRITE (*,'(A,ES12.3,A)') 'Graph colouring total: ', t_end - t_start, ' sec.'
    WRITE (*,'(A,I0)') 'Number of colours created ngc=', GraphColouring % nc
    CALL GraphColourVerify(DualGraph % n, DualGraph % ptr, & 
            DualGraph % ind, GraphColouring % nc, GraphColouring % colours, &
            nerror_colour)
    nerror = nerror + nerror_colour
    CALL Graph_Deallocate(DualGraph)

    t_start = ftimer()
    CALL ElmerColouringToGraph(GraphColouring, ColourIndexList)
    t_end = ftimer()
    WRITE (*,'(A,ES12.3,A)') 'Colour gather total: ', t_end-t_start, ' sec.'
    CALL GraphColourListVerify(GraphColouring % nc, GraphColouring % colours, &
            ColourIndexList % ptr, ColourIndexList % ind, nerror_clist)
    nerror = nerror + nerror_clist
    CALL Colouring_Deallocate(GraphColouring)
    CALL Graph_Deallocate(ColourIndexList)

    ! Build solution norm for error checking
    Solver % Variable % Norm = REAL(1+nerror,dp)
    Solver % Variable % Values = REAL(1+nerror,dp)
    
CONTAINS

  ! Portable wall-clock timer
  FUNCTION ftimer() RESULT(timerval)
    IMPLICIT NONE
    
    REAL(KIND=dp) :: timerval
    INTEGER(KIND=8) :: t, rate
    
#ifdef _OPENMP
    timerval = OMP_GET_WTIME()
#else
    CALL SYSTEM_CLOCK(t,count_rate=rate)
    timerval = REAL(t,dp)/rate
#endif
  END FUNCTION ftimer

#ifdef HAVE_METIS
    SUBROUTINE MeshToDualMetisVerify(Mesh, DualGraph, err)
        IMPLICIT NONE
        TYPE(Mesh_t) :: Mesh
        TYPE(VertexMap_t), TARGET :: DualGraph
        INTEGER :: err

        !------------------------------------------------------------------------------
        ! Metis MeshToDual interface
        !------------------------------------------------------------------------------
        INTERFACE
            ! Assume 32-bit version of Metis, i.e., idx_t = int32_t
            ! int METIS_MeshToDual(idx_t *ne, idx_t *nn, idx_t *eptr, idx_t *eind, 
            !                      idx_t *ncommon, idx_t *numflag,  idx_t **r_xadj, idx_t **r_adjncy)
            FUNCTION METIS_MeshToDual(ne, nn, eptr, eind, ncommon, numflag,  r_xadj, r_adjncy) RESULT(val) & 
                    BIND(C,name='METIS_MeshToDual') 
                USE ISO_C_BINDING
                IMPLICIT NONE
                INTEGER(KIND=c_int32_t) :: ne, nn           ! idx_t *ne, idx_t *nn
                INTEGER(KIND=c_int32_t) :: eptr(*), eind(*) ! idx_t *eptr, idx_t *eind 
                INTEGER(KIND=c_int32_t) :: ncommon, numflag ! idx_t *ncommon, idx_t *numflag
                TYPE(C_PTR) :: r_xadj, r_adjncy             ! idx_t **r_xadj, idx_t **r_adjncy
                ! INTEGER(KIND=c_int32_t) :: r_xadj(*), r_adjncy(*)       ! idx_t **r_xadj, idx_t **r_adjncy
                INTEGER(KIND=C_INT) :: val
            END FUNCTION METIS_MeshToDual

            ! METIS_API(int) METIS_Free(void *ptr);
            FUNCTION METIS_Free(ptr) RESULT(val) BIND(C,name='METIS_Free') 
                USE ISO_C_BINDING
                IMPLICIT NONE
                TYPE(C_PTR), VALUE :: ptr                          ! void *ptr
                INTEGER(KIND=C_INT) :: val
            END FUNCTION METIS_Free
        END INTERFACE

        INTEGER :: i, j, allocstat, nl, nli, nti
        INTEGER(KIND=C_INT) :: retval
        INTEGER(KIND=c_int32_t) :: ne, nn, ncommon, numflag
        INTEGER(KIND=c_int32_t), POINTER CONTIG :: eptr(:), eind(:), dualptr(:), dualind(:)
        TYPE(C_PTR) :: r_xadj, r_adjncy
        ! INTEGER(KIND=c_int32_t), POINTER CONTIG :: r_xadj(:), r_adjncy(:)
        ! TYPE(IntegerList_t), POINTER :: elist
        LOGICAL :: graphOk
        TYPE(Element_t), POINTER :: Element, Elements(:)
        TYPE(IntegerList_t), POINTER :: vlist
        INTEGER, POINTER :: varr(:)
        INTEGER :: vsize
        REAL(kind=dp) :: t_start, t_end

        err = 0
        Elements => Mesh % Elements

        ! Set up parameters
        ne = Mesh % NumberOfBulkElements
        nn = Mesh % NumberOfNodes
        ncommon = 1 ! Dual graph will have an edge if elements share a node
        ! numflag = 1 ! Fortran-style numbering
        numflag = 0 ! C-style numbering

        t_start = ftimer()
        ! Copy mesh to CSR structure
        ALLOCATE(eptr(ne+1), eind(ne*Mesh % MaxElementNodes))
        eptr(1)=1 ! Fortran numbering
        DO i=1, ne
            Element => Elements(i)
            nl = Element % TYPE % NumberOfNodes
            nli = eptr(i) ! Fortran numbering
            nti = nli+nl-1
            eind(nli:nti) = Element % NodeIndexes(1:nl) ! Fortran numbering
            eptr(i+1) = nli+nl
        END DO

        ! Convert eptr and eind to C numbering
        DO i=1,eptr(ne+1)-1
            eind(i)=eind(i)-1
        END DO
        DO i=1,ne+1
            eptr(i)=eptr(i)-1
        END DO
        t_end = ftimer()
        WRITE (*,'(A,ES12.3,A)') 'Mesh transformation, Metis: ', t_end - t_start, ' sec.'

        t_start = ftimer()
        ! METIS call to construct dual graph
        retval = METIS_MeshToDual(ne, nn, eptr, eind, ncommon, numflag, r_xadj, r_adjncy)
        t_end = ftimer()
        WRITE (*,'(A,ES12.3,A)') 'Dual graph creation, Metis: ', t_end - t_start, ' sec.'

        ! TODO: Verify the graph against the given dual
        CALL C_F_POINTER(r_xadj, dualptr, (/ ne+1 /))
        ! Convert dualptr to Fortran numbering
        DO i=1,ne+1
            dualptr(i)=dualptr(i)+1
        END DO

        CALL C_F_POINTER(r_adjncy, dualind, (/ dualptr(ne+1)-1 /))      
        ! Convert dualind to Fortran numbering
        DO i=1,dualptr(ne+1)-1
            dualind(i)=dualind(i)+1
        END DO

        ! Verify graph structure
        graphOk = .TRUE.
        DO i=1,ne
            nl = dualptr(i+1)-dualptr(i)

            vlist => VertexMapGetList(DualGraph,i)
            vsize = IntegerListGetSize(vlist)
            varr => IntegerListGetArray(vlist)

            IF (IntegerListGetSize(VertexMapGetList(DualGraph, i)) == nl) THEN
                DO j=dualptr(i),dualptr(i+1)-1
                    IF (.NOT. VertexMapFind(DualGraph, i, dualind(j))) THEN
                        WRITE (*,*) 'ERROR: Could not find node=', i, ', edge=', dualind(j)
                        graphOk = .FALSE.
                        err = err + 1
                    END IF
                END DO
            ELSE
                WRITE (*,*) 'ERROR: Size of local edge list does not match for node=', i
                graphOk = .FALSE.
                err = err + 1
            END IF
        END DO
        IF (graphOk) THEN
            WRITE (*,'(A)') 'Dual graph matches Metis output'
        ELSE
            WRITE (*,*) 'ERROR: Dual graph noes not match Metis output'
        END IF

        ! Free memory allocated by Metis
        retval = Metis_Free(r_xadj)  
        retval = Metis_Free(r_adjncy)

        ! Free memory reserved for mesh
        DEALLOCATE(eptr, eind)

    END SUBROUTINE MeshToDualMetisVerify
#endif

    SUBROUTINE GraphColourVerify(gn, gptr, gind, ngc, gc, err)
        IMPLICIT NONE

        INTEGER, INTENT(IN) :: gn
        INTEGER, INTENT(IN) :: gptr(:), gind(:)
        INTEGER, INTENT(IN) :: ngc
        INTEGER, INTENT(IN) :: gc(:)
        INTEGER :: err

        INTEGER :: c, v, w, vli, vti, vcol, wind, wcol
        REAL(KIND=dp) :: avg, dev
        INTEGER :: ccount(ngc)
        LOGICAL :: colourOk

        err = 0
        ccount = 0
        colourOk = .TRUE.
        ! Verify and count colours (in serial!)
        DO v=1,gn
            vli = gptr(v)
            vti = gptr(v+1)-1
            ! Get colour of v
            vcol = gc(v)

            ! Verify that colour is in range
            IF (vcol<1 .OR. vcol>ngc) THEN
                WRITE (*,'(A,I0,A,I0,A)') 'ERROR: Graph vertex v=', v, &
                        ' colour ', vcol, ' out of range' 
                colourOk = .FALSE.
                err = err + 1
                CYCLE
            ELSE
                ccount(vcol)=ccount(vcol)+1
            END IF

            ! Check colour versus each neighbour
            DO wind=vli,vti
                w = gind(wind)
                wcol = gc(w)
                IF (wcol == vcol) THEN
                    WRITE (*,'(A,I0,A,I0,A,I0)') 'ERROR: Neighbouring vertices (v,w)=(', v,',', w, &
                            ') of the same colour col=', vcol
                    colourOk = .FALSE.
                    err = err + 1
                END IF
            END DO
        END DO

        ! Compute average
        avg = REAL(SUM(ccount),dp)/ngc

        WRITE (*,'(A,I0,/,A,I0,/,A,ES12.3)') 'Number of vertices, n=', gn, &
                'Number of coloured vertices, nc=', SUM(ccount), &
                'Average vertices per colour avg=', avg
        ! Print out statistics
        DO c=1,ngc
            dev = ABS(avg-ccount(c))
            WRITE (*,'(A,I0,A,I0,A,ES12.3)') 'Colour c=', c, ', count=', ccount(c), ', average dev=', dev
        END DO
        IF (colourOk) THEN
            WRITE (*,'(A)') 'Colouring seems ok.'
        ELSE
            WRITE (*,'(A)') 'ERROR: Colouring seems inconsistent!'
        END IF
    END SUBROUTINE GraphColourVerify

    SUBROUTINE GraphColourListVerify(ngc, gc, cptr, cind, err)
        IMPLICIT NONE
        INTEGER, INTENT(IN) :: ngc
        INTEGER, INTENT(IN) :: gc(:)
        INTEGER, INTENT(IN) :: cptr(:), cind(:)
        INTEGER :: err

        INTEGER :: ccount(ngc)
        INTEGER, ALLOCATABLE :: cverify(:)
        INTEGER :: i, j, cli, cti,  n, ncol, totcol
        LOGICAL :: listsOk

        err = 0
        listsOk = .TRUE.

        n=size(gc)
        ! Count colours
        ccount = 0
        DO i=1,n
            ccount(gc(i))=ccount(gc(i))+1
        END DO

        ! Verify list pointers
        IF (SIZE(cptr) /= ngc+1 .OR. SIZE(cind) /= n) THEN
            WRITE (*,*) 'ERROR: Colour list pointer size does not', &
                    ' match the number of colours'
            err = err + 1
            RETURN
        END IF
        totcol = 0
        DO i=1,ngc
            ncol = cptr(i+1)-cptr(i)
            IF (ncol /= ccount(i)) THEN
                WRITE (*,'(3(A,I0))') 'ERROR: Colour=', i, ': pointer=', ncol,', count=', ccount(i)
                listsOk = .FALSE.
                err = err + 1
            END IF
        END DO
        ! Further verification of no use since pointers to lists are incorrect
        IF (.NOT. listsOk) RETURN

        IF (SUM(ccount) /= n) THEN
            WRITE (*,*) 'ERROR: Not enough colours in lists to cover the graph'
            listsOk = .FALSE.
        END IF

        ! Verify colours themselves
        ALLOCATE(cverify(n))

        cverify=0
        DO i=1,ngc
            cli = cptr(i)
            cti = cptr(i+1)-1
            DO j=cli,cti
                cverify(cind(j))=cverify(cind(j))+1
            END DO
        END DO
        DO i=1,n
            IF (cverify(i) > 1 .OR. cverify(i) < 1) THEN
                WRITE (*,'(2(A,I0))') 'ERROR: Vertex=', i, ', colour count=', cverify(i)
                listsOk = .FALSE.
                err = err + 1
            END IF
        END DO

        DEALLOCATE(cverify)

        IF (listsOk) THEN
            WRITE (*,'(A)') 'Colour lists seem ok.'
        ELSE
            WRITE (*,'(A)') 'ERROR: Colour lists seem inconsistent!'
        END IF
    END SUBROUTINE GraphColourListVerify

!------------------------------------------------------------------------------
END SUBROUTINE MeshColour
!------------------------------------------------------------------------------

SUBROUTINE StokesSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
!******************************************************************************
!
! A Navier-Stokes solver with p-bubbles and/or p2/p1 elements
!
! feasible elements (these are just examples):
! -------------------------------------------
! 303b1    - triangle with one bubble
! 303e1b1  - p2/p1 triangle
!
! 404b4    - quad with four bubbles
! 404e1b1  - q2/q1 quad
!
!  etc....
!
!  Even for the unequal order elements, the matrix is assembled for
!  pn/pn dofs, EliminateDirichlet may be used to get rid of the
!  unused dofs. 
!
!  12/12/2003, Juha
!
!  ARGUMENTS:
!
!  TYPE(Model_t) :: Model,  
!     INPUT: All model information (mesh, materials, BCs, etc...)
!
!  TYPE(Solver_t) :: Solver
!     INPUT: Linear & nonlinear equation solver options
!
!  REAL(KIND=dp) :: dt,
!     INPUT: Timestep size for time dependent simulations
!
!  LOGICAL :: TransientSimulation
!     INPUT: Steady state or transient simulation
!
!******************************************************************************
  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  LOGICAL :: AllocationsDone = .FALSE., Newton = .FALSE., Found, Convect
  TYPE(Element_t),POINTER :: Element

  INTEGER :: i,j,k,n, nb, nd, t, istat, dim, BDOFs=1,Active
  REAL(KIND=dp) :: Norm = 0, PrevNorm, RelC

  TYPE(ValueList_t), POINTER :: BodyForce, Material
  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp), ALLOCATABLE :: STIFF(:,:), LOAD(:,:), &
        FORCE(:), rho(:), mu(:), Velocity(:,:), MASS(:,:)

  SAVE STIFF, MASS, LOAD, FORCE, rho, mu, Velocity, AllocationsDone
!------------------------------------------------------------------------------

   dim = CoordinateSystemDimension()
   Mesh => GetMesh()

  !Allocate some permanent storage, this is done first time only:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
     n = (dim+1)*(Mesh % MaxElementDOFs+BDOFs)  ! just big enough for elemental arrays
     ALLOCATE( FORCE(n), LOAD(n,4), STIFF(n,n), MASS(n,n), &
         rho(n), mu(n), Velocity(dim+1,n), STAT=istat )

     IF ( istat /= 0 ) THEN
        CALL Fatal( 'StokesSolve', 'Memory allocation error.' )
     END IF
     AllocationsDone = .TRUE.
  END IF

  Convect = GetLogical( GetSolverParams(), 'Convect', Found )
  IF ( .NOT. Found ) Convect = .TRUE.

  Velocity = 0.0d0

  !Initialize the system and do the assembly:
  !------------------------------------------
  Active = GetNOFActive()
  CALL DefaultInitialize()
  DO t=1,Active
     Element => GetActiveElement(t)
     n  = GetElementNOFNodes()
     nd = GetElementNOFDOFs()
     nb = GetElementNOFBDOFs()

     ! Volume forces:
     !---------------
     BodyForce => GetBodyForce()
     LOAD = 0.0d0
     IF ( ASSOCIATED(BodyForce) ) THEN
        Load(1:n,1) = GetReal( BodyForce, 'Source x', Found )
        Load(1:n,2) = GetReal( BodyForce, 'Source y', Found )
        Load(1:n,3) = GetReal( BodyForce, 'Source z', Found )
     END IF

     ! Material parameters:
     !---------------------
     Material => GetMaterial()
     rho(1:n) = GetReal( Material, 'Density' )
     mu(1:n)  = GetReal( Material, 'Viscosity' )

     ! Get previous elementwise velocity iterate:
     !-------------------------------------------
     IF ( Convect ) CALL GetVectorLocalSolution( Velocity )

     ! Get element local matrix and rhs vector:
     !-----------------------------------------
     CALL LocalMatrix(  MASS, STIFF, FORCE, LOAD, rho, mu, &
         Velocity, Element, n, nd, nd+nb, dim )
     IF ( nb>0 ) CALL LCondensate( nd, nb, dim, STIFF, FORCE )

     IF ( TransientSimulation ) THEN
       CALL Default1stOrderTime( MASS, STIFF, FORCE )
     END IF

     ! Update global matrix and rhs vector from local matrix & vector:
     !----------------------------------------------------------------
     CALL DefaultUpdateEquations( STIFF, FORCE )
  END DO
  
  CALL DefaultFinishAssembly()
  CALL DefaultDirichletBCs()

  PrevNorm = Norm
  Norm = DefaultSolve()
  RELC = 2.0d0 * ABS(PrevNorm - Norm) / (PrevNorm + Norm)
  IF ( RELC < 1.0d-2 ) Newton = .TRUE.

CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  MASS, STIFF, FORCE, LOAD, Nodalrho, &
     Nodalmu, NodalVelo, Element, n, nd, ntot, dim )
!------------------------------------------------------------------------------
    REAL(KIND=dp), TARGET :: MASS(:,:), STIFF(:,:), FORCE(:), LOAD(:,:)
    REAL(KIND=dp) :: Nodalmu(:), Nodalrho(:), NodalVelo(:,:)
    INTEGER :: dim, n, nd, ntot
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    REAL(KIND=dp) :: Basis(ntot),dBasisdx(ntot,3), &
               DetJ,LoadAtIP(dim+1),Velo(dim), Grad(dim,dim)
    REAL(KIND=dp), POINTER :: A(:,:), F(:),M(:,:)
    LOGICAL :: Stat
    INTEGER :: t, i, j, k, l, p, q
    TYPE(GaussIntegrationPoints_t) :: IP

    REAL(KIND=dp) :: mu = 1.0d0, rho = 1.0d0, s, c

    TYPE(Nodes_t) :: Nodes
    SAVE Nodes
!------------------------------------------------------------------------------
    CALL GetElementNodes( Nodes )
    STIFF = 0.0d0
    MASS  = 0.0d0
    FORCE = 0.0d0

    ! Numerical integration:
    !-----------------------
    IP = GaussPoints( Element,ntot )
    DO t=1,IP % n
       ! Basis function values & derivatives at the integration point:
       !--------------------------------------------------------------
       stat = ElementInfo( Element, Nodes, IP % U(t), IP % V(t), &
         IP % W(t),  detJ, Basis, dBasisdx )

       s = IP % s(t) * detJ

       ! Material parameters at the integration point:
       !----------------------------------------------
       mu  = SUM( Basis(1:n) * Nodalmu(1:n) )
       rho = SUM( Basis(1:n) * Nodalrho(1:n) )

       ! Previous velocity at the integration point:
       !--------------------------------------------
       Velo = MATMUL( NodalVelo(1:dim,1:nd), Basis(1:nd) )
       Grad = MATMUL( NodalVelo(1:dim,1:nd), dBasisdx(1:nd,1:dim) )

       ! The source term at the integration point:
       !------------------------------------------
       LoadAtIP(1:dim+1) = MATMUL( Basis(1:n), LOAD(1:n,1:dim+1) )
       IF ( Convect .AND. Newton ) THEN
         LoadAtIp(1:dim) = LoadAtIp(1:dim) + rho * MATMUL(Grad,Velo)
       END IF

       ! Finally, the elemental matrix & vector:
       !----------------------------------------
       DO p=1,ntot
         DO q=1,ntot
           i = (dim+1) * (p-1) + 1
           j = (dim+1) * (q-1) + 1
           A => STIFF(i:i+dim,j:j+dim)
           M => MASS(i:i+dim,j:j+dim)
           DO i=1,dim
             M(i,i) = M(i,i) + s * rho * Basis(q) * Basis(p)
             DO j = 1,dim
               A(i,i) = A(i,i) + s * mu * dBasisdx(q,j) * dBasisdx(p,j)
               A(i,j) = A(i,j) + s * mu * dBasisdx(q,i) * dBasisdx(p,j)
               IF ( Convect ) THEN
                 A(i,i) = A(i,i) + s * rho * Velo(j) * dBasisdx(q,j) * Basis(p)
                 IF ( Newton ) THEN
                    A(i,j) = A(i,j) + s * rho * Grad(i,j) * Basis(q) * Basis(p)
                 END IF
               END IF
             END DO
             A(i,dim+1) = A(i,dim+1) - s * Basis(q) * dBasisdx(p,i)
             A(dim+1,i) = A(dim+1,i) + s * rho * dBasisdx(q,i) * Basis(p)
           END DO
         END DO
         i = (dim+1) * (p-1) + 1
         F => FORCE(i:i+dim)
         F = F + s * LoadAtIP * Basis(p) 
       END DO
    END DO

   ! for p2/p1 elements set Dirichlet constraint for unused dofs,
   ! EliminateDirichlet will get rid of these:
   !-------------------------------------------------------------
    DO p = n+1,ntot
      i = (dim+1) * p
      FORCE(i)   = 0.0d0
      MASS(:,i)  = 0.0d0
      MASS(i,:)  = 0.0d0
      STIFF(i,:) = 0.0d0
      STIFF(:,i) = 0.0d0
      STIFF(i,i) = 1.0d0
    END DO
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
    SUBROUTINE LCondensate( N, nb, dim, K, F )
!------------------------------------------------------------------------------
      USE LinearAlgebra
      INTEGER :: N, nb, dim
      REAL(KIND=dp) :: K(:,:),F(:), Kbb(Nb*dim,Nb*dim), &
       Kbl(nb*dim,n*(dim+1)),Klb(n*(dim+1),nb*dim),Fb(nb*dim)

      INTEGER :: m, i, j, l, p, Cdofs((dim+1)*n), Bdofs(dim*nb)

      m = 0
      DO p = 1,n
        DO i = 1,dim+1
          m = m + 1
          Cdofs(m) = (dim+1)*(p-1) + i
        END DO
      END DO
      
      m = 0
      DO p = 1,nb
        DO i = 1,dim
          m = m + 1
          Bdofs(m) = (dim+1)*(p-1) + i + n*(dim+1)
        END DO
      END DO

      Kbb = K(Bdofs,Bdofs)
      Kbl = K(Bdofs,Cdofs)
      Klb = K(Cdofs,Bdofs)
      Fb  = F(Bdofs)

      CALL InvertMatrix( Kbb,Nb*dim )

      F(1:(dim+1)*n) = F(1:(dim+1)*n) - MATMUL( Klb, MATMUL( Kbb, Fb ) )
      K(1:(dim+1)*n,1:(dim+1)*n) = &
           K(1:(dim+1)*n,1:(dim+1)*n) - MATMUL( Klb, MATMUL( Kbb,Kbl ) )
!------------------------------------------------------------------------------
    END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

!------------------------------------------------------------------------------
END SUBROUTINE StokesSolver
!------------------------------------------------------------------------------

FUNCTION InletVelo(Model, n, t) RESULT(v)
  USE DefUtils
  IMPLICIT None
  TYPE(Model_t) :: Model
  INTEGER :: n
  REAL(KIND=dp) :: t, v

  TYPE(Mesh_t), POINTER :: Mesh
  REAL(KIND=dp) :: xq, yq, zq

  Mesh => Model % Mesh

  xq = Mesh % Nodes % x(n)
  yq = Mesh % Nodes % y(n)
  zq = Mesh % Nodes % z(n)

  v = 100.0*(1.0e-4-xq**2-yq**2)

END FUNCTION InletVelo

SUBROUTINE PoissonSolver( Model,Solver,dt,TransientSimulation )
!------------------------------------------------------------------------------
! Solve the Poisson equation with OpenMP threading for assembly and solution
! phases implemented. Original case by Mikko B. 
!
! In this case the colouring calls have been moved to the library.
! Modidified 31.5.2016 / P.R.
!------------------------------------------------------------------------------
  USE Types
  USE DefUtils
  IMPLICIT NONE
  !------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model
  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
  !------------------------------------------------------------------------------
  ! Local variables
  !-----------------------------------------------------------------------------
  TYPE(Element_t),POINTER :: Element
  REAL(KIND=dp) :: Norm
  INTEGER :: nnz, n, nb, nd, t, istat, active
  LOGICAL :: Found
  TYPE(Mesh_t), POINTER :: Mesh
  TYPE(ValueList_t), POINTER :: BodyForce
  REAL(KIND=dp), ALLOCATABLE, SAVE :: STIFF(:,:), LOAD(:), FORCE(:)
  INTEGER, POINTER :: Indexes(:)
  INTEGER :: nind, ii, jj
  INTEGER, SAVE :: maxdofs
  LOGICAL, SAVE :: AllocationsDone = .FALSE.
  !$OMP THREADPRIVATE(STIFF, LOAD, FORCE, AllocationsDone, maxdofs)
  INTEGER :: nactive,col,nColours

  LOGICAL :: VecAsm, MCAsm

  REAL(kind=dp), POINTER :: LoadPtr(:)
  !------------------------------------------------------------------------------

  Mesh => GetMesh()

  !System assembly:
  !----------------
  CALL DefaultInitialize()

  VecAsm = .TRUE.
  CALL ResetTimer('ThreadedAssembly')

  !$OMP PARALLEL DEFAULT(NONE) &
  !$OMP SHARED(Solver, Mesh, nColours, nActive, VecAsm) &
  !$OMP PRIVATE(BodyForce, Element, col, n, nd, nb, t, istat, Found, Norm, &
  !$OMP         Indexes, nind, LoadPtr)

  !Allocate some permanent storage per thread:
  !--------------------------------------------------------------
  IF ( .NOT. AllocationsDone ) THEN
    n = Mesh % MaxElementDOFs  ! just big enough for elemental arrays
    maxdofs = n
    ALLOCATE( FORCE(N), LOAD(N), STIFF(N,N), STAT=istat )
    IF ( istat /= 0 ) THEN
      CALL Fatal( 'PoissonSolve', 'Memory allocation error.' )
    END IF
    AllocationsDone = .TRUE.
  END IF

  ! Perform FE assembly one colour at a time (thread-safe)
  ! Element indices are listed in packed (CRS) structure  ColourIndexList
  !$OMP SINGLE
  nColours = GetNOFColours(Solver) ! Initialize coloured assembly
  !$OMP END SINGLE

  DO col=1,nColours
    !$OMP SINGLE
    CALL Info('PoissonSolve','Assembly of colour: '//TRIM(I2S(col)),Level=10)
    nactive = GetNOFActive(Solver) ! Pick the next available colour
    !$OMP END SINGLE

    !$OMP DO SCHEDULE(STATIC)
    DO t=1,nactive
      Element => GetActiveElement(t)
      n  = GetElementNOFNodes(Element)
      nd = GetElementNOFDOFs(Element)
      nb = GetElementNOFBDOFs(Element)

      LOAD(1:n) = 0.0d0
      BodyForce => GetBodyForce(Element)
      
      IF ( ASSOCIATED(BodyForce) ) THEN
        CALL GetRealValues( BodyForce, 'Source', Load, Found, UElement=Element )
      END IF

      !Get element local matrix and rhs vector:
      !----------------------------------------
      CALL LocalMatrix( STIFF, FORCE, LOAD, Element, n, nd+nb )
      CALL LCondensate( nd, nb, STIFF, FORCE, maxdofs )

      CALL DefaultUpdateEquations( STIFF, FORCE, UElement=Element, VecAssembly=VecAsm )
    END DO ! Element loop
    !$OMP END DO

  END DO ! Colour loop
  !$OMP END PARALLEL

  CALL CheckTimer('ThreadedAssembly',Delete=.TRUE.)

  CALL DefaultFinishAssembly()
  CALL DefaultDirichletBCs()

  ! And finally, solve:
  !--------------------
  Norm = DefaultSolve()

  CONTAINS

!------------------------------------------------------------------------------
  SUBROUTINE LocalMatrix(  STIFF, FORCE, LOAD, Element, n, nd )
!------------------------------------------------------------------------------
    USE LinearForms
    REAL(KIND=dp) CONTIG :: STIFF(:,:), FORCE(:), LOAD(:)
    INTEGER :: n, nd
    TYPE(Element_t), POINTER :: Element
!------------------------------------------------------------------------------
    LOGICAL :: Stat
    INTEGER :: i, dim, ldbasis, ngp, allocstat
    TYPE(GaussIntegrationPoints_t) :: IP

    TYPE(Nodes_t), SAVE :: Nodes
    REAL(KIND=dp), ALLOCATABLE, SAVE :: Basis(:,:), dBasisdx(:,:,:), DetJ(:), LoadAtIPs(:)
!DIR$ ATTRIBUTES ALIGN:64 :: Basis, dBasisdx, DetJ, LoadAtIPs
    !$OMP THREADPRIVATE(Nodes, Basis, dBasisdx, DetJ, LoadAtIPs)
!------------------------------------------------------------------------------
    CALL GetElementNodesVec( Nodes, UElement=Element )
    STIFF = 0.0d0
    FORCE = 0.0d0

    ! Get integration points
    IP = GaussPoints( Element )
    ! IP = GaussPoints( Element, 64 )
    ! IP = GaussPoints( Element, 512 )
    ngp = IP % n

    ! Reserve workspace
    IF (.NOT. ALLOCATED(Basis)) THEN
      ALLOCATE(Basis(ngp,nd), dBasisdx(ngp,nd,3), &
              DetJ(ngp), LoadAtIPs(ngp), STAT=allocstat)
      IF (allocstat /= 0) THEN
        CALL Fatal('LocalMatrix',&
                'Storage allocation for local element basis failed')
      END IF
    ELSE IF (SIZE(Basis,1) < ngp .OR. SIZE(Basis,2) < nd) THEN
      DEALLOCATE(Basis, dBasisdx, DetJ, LoadAtIPs)
      ALLOCATE(Basis(ngp,nd), dBasisdx(ngp,nd,3), &
              DetJ(ngp), LoadAtIPs(ngp), STAT=allocstat)
      IF (allocstat /= 0) THEN
        CALL Fatal('LocalMatrix',&
                'Storage allocation for local element basis failed')
      END IF
    END IF
    
    ldbasis = SIZE(Basis,1)
    ! Compute values of all basis functions at all integration points
    stat = ElementInfoVec( Element, Nodes, ngp, &
            IP % U, IP % V, IP % W, DetJ, SIZE(Basis,2), Basis, dBasisdx )
    ! Compute actual integration weights (recycle memory space of DetJ)
    DetJ(1:ngp) = IP % s(1:ngp)*Detj(1:ngp)

    ! STIFF=STIFF+(grad u, grad u)
    CALL LinearForms_GradUdotGradU(ngp, nd, Element % TYPE % DIMENSION, dBasisdx, DetJ, STIFF)

    ! Source terms at IPs
    !------------------------------------------
    ! LoadAtIPs(1:ngp) = MATMUL( Basis(1:ngp,1:n), LOAD(1:n) )
    CALL LinearForms_ProjectToU(ngp, n, Basis, LOAD, LoadAtIPs)

    ! FORCE=FORCE+(u,f)
    CALL LinearForms_UdotF(ngp, nd, Basis, DetJ, LoadAtIPs, FORCE)
!------------------------------------------------------------------------------
  END SUBROUTINE LocalMatrix
!------------------------------------------------------------------------------

  
! Condensate bubble functions from the local stiffness matrix and force vector.
! Uses BLAS and LAPACK
!------------------------------------------------------------------------------
  SUBROUTINE LCondensate( N, Nb, K, F, kld )
!------------------------------------------------------------------------------
    USE LinearAlgebra
    IMPLICIT NONE

    ! Parameters
    INTEGER, INTENT(IN) :: N, Nb
    REAL(KIND=dp) :: K(kld, kld)
    REAL(KIND=dp) :: F(kld)
    INTEGER, INTENT(IN) :: kld
    
    ! Variables
    REAL(KIND=dp) :: Kbb(Nb,Nb), &
            Kbl(Nb,N), Klb(N,Nb), Fb(Nb), DNRM2
    
    INTEGER :: m, i, j, l, p, nfo, PIV(Nb)
    ! INTEGER :: Ldofs(N), Bdofs(Nb)
    
    ! BLAS interfaces
    INTERFACE
      SUBROUTINE DGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
        IMPLICIT NONE
        DOUBLE PRECISION ALPHA,BETA
        INTEGER INCX,INCY,LDA,M,N
        CHARACTER TRANS
        DOUBLE PRECISION A(LDA,*),X(*),Y(*)
      END SUBROUTINE DGEMV
    END INTERFACE
    
    INTERFACE
      SUBROUTINE DGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
        IMPLICIT NONE
        DOUBLE PRECISION ALPHA,BETA
        INTEGER K,LDA,LDB,LDC,M,N
        CHARACTER TRANSA,TRANSB
        DOUBLE PRECISION A(LDA,*),B(LDB,*),C(LDC,*)
      END SUBROUTINE DGEMM
    END INTERFACE
    
    ! LAPACK interfaces
    INTERFACE
      SUBROUTINE DGETRF(M, N, A, LDA, IPIV, INFO)
        IMPLICIT NONE
        INTEGER :: INFO, LDA, M, N
        INTEGER :: IPIV( * )
        DOUBLE PRECISION :: A( LDA, * )
      END SUBROUTINE DGETRF
    END INTERFACE
    
    INTERFACE
      SUBROUTINE DGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
        IMPLICIT NONE
        CHARACTER ::TRANS
        INTEGER :: INFO, LDA, LDB, N, NRHS
        INTEGER :: IPIV(*)
        DOUBLE PRECISION :: A(LDA,*), B(LDB,*)
      END SUBROUTINE DGETRS
    END INTERFACE
    
    IF ( Nb <= 0 ) RETURN

    ! Ldofs = (/ (i, i=1,n) /)
    ! Bdofs = (/ (i, i=n+1,n+nb) /)

    ! Can we use blas/lapack without copying the matrices?
    ! Kbb = K(Bdofs,Bdofs)
    DO j=n+1,n+nb
      DO i=n+1,n+nb
        Kbb(i-n,j-n) = K(i,j)
      END DO
    END DO
    ! Kbl = K(Bdofs,Ldofs)
    DO j=1,n
      DO i=n+1,n+nb
        Kbl(i-n,j) = K(i,j)
      END DO
    END DO
    ! Klb = K(Ldofs,Bdofs)
    DO j=n+1,n+nb
      DO i=1,n
        Klb(i,j-n) = K(i,j)
      END DO
    END DO
    ! Fb  = F(Bdofs)
    DO i=n+1,n+nb
      Fb(i-n) = F(i)
    END DO

    ! CALL InvertMatrix( Kbb,nb )
    CALL DGETRF(nb, nb, Kbb, nb, PIV, NFO)

    ! F(1:n) = F(1:n) - MATMUL( Klb, MATMUL( Kbb, Fb  ) )
    CALL DGETRS('N', Nb, 1, Kbb, Nb, PIV, Fb, Nb, NFO)
    CALL DGEMV('N', n, nb, -1D0, Klb, n, Fb, 1, 1D0, F, 1)

    ! K(1:n,1:n) = &
    !        K(1:n,1:n) - MATMUL( Klb, MATMUL( Kbb, Kbl ) )
    CALL DGETRS('N', Nb, n, Kbb, Nb, PIV, Kbl, Nb, NFO)
    CALL DGEMM('N', 'N', n, n, nb, -1D0, Klb, n, Kbl, nb, 1D0, K, kld)
!------------------------------------------------------------------------------
  END SUBROUTINE LCondensate
!------------------------------------------------------------------------------

END SUBROUTINE PoissonSolver  
!------------------------------------------------------------------------------
! END SUBROUTINE PoissonSolver
!------------------------------------------------------------------------------

PROGRAM SurfaceMap
!----------------------------------------------------------------
! This program is used to map a given plane mesh to a surface 
! in the threee-dimensional point space. It can also be used to 
! create mesh.director file which defines the director at the
! nodes in a similar way as nodes are defined. 
! To be decided: should mesh.director contain also nodes data
!---------------------------------------------------------------
  IMPLICIT NONE 

  LOGICAL :: CreateDirector

  INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(12)

  INTEGER, ALLOCATABLE :: Node(:)
  INTEGER :: n, i, j, MappingMode
  
  REAL(KIND=dp), ALLOCATABLE :: x(:), y(:), z(:)
  REAL(KIND=dp) :: R, xi, yi, zi, t, d1, d2, d3
!-------------------------------------------------
  CreateDirector = .FALSE.
  MappingMode = 5 ! 1 = polar mapping, 
                  ! 2 = shear + polar mapping,
                  ! 3 = polar mapping & create mesh.director file
                  ! 4 = shear + polar mapping & create mesh.director file
                  ! 5 = plate body & create mesh.director file
  IF (MappingMode == 3 .OR. MappingMode == 4 .OR. MappingMode == 5) CreateDirector = .TRUE.
  R = 1.0d0

  OPEN(11,file="mesh.header")
  READ(11,*) N
  CLOSE(11)
  ALLOCATE (Node(N), x(N), y(N), z(N))

  OPEN(12,file="mesh.nodes")
  DO i=1,N
    READ(12,*) Node(i),j,x(i),y(i),z(i)
  END DO
  REWIND(12)

  IF (CreateDirector) OPEN(13,file="mesh.director")

  SELECT CASE(MappingMode)
  CASE(1)
     DO i=1,N
        xi = R * SIN(x(i)/R)
        yi = y(i)
        zi = R*(1.0d0-COS(x(i)/R))
        WRITE(12,1200) Node(i),j,xi,yi,zi
     END DO
  CASE(2)
     DO i=1,N
        xi = x(i)
        yi = y(i)
        zi = z(i)
        x(i) = xi + 0.25d0 * yi
        y(i) = yi
        z(i) = zi
        
        WRITE(12,1200) Node(i),j,R*SIN(x(i)/R), y(i), R*(1.0d0-COS(x(i)/R))
     END DO
  CASE(3)
     DO i=1,N
        t = x(i)/R
        xi = R * SIN(t)
        yi = y(i)
        zi = R*(1.0d0-COS(t))
        WRITE(12,1200) Node(i),j,xi,yi,zi
        d1 = R * SIN(t)
        d2 = 0.0d0
        d3 = -R * cos(t)
        WRITE(13,1300) Node(i),d1,d2,d3 
     END DO
  CASE(4)
     DO i=1,N
        xi = x(i)
        yi = y(i)
        zi = z(i)
        x(i) = xi + 0.25d0 * yi
        y(i) = yi
        z(i) = zi

        t = x(i)/R
        WRITE(12,1200) Node(i),j,R*SIN(t), y(i), R*(1.0d0-COS(t))
        d1 = R * SIN(t)
        d2 = 0.0d0
        d3 = -R * cos(t)
        WRITE(13,1300) Node(i),d1,d2,d3 
     END DO
   CASE(5)
     DO i=1,N
       WRITE(12,1200) Node(i),j,x(i),y(i),z(i)
       WRITE(13,1300) Node(i),0.0d0,0.0d0,1.0d0
     END DO
  END SELECT
  CLOSE(12)
  IF (CreateDirector) CLOSE(13)

  DEALLOCATE (Node, x, y, z)
  
1200 FORMAT(i6,2x,i5,3(2x,e22.15)) 
1300 FORMAT(i6,3(2x,e22.15)) 

END PROGRAM SurfaceMap

!------------------------------------------------------
! Pijl et al, 4.1.2. Zalesak's rotating disk
!------------------------------------------------------

  FUNCTION InitZalesak( Model, n, t ) RESULT(f)
    USE Types
    USE SolverUtils
    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    LOGICAL :: Visited = .FALSE., GotIt
    INTEGER :: n,i,j
    REAL(KIND=dp) :: t,x,y,r,Lx,Ly,x0,y0,r0,w0,dist(4),f,a1,a2,b1,b2,f1,f2
    
    SAVE Visited, x0, y0, r0, w0, a1, a2, b1, b2
    
    IF(.NOT. Visited) THEN
      Lx = ListGetConstReal(Model % Simulation,'Zalesak Lx',GotIt)
      IF(.NOT. GotIt) Lx = MAXVAL( Model % Nodes % x ) 
      Ly = ListGetConstReal(Model % Simulation,'Zalesak Ly',GotIt)
      IF(.NOT. GotIt) Ly = MAXVAL( Model % Nodes % y ) 

      x0 = 0.5 * Lx
      y0 = 0.75 * Ly
      r0 = (3.0/20.0) * Lx
      w0 = r0 / 3.0d0

      a1 = x0 - w0/2
      a2 = x0 + w0/2
      b1 = -1.0
      b2 = y0 + r0 - w0
      Visited = .TRUE.
    END IF

    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    

    ! distance from horizontal lines
    IF( x < a1 ) THEN
      dist(1) = SQRT( (x-a1)**2.0 + (y-b1)**2.0)
      dist(2) = SQRT( (x-a1)**2.0 + (y-b2)**2.0)
    ELSE IF( x > a2 ) THEN     
      dist(1) = SQRT( (x-a2)**2.0 + (y-b1)**2.0)
      dist(2) = SQRT( (x-a2)**2.0 + (y-b2)**2.0)
    ELSE     
      dist(1) = ABS(y - b1)
      dist(2) = ABS(y - b2)
    END IF

    ! distance from vertical lines
    IF( y < b1 ) THEN
      dist(3) = SQRT( (x-a1)**2.0 + (y-b1)**2.0)
      dist(4) = SQRT( (x-a2)**2.0 + (y-b1)**2.0)
    ELSE IF( y > b2 ) THEN     
      dist(3) = SQRT( (x-a1)**2.0 + (y-b2)**2.0)
      dist(4) = SQRT( (x-a2)**2.0 + (y-b2)**2.0)
    ELSE     
      dist(3) = ABS(x - a1)
      dist(4) = ABS(x - a2)
    END IF
    
    ! minimum distance to the sides of the rectangle
    f1 = MINVAL( ABS( dist ) )
    
    ! set negative sign inside the rectangle 
    IF( x > a1 .AND. x < a2 .AND. y > b1 .AND. y < b2) THEN
      f1 = -f1
    END IF
      
    ! inside of a circle
    f2 = r0 - SQRT( (x-x0)**2.0 + (y-y0)**2.0 )

    ! take a union of the rectangle and circle
    IF( f2 > 0.0 ) THEN
      IF( f1 < 0.0 ) THEN
        f = f1
      ELSE
        f = MIN(f1,f2)
      END IF
    ELSE 
      IF( f1 > 0.0 ) THEN
        f = f2
      ELSE 
        f = MIN(f1,f2)
      END IF
    END IF
     
  END FUNCTION InitZalesak



  FUNCTION RotateVeloX( Model, n, t ) RESULT(f)
    USE Types
    USE SolverUtils
    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    LOGICAL :: Visited = .FALSE., GotIt
    INTEGER :: n,i,j
    REAL(KIND=dp) :: t,x,y,r,Lx,Ly,x0,y0,f
    
    SAVE Visited, x0, y0
    
    IF(.NOT. Visited) THEN
      Lx = ListGetConstReal(Model % Simulation,'Zalesak Lx',GotIt)
      IF(.NOT. GotIt) Lx = MAXVAL( Model % Nodes % x ) 
      Ly = ListGetConstReal(Model % Simulation,'Zalesak Ly',GotIt)
      IF(.NOT. GotIt) Ly = MAXVAL( Model % Nodes % y )

      x0 = Lx / 2.0
      y0 = Ly / 2.0
      Visited = .TRUE.
    END IF
    
    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    

    f = -(y-y0)

  END FUNCTION RotateVeloX  


  FUNCTION RotateVeloY( Model, n, t ) RESULT(f)
    USE Types
    USE SolverUtils
    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    LOGICAL :: Visited = .FALSE., GotIt
    INTEGER :: n,i,j
    REAL(KIND=dp) :: t,x,y,r,Lx,Ly,x0,y0,f
    
    SAVE Visited, x0, y0
    
    IF(.NOT. Visited) THEN
      Lx = ListGetConstReal(Model % Simulation,'Zalesak Lx',GotIt)
      IF(.NOT. GotIt) Lx = MAXVAL( Model % Nodes % x ) 
      Ly = ListGetConstReal(Model % Simulation,'Zalesak Ly',GotIt)
      IF(.NOT. GotIt) Ly = MAXVAL( Model % Nodes % y ) 

      x0 = Lx / 2.0
      y0 = Ly / 2.0
      Visited = .TRUE.
    END IF
    
    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    

    f = x - x0

  END FUNCTION RotateVeloY

FUNCTION Motion( Model,n,t ) RESULT(uy)
USE Types

IMPLICIT NONE

TYPE(Model_t) :: Model

INTEGER :: n
DOUBLE PRECISION :: t, uy, x, umax, tpulse

x = Model % Nodes % x(n)

! Total displacement
umax = 0.05

! Duration of the motion (umax)
tpulse = 0.6

x = Model % Nodes % x(n)

IF (t < tpulse/2) THEN
   uy = (umax/2)*(SIN((2*t-tpulse/2)/tpulse*pi)+1)
ELSE
   uy = umax
END IF

END FUNCTION Motion

!------------------------------------------------------------------------------
SUBROUTINE BulkAssembly( Model,Solver,dt,Transient, &
    Mass, Damp, Stiff, Force, InElement, nrow, ncol )
!------------------------------------------------------------------------------

  USE DefUtils
 
  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t), TARGET :: Solver
  LOGICAL ::  Transient
  REAL(KIND=dp) :: dt
  REAL(KIND=dp) :: Stiff(:,:), Damp(:,:), Mass(:,:), Force(:)
  TYPE(Element_t), TARGET :: InElement
  INTEGER :: Nrow, Ncol 
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------

  TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
  TYPE(Nodes_t) :: Nodes
  REAL(KIND=dp), ALLOCATABLE :: Source(:), Cond(:), React(:)
  REAL(KIND=dp), ALLOCATABLE :: Basis(:), dBasisdx(:,:)
  REAL(KIND=dp) :: SourceAtIP, CondAtIP, ReactAtIp, Weight, DetJ
  INTEGER :: i,j,t,p,q,n
  LOGICAL :: Visited = .FALSE., Found
  TYPE(ValueList_t), POINTER :: Material
  TYPE(Element_t), POINTER :: Element

  
  SAVE Visited, Source, Cond, React, Nodes, Basis, dBasisdx

  IF( .NOT. Visited ) THEN
     N = Solver % Mesh % MaxElementNodes    
     ALLOCATE( Source(n), Cond(n), React(n), Basis(n), dBasisdx(n,3), &
         Nodes % x(n), Nodes % y(n), Nodes % z(n) )     
     CALL info('PoissonBulkAssembly','1st time')
     Visited = .TRUE.
  END IF

  n = Nrow 
  CALL GetElementNodes( Nodes ) 
  Material => GetMaterial()  
  React(1:n) = GetReal( Material,'Reaction',Found )
  Source(1:n) = GetReal( Material,'Source' )
  Cond(1:n) = GetReal( Material,'Conductivity')

  Element => GetCurrentElement()
  IntegStuff = GaussPoints( Element )

  DO t=1,IntegStuff % n
    
    Found = ElementInfo( Element, Nodes, IntegStuff % u(t), &
        IntegStuff % v(t), IntegStuff % w(t), detJ, Basis, dBasisdx )
    
    Weight = IntegStuff % s(t) * detJ
    
    CondAtIP = SUM( Basis(1:Nrow) * Cond(1:Nrow) )
    SourceAtIP = SUM( Basis(1:Nrow) * Source(1:Nrow) )
    ReactAtIP = SUM( Basis(1:Nrow) * React(1:Nrow) )
    
    DO p=1,n
      DO q=1,n
        STIFF(p,q) = STIFF(p,q) + Weight * CondAtIP * &
            SUM(dBasisdx(p,1:3)*dBasisdx(q,1:3))
        STIFF(p,q) = STIFF(p,q) + Weight * ReactAtIP * &
            Basis(p)*Basis(q)
      END DO
      
      FORCE(p) = FORCE(p) + Weight * SourceAtIP * Basis(p)
    END DO
  END DO
  
!------------------------------------------------------------------------------
END SUBROUTINE BulkAssembly
!------------------------------------------------------------------------------



!------------------------------------------------------------------------------
SUBROUTINE BoundaryAssembly( Model,Solver,dt,Transient, &
            Mass, Damp, Stiff, Force, InElement, nrow, ncol )
!------------------------------------------------------------------------------

  USE DefUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Model_t)  :: Model
  TYPE(Solver_t), TARGET :: Solver
  LOGICAL ::  Transient
  REAL(KIND=dp) :: dt
  REAL(KIND=dp) :: Stiff(:,:), Damp(:,:), Mass(:,:), Force(:)
  TYPE(Element_t), TARGET :: InElement
  INTEGER :: Nrow, Ncol 
!------------------------------------------------------------------------------
!    Local variables
!------------------------------------------------------------------------------

  TYPE(GaussIntegrationPoints_t), TARGET :: IntegStuff
  TYPE(Nodes_t) :: Nodes
  REAL(KIND=dp), ALLOCATABLE :: Flux(:), Text(:), Coeff(:)
  REAL(KIND=dp), ALLOCATABLE :: Basis(:), dBasisdx(:,:)
  REAL(KIND=dp) :: FluxAtIP, TextAtIP, CoeffAtIP, Weight, DetJ
  INTEGER :: i,j,t,p,q,n
  LOGICAL :: Visited = .FALSE., Found, Found2
  TYPE(ValueList_t), POINTER :: BC
  TYPE(Element_t), POINTER :: Element

  
  SAVE Visited, Flux, Text, Coeff, Nodes, Basis, dBasisdx


  IF( .NOT. Visited ) THEN
    N = Solver % Mesh % MaxElementNodes    
    ALLOCATE( Flux(n), Text(n), Coeff(n), Basis(n), dBasisdx(n,3), &
        Nodes % x(n), Nodes % y(n), Nodes % z(n) )     
    CALL info('PoissonBoundaryAssembly','1st time')
    Visited = .TRUE.
  END IF
  
  Element => GetCurrentElement()
  n = Nrow 
  CALL GetElementNodes( Nodes ) 
  
  BC => GetBC( )
  
  Flux(1:n) = GetReal( BC,'Flux',Found )
  Coeff(1:n) = GetReal( BC,'Coeffient',Found2 )
  IF(.NOT. (Found .OR. Found2)) RETURN
  Text(1:n) = GetReal( BC,'External',Found )


  IntegStuff = GaussPoints( Element )
  
  DO t=1,IntegStuff % n
    
    Found = ElementInfo( Element, Nodes, IntegStuff % u(t), &
        IntegStuff % v(t), IntegStuff % w(t), detJ, Basis, dBasisdx )
    
    Weight = IntegStuff % s(t) * detJ
    
    FluxAtIP = SUM( Basis(1:Nrow) * Flux(1:Nrow) )
    CoeffAtIP = SUM( Basis(1:Nrow) * Coeff(1:Nrow) )
    TextAtIP = SUM( Basis(1:Nrow) * Text(1:Nrow) )
    
    DO p=1,n
      DO q=1,n
        STIFF(p,q) = STIFF(p,q) + Weight * CoeffAtIP * &
            Basis(p)*Basis(q)
      END DO
      FORCE(p) = FORCE(p) + Weight * Basis(p) * &
          ( FluxAtIP + CoeffAtIP * TextAtIP )
    END DO
  END DO

!------------------------------------------------------------------------------
END SUBROUTINE BoundaryAssembly
!------------------------------------------------------------------------------

!-------------------------------------------------------------------------------
SUBROUTINE ZirkaTest( Model,Solver,dt,TransientSimulation ) ! {{{
!-------------------------------------------------------------------------------
  USE DefUtils
  USE ZirkaUtils

  IMPLICIT NONE
!------------------------------------------------------------------------------
  TYPE(Solver_t) :: Solver
  TYPE(Model_t) :: Model

  REAL(KIND=dp) :: dt
  LOGICAL :: TransientSimulation
  integer :: unit, testnum
  TYPE(ValueList_t), POINTER :: params
  type(Variable_t), POINTER :: variable
  logical :: found
!------------------------------------------------------------------------------
! Local variables
!------------------------------------------------------------------------------
  
  testnum = ListGetInteger(GetSolverparams(Solver), 'test number', found)
  if (.not. found) testnum = 6

  call info('ZirkaTest','Running zirkatest')
  select case(testnum)
  case (6); call test6()
  case (5); call test5()
  case (4); call test4()
  case (3); call test3()
  end select

  OPEN (newunit=unit, FILE='TEST.PASSED')
  write(unit, '(I0)') 1
   
  close(unit)

contains

subroutine test6() ! {{{
  use zirka
  use defutils
  type(MasterCurve_t) :: mc, mc2
  real(kind=dp), allocatable :: BHasc(:,:), BHsingle(:,:), Bsingle(:), Hsingle(:)
  real(kind=dp), allocatable :: rps(:)
  real(kind=dp), allocatable :: H(:), dH(:), Hnobuf(:)
  real(kind=dp), pointer :: rps_array(:,:)
  integer  :: n, m
  integer, parameter :: nr = 20
  type(ZirkaABC_t), POINTER :: ABCParams
  allocate(ABCParams )

  BHasc = readBH('../HB/BH_asc_real')
  BHsingle = readBH('../HB/BH_single_real')

  allocate(H(size(BHasc,1)), dH(size(BHasc,1)), Hnobuf(size(BHasc,1)))

  allocate(rps(nr))
  rps = [(2.0*(-0.5_dp)**n, n=0,nr-1)]

  mc = MasterCurve_t(InitSplineLoop(BHasc, BHsingle), &
      ABCparams, n_cachesubsample = 2)

  call mc % drive(1.8_dp)

  DO n = 1,nr-1
    CALL mc % drive(rps(n), cache=.false.)
  END DO
  CALL mc % drive(rps(nr), cache=.true.)

  rps_array => null()
  m = 250
  BLOCK
    integer :: i_r
    rps_array => ListGetConstRealArray(GetSolverParams(), 'rps', found)
    if (.not. found) then
      rps = [0.0_dp, 1.8_dp, -1.0_dp, 0.5_dp, 0.25_dp, 0.4_dp, -0.4_dp, -0.8_dp, 0.9_dp]
    else
      rps = rps_array(:,1)
    end if

    ! rps = -rps
    ! rps = [0.0_dp, -1.84102067_dp, 1.3_dp, -0.5_dp]
    do i_r = 2, ubound(rps,1)
      call mc % drive(rps(i_r-1), cache = .true.)
        associate (B_low => rps(i_r-1),  B_up => rps(i_r))
          call print_interval(mc, B_low, B_up, m)
        end associate
    end do
  END BLOCK

end subroutine ! }}}

subroutine print_interval(mc, B_low, B_up, m, Hexact) ! {{{
  type(MasterCurve_t) :: mc
  real(kind=dp) :: B_low, B_up, H, Hnobuf, dH
  real(kind=dp), intent(in), optional :: Hexact
  integer :: n, m
  !-------------------------------------------------------------------------------
  DO n = 0, m-1
    associate( Bhere => (B_low + n*(B_up-B_low)/m) )
      H = mc % eval(Bhere, cached = .true., dhdb=dH)
      Hnobuf = mc % eval(Bhere, cached = .false.)

      if (present(Hexact)) then
        print *, Bhere, H, dH, Hnobuf, Hexact
      else
        print *, Bhere, H, dH, Hnobuf
      end if

    end associate
  end do
end subroutine ! }}}

subroutine test5() ! {{{
  use zirka
  use defutils
  type(MasterCurve_t) :: mc, mc2
  real(kind=dp), allocatable :: BHasc(:,:), BHsingle(:,:), Bsingle(:), Hsingle(:)
  real(kind=dp), allocatable :: rps(:)
  real(kind=dp), allocatable :: H(:), dH(:), Hnobuf(:)
  integer  :: n, m
  integer, parameter :: nr = 20
  type(ZirkaABC_t), POINTER :: ABCParams
  allocate(ABCParams )

  BHasc = readBH('../HB/BH_asc_real')
  BHsingle = readBH('../HB/BH_single_real')

  allocate(H(size(BHasc,1)), dH(size(BHasc,1)), Hnobuf(size(BHasc,1)))

  allocate(rps(nr))
  rps = [(2.0*(-0.5_dp)**n, n=0,nr-1)]

  mc = MasterCurve_t(InitSplineLoop(BHasc, BHsingle), &
      ABCparams)

  call mc % drive(1.8_dp)

  DO n = 1,nr-1
    CALL mc % drive(rps(n), cache=.false.)
  END DO
  CALL mc % drive(rps(nr), cache=.true.)


  m = 250
  associate (B_low => -0.0_dp, B_up => 1.9_dp )
    DO n = 1,m
      associate( Bhere => (B_low + n*(B_up-B_low)/m) )
        H(n) = mc % eval(Bhere, cached = .true., dhdb=dH(n))
        Hnobuf(n) = mc % eval(Bhere)
        print *, Bhere, H(n), dH(n), Hnobuf(n)
      end associate
    END DO
  end associate

end subroutine ! }}}
!-------------------------------------------------------------------------------
subroutine test4() ! {{{
  use zirka
  use defutils
  type(MasterCurve_t) :: mc, mc2
  real(kind=dp), allocatable :: BHasc(:,:), BHsingle(:,:), Bsingle(:), Hsingle(:)
  real(kind=dp), allocatable :: rps(:)
  real(kind=dp) :: H
  integer  :: n, m
  integer, parameter :: nr = 20
  type(ZirkaABC_t), POINTER :: ABCParams
  real(kind=dp), pointer :: rps_array(:,:)
  allocate(ABCParams )

  BHasc = readBH('../HB/BH_asc_real')
  BHsingle = readBH('../HB/BH_single_real')


  allocate(rps(nr))
  rps = [(2.0*(-0.5_dp)**n, n=0,nr-1)]

  mc = MasterCurve_t(InitSplineLoop(BHasc, BHsingle), &
      ABCparams)

  rps_array => null()
  rps_array => ListGetConstRealArray(GetSolverParams(), 'rps_4', found)

  do n=1,size(rps_array,1)
    call mc % drive(rps_array(n,1), cache = .false.)
    call mc % printme()
    print *, 'B = ', rps_array(n,1) 
    H = mc % eval (rps_array(n,1), cached = .false.)
    print *, 'H = ',H
    ! call printeval(mc, rps_array(n,1))
  end do
  ! call mc % drive(0.1_dp, cache = .false.)
  ! call mc % printme()
  ! call mc % drive(-1.8_dp, cache = .false.)
  ! call mc % printme()
  ! call mc % drive(0.8_dp, cache = .false.)
  ! call mc % printme()
  ! call mc % drive(-1.2_dp, cache = .false.)
  ! call mc % printme()

  ! deallocate(rps_array)

end subroutine ! }}}
subroutine test3() ! {{{
  use zirka
  use defutils
  type(MasterCurve_t) :: mc, mc2
  real(kind=dp), pointer :: BHasc(:,:), BHsingle(:,:)
  real(kind=dp), pointer :: rps(:), H(:)
  real(kind=dp), pointer :: rps_array(:,:)
  real(kind=dp), allocatable, target :: scalar_array(:,:)
  
  integer  :: n, m
  integer :: nr
  type(ZirkaABC_t), POINTER :: ABCParams
  allocate(ABCParams )

  call GetConstRealArray(model % materials(2) % values, BHasc, 'Ascending BH curve', found) 
  if(.not. Found) call fatal('ZirkaTest', 'Ascending BH curve not found')
  call GetConstRealArray(model % materials(2) % values, BHSingle, 'Single valued BH curve', found)
  if(.not. Found) call fatal('ZirkaTest', 'Single valued BH curve not found')

  call info('ZirkaTest','Running zirkatest')
  rps_array => ListGetConstRealArray(GetSolverParams(), 'zirka init sequence', found)
  rps(1:size(rps_array,1)) => rps_array(:,1)

  mc = MasterCurve_t(InitSplineLoop(BHasc, BHsingle), &
      ABCparams, n_cachesubsample = 2)

  nr = size(rps,1)

  DO n = 1,nr-1
    CALL mc % drive(rps(n), cache=.false.)
  END DO
  CALL mc % drive(rps(nr), cache=.true.)

  rps => null()

  m = 1
  BLOCK
    integer :: i_r
    ! rps_array => ListGetConstRealArray(GetSolverParams(), 'rps_3', found)
    scalar_array = readdat("scalars_a.dat", 7, 9)
  call info('ZirkaTest','Running zirkatest')
    rps(1:size(scalar_array,1)) => scalar_array(:,3)
    H(1:size(scalar_array,1)) => scalar_array(:,4)

    do i_r = 2, ubound(rps,1)
      call mc % drive(rps(i_r-1), cache = .true.)
        associate (B_low => rps(i_r-1),  B_up => rps(i_r))
          call print_interval(mc, B_low, B_up, m, H(i_r-1))
        end associate
    end do
    i_r = ubound(rps,1)
    call mc % drive(rps(i_r), cache = .true.)
    associate (B_low => rps(i_r),  B_up => rps(i_r))
      call print_interval(mc, B_low, B_up, m, H(i_r))
    end associate
    variable => VariableGet(solver % variable, "testvar")
    variable % values = abs(H(i_r)-mc % eval(rps(i_r), cached = .true.))/abs(H(i_r))
    variable % norm = abs(H(i_r)-mc % eval(rps(i_r), cached = .true.))/abs(H(i_r))
  END BLOCK

end subroutine ! }}}
function readBH(f) result(BH) ! {{{
  real(kind=dp), allocatable :: BH(:,:)
  character(len=*) :: f
  real*8 :: lenf
  integer :: iu, len, n

  open(newunit=iu, file=f, action='read', status='old')

  read(iu, *) len

  allocate(BH(1:len,2))

  do n = 1,len
    read (iu,*) BH(n,1:2)
  end do
  close(iu)

end function ! }}}

function readdat(f, m, n) result(table) ! {{{
  real(kind=dp), allocatable :: table(:,:)
  character(len=*) :: f
  real*8 :: lenf
  integer :: iu, m, n, k

  open(newunit=iu, file=f, action='read', status='old')

  allocate(table(m,n))

  do k = 1,m
    read (iu,*) table(k,1:n)
  end do
  close(iu)

end function ! }}}
END SUBROUTINE ZirkaTest ! }}}
!-------------------------------------------------------------------------------

  FUNCTION InitCircle( Model, n, t ) RESULT(f)
    USE Types
    USE SolverUtils
    IMPLICIT NONE
    
    TYPE(Model_t) :: Model
    LOGICAL :: Visited = .FALSE., GotIt
    INTEGER :: n,i,j
    REAL(KIND=dp) :: t,x,y,r,Lx,Ly,f,a1,b1,r1
    
    SAVE Visited, a1, b1, r1  

    IF(.NOT. Visited) THEN
      Lx = 1.0
      Ly = 1.0
      
      a1 = 0.5 * Lx 
      b1 = 0.5 * Ly
      r1 = 0.25 * Lx
      Visited = .TRUE.
    END IF
    
    x = Model % Nodes % x(n)
    y = Model % Nodes % y(n)    
    

    ! positive inside the circle
    f = r1 - SQRT((x-a1)**2.0 + (y-b1)**2.0) 

  END FUNCTION InitCircle




  FUNCTION Viscosity( Model, n, fii ) RESULT(r)
   USE Types
   USE SolverUtils

   IMPLICIT NONE

   TYPE(Model_t) :: Model
   INTEGER :: i,j,k,n, body_id

   REAL(KIND=dp) :: x,y,r,fii,dfii,t,visc0,visc1,fstep
   LOGICAL :: Visited = .FALSE., GotIt


   SAVE Visited, visc1, visc0, dfii

   IF(.NOT. Visited) THEN
     body_id = Model % CurrentElement % Bodyid    
     k = ListGetInteger( Model % Bodies( body_id ) % Values, 'Material' )
     visc0 = ListGetConstReal(Model % Materials(k) % Values,'Inside Viscosity')
     visc1 = ListGetConstReal(Model % Materials(k) % Values,'Outside Viscosity')
     dfii = ListGetConstReal(Model % Materials(k) % Values,'Levelset Bandwidth')
     Visited = .TRUE.
   END IF

   t = fii / dfii
   IF(t < -1.0) THEN
     fstep = 0.0d0
   ELSE IF(t > 1.0) THEN
     fstep = 1.0d0
   ELSE
     fstep = 0.75d0 * (t - t**3.0d0/3) + 0.5d0
   END IF

   r = (visc0-visc1) * fstep + visc1

 END FUNCTION Viscosity



  FUNCTION Density( Model, n, fii ) RESULT(r)
   USE Types
   USE SolverUtils

   IMPLICIT NONE

   TYPE(Model_t) :: Model
   INTEGER :: i,j,k,n, body_id

   REAL(KIND=dp) :: x,y,r,fii,dfii,t,dens0,dens1,fstep
   LOGICAL :: Visited = .FALSE., GotIt


   SAVE Visited, dens1, dens0, dfii

   IF(.NOT. Visited) THEN
     body_id = Model % CurrentElement % Bodyid    
     k = ListGetInteger( Model % Bodies( body_id ) % Values, 'Material' )
     dens0 = ListGetConstReal(Model % Materials(k) % Values,'Inside Density')
     dens1 = ListGetConstReal(Model % Materials(k) % Values,'Outside Density')
     dfii = ListGetConstReal(Model % Materials(k) % Values,'Levelset Bandwidth')
     Visited = .TRUE.
   END IF

   t = fii / dfii
   IF(t < -1.0) THEN
     fstep = 0.0d0
   ELSE IF(t > 1.0) THEN
     fstep = 1.0d0
   ELSE
     fstep = 0.75d0 * (t - t**3.0d0/3) + 0.5d0
   END IF

   r = (dens0-dens1) * fstep + dens1

 END FUNCTION Density



 FUNCTION FrameVelo( Model, n, dt ) RESULT(v)
   USE Types
   USE SolverUtils

   IMPLICIT NONE

   TYPE(Model_t) :: Model
   INTEGER :: i,j,k,n,DoneTime

   REAL(KIND=dp) :: x,y,dy,dt,v,v1,relax,dist=0.0d0
   LOGICAL :: GotIt, Visited 

   SAVE v1, dist, DoneTime

   IF( Model % Solver % DoneTime /= DoneTime) THEN
     relax = ListGetConstReal( Model % Simulation,'Frame Velocity Relaxation Factor')
     DoneTime = Model % Solver % DoneTime

     dy = ListGetConstReal(Model % Simulation,"res: levelset center 2",GotIt) 
     v1 = relax * (0.5-dy)/dt

     dist = dist + v1 * dy
     CALL ListAddConstReal(Model % Simulation,"res: cumulative distance",dist) 

     Visited = .TRUE.
   END IF

   v = v1

 END FUNCTION FrameVelo

ElmerGrid 1 2 mesh_coarse.grd -partition 2 1 1
echo 'coarse.sif' > ELMERSOLVER_STARTINFO
mpirun -np 2 ElmerSolver_mpi 

ElmerGrid 1 2 mesh_fine.grd -partition 3 1 1
echo 'fine.sif' > ELMERSOLVER_STARTINFO
mpirun -np 3 ElmerSolver_mpi 
